$(document).ready(function () {
    RepeatCall();
    $("#Messages").click(function () {

        if (!$("#MessageBox").is(":visible")) {
            $.ajax({
                type: "POST",
                url: "index.php?module=messages&event=listMessages" + "&" + $('#MessageForm').serialize(),
                data: $('#MessageForm').serialize(),
                //contentType: 'Content-type: multipart/form-data; charset=iso-8859-1',
                beforeSend: function (jqXHR) {
                    jqXHR.overrideMimeType('multipart/form-data;charset=iso-8859-1');
                }
            }).done(function (data) {
                $("#MessageBox").html(data);

                $("#MessageFilter").multiselect({
                    noneSelectedText: 'Filter',
                    selectedText: '# Typen gewhlt',
                    selectedList: 1,
                    header: false,
                    close: function () {
                        var values = $("#MessageFilter").val();
                        if (!values || values.length == 0) {
                            $("#MessageFilter").val(99);
                            // Then refresh
                            $("#MessageFilter").multiselect("refresh");
                        }
                        filterMessages();
                    }
                });

            });
        }
        $("#MessageBox").toggle();
    })

    $(function () {
        var intervalID;
        var freqSecs = 60;
        intervalID = setInterval(RepeatCall, freqSecs * 1000);
    });

    function RepeatCall() {
        $.ajax({
            type: "POST",
            data: $('#MessageForm').serialize(),
            url: "index.php?module=messages&event=checkMessages"
        }).done(function (json) {
            $('#MessageCount').html(json.cntAllMessages);
            //$('#NewMessages').html(json.cntNewMessages ? json.cntNewMessages : '');
            if (0 < json.cntNewMessages) {
                $('#Messages').fadeOut().fadeIn();
                if (json.cntNewMessages > 5) {
                    var n = noty({text: "",
                        closeWith: ['click'], // ['click', 'button', 'hover']
                        buttons: [
                            {addClass: 'button button-orange', text: 'Alle schlieen', onClick: function () {
                                    $.noty.closeAll();
                                }
                            },
                            {addClass: 'button button-red', text: 'Alle lschen', onClick: function ($noty) {
                                    $.each(json.Messages, function (i, item) {
                                        deleteMessage(item.id);
                                    });
                                    $.noty.closeAll();
                                }
                            }
                        ]
                    });
                }
                $.each(json.Messages, function (i, item) {
                    if (typeof (Notification) != 'undefined' && Notification.permission === "granted") {
                        // If it's okay let's create a notification
                        var notification = new Notification(
                                "Heinzelmann:",
                                {
                                    body: item.plaintext,
                                    onshow: function () {
                                        $.ajax({
                                            type: "POST",
                                            url: "index.php?module=messages&event=messageShowed&id=" + item.id
                                        })
                                    }
                                });
                        notification.onclick = function () {
                            notification.close();
                            window.location.href = item.url;
                        }
                    }
                    var n = noty({text: item.message,
                        callback: {
                            afterShow: function () {
                                $.ajax({
                                    type: "POST",
                                    url: "index.php?module=messages&event=messageShowed&id=" + item.id
                                })
                            }
                        }
                    });

                });
            }
        });
    }

    $.noty.defaults = {
        layout: 'topRight',
        theme: 'heinzelmannTheme',
        type: 'information',
        text: '', // can be html or string
        dismissQueue: true, // If you want to use queue feature set this true
        template: '<div class="noty_message"><span class="noty_text"></span><div class="noty_close"></div></div>',
        animation: {
            open: {height: 'toggle'},
            close: {height: 'toggle'},
            easing: 'swing',
            speed: 500 // opening & closing animation speed
        },
        timeout: false, // delay for closing event. Set false for sticky notifications
        force: false, // adds notification to the beginning of queue when set to true
        modal: false,
        maxVisible: 10, // you can set max visible notification for dismissQueue true option,
        killer: false, // for close all notifications before show
        closeWith: ['click'], // ['click', 'button', 'hover']
        callback: {
            onShow: function () {
            },
            afterShow: function () {
            },
            onClose: function () {
            },
            afterClose: function () {
            }
        },
        buttons: false // an array of buttons
    };




});


function deleteMessage(ID) {
    $.ajax({
        type: "POST",
        url: "index.php?module=messages&event=deleteMessage&id=" + ID,
    }).done(function (data) {
        if (data == 1) {
            $("#Message_" + ID).hide();
            var cnt = $('#MessageCount').html();
            $('#MessageCount').html(cnt - 1);
        }
    });
}

$(document).click(function (event) {
    if (!$(event.target).closest('#MessageBox, #Messages, .ui-widget').length) {
        if ($('#MessageBox').is(":visible")) {
            $('#MessageBox').hide()
        }
    }
})

function deleteAllMessages() {
    $.ajax({
        type: "POST",
        url: "index.php?module=messages&event=deleteAllMessages",
    }).done(function (data) {
        if (data == 1) {
            $('#MessageCount').html(0);
            $("#Messages").click();
        }
    });
}


function filterMessages() {
    $("#MessageBox").hide();
    $("#Messages").click();

}

if (window.Notification && Notification.permission !== "granted") {
    Notification.requestPermission(function (status) {
        if (Notification.permission !== status) {
            Notification.permission = status;
        }
    });
}

