<?php

/**
 * index.php
 *
 * MVC - Controller
 *
 * @author Dirk Herbes
 * @author Jan Koepke
 * @package Framework
 */
// Base Settings
define('DS', DIRECTORY_SEPARATOR);
define('_VALID_HM', 1);
//define('_HM_BASE', dirname(__FILE__));
define('_HM_BASE', dirname($_SERVER['SCRIPT_FILENAME']));
define('_HM_INCLUDES', _HM_BASE . DS . 'includes' . DS);
define('_HM_RELPATH', str_replace('index.php', '', $_SERVER['SCRIPT_NAME']));
define('_HM_PEAR_DIR', _HM_INCLUDES . 'PEAR' . DS);
define('_HM_RELUPLOAD', _HM_RELPATH . 'upload/');
define('_HM_STYLEPATH', 'styles/default/css/ownStyles/');
ini_set('include_path', _HM_PEAR_DIR);


if (is_dir(_HM_BASE . DS . "Sessions") && is_writable(_HM_BASE . DS . "Sessions")) {
    session_save_path(_HM_BASE . DS . "Sessions");
}

//Textlimit fr mssql auf maximum setzen:
ini_set('mssql.textlimit', 2147483600);
ini_set('mssql.textsize', 2147483600);
ini_set('default_charset', "ISO-8859-1");

if ('' == session_id()) {
    session_start();
}

require_once _HM_BASE . DS . 'configuration.php';

// Database Connection
$dsn = DBTYPE . '://' . DBUSER . ':' . DBPASS . '@' . DBHOST;
if (DBPORT > 0)
    $dsn .= ':' . DBPORT;
$dsn .= '/' . DBNAME;

define('FR_DSN', $dsn);
define('SMARTY_DIR', _HM_BASE . DS . 'inc' . DS . 'Smarty' . DS);
define('FR_TEMPLATE', 'default');

//Transaction steuerbar machen
if (!defined('DBUSETRANSACTIONS')) {
    define('DBUSETRANSACTIONS', 0);
}
// Error Reporting Off
error_reporting(E_ERROR);
ini_set('display_errors', 0);

// Time measuring
if (isset($_SESSION['UserName'])) {
    $_SERVER['Zeitmessung']['UserName'] = $_SESSION['UserName'];
}
$_SERVER['Zeitmessung']['Query'] = $_SERVER['QUERY_STRING'];
$_SERVER['Zeitmessung']['beginn'] = microtime(true);

// {{{ __autoload($class)
/**
 * __autoload
 *
 * Autoload is ran by PHP when it can't find a class it is trying to load.
 * By naming our classes intelligently we should be able to load most classes
 * dynamically.
 *
 * @author Dirk Herbes <d.herbes@fair-computer.de>
 * @param string $class Class name we're trying to load
 * @return void
 * @package Framework
 */
//require_once(_HM_PEAR_DIR.'Doctrine.php');
//spl_autoload_register(array('Doctrine', 'autoload'));

function hmautoload($class) {
    $file = str_replace('_', DS, substr($class, 2)) . '.php';
    include_once _HM_BASE . DS . 'inc' . DS . $file;
}

spl_autoload_register('hmautoload');


//function __autoload($class) {
//    $file = str_replace('_', DS, substr($class, 2)) . '.php';
//    include_once _HM_BASE . DS . 'inc' . DS . $file;
//}
// }}}
//Kompatibilitt zu alten Ticketaufrufen herstellen:
if (isset($_GET['option']) && 'ticket' == $_GET['option'] && isset($_GET['task']) && 'details' == $_GET['task']) {
    header('Location: index.php?module=ticket&event=show&id=' . $_GET['id']);
}

$QUERY_STRING = (strpos($_SERVER['QUERY_STRING'], '&') !== FALSE) ? substr($_SERVER['QUERY_STRING'], 0, strpos($_SERVER['QUERY_STRING'], '&')) //String vor dem ersten &
        : trim($_SERVER['QUERY_STRING']);

switch ($QUERY_STRING) {
    case 'LogonUser':
        $_GET['module'] = 'login';
        break;
    case 'GetLoginData':
        $_GET['module'] = 'user';
        $_GET['event'] = 'getLoginData';
        break;
    case 'GetDomains':
        $_GET['module'] = 'login';
        $_GET['event'] = 'getDomains';
        break;
    case 'GetMessages':
        $_GET['module'] = 'messages';
        $_GET['event'] = 'getMessages';
        break;
    case 'GetAllKBEntries':
        $_GET['module'] = 'knowledgebase';
        $_GET['event'] = 'RESTgetAllKBArticle';
        break;
    case 'GetAllTicketstatus':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTgetTicketstatus';
        break;
    case 'GetCategories':
        $_GET['module'] = 'category';
        $_GET['event'] = 'jsonAllCategories';
        break;
    case 'GetTickets':
        $_GET['module'] = 'ticketlist';
        $_GET['event'] = 'getTicketsJson';
        break;
    case 'GetTicketevents':
        $_GET['module'] = 'ticketlist';
        $_GET['event'] = 'getTEvents';
        break;
    case 'GetTicketAttachments':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTgetDocs';
        break;
    case 'GetDocument':
        $_GET['module'] = 'upload';
        $_GET['event'] = 'ShowImage';
        break;
    case 'GetFilter':
        $_GET['module'] = 'ticketlist';
        $_GET['event'] = 'getUserTicketFilter';
        break;
    case 'ApplyFilter':
        $_GET['module'] = 'ticketlist';
        $_GET['event'] = 'applyFilter';
        break;
    case 'GetSupporter':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTgetSupporterWithGroups';
        break;
    case 'GetGroups':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTgetSupporterGroupsWithSupporter';
        break;
    case 'GetContacts':
        $_GET['module'] = 'contact';
        $_GET['event'] = 'getContactsAsJson';
        break;
    case 'GetContactName':
        //Liefert den Kontaktnamen zu einer $_REQUEST['id']
        $_GET['module'] = 'contact';
        $_GET['event'] = 'RESTgetContactName';
        break;
    case 'GetStatusInfo':
        $_GET['module'] = 'ticketlist';
        $_GET['event'] = 'getTicketstatusAsJson';
        break;
    case 'GetNewTicketFields':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTgetNewTicketFields';
        break;
    case 'GetNewTicketeventFields':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTgetNewTicketeventFields';
        break;
    case 'GetUpdateTicketPermissions':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTgetUpdateTicketPermissions';
        break;

    case 'GetPriorities':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTgetPriorities';
        break;

    case 'GetProcessingtypes':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTGetProcessingtypeList';
        break;

    case 'AddTicket':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTaddTicket';
        break;

    case 'AddTicketDoc':
        $_GET['module'] = 'upload';
        $_GET['event'] = 'RESTuploadDocs';
        break;

    case 'RenameDoc':
        /* Request: attachmentid, newfilename, ruid */
        /* Response: error, newfilename */
        $_GET['module'] = 'upload';
        $_GET['event'] = 'RESTrenameFilename';
        break;

    case 'AddTicketEvent':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTaddTicketEvent';
        break;


    case 'AddKBEntry':
        $_GET['module'] = 'knowledgebase';
        $_GET['event'] = 'AddKBEntry';
        break;
    case 'GetTicketDataforArticle':
        $_GET['module'] = 'knowledgebase';
        $_GET['event'] = 'RESTgetTicketDataforArticle';
        break;

    //Kurzbeschreibung des Tickets ndern
    case 'UpdateTicketShortDescr':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTUpdateTicketShortDescr';
        /*
         * $_REQUEST['ticketid'] = 1;
         * $_REQUEST['newShortDescr'] = '';
         * $_REQUEST['oldShortDescr'] = '';
         */
        break;
    //Kontakt im Ticket ndern
    case 'UpdateTicketContact':
        $_GET['module'] = 'contact';
        $_GET['event'] = 'editTicketContact';
        /*
         * $_REQUEST['ticketid']
         * $_REQUEST['oldcid']
         * $_REQUEST['newcid']
         */
        break;

    //TicketPrio ndern
    case 'UpdateTicketPrio':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTUpdateTicketPrio';
        break;
    /*
     * $_REQUEST['tid']
     * $_REQUEST['oldPrioID']
     * $_REQUEST['newPrioID']
     */
    case 'UpdateTicketDesireDate':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTUpdateTicketDesireDate';
        /*
          $_REQUEST['newTicketDesireDate']
          $_REQUEST['oldTicketDesireDate']
          $_REQUEST['ticketid']
         */
        break;

    case 'UpdateTicketIsProblem':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'switchProblem';
        /*
          $_REQUEST['value']
         * $_REQUEST['ticketid']
         */
        break;

    case 'UpdateTicketOnHoldDate':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTUpdateTicketOnHoldDate';
        /*
          $_REQUEST['OnHoldDate'];
          $_REQUEST['remove'];
         */
        break;

    case 'UpdateExpExpense':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'changeExpExpense';
        $_REQUEST['save'] = 1;
        $_REQUEST['keepOnHold'] = 1;
        $_REQUEST['json'] = 1;
        /*
          $_REQUEST['ExpExpense'];
          $_REQUEST['ticketid'];
         */
        break;
    case 'UpdateTicketCategoryID':
        $_GET['module'] = 'category';
        $_GET['class'] = 'select';
        $_GET['event'] = 'UpdateTicketCategoryID';
        break;
    /*
      $_REQUEST['tid']
      $_REQUEST['cat'] => Kategorie 1 oder 2
      $_REQUEST['oldcid'] => KategorieID
      $_REQUEST['newcid'] => KategorieID
     */

    case 'UpdateTicketGroupIDs':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTUpdateTicketGroupIDs';

        /*
         * $_REQUEST['newSupporterIDs']
         * $_REQUEST['oldSupporterIDs']
         * $_REQUEST['newGroupIDs']
         * $_REQUEST['oldGroupIDs']
         */
        break;

    case 'UpdateTicketStatus':
        //3, 9 oder 6 (CLOSE | DONE | REOPENED)
        switch ($_REQUEST['newStatusID']) {
            case 3:
                $_GET['module'] = 'ticket';
                $_GET['event'] = 'RESTupdateTicketStatusClose';
                break;
            case 6:
                $_GET['module'] = 'ticket';
                $_GET['event'] = 'RESTupdateTicketStatusReopen';
                break;
            case 9:
                $_GET['module'] = 'ticket';
                $_GET['event'] = 'RESTupdateTicketStatusDone';
                break;
            default:
                echo json_encode("Just StatusID 3,6 or 9 allowed");
                break;
        }
        break;

    case 'DeleteTicket':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTdeleteTicket';
        break;

    case 'ToggleTicketBasket':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTAddOrRemoveTicketToBasket';
        break;

    case 'GetCompanies':
        $_GET['module'] = 'contact';
        $_GET['class'] = 'company';
        $_GET['event'] = 'jsonGetCompanys';
        break;
    case 'GetTicketUpdateUsers':
        $_GET['module'] = 'ticketlist';
        $_GET['event'] = 'getTicketUpdateUsers';
        break;
    case 'GetTimeperiods':
        $_GET['module'] = 'ticketlist';
        $_GET['event'] = 'getAllTimePeriots';
        break;
    case 'DeleteTicketevent':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTdeleteTicketevent';
        break;
    case 'GetEditEventFields':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTgetEditEventFields';
        break;
    /* $_REQUEST['eventid'] */
    case 'EditTicketevent':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'RESTeditEvent';
        break;
    case 'RemoveAttachment':
        $_GET['module'] = 'upload';
        $_GET['event'] = 'RESTremoveUpload';
        break;
    case 'GetCategoryName':
        //Liefert den Namen einer Kategorie zu einer $_REQUEST['id'] als JSON-Object.
        $_GET['module'] = 'category';
        $_GET['event'] = 'RESTgetCategoryName';
        break;
    case 'SetPushMessageStatus':
        //Aktiviert oder Deaktiviert die PushMessage-Einstellung fr $_REQUEST['messagetype']  $_REQUEST['value'].
        //Erlaubte MessageTypen: 'PushMessageCreate', 'PushMessageEdit', 'PushMessageAssign', 'PushMessageClose', 'PushMessageEscalation'
        $_GET['module'] = 'user';
        $_GET['event'] = 'RESTPushMessageSettings';
        break;
    case 'GetPushMessageStatus':
        $_GET['module'] = 'user';
        $_GET['event'] = 'RESTgetPushMessageSettings';
        break;

    case 'SendMailToFCS':
        $_GET['module'] = 'login';
        $_GET['event'] = 'RESTSendLogToFCS';
        break;
    case 'SetSorting':
        /**
         * $_POST['column']
         * $_POST['order']
         */
        $_GET['module'] = 'ticketlist';
        $_GET['event'] = 'RESTsetSortorderForUser';
        break;
    case 'GetLocationData':
        /* In Tickets verwendete Standortdaten */
        $_GET['module'] = 'ticketlist';
        $_GET['event'] = 'getTicketLocatioData';
        break;
    case 'SetTicketLocation':
        $_GET['module'] = 'ticket';
        $_GET['event'] = 'changeLocationStructure';
        /*
         * $_REQUEST['tid']
         * $_REQUEST['LocationStructureID'];
         * $_REQUEST['LocationLogGroupID'];
         * $_REQUEST['LocationRefType'];
         */
        break;

    case 'GetLocationTree':
        /* Smtliche Standortdaten */
        $_GET['module'] = 'structure';
        $_GET['event'] = 'showfulltree';
    /* $_REQUEST['selected'] LogGroupID */

    default:
        break;
}
/* REST Routing Ende */

$module = basename((isset($_GET['module'])) ? $_GET['module'] : 'start');
$event = basename((isset($_GET['event'])) ? $_GET['event'] : '__default');
$class = basename((isset($_GET['class'])) ? $_GET['class'] : $module);


$classFile = _HM_BASE . DS . 'modules' . DS . $module . DS . $class . '.php';

/* Ende REST Routing */

if (is_dir(_HM_BASE . DS . 'installation')) {
    header('Location: installation/index.php');
    // Error::display('Please remove or rename installation directory ....');
}

//TAPI-APP Abfrage markieren:
//if (isset($_REQUEST['phoneno']) && '' != $_REQUEST['phoneno']) {
if (isset($_REQUEST['phoneno'])) {
    $_SESSION['TAPILogin'] = TRUE;
    $_SESSION['UserName'] = $_REQUEST['lx_username'];
    if (!isset($_SESSION['TAPIPass']) && isset($_REQUEST['lx_password'])) {
        //Wenn das Passwort schon gehashed ist, nicht noch einmal hashen:
        if (32 == strlen($_REQUEST['lx_password'])) {
            $_SESSION['TAPIPass'] = $_REQUEST['lx_password'];
        } else {
            $_SESSION['TAPIPass'] = md5($_REQUEST['lx_password']);
        }
    }
    $_SESSION['RandomUserID'] = '1';
}

// Module file exists ?
if (file_exists($classFile)) {

    require_once($classFile);

    // Module class exists ?
    if (class_exists($class)) {

        try {

            // Init Module
            $instance = new $class();
            $instance->className = $class;

            // Is this a valid module ?
            if (!FR_Module::isValid($instance)) {
                die('Requested module is not valid framework module!');
                //header('Location: error404.html');
            }

            $instance->moduleName = $module;

            // Have you access to module ?
            if ($instance->authenticate()) {

                try {
                    if (method_exists($instance, $event)) {
                        $result = $instance->$event();

                        if (!PEAR::isError($result)) {

                            $instance->eventName = $event;
                            $presenter = FR_Presenter::factory($instance->presenter, $instance);

                            if (!PEAR::isError($presenter)) {
                                $presenter->display();
                            } else {
                                die($presenter->getMessage());
                                //header('Location: /error404.html');
                            }
                        }
                    } else {
                        //header('Location: /error404.html');
                        echo '404';
                        exit;
                    }
                } catch (Exception $error) {
                    die($error->getMessage());
                    //header('Location: /error404.html');
                }
            } else {
                // die('You do not have access to the requested page!');
                //ggf. URL merken:
                if ('module=start&class=shoutbox' != trim($_SERVER['QUERY_STRING']) &&
                        FALSE === strpos($_SERVER['QUERY_STRING'], 'module=messages') &&
                        FALSE === strpos($_SERVER['QUERY_STRING'], 'module=login') &&
                        FALSE === strpos($_SERVER['QUERY_STRING'], 'module=tapi')
                ) {
                    $_SESSION['QUERY_STRING'] = trim($_SERVER['QUERY_STRING']);
                }
                header('Location: index.php?module=login');
            }
        } catch (Exception $error) {
            echo $error->getTraceAsString();
            die($error->getMessage());
            //header('Location: /error404.html');
        }
    } else {
        //die('An valid module for your request was not found');
        include_once 'includes/heinzelmann.php';
        //header('Location: /error404.html');
    }
} else {
    // die('Could not find: '.$classFile);
    include_once 'includes/heinzelmann.php';
    // header('Location: /error404.html');
}
?>