<?php

define('DS', DIRECTORY_SEPARATOR);
define('_VALID_HM', 1);

error_reporting(E_ALL);
ini_set('display_errors', 0);

$basedir = dirname(__FILE__);
$base = substr($basedir, 0, strrpos($basedir, DS));

define('_HM_BASE', $base);
define('_HM_INCLUDES', _HM_BASE . DS . 'includes' . DS);
define('_HM_PEAR_DIR', _HM_INCLUDES . 'PEAR' . DS);
define('_HM_STYLEPATH', 'styles/default/css/ownStyles/');
define('_HM_TEMPLATES_DIR', $basedir . DS . 'templates');
define('_HM_COMPILE_DIR', _HM_TEMPLATES_DIR . DS . 'templates_c');
ini_set('include_path', _HM_PEAR_DIR);


if (!defined("DEBUG")) {
    define('DEBUG', false); //Sollte false sein, wenn nicht getestet wird
}

require_once _HM_INCLUDES . 'template.php';
require_once _HM_INCLUDES . 'globalvars.php';
require_once _HM_INCLUDES . 'validate.php';
require_once _HM_INCLUDES . 'logging.php';
require_once _HM_INCLUDES . 'version.php';


require_once _HM_BASE . DS . 'configuration.php';

if (!defined('_HM_UPLOAD')) {
    define('_HM_UPLOAD', _HM_BASE . DS . 'upload' . DS);
}

class installation {

    var $smarty = null;
    var $db = null;
    var $BackupPath = '';
    var $report = '';
    public $sqlsrv = false;
    public $mssql = false;
    public $oci8 = false;

    function installation() {

        global $smarty;

        $this->sqlsrv = function_exists('sqlsrv_connect');
        $this->mssql = function_exists('mssql_connect');
        $this->oci = function_exists('oci_connect');


        $this->smarty = $smarty;
        $this->smarty->template_dir = _HM_TEMPLATES_DIR;
        $this->smarty->compile_dir = _HM_COMPILE_DIR;

        $this->smarty->assign('mssql', $this->mssql);
        $this->smarty->assign('sqlsrv', $this->sqlsrv);
        $this->smarty->assign('oracle', $this->oci);

        switch (@$_REQUEST['option']) {

            case 'cat':
                $this->get_categories();
                break;

            case 'exec':
                $this->create_structure();
                break;

            case 'sqlexec':
                $this->xmlSQLExec();
                break;

            case 'dbselect':
                $this->db_select();
                break;

            case 'db':
                $this->db_settings();
                break;

            case 'final':
                $this->finalize();
                break;

            case 'backup':
                $this->db_backup();
                break;

            default:
                $this->pre_installation_check();
                break;
        }
    }

    function pre_installation_check() {

        $this->smarty->assign('phpversion', (strcmp(phpversion(), '5.2') >= 0) ? true : false);

        @include_once 'PEAR.php';
        $this->smarty->assign('pear', class_exists('PEAR'));

        @include_once 'DB.php';
        @include_once 'Log.php';
        $this->smarty->assign('pearmod', (class_exists('DB') && class_exists('Log')) ? true : false);


        $this->smarty->assign('mssql', $this->mssql);
        $this->smarty->assign('sqlsrv', $this->sqlsrv);
        $this->smarty->assign('oracle', $this->oci);
        $this->smarty->assign('uniqid', (trim(@uniqid()) != '') ? true : false);

        $this->smarty->assign('conf', is_writeable(_HM_BASE . DS . 'configuration.php'));
        $this->smarty->assign('session_path', ini_get('session.save_path'));
        $this->smarty->assign('session', is_writeable(ini_get('session.save_path')));

        //$this->smarty->assign('display_errors', ini_get('display_errors'));
        $this->smarty->assign('display_errors', 1);

        $this->smarty->assign('safe_mode', (ini_get('safe_mode') == 1) ? true : false);
        $this->smarty->assign('file_uploads', ini_get('file_uploads'));
        $this->smarty->assign('magic_quotes_gpc', ini_get('magic_quotes_gpc'));
        $this->smarty->assign('magic_quotes_runtime', ini_get('magic_quotes_runtime'));
        $this->smarty->assign('register_globals', ini_get('register_globals'));
        $this->smarty->assign('session_auto_start', ini_get('session.auto_start'));
        $this->smarty->assign('output_buffering', ini_get('output_buffering'));

        $this->smarty->assign('modules_dir', is_writeable(_HM_BASE . DS . 'modules'));
        //$this->smarty->assign('templates_dir', is_writeable(_HM_BASE . DS . 'templates' . DS . 'templates_c'));
        $this->smarty->assign('templates_dir', is_writeable(_HM_BASE . DS . 'tpl' . DS . 'default' . DS . 'templates_c'));
        $this->smarty->assign('log_dir', is_writeable(_HM_BASE . DS . 'log'));
        $this->smarty->assign('upload_dir', is_writeable(_HM_BASE . DS . 'upload'));
//Zend Optimation:
        $this->smarty->assign('ZendOptimation', get_cfg_var('zend_optimizer.enable_loader') ? true : true);
        $this->smarty->assign('ZendOptimationLevel', (int) get_cfg_var('zend_optimizer.optimization_level'));

        $this->smarty->assign('mbstring', function_exists('mb_detect_encoding'));

        $this->smarty->display('syscheck.tpl');
    }

    function db_settings() {

        if (@$_REQUEST['task'] == 'store') {
            $_REQUEST = $this->array_stripslashes($_REQUEST);
            //Stringzeichen maskieren damit es in der config gespeichert werden kann:
            $_REQUEST['password'] = str_replace('$', '\$', @$_REQUEST['password']);

            $config = file_get_contents(_HM_BASE . DS . 'configuration.php');

            $db_port = ((int) @$_REQUEST['port'] > 0) ? (int) $_REQUEST['port'] : 0;
            $config = preg_replace("#define\('DBTYPE', '.*'\);#Uis", "define('DBTYPE', '" . @$_REQUEST['phptype'] . "');", $config);
            $config = preg_replace("#define\('DBUSER', '.*'\);#Uis", "define('DBUSER', '" . @$_REQUEST['username'] . "');", $config);
            $config = preg_replace("#define\('DBPASS', '.*'\);#Uis", 'define(\'DBPASS\', \'' . @$_REQUEST['password'] . '\');', $config);
            $config = preg_replace("#define\('DBHOST', '.*'\);#Uis", "define('DBHOST', '" . @$_REQUEST['hostspec'] . "');", $config);
            $config = preg_replace("#define\('DBPORT', .*\);#Uis", "define('DBPORT', $db_port);", $config);
            //AssetDesk erstmal aus fr alle:
            $config = preg_replace("#define\('ASSETDESK', .*\);#Uis", "define('ASSETDESK', 0);", $config);

            $fh = @fopen(_HM_BASE . DS . 'configuration.php', 'w');
            @fwrite($fh, $config);
            if (fflush($fh)) {
                @fclose($fh);
                @include _HM_BASE . DS . 'configuration.php';
            }
        }

        if (@$_REQUEST['task'] == 'store' && DBTYPE != 'odbc') {
            //$db = $this->_getDBHandle('');
            //Maskierung von Stringzeichen ($) wieder entfernen, damit die Authentifizierung in _getDBHandle() funktioniert:
            $_REQUEST['password'] = str_replace('\$', '$', @$_REQUEST['password']);
            $db = $this->_getDBHandle('', @$_REQUEST['phptype'], @$_REQUEST['username'], @$_REQUEST['password'], @$_REQUEST['hostspec'],
                    (int) @$_REQUEST['port']);

            if (!DB::isError($db)) {
                sleep(3);   //JK: warten, damit Daten verarbeitet werden...
                header('Location: index.php?option=dbselect');
            } else {
                $this->smarty->assign('connection_failed', true);
                $this->smarty->assign('error', $this->error);
            }
        }

        $this->smarty->assign('phptype', @$_REQUEST['phptype'] == '' ? DBTYPE : @$_REQUEST['phptype']);
        $this->smarty->assign('hostspec', @$_REQUEST['hostspec'] == '' ? DBHOST : @$_REQUEST['hostspec']);
        $this->smarty->assign('username', @$_REQUEST['username'] == '' ? DBUSER : @$_REQUEST['username']);
        $this->smarty->assign('password', @$_REQUEST['password'] == '' ? DBPASS : @$_REQUEST['password'] );
        $this->smarty->assign('port', ((int) DBPORT > 0) ? DBPORT : '');

        $this->smarty->display('dbsettings.tpl');
    }

    /** db_select()
     *
     *  Step 2 of the installationprocess
     *
     * */
    function db_select() { //Step 2
        @include_once _HM_BASE . DS . 'configuration.php';
        $DbName = '';

        // Wenn eine existierende DB gewhlt wurde:
        if (@$_REQUEST['task'] == 'store2' &&
                (trim(@$_REQUEST['database']) != '') &&
                $_REQUEST['NewOrExist'] == 'ExistDB') {  // Bestehende DB ausgewhlt:
            $_REQUEST = $this->array_stripslashes($_REQUEST);
            $config = file_get_contents(_HM_BASE . DS . 'configuration.php');
            $config = preg_replace("#define\('DBNAME', '.*'\);#Uis", "define('DBNAME', '" . @$_REQUEST['database'] . "');", $config);

            $fh = @fopen(_HM_BASE . DS . 'configuration.php', 'w');
            @fwrite($fh, $config);
            @fclose($fh);

            $DbName = @$_REQUEST['database'];
            //Logging:
            $this->Logging('Existing database choosen: ' . $DbName);

            //Oracle: Passswort von SYS-PW auf HM_PW setzen:
            if (DBTYPE == 'oci8' && trim($_POST['HMPW']) != '') {
                $config = preg_replace("#define\('DBPASS', '.*'\);#Uis", 'define(\'DBPASS\', \'' . trim(@$_POST['HMPW']) . '\');', $config);
                $config = preg_replace("#define\('DBUSER', '.*'\);#Uis", "define('DBUSER', '" . $DbName . "');", $config);
                $fh = @fopen(_HM_BASE . DS . 'configuration.php', 'w');
                @fwrite($fh, $config);
                @fclose($fh);
                $this->smarty->assign('password', trim(@$_POST['HMPW']));
            }
        } elseif (@$_REQUEST['task'] == 'store2' &&
                $_REQUEST['NewOrExist'] == 'NewDB') { // neue DB eintragen:
            $_REQUEST = $this->array_stripslashes($_REQUEST);
            $NewDBName = Validator::ConvertStringToSQL(@$_REQUEST['enterDBName']);

            $DbName = $NewDBName;

            if ($NewDBName != '') {

                if (DBTYPE != 'odbc') {

                    $master = (DBTYPE == 'mssql' || DBTYPE == 'sqlsrv') ? 'master' : 'mysql';

                    $db = $this->_getDBHandle($master);
                    $this->smarty->assign('connected', ($db === false || DB::isError($db)) ? false : true);

                    if ($db !== false && !DB::isError($db) &&
                            (DBTYPE == 'mssql' || DBTYPE == 'sqlsrv' || DBTYPE == 'mysql' || DBTYPE == 'oci8')) {

                        $sql = (DBTYPE == 'mysql') ? 'SHOW DATABASES' : "SELECT name FROM sysdatabases WHERE name <> 'master' AND
                                name <> 'model' AND name <> 'msdb' ORDER BY name";

                        // Datenbanken in Oracle
                        if (DBTYPE == 'oci8') {
                            $sql = 'SELECT username FROM all_users ';
                        }

                        $res = $db->query($sql);
                        //Prfung, ob neuer Datenbankname schon existiert:
                        $NameExists = false;
                        if (!DB::isError($res)) {
                            while ($row = $res->fetchrow()) {
                                if (DBTYPE == 'mysql' && $row[0] == 'mysql') continue;
                                if (strtolower((string) $row[0]) == strtolower($NewDBName)) {
                                    $NameExists = true;
                                }
                            }
                        } else { //Verbindung mit DB fehlgeschlagen:
                            $this->smarty->assign('Error', "Connection error: " . $DB->getMessage());
                        }
                        if ($NameExists) { //Wenn Datenbank schon existiert: Fehlermeldung
                            $this->smarty->assign('Error', "The database $NewDBName already exist");
                            $this->Logging('New database name ' . $NewDBName . ' alredy exist.');

                            $this->smarty->assign('databases', $this->getDatabases());
                            $this->smarty->assign('enterDBName', $NewDBName);
                            $this->smarty->assign('database', DBNAME);
                            $this->smarty->assign('phptype', DBTYPE);
                            $this->smarty->assign('hostspec', DBHOST);
                            $this->smarty->assign('username', DBUSER);
                            $this->smarty->assign('password', DBPASS);
                            $this->smarty->assign('port', ((int) DBPORT > 0) ? DBPORT : '');

                            $this->smarty->display('dbselect.tpl');
                            exit();
                        } else {    //Wenn nicht existent: In "configuration.php" eintragen
                            //Datenbankname in HM-config eintragen:
                            $config = file_get_contents(_HM_BASE . DS . 'configuration.php');
                            $config = preg_replace("#define\('DBNAME', '.*'\);#Uis", "define('DBNAME', '" . $NewDBName . "');", $config);
                            // @file_put_contents(_HM_BASE.DS.'configuration.php', $config);
                            $fh = @fopen(_HM_BASE . DS . 'configuration.php', 'w');
                            @fwrite($fh, $config);
                            @fclose($fh);

                            //Neue Datenbank anlegen:
                            switch (DBTYPE) {
                                case 'mssql':
                                case 'sqlsrv':
                                    $this->db = $this->_getDBHandle('master');
                                    break;
                                case 'mysql':
                                    $this->db = $this->_getDBHandle('mysql');
                                    break;
                                case 'oci8':   //Oracle, noch einiges unklar...
                                    $this->db = $this->_getDBHandle('SYS');
                                    break;
                                default:
                                    $this->db = $this->_getDBHandle('');
                            }
                            if (DBTYPE != 'oci8') {
                                $sql = "CREATE DATABASE $NewDBName";
                            } else {

                                //Oracle DB anlegen
                                $sql = "create user $NewDBName
                                   identified by " . trim(@$_POST['HMPW']) . "
                                  default tablespace USERS
                                  temporary tablespace TEMP
                                  profile DEFAULT";
                                $res = $this->db->query($sql);
                                if (DB::isError($res)) {
                                    $this->smarty->assign('newdb_error', true);
                                    $this->Logging("New " . DBTYPE . " database " . $NewDBName . " could not created. Message: " . $res->getMessage());
                                    //Error::Log("Neue ".DBTYPE." Datenbank ".$NewDBName." konnte nicht angelegt werden. Meldung: ".$res->getMessage(), PEAR_LOG_ERR);
                                }

                                $NewDBName = strtoupper($NewDBName);

                                $sql = "grant connect to \"$NewDBName\" with admin option";
                                $res = $this->db->query($sql);
                                if (DB::isError($res)) {
                                    $this->smarty->assign('newdb_error', true);
                                    $this->Logging("New " . DBTYPE . " database " . $NewDBName . ": Error while \"$sql\". Message: " . $res->getMessage());
                                    //Error::Log("Neue ".DBTYPE." Datenbank ".$NewDBName." konnte nicht angelegt werden. Meldung: ".$res->getMessage(), PEAR_LOG_ERR);
                                }

                                $sql = "grant dba to \"$NewDBName\" with admin option";
                                $res = $this->db->query($sql);
                                if (DB::isError($res)) {
                                    $this->smarty->assign('newdb_error', true);
                                    $this->Logging("New " . DBTYPE . " database " . $NewDBName . ": Error while \"$sql\". Message: " . $res->getMessage());
                                    //Error::Log("Neue ".DBTYPE." Datenbank ".$NewDBName." konnte nicht angelegt werden. Meldung: ".$res->getMessage(), PEAR_LOG_ERR);
                                }

                                $sql = "grant unlimited tablespace to \"$NewDBName\" with admin option";
                                $res = $this->db->query($sql);
                                if (DB::isError($res)) {
                                    $this->smarty->assign('newdb_error', true);
                                    $this->Logging("New " . DBTYPE . " database " . $NewDBName . ": Error while \"$sql\". Message: " . $res->getMessage());
                                    //Error::Log("Neue ".DBTYPE." Datenbank ".$NewDBName." konnte nicht angelegt werden. Meldung: ".$res->getMessage(), PEAR_LOG_ERR);
                                }

                                $sql = "grant alter any table to \"$NewDBName\" with admin option";
                                $res = $this->db->query($sql);
                                if (DB::isError($res)) {
                                    $this->smarty->assign('newdb_error', true);
                                    $this->Logging("New " . DBTYPE . " database " . $NewDBName . ": Error while \"$sql\". Message: " . $res->getMessage());
                                    //Error::Log("Neue ".DBTYPE." Datenbank ".$NewDBName." konnte nicht angelegt werden. Meldung: ".$res->getMessage(), PEAR_LOG_ERR);
                                }

                                $sql = "grant create any table to \"$NewDBName\" with admin option";
                            }

                            $res = $this->db->query($sql);

                            if (DB::isError($res)) {
                                $this->smarty->assign('newdb_error', true);
                                $this->Logging("New " . DBTYPE . " database " . $NewDBName . ": Error while \"$sql\". Message: " . $res->getMessage());
                                //Error::Log("Neue ".DBTYPE." Datenbank ".$NewDBName." konnte nicht angelegt werden. Meldung: ".$res->getMessage(), PEAR_LOG_ERR);
                            } else {
                                $this->Logging("New " . DBTYPE . " database " . $NewDBName . " created.");
                                $this->smarty->assign('newdb_error', false);
                                $this->smarty->assign('NewDB', $NewDBName);
                                //Error::Log("Neue ".DBTYPE." Datenbank ".$NewDBName." wurde angelegt.", PEAR_LOG_NOTICE);
                                //Oracle: Passswort von SYS-PW auf HM_PW setzen:
                                if (DBTYPE == 'oci8' && trim($_POST['HMPW']) != '') {
                                    $config = preg_replace("#define\('DBPASS', '.*'\);#Uis", 'define(\'DBPASS\', \'' . trim(@$_POST['HMPW']) . '\');',
                                            $config);
                                    $config = preg_replace("#define\('DBUSER', '.*'\);#Uis", "define('DBUSER', '" . $NewDBName . "');", $config);
                                    $fh = @fopen(_HM_BASE . DS . 'configuration.php', 'w');
                                    @fwrite($fh, $config);
                                    @fclose($fh);
                                    $this->smarty->assign('password', trim(@$_POST['HMPW']));
                                }
                            }
                        }
                    }
                }
            } else { // ...wenn kein Name eingegeben: Fehlermeldung
                $this->smarty->assign('Error', "Enter a new database name.");

                $this->smarty->assign('enterDBName', $NewDBName);

                $this->smarty->assign('databases', $this->getDatabases());
                $this->smarty->assign('database', DBNAME);
                $this->smarty->assign('phptype', DBTYPE);
                $this->smarty->assign('hostspec', DBHOST);
                $this->smarty->assign('username', DBUSER);
                $this->smarty->assign('password', DBPASS);
                $this->smarty->assign('port', ((int) DBPORT > 0) ? DBPORT : '');

                $this->smarty->display('dbselect.tpl');
                exit();
            }
        } // Ende Bestehende DB oder Neue DB

        @include_once _HM_BASE . DS . 'configuration.php';

        if (@$_REQUEST['task'] == 'store2') {

            $db = $this->_getDBHandle($DbName);

            if (!DB::isError($db)) {
                //Wenn Verbindung steht, weiter mit Step 3
                return $this->mode_selection();
            } else {
                $this->smarty->assign('connection_failed', true);
            }
        }

        if (DBTYPE != 'odbc') {

            $master = (DBTYPE == 'mssql' || DBTYPE == 'sqlsrv') ? 'master' : 'mysql';
            $db = $this->_getDBHandle($master);
            $this->smarty->assign('connected', ($db === false || DB::isError($db)) ? false : true);

            if ($db !== false && !DB::isError($db) &&
                    (DBTYPE == 'mssql' || DBTYPE == 'sqlsrv' || DBTYPE == 'mysql' || DBTYPE == 'oci8')) {

                $databases = array();

                $sql = (DBTYPE == 'mysql') ? 'SHOW DATABASES' : "SELECT name FROM sysdatabases WHERE name <> 'master' AND
                        name <> 'model' AND name <> 'msdb' ORDER BY name";

                // Datenbanken in Oracle
                if (DBTYPE == 'oci8') {
                    $sql = 'SELECT username FROM all_users ';
                }

                $res = $db->query($sql);
                if (!DB::isError($res)) {
                    while ($row = $res->fetchrow()) {
                        if (DBTYPE == 'mysql' && $row[0] == 'mysql') continue;
                        $databases[] = $row[0];
                    }
                }

                if (count($databases) > 0) {
                    $this->smarty->assign('databases', $databases);
                }
            }
        }
        $NewDBName = ($NewDBName != '') ? $NewDBName : '';
        //$this->smarty->assign('databases', $this->getDatabases());
        //$this->smarty->assign('enterDBName', $enterDBName);
        $this->smarty->assign('enterDBName', $NewDBName);

        $this->smarty->assign('database', DBNAME);
        $this->smarty->assign('phptype', DBTYPE);
        $this->smarty->assign('hostspec', DBHOST);
        $this->smarty->assign('username', DBUSER);
        $this->smarty->assign('password', DBPASS);
        $this->smarty->assign('port', ((int) DBPORT > 0) ? DBPORT : '');
        $this->smarty->display('dbselect.tpl');
    }

    /** function getDatabases()
     *  gibt die Namen der existierenden Datenbanken zurck
     *
     *  return array  exist databases
     * */
    function getDatabases() {

        if (DBTYPE != 'odbc') {

            $master = (DBTYPE == 'mssql' || DBTYPE == 'sqlsrv') ? 'master' : 'mysql';
            $db = $this->_getDBHandle($master);

            $this->smarty->assign('connected', ($db === false || DB::isError($db)) ? false : true);

            if ($db !== false && !DB::isError($db) &&
                    (DBTYPE == 'mssql' || DBTYPE == 'sqlsrv' || DBTYPE == 'mysql' || DBTYPE == 'oci8')) {

                $databases = array();

                $sql = (DBTYPE == 'mysql') ? 'SHOW DATABASES' : "SELECT name FROM sysdatabases WHERE name <> 'master' AND
                        name <> 'model' AND name <> 'msdb' ORDER BY name";

                // Datenbanken in Oracle, warscheinlich nicht exakt genug...:
                if (DBTYPE == 'oci8') {
                    $sql = 'SELECT username FROM all_users ';
                }

                $res = $db->query($sql);
                if (!DB::isError($res)) {
                    while ($row = $res->fetchrow()) {
                        if (DBTYPE == 'mysql' && $row[0] == 'mysql') continue;
                        $databases[] = $row[0];
                    }
                }

                if (count($databases) > 0) {
                    return $databases;
                } else {
                    return false;
                }
            }
        }
    }

    /**
     *  function db_backup
     *
     *
     * */
    function db_backup() {

        @session_start();


        // Wenn ein Pfad gewhlt wurde und "Backup"-Button geklickt: ":
        if (trim($_REQUEST['BackupPath']) != '' && trim(@$_REQUEST['Backup']) == 'Backup') {

            //evtl. vorhandene Maskierungen entfernen
            $BackupPath = trim(Validator::toString($_REQUEST['BackupPath']), '\\');

            $this->smarty->assign('BackupPath', $BackupPath);
            $this->smarty->assign('BackupSucces', false);

            //Wenn Schreibberechtigung...
            if (is_writeable($BackupPath)) {

                //Pfad global aufbewahren
                $this->BackupPath = $BackupPath;

                //Backup aufrufen und Smarty Ergebnisse mitteilen
                $BackupSucces = (bool) $this->Backup();

                $this->smarty->assign('BackupSucces', $BackupSucces ? true : false );
                $this->smarty->assign('BackupReport', $this->report);
                $this->smarty->assign('BackupPath', $this->BackupPath);
                //Pfad aufbewahren
                $_SESSION['BackupPath'] = $this->BackupPath;
                $this->smarty->display('backup.tpl');

                //Wenn keine Schreibberechtigung fr Pfad...
            } else {

                //.... Fehlermeldung
                $this->smarty->assign('BackupPathError', true);
                $this->smarty->assign('BackupSucces', 1);

                $this->smarty->assign('BackupPath', $this->BackupPath);
                $this->smarty->display('backup.tpl');
            }
            //$this->smarty->display('backup.tpl');
            //Wenn eine Datei ausgewhlt wurde und "Restore"-Button geklickt wurde:
        } elseif (trim($_REQUEST['RestorePath']) != '' && trim(@$_REQUEST['Backup']) == 'Restore') {

            $RestorePath = Validator::toString($_REQUEST['RestorePath']);
            $this->BackupPath = $RestorePath;
            $RestoreSucces = $this->Restore();

            $this->smarty->assign('RestoreSucces', $RestoreSucces ? 1 : 0 );
            $this->smarty->assign('RestoreReport', $this->report);

            $this->BackupPath = $_SESSION['BackupPath'];
            $this->smarty->assign('BackupPath', $this->BackupPath);
            $this->smarty->display('backup.tpl');
        } else {
            $this->smarty->assign('RestoreSucces', false);
            $this->smarty->assign('BackupSucces', false);
            $this->BackupPath = $_SESSION['BackupPath'];
            $this->smarty->assign('BackupPath', $this->BackupPath);
            $this->smarty->display('backup.tpl');
        }
    }

    function mode_selection() {

        // Backup in Schritt 3:
        //Wenn Backup/Restore-Button gedrck wurde:
        if (trim(@$_REQUEST['Backup']) == 'Backup/Restore' ||
                trim(@$_REQUEST['Backup']) == 'Backup' ||
                trim(@$_REQUEST['Backup']) == 'Restore') {

            $this->db_backup();
            exit();

            //Backup ende
            // Wenn keine Backupfunktion gewhlt wurde:
        } else {

            $hm_exists = false;
            $update = false;

            @include_once _HM_BASE . DS . 'configuration.php';
            //Probleme beim Auslesen des gespeicherten DB-Namens umgehen:
            $dbname = ($_REQUEST['NewOrExist'] == 'NewDB') ?
                    trim($_REQUEST['enterDBName']) : trim($_REQUEST['database']);
            $dbname = ($dbname == '' ) ? DBNAME : $dbname;

            $db = $this->_getDBHandle($dbname);

            if (DBTYPE == 'oci8') $db = $this->_getDBHandle($dbname, DBTYPE, $dbname, $_POST['HMPW'], DBHOST);

            //Prfen ob DB AssetDesk DB ist
            $res = $db->getOne('SELECT COUNT(*) FROM [dbo].[DBVersion]');

            $AssetDesk = (DB::isError($res)) ? 0 : 1;

            //In die config.php eintragen, ob HM zusammen mit AssetDesk genutzt wird:
            $config = file_get_contents(_HM_BASE . DS . 'configuration.php');

            $config = preg_replace("#define\('ASSETDESK', .*\);#Uis", "define('ASSETDESK', $AssetDesk);", $config);

            //@file_put_contents(_HM_BASE.DS.'configuration.php', $config);
            $fh = @fopen(_HM_BASE . DS . 'configuration.php', 'w');
            @fwrite($fh, $config);
            @fclose($fh);

            // Prfen, ob DB schon fr HM genutzt wird (Update)
            $sql = 'SELECT COUNT(*) FROM ' . HMPREFIX . 'Ticket';
            $res = $db->getOne($sql);

            //Wenn es in der DB eine Tabelle hm_Ticket gibt, dann...:
            if (!DB::isError($res)) {
                //... ist es eine HM-Datenbank:
                $hm_exists = true;
                //Ist die DB evtl. HM-Version 1.x?
                $sql = 'SELECT COUNT(*) FROM TicketCategory';
                $res = $db->getOne($sql);
                //jk 24.04.09: Wenn es eine Tabelle TicketCategory gibt: $update = true d.h. HM Version == 1.x
                $update = (!DB::isError($res)) ? true : false;
                $this->Logging("Selected HEINZELMANN DB contains HM tables: Update.");
            } else {
                //Wenn keine Tabelle hm_Tickets => neue Tabellen anlegen
                $update = false;
                $hm_exists = false;
                $this->Logging("Selected HEINZELMANN DB contains no HM tables. Tables created.");
            }

            $this->smarty->assign('backup_possible', DBTYPE == 'oci8' ? 0 : 1);

            $this->smarty->assign('update', $update);
            $this->smarty->assign('assetdesk', $AssetDesk);
            $this->smarty->assign('hm_exists', $hm_exists);

            $this->smarty->assign('database', $dbname);
            $this->smarty->assign('phptype', DBTYPE);
            $this->smarty->assign('hostspec', DBHOST);
            if (DBTYPE == 'oci8') {
                $this->smarty->assign('username', $dbname);
                $this->smarty->assign('password', $_POST['HMPW']);
            } else {
                $this->smarty->assign('username', DBUSER);
                $this->smarty->assign('password', DBPASS);
            }
            $this->smarty->assign('port', ((int) DBPORT > 0) ? DBPORT : '');

            $this->smarty->display('modeselection.tpl');
        }
    }

    function create_structure() {
        $this->smarty->assign('mode', (@$_REQUEST['mode'] == 1) ? 1 : 0);
        $this->smarty->display('createstructure.tpl');
    }

    function finalize() {
        $this->smarty->display('final.tpl');
    }

    function xmlSQLExec() {
        global $basedir;
        @include_once _HM_BASE . DS . 'configuration.php';
        @include_once _HM_INCLUDES . 'logging.php';


//JK, 08.09.2011: Headerdaten senden, da sons gecachte Aufrufe nicht mit AjaX verarbeitet werden knnen
        header("Content-Type: text/html");
        header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // Datum aus Vergangenheit
        header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // immer gendert
        header("Cache-Control: no-store, no-cache, must-revalidate");  // HTTP/1.1
        header("Cache-Control: post-check=0, pre-check=0", false);
        header("Pragma: no-cache");


        $mode = (@$_REQUEST['mode'] == 1) ? 'Update' : 'Create';
        $pos = (int) @$_REQUEST['pos'];
        $step = 10;
        $offset = ($pos - 1) * $step;
        $max = $offset + $step;

        if (DEBUG) $this->Logging("(DEBUG) mode:[$mode] pos:[$pos] step [$step] offset: [$offset]  max [$max] ");

        $this->db = $this->_getDBHandle(DBNAME);

        if (strtoupper($mode) == 'CREATE') {

            if (strtolower(DBTYPE) == 'oci8') {
                $file = $basedir . DS . 'sql' . DS . 'oracle_new.sql';
            } else if (strtolower(DBTYPE) == 'mssql' || strtolower(DBTYPE) == 'sqlsrv') {
                $file = $basedir . DS . 'sql' . DS . 'mssql_new.sql';
            } else {
                $file = $basedir . DS . 'sql' . DS . strtolower(DBTYPE) . '_new.sql';
            }
            if ($pos == 0) $this->Logging("Creat new " . DBTYPE . " DB " . DBNAME . " with script: $file ");
            $buffer = @file_get_contents($file);

            switch (strtolower(DBTYPE)) {
                case 'mssql':
                case 'sqlsrv':
                    $statements = explode('GO', $buffer);
                    break;
                case 'mysql':
                    $statements = explode('#--', $buffer);
                    break;
                case 'oci8':   //Oracle, noch einiges unklar...
                    $statements = explode('/', $buffer);
                    break;
                default:
                    $statements = explode('GO', $buffer);
            }

            $lfdnr = count($statements);

            if ($max > $lfdnr) $max = $lfdnr;

            for ($i = $offset; $i < $max; $i++) {
                $sql = str_replace('#--', '', trim(@$statements[$i]));
                if ($sql != '') {
                    if (DBTYPE == 'oci8') {  //Oracle-Statements in eine Zeile bringen:
                        $order = array("\r\n", "\n", "\r");
                        $replace = ' ';
                        $sql = str_replace($order, $replace, $sql);
                        $sql = str_replace("UPPER(SEQUENCE_OWNER) = ''", "UPPER(SEQUENCE_OWNER) = UPPER('" . DBNAME . "')", $sql);
                        $sql = str_replace("hm_", DBNAME . ".hm_", $sql);
                    }
                    $res = $this->db->query($sql);
                    if (DB::isError($res)) {
                        $this->Logging('ERROR with statement: ' . $sql . '. Message: ' . $res->getMessage());
                        $this->db->disconnect();
                        echo '999';
                        exit;
                    }
                }
            }
            if ($max == $lfdnr) {
                $this->Logging("Tables was created without errors.");


                $this->postUpdateActions();
            }
            $this->db->disconnect();
            echo floor(($max / $lfdnr) * 100);
            exit;
        } else { // Update
            if (strtolower(DBTYPE) == 'oci8') {
                $file = $basedir . DS . 'sql' . DS . 'oracle_update_3.x_to_3.x.sql';
            } else
            if (strtolower(DBTYPE) == 'mssql' || strtolower(DBTYPE) == 'sqlsrv') {
                $file = $basedir . DS . 'sql' . DS . 'mssql_update_3.x_to_3.x.sql';
            } else {
                $file = $basedir . DS . 'sql' . DS . strtolower(DBTYPE) . '_update_3.x_to_3.x.sql';
            }
            if ($pos == 0) {
                $this->Logging("Update the " . DBTYPE . " database " . DBNAME . " with script: $file ");
            }
            $buffer = @file_get_contents($file);

            switch (strtolower(DBTYPE)) {
                case 'mssql':
                case 'sqlsrv' :
                    $statements = explode('GO', $buffer);
                    break;
                case 'mysql':
                    $statements = explode('#--', $buffer);
                    break;
                case 'oci8':   //Oracle, noch einiges unklar...
                    $statements = explode('/', $buffer);
                    break;
                default:
                    $statements = explode('GO', $buffer);
            }

            $lfdnr = count($statements);

            if ($max > $lfdnr) {
                $max = $lfdnr;
            }

            for ($i = $offset; $i < $max; $i++) {

                $sql = str_replace('#--', '', trim(@$statements[$i]));
                if ($sql != '') {

                    //MySQL kann kein "IF NOT EXIST ALTER TABLE..."
                    if (trim(strtolower(DBTYPE)) == 'mysql') $alter_test = explode(' ', $sql);


                    if (DBTYPE == 'oci8') {  //Oracle-Statements in eine Zeile bringen:
                        $order = array("\r\n", "\n", "\r");
                        $replace = ' ';
                        $sql = str_replace($order, $replace, $sql);
                        $sql = str_replace("UPPER(SEQUENCE_OWNER) = ''", "UPPER(SEQUENCE_OWNER) = UPPER('" . DBNAME . "')", $sql);
                    }
                    if (DEBUG) $this->Logging("(DEBUG) Statement $i: $sql ");
                    $res = $this->db->query($sql);
                    if (DB::isError($res)) {
                        $this->Logging("Error with statement: $sql . Message: " . $res->getMessage());
                        $this->db->disconnect();
                        echo '999';
                        exit;
                    }
                }
            } //ende forschleife

            echo floor(($max / $lfdnr) * 100);


            if ($max == $lfdnr) {
                $this->Logging("Tables created without error.");
                $this->postUpdateActions();
            } else {
                $this->moveSupporterAndGroups();
            }
            $this->db->disconnect();
            exit;
        } //Ende  Update
    }

    function array_stripslashes($var) {
        if (is_array($var)) {
            if (count($var) > 0) {
                foreach ($var as $key => $val) {
                    $var[$key] = $this->array_stripslashes($val);
                }
                return $var;
            }
            return $var;
        }
        if (get_magic_quotes_gpc()) $var = stripslashes($var);
        return str_replace(array('"', "'"), '', $var);
    }

    function _getDBHandle($dbname = '', $dbtype = '', $dbuser = '', $dbpass = '', $dbhost = '', $dbport = 0) {

        include_once _HM_BASE . DS . 'configuration.php';
        @include_once 'DB.php';

        if ($dbhost == '' && $dbuser == '') {
            $dsn = array(
                'phptype' => DBTYPE,
                'username' => DBUSER,
                'password' => DBPASS,
                'hostspec' => DBHOST,
                'database' => $dbname
            );
        } else {
            $dsn = array(
                'phptype' => $dbtype,
                'username' => $dbuser,
                'password' => $dbpass,
                'hostspec' => $dbhost,
                'database' => $dbname
            );
        }


        if ($dbport == 0) {
            if (DBTYPE == 'oci8') unset($dsn['database']);
            if ((int) DBPORT > 0) $dsn['port'] = DBPORT;
        } else {
            if ((int) $dbport > 0) $dsn['port'] = $dbport;
        }

        //JK, 14.04.2011: Oracle - Port bei Verbindung mit TNS-Listener nicht angeben
        if (DBTYPE == 'oci8') {
            unset($dsn['port']);
            @putenv('NLS_LANG=GERMAN_GERMANY.WE8ISO8859P15');
        }

        if ('sqlsrv' == DBTYPE && '' == trim($dsn['database'])) {
            $dsn['database'] = 'master';
        }

        $connection = DB::connect($dsn);
        if (DB::iserror($connection)) {
            $this->error = $connection->getUserInfo();
        }

        return (class_exists('DB')) ? $connection : false;
    }

    /**
     *  function Backup ($Path)
     *
     *  Erstellt fhrt ein MSSql-Script aus, welches ein Datenbank-Backup macht.
     *
     *  return  (bool)    Gab es einen Fehler dabei? true = ohne Fehler
     * */
    function Backup() {
        $max_Execution_time = ini_get('max_execution_time');
        ini_set('max_execution_time', 1000);

        @include_once _HM_BASE . DS . 'configuration.php';
        require_once("DB.php");

        $db_server = DBHOST;
        $db_user = DBUSER;
        $db_pass = DBPASS;
        $db_name = DBNAME;

        $pfad = $this->BackupPath;
        $bname = $db_name . '_backup_';
        $this->BackupPath = "$pfad\\$bname" . date('dmYHi') . '.bak';
        $pfad = $this->BackupPath;

        if (trim(strtolower(DBTYPE) == 'mssql')) {
            $sql = "BACKUP DATABASE $db_name TO  DISK = N'$pfad' WITH NOFORMAT, INIT, NAME = N'Full Database Backup', SKIP, STATS = 10";

            //Aufbau der Datenbankverbindung
            $db = mssql_connect($db_server, $db_user, $db_pass) or die('Fehler ist aufgetreten!');

            //Ausfhren des Backups

            $res = mssql_query($sql);

            //Meldung - ob das Backup erfolgreich war oder nicht!
            $report = mssql_get_last_message();

            $this->report = $report;

            $end = mssql_close();
            ini_set('max_execution_time', $max_Execution_time);
            return !DB::isError($res);
        } else if (trim(strtolower(DBTYPE)) == 'sqlsrv') {

            $sql = "BACKUP DATABASE $db_name TO  DISK = N'$pfad' WITH NOFORMAT, INIT, NAME = N'Full Database Backup', SKIP, STATS = 10";

            //Aufbau der Datenbankverbindung
            $db = sqlsrv_connect($db_server, $db_user, $db_pass) or die('Fehler ist aufgetreten!');

            //Ausfhren des Backups

            $res = sqlsrv_query($sql);

            //Meldung - ob das Backup erfolgreich war oder nicht!
            if (($errors = sqlsrv_errors() ) != null) {
                $this->report = $errors[0];
            }

            $end = sqlsrv_close();
            ini_set('max_execution_time', $max_Execution_time);
            return !DB::isError($res);
        }

        //Backup mit MySQL:
        if (trim(strtolower(DBTYPE) == 'mysql')) {
            $db = $this->_getDBHandle($db_name);

            $tables = Array();
            $res = $db->query("SHOW TABLES FROM `" . $db_name . "`");
            if (!DB::isError($res)) {
                while ($row = $res->fetchrow()) {
                    $tables[] = $row[0];
                }
            }

            $this->BackupScript("USE $db_name;\n\n#--\n");

            foreach ($tables as $table) {
                $this->BackupScript("DROP TABLE IF EXISTS " . $table . ";\n#--\n");

                $res = $db->query("SHOW CREATE TABLE `$table`");
                if (!DB::isError($res)) {
                    while ($row = $res->fetchrow()) {
                        $this->BackupScript($row[1] . ";\n\n#--\n");
                    }
                } else {
                    $this->report = "Fehler beim Auslesen der Tabellen";
                    return false;
                }

                //Funktion "Immer $backuprows Zeilen einlesen"
                $backuprows = 1000;
                $anzahl = $db->getOne("SELECT COUNT(*) AS anzahl FROM " . $table);
                for ($x = 0; $x < $anzahl; $x += $backuprows) {
                    //Tabelle teilweise einlesen
                    $res = $db->query("SELECT * FROM " . $table . " LIMIT " . ($x * $backuprows) . "," . $backuprows . ";");
                    if (!DB::isError($res)) {
                        while ($row = $res->fetchrow()) {
                            $val = "INSERT INTO " . $table . " VALUES(";
                            //$this->BackupScript("INSERT INTO ".$table." VALUES(");

                            foreach ($row as $eintrag) {
                                $temptext = $eintrag;
                                //$temptext = str_replace("'","\'",$temptext);
                                $temptext = mysql_real_escape_string($temptext);
                                $val .= "'" . $temptext . "',";
                            }
                            $val = substr($val, 0, strlen($val) - 1); // letztes Komma verwerfen (abschneiden)
                            $this->BackupScript($val . ");\n\n#--\n");
                        }
                    } else {
                        $this->report = "Error while creating backup";
                        ini_set('max_execution_time', $max_Execution_time); //ExecutionTime zurcksetzen
                        return false;
                    }
                }
            }
            $this->report = "Backup succsesfully applied.";
            //ExecutionTime zurcksetzen
            ini_set('max_execution_time', $max_Execution_time);
            return true;
        } // Ende MySQL
    }

//end function Backup

    /**
     *  function Restore ($Path)
     *
     *  Fhrt ein MSSql-Script aus, welches ein Datenbank-Backup einspielt.
     *
     *  return  (bool)    Gab es einen Fehler dabei? true = ohne Fehler
     * */
    function Restore() {

        $max_Execution_time = ini_get('max_execution_time');
        ini_set('max_execution_time', 3000);
        $Memory_limit = ini_get('memory_limit');

        ini_set('memory_limit', $Memory_limit);

        @include_once _HM_BASE . DS . 'configuration.php';
        require_once("DB.php");


        $db_server = DBHOST;
        $db_user = DBUSER;
        $db_pass = DBPASS;
        $db_name = DBNAME;

        $Path = $this->BackupPath;

        if (trim(strtolower(DBTYPE)) == 'mssql' || trim(strtolower(DBTYPE)) == 'sqlsrv') {

            $db = $this->_getDBHandle('master');

            $sql = "ALTER DATABASE $db_name SET OFFLINE WITH ROLLBACK IMMEDIATE";
            $res = $db->query($sql);

            $sql = "ALTER DATABASE $db_name SET ONLINE, SINGLE_USER";
            $res = $db->query($sql);

            $sql = "RESTORE DATABASE $db_name FROM DISK = N'$Path' WITH FILE = 1, REPLACE";
            $res = $db->query($sql);
            // Report bergeben

            if (trim(strtolower(DBTYPE)) == 'mssql') {
                $this->report = mssql_get_last_message();
            } else {
                //Meldung - ob das Backup erfolgreich war oder nicht!
                if (($errors = sqlsrv_errors() ) != null) {
                    $this->report = $errors[0];
                }
            }

            $sql = "ALTER DATABASE  $db_name SET MULTI_USER";
            $res = $db->query($sql);

            ini_set('max_execution_time', $max_Execution_time); //ExecutionTime zurcksetzen
            ini_set('memory_limit', $Memory_limit);
            return !DB::isError($res);
        }

        if (trim(strtolower(DBTYPE) == 'mysql')) {

            $db = $this->_getDBHandle(DBNAME);

            $file = $this->BackupPath;
            $this->Logging("Restore the " . DBTYPE . " DB " . DBNAME . " with script: $file ");
            $buffer = @file_get_contents($file);

            $statements = explode('#--', $buffer);

            foreach ($statements as $sql) {
                $i++;
                $sql = str_replace('#--', '', trim($sql));
                if ($sql != '') {
                    $res = $db->query($sql);
                    if (DB::isError($res)) {
                        $this->Logging('Backup-Restore: ERROR with statement: ' . $sql . ' Message: ' . $res->getMessage());
                        $db->disconnect();

                        $this->report = "Tables could not been restored." . $res->getMessage();
                        ini_set('max_execution_time', $max_Execution_time); //ExecutionTime zurcksetzen
                        return false;
                    }
                }
            }
            $this->report = "Tables restored without errors.";
            $this->Logging("Tables restored without errors.");
            ini_set('max_execution_time', $max_Execution_time); //ExecutionTime zurcksetzen
            return true;
            $db->disconnect();
        }
    }

    function Logging($text) {
        $zeit = date('d-m-Y H:i:s');
        $nl = chr(13) . chr(10);
        $fh = @fopen(_HM_BASE . DS . '/log/' . date('Y-m-d') . '.log', 'a+');
        @fwrite($fh, $nl . $zeit . ": " . $text);
        @fclose($fh);
    }

    function BackupScript($text) {
        $nl = chr(13) . chr(10);
        $fh = @fopen($this->BackupPath, 'a+');
        @fwrite($fh, $nl . $text);
        @fclose($fh);
    }

    /**
     * Trgt die aktuelle Versionsnummer in die DB ein.
     * Die RELEASE-Nummer aus class $heinzelmannVersion wird in die Tabelle hm_ServicesData als Active eingetragen.
     * Desweiteren wird der Pfad vom HM und das UpdateDatum eingetragen.
     */
    private function updateVersion() {
        try {
            // Versionsnummer in DB anpassen
            $hmVersion = new heinzelmannVersion();
            $hmVersion->RELEASE;
            $this->Logging("Updated HM-Version in DB to [" . $hmVersion->RELEASE . "]");
            if (isset($this->db) && isset($hmVersion->RELEASE)) {
                $deactivateSQL = "UPDATE hm_ServicesData SET ServiceActive = 0 WHERE ServiceType = 'HM' AND ServiceActive = 1 ";
                $res = $this->db->query($deactivateSQL);
                if (!DB::isError($res)) {
                    $DateString = (DBTYPE == 'oci8') ? ' SYSDATE ' : ' GETDATE() ';
                    $activateVersionSQL = sprintf("INSERT INTO hm_ServicesData (ServiceType,StartDate,Version, PathToService, ServiceActive ) VALUES ('HM', %s, %s ,'%s', 1 )",
                            $DateString, $this->db->quoteSmart($hmVersion->RELEASE), _HM_BASE);
                    $res = $this->db->query($activateVersionSQL);
                    if (!DB::isError($res)) {
                        $this->Logging("Updated HM-Version in DB to [" . $hmVersion->RELEASE . "]");
                    }
                }
            }
        } catch (Exception $ex) {
            $this->Logging("Es gab einen Fehler beim eintragen der Versionsnummer in hm_ServicesData. Message:" . $ex->getMessage());
        }
    }

    private function moveSupporterAndGroups($withStops = true) {
        if (!$withStops) {
            ini_set('max_execution_time', 0);
        }

        try {
            //Alle Supporter ermitteln:
            $sql = sprintf("SELECT T.SupporterID, T.GroupID, T.ID
                            FROM hm_Ticket T
                            LEFT JOIN hm_TicketSupporter TS ON TS.TicketID = T.ID
                            LEFT JOIN hm_TicketGroup TG ON TG.TicketID = T.ID
                            WHERE ( T.SupporterID > 0 AND TS.TicketID IS NULL ) OR ( T.GroupID > 0 AND TG.TicketID IS NULL)");
            $res = $this->db->query($sql);
            $cnt = 0;
            if (!DB::isError($res)) {
                while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                    $row = array_change_key_case($row, CASE_LOWER);
                    $SQLError = TRUE;
                    //$this->Logging("[$cnt] Supporter bertragen fr Ticket [" . $row['id'] . "] " . print_r($row, true));
                    if ($row['supporterid']) {
                        $sqlSupporter = sprintf('INSERT INTO hm_TicketSupporter (TicketID, UserID) VALUES( %u, %u )', $row['id'], $row['supporterid']);
                        $resSupporter = $this->db->query($sqlSupporter);
                        $SQLError = DB::isError($resSupporter) ? true : false;
                        //$this->Logging("[$cnt] Supporter bertragen: $sqlSupporter : " . print_r($SQLError, true));
                    }
                    if ($row['groupid']) {
                        $sqlGroup = sprintf('INSERT INTO hm_TicketGroup (TicketID, GroupID) VALUES( %u, %u )', $row['id'], $row['groupid']);
                        $resGroup = $this->db->query($sqlGroup);
                        $SQLError = DB::isError($resGroup) ? true : false;
                        //$this->Logging("[$cnt] Gruppe bertragen: $sqlGroup : " . print_r($SQLError, true));
                    }
                    if (!$SQLError) {
                        $sqlCleanTicket = sprintf("UPDATE hm_Ticket SET SupporterID = NULL, GroupID = NULL WHERE ID = %u", $row['id']);
//                        $resCleanTicket = $this->db->query($sqlCleanTicket);
                        //$this->Logging("[$cnt] Daten aus hm_Ticket entfernen: $sqlCleanTicket : " . print_r($resCleanTicket, true));
                    }
                    $cnt++;

//$this->Logging("[$cnt] Supporter bertragen fr Ticket [".$row['ID']."] ");
                    if ($withStops && $cnt > 1000) {
                        break;
                    }
                }
            }
            $this->moveTemplateSupporterAndGroups($withStops);
        } catch (Exception $ex) {
            $this->Logging("Es gab Fehler bei der bertragung der Supporter und Gruppen in die Tabellen zhm_Ticketsupporter und hm_TicketGroup. Message:" . $ex->getMessage());
        }
    }

    private function moveTemplateSupporterAndGroups($withStops = true) {
        if (!$withStops) {
            ini_set('max_execution_time', 0);
        }

        try {
            //Alle Supporter ermitteln:
            $sql = sprintf("SELECT TT.SupporterID, TT.GroupID, TT.TicketTemplateID FROM hm_Tickettemplate TT
                            LEFT JOIN hm_TicketTemplateSupporter TTS ON TTS.TicketTemplateID = TT.TicketTemplateID
                            LEFT JOIN hm_TicketTemplateGroup TTG ON TTG.TicketTemplateID = TT.TicketTemplateID
                            WHERE (TT.SupporterID > 0 OR TT.GroupID > 0) AND TTS.TicketTemplateID IS NULL AND TTG.TicketTemplateID IS NULL");
            $res = $this->db->query($sql);
            $cnt = 0;
            if (!DB::isError($res)) {
                while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                    $row = array_change_key_case($row, CASE_LOWER);

                    if ($row['supporterid']) {
                        $sqlSupporter = sprintf('INSERT INTO hm_TicketTemplateSupporter (TicketTemplateID, UserID) VALUES( %u, %u )',
                                $row['tickettemplateid'], $row['supporterid']);
                        $resSupporter = $this->db->query($sqlSupporter);
                    }
                    if ($row['groupid']) {
                        $sqlGroup = sprintf('INSERT INTO hm_TicketTemplateGroup (TicketTemplateID, GroupID) VALUES( %u, %u )',
                                $row['tickettemplateid'], $row['groupid']);
                        $resGroup = $this->db->query($sqlGroup);
                    }
                    if (!DB::isError($resSupporter) && !DB::isError($resGroup)) {
                        $sqlCleanTicket = sprintf("UPDATE hm_TicketTemplate SET SupporterID = NULL, GroupID = NULL WHERE TicketTemplateID = %u",
                                $row['tickettemplateid']);
                        //$resCleanTicket = $this->db->query($sqlCleanTicket);
                    }
                    $cnt++;
                    //$this->Logging("[$cnt] Supporter bertragen fr Template [" . $row['TicketTemplateID'] . "] ");
                    if ($withStops && $cnt > 100) {
                        break;
                    }
                }
            }
        } catch (Exception $ex) {
            $this->Logging("Es gab Fehler bei der bertragung der Supporter und Gruppen in die TicketTemplate-Tabellen hm_TicketTemplateSupporter und hm_TicketTemplateGroup. Message:" . $ex->getMessage());
        }
    }

    /**
     * Fhrt Funktionen aus, welche nach einem Update durchgefhrt werden mssen
     */
    private function postUpdateActions() {
        $this->updateVersion();
        $this->clearStyles();
        $this->clearRenderedFiles();
        $this->clearCompiledTemplates();
        $this->moveSupporterAndGroups(FALSE);
        //$this->clearUserGroupTable();
        $this->createIndexes();
    }

    /**
     * Lscht generierte .css-Dateien aus dem entsprechendem Pfad.
     * Das ist notwenig damit nderungen in den .less-Dateien nach einem Update griefen.
     * Die Dateien werden neu generiert, wenn Sie gebraucht werden.
     */
    public function clearStyles() {
        $Dir = _HM_BASE . DS . _HM_STYLEPATH;
        //$files = glob($Dir.'/*.{jpg,png,gif}', GLOB_BRACE);
        $files = glob($Dir . '*.css', GLOB_BRACE);
        foreach ($files as $file) {
            unlink($file);
        }
    }

    /**
     * Lscht generierte .css-Dateien aus dem entsprechendem Pfad.
     * Das ist notwenig damit nderungen in den .less-Dateien nach einem Update griefen.
     * Die Dateien werden neu generiert, wenn Sie gebraucht werden.
     */
    public function clearRenderedFiles() {
        $Dir = _HM_BASE . DS . _HM_STYLEPATH . 'rendFiles' . DS;
        //$files = glob($Dir.'/*.{jpg,png,gif}', GLOB_BRACE);
        $files = glob($Dir . '*.*', GLOB_BRACE);
        foreach ($files as $file) {
            unlink($file);
        }
    }

    /**
     * Lscht die Dateien im Verzeichnis tpl/default/templates_c
     */
    private function clearCompiledTemplates() {

        $Dir = _HM_BASE . DS . 'tpl' . DS . 'default' . DS . 'templates_c';
        $files = glob($Dir . DS . '*.tpl.php', GLOB_BRACE);
        foreach ($files as $file) {
            unlink($file);
        }
    }

    private function createIndexes() {
        $Indices = array(
            'CREATE INDEX idx_hm_TSupp_TIDUserID ON hm_TicketSupporter (TicketID, UserID)',
            'CREATE INDEX idx_hm_TEvent_TsNPDTID ON hm_TicketEvent (TicketID, Deleted, NotPublic, TicketStatusID)',
            'CREATE INDEX idx_hm_Ti_Search ON hm_Ticket (ID, Archived, TicketStatusID, published, EditDate, TicketReferenzID)',
            'CREATE INDEX idx_hm_TEvent_IdCUsr ON hm_TicketEvent (CREATEUSERID, ID)'
        );
        foreach ($Indices as $Index) {
            $res = $this->db->query($Index);
        }
    }

    private function clearUserGroupTable() {
        if (FALSE && (DBTYPE == 'mssql' || DBTYPE == 'sqlsrv')) {
            $error = false;
            $useTransactions = $this->db->provides('transactions');

            if ($useTransactions) {
                $this->db->autoCommit(false);
            }
            $sql = "CREATE TABLE [dbo].[hm_UserGroups_tmp] (
	[user_id] [bigint] NOT NULL ,
	[group_id] [bigint] NOT NULL,
CONSTRAINT [PK_hm_UserGroups] PRIMARY KEY CLUSTERED
(
	[user_id] ASC,
	[group_id] ASC
))";
            $res = $this->db->query($sql);
            $error = ($error || DB::isError($res));
            $sql = "INSERT INTO hm_UserGroups_tmp (user_id, group_id) SELECT DISTINCT  user_id, group_id from hm_UserGroups";
            $res = $this->db->query($sql);
            $error = ($error || DB::isError($res));
            $sql = "DROP TABLE hm_UserGroups_old";
            $res = $this->db->query($sql);
            $sql = "exec sp_rename 'hm_UserGroups', 'hm_UserGroups_old'";
            $res = $this->db->query($sql);
            $error = ($error || DB::isError($res));
            $sql = "exec sp_rename 'hm_UserGroups_tmp', 'hm_UserGroups'";
            $res = $this->db->query($sql);
            $error = ($error || DB::isError($res));

            //Transaction Ende
            if ($useTransactions) {
                if (!$error) {  // Daten bestaetigen
                    $this->db->commit();
                    $this->Logging("Tabelle hm_UserGroup wurde bereinigt.");
                } else {  // Transaktionen rueckgaengig machen
                    $this->Logging("Tabelle hm_UserGroup wurde nicht bereinigt. Message: " . $res->getMessage());
                    $this->db->rollback();
                }
                $this->db->autoCommit(true);
            }
        }
    }

}

$setup = new installation();
?>
