/* ******************************************************************************
 *	nderungen fr Report fr FHD - Ticket Status je Tag
 * ****************************************************************************** 
 *  Stored Procedure muss jeden Tag ausgefhrt werden damit die View auf Tabelle 
 *  zugreifen kann
 *  ti 4.6.2009
 * ****************************************************************************** */

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[gp_hm_TicketStatusEveryDayLastYear]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[gp_hm_TicketStatusEveryDayLastYear]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[vw_ReportTicketStatus]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[vw_ReportTicketStatus]
GO

-- Die Tabelle kann gelscht werden -> Wird durch Stored Procedure gefllt
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_ForViewTicketStatus]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[hm_ForViewTicketStatus]
GO

CREATE TABLE [dbo].[hm_ForViewTicketStatus] (
	[Date] [datetime] NOT NULL ,
	[TicketNew] [int] NULL ,
	[TicketOpen] [int] NULL 
) ON [PRIMARY]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE VIEW dbo.vw_ReportTicketStatus
AS
SELECT     dbo.hm_ForViewTicketStatus.*
FROM         dbo.hm_ForViewTicketStatus

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[gp_hm_TicketStatusEveryDayLastYear]

AS


/****************************************
 * Datumstabelle der letzten 365 Tage
 ****************************************/
SELECT Convert(datetime,Convert(varchar,DATEADD(day, z.num, GetDate()-365),104)) as date, 0 as 'NEW', 0 as 'OPEN'
into #d
FROM (
SELECT b10.i + b9.i + b8.i + b7.i + b6.i + b5.i + b4.i + b3.i + b2.i + b1.i + b0.i num
FROM (SELECT 0 i UNION ALL SELECT 1) b0
CROSS JOIN (SELECT 0 i UNION ALL SELECT 2) b1
CROSS JOIN (SELECT 0 i UNION ALL SELECT 4) b2
CROSS JOIN (SELECT 0 i UNION ALL SELECT 8) b3
CROSS JOIN (SELECT 0 i UNION ALL SELECT 16) b4
CROSS JOIN (SELECT 0 i UNION ALL SELECT 32) b5
CROSS JOIN (SELECT 0 i UNION ALL SELECT 64) b6
CROSS JOIN (SELECT 0 i UNION ALL SELECT 128) b7
CROSS JOIN (SELECT 0 i UNION ALL SELECT 256) b8
CROSS JOIN (SELECT 0 i UNION ALL SELECT 512) b9
CROSS JOIN (SELECT 0 i UNION ALL SELECT 1024) b10
) z
WHERE z.num <= DATEDIFF(day, GetDate()-365, GetDate())
ORDER BY z.num

Delete from hm_ForViewTicketStatus
Insert into hm_ForViewTicketStatus 
Select 	tbldate.date As SearchDate,
		--Convert(datetime,Convert(varchar,hm_tickethistory.CreateDate,104)) as CreateDate, 
		--hm_tickethistory.ID As IDNew,
		(Select Count(ID) FROM
			(
				SELECT ID FROM hm_tickethistory 
				WHERE Convert(datetime,Convert(varchar,CreateDate,104)) = tbldate.date 
				group by hm_tickethistory.ID
			) DERIVEDTBL
		) as TICKETNEW,
		(
			(
				Select Count(ID) FROM
				(
					SELECT ID FROM hm_tickethistory 
					WHERE Convert(datetime,Convert(varchar,CreateDate,104)) <= tbldate.date
					group by hm_tickethistory.ID
				) DERIVEDTBL
			) 			
			- 
			(
				--WENN GESCHLOSSEN VORHANDEN - ZAEHLE EINTRAG NICHT ANSONSTEN JA
				Select Count(ID) As CountTicketIsClosed FROM
				(
					SELECT ID FROM hm_tickethistory
					WHERE --Convert(datetime,Convert(varchar,CreateDate,104)) <= tbldate.date AND 
					Convert(datetime,Convert(varchar,UpdateDate,104)) < tbldate.date + 1 AND 
					(TicketStatusID = 3 OR TicketStatusID = 7 OR TicketStatusID = 8 )
					group by hm_tickethistory.ID
				) DERIVEDTBL				
				
			) 
		) as TICKETOPEN	
		from  #d As tbldate
		order by tbldate.date

DROP Table #d 


if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_ForViewTicketStatus]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[hm_Report](
		[ReportID] [bigint] IDENTITY(1,1) NOT NULL,
		[ReportName] [varchar](150) NOT NULL,
		[ReportView] [varchar](200) NOT NULL,
		[IsVisible] [tinyint] NOT NULL,
	 CONSTRAINT [PK_hm_Report] PRIMARY KEY CLUSTERED 
	(
		[ReportID] ASC
	)
	) ON [PRIMARY]
END

if not exists (Select ReportView from hm_Report where ReportView = 'vw_ReportTicketStatus')
BEGIN
	Insert into hm_Report (ReportName, ReportView, IsVisible) values ('Status Tickets', 'vw_ReportTicketStatus', 1)
END

/************************************************
 * Ergnzende Abfragen zum Erweiterten Reporting
 ************************************************ */
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 60)
  INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (60, 'Erweitertes Reporting anzeigen', 3, 3)
GO

Declare @adminID int
Select @adminID = group_id from hm_groups where [name] = 'Administrator'

if not exists (Select group_id from hm_GroupRights where group_id = @adminID and right_id = 60)
BEGIN
	Insert into hm_GroupRights (group_id, right_id) values (1, 60)
END

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[vw_hm_ReportBearbeitungsart]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[vw_hm_ReportBearbeitungsart]
GO


CREATE VIEW dbo.vw_hm_ReportBearbeitungsart
AS
SELECT     CONVERT(datetime, CONVERT(varchar, dbo.hm_TicketEvent.CreateDate, 104)) AS Date, description AS Bearbeitungsart, COUNT(dbo.hm_TicketEvent.ID)
                       AS Expr1, SUM(dbo.hm_TicketEvent.Expense) AS Zeitaufwand
FROM         dbo.hm_TicketEvent INNER JOIN
                      dbo.hm_ProcessingType ON dbo.hm_TicketEvent.processingtype = dbo.hm_ProcessingType.processingtype_id
WHERE     (ProcessingType IS NOT NULL)
GROUP BY CONVERT(datetime, CONVERT(varchar, dbo.hm_TicketEvent.CreateDate, 104)), description
GO

if not exists (Select ReportView from hm_Report where ReportView = 'vw_hm_ReportBearbeitungsart')
BEGIN
	Insert into hm_Report (ReportName, ReportView, IsVisible) values ('Anzahl Events nach Bearbeitungsart', 'vw_hm_ReportBearbeitungsart', 1)
END


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

