DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 57;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (57, 'Interne Notiz verfassen', 2, 0);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketTemplateSupporter');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketTemplateSupporter(
            	TicketTemplateID NUMBER NOT NULL,
            	UserID  NUMBER NOT NULL
             )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketTemplateGroup');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketTemplateGroup(
            	TicketTemplateID NUMBER NOT NULL,
            	GroupID  NUMBER NOT NULL
             )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketSupporter');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketSupporter(
            	TicketID NUMBER NOT NULL,
            	UserID  NUMBER NOT NULL,
                addDate DATE Default SYSDATE NOT NULL,
                Constraint PK_TicketSupp Primary Key (TicketID, UserID)
             )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketGroup');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketGroup(
            	TicketID NUMBER NOT NULL,
            	GroupID  NUMBER NOT NULL,
                addDate DATE Default SYSDATE NOT NULL,
                Constraint PK_TicketGroup Primary Key (TicketID, GroupID)
             )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketDeviceDate');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketDeviceDate(
            	TicketID NUMBER NOT NULL,
            	DeviceID  NUMBER NOT NULL,
                addDate DATE Default SYSDATE NOT NULL,
                removeDate DATE NULL
             )');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketContactDate');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketContactDate(
            	TicketID NUMBER NOT NULL,
            	ContactID  NUMBER NOT NULL,
                addDate DATE Default SYSDATE NOT NULL,
                removeDate DATE NULL 
             )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 57;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 57);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 58;
	IF(p_Count = 1) THEN
		DELETE FROM hm_Rights WHERE RightID = 58;
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 58;
	IF(p_Count = 1) THEN
		DELETE FROM hm_GroupRights WHERE group_id = 1 AND right_id = 58;
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 60;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (60, 'Erweitertes Reporting anzeigen', 3, 3);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project_Ref_Definition');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_Project_Ref_Definition
			(
				ProjectRefDefinitionID NUMBER NOT NULL,
				TableRef VARCHAR2(100) NOT NULL,
				Active NUMBER NOT NULL,
				SourceTable VARCHAR2(100) NOT NULL,
				SourceIDField VARCHAR2(100) NOT NULL,
				SourceNumberField VARCHAR2(100) NOT NULL,
				SourceLabelField VARCHAR2(100) NOT NULL,
				SourceNumberFieldRef VARCHAR2(100) NULL,
				Name VARCHAR2(100) NOT NULL,
				Constraint PK_Project_Ref_Definition Primary Key (ProjectRefDefinitionID)
			)');
	END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_PROJECT_REF_DEFINITION_SEQ' ;

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_PROJECT_REF_DEFINITION_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER PROJECT_REF_DEFINITION_TRIGGER
	BEFORE INSERT ON HM_PROJECT_REF_DEFINITION
    FOR EACH ROW
    BEGIN
        IF :NEW.PROJECTREFDEFINITIONID IS NULL THEN
            SELECT HM_PROJECT_REF_DEFINITION_SEQ.NEXTVAL INTO :NEW.PROJECTREFDEFINITIONID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ProjectTypeLevel1');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ProjectTypeLevel1
			(
				ProjectTypeID NUMBER NOT NULL,
				Level1ID VARCHAR2(100) NOT NULL
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ProjectLevel2');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ProjectLevel2
			(
				ProjectID NUMBER NOT NULL,
				Level2ID VARCHAR2(100) NOT NULL
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ProjectTicket');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ProjectTicket
			(
				ProjectTicketID NUMBER NOT NULL,
				ProjectID NUMBER NOT NULL,
				TicketID NUMBER NOT NULL,
				ProjectCosts NUMBER NULL,
				Level2ID VARCHAR2(100) NULL,
				Constraint PK_ProjectTicket Primary Key (ProjectTicketID)
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ProjectType');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ProjectType
			(
				ProjectTypeID NUMBER NOT NULL,
				TypeName VARCHAR2(255) NOT NULL,
				Description CLOB NULL,
				Active NUMBER(1) Default 1 NOT NULL,
				Level2ID VARCHAR2(100) NULL,
				Constraint PK_ProjectType Primary Key (ProjectTypeID)
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_PROJECT');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_PROJECT
			(
				ProjectID NUMBER NOT NULL,
				ProjectTypeID NUMBER NOT NULL,
				ProjectName VARCHAR2(255) NOT NULL,
				Description CLOB NULL,
				EmployeeID NUMBER NULL,
				CostCenterID NUMBER NULL,
				Active NUMBER(1) Default 0 NOT NULL,
				StartDate DATE NULL,
				EndDate DATE NULL,
				EstimatedBudget NUMBER NULL,
				UsedBudget NUMBER NULL,
				CreateUserID NUMBER NULL,
				CreateUser VARCHAR2(100) NULL,
				CreateDate DATE NULL,
				UpdateUserID NUMBER NULL,
				UpdateUser VARCHAR2(100) NULL,
				UpdateDate DATE NULL,
				ProjectFactor NUMBER NULL,
				Level1ID VARCHAR2(100) NULL,
                                invoiced_1 NUMBER NULL,
                                invoiced_2 NUMBER NULL,
                                invoiced_3 NUMBER NULL,
                                invoiced_4 NUMBER NULL,
                                invoiced_5 NUMBER NULL,
                                invoiced_6 NUMBER NULL,
                                invoiced_7 NUMBER NULL,
                                invoiced_8 NUMBER NULL,
                                invoiced_9 NUMBER NULL,
                                invoiced_10 NUMBER NULL,
                                invoiced_11 NUMBER NULL,
                                invoiced_12 NUMBER NULL,
                                deduction_1 NUMBER NULL,
                                deduction_2 NUMBER NULL,
                                deduction_3 NUMBER NULL,
                                deduction_4 NUMBER NULL,
				Constraint PK_Project Primary Key (ProjectID)
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ProjectType') AND UPPER(column_name) = UPPER('Level2ID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_ProjectType ADD Level2ID VARCHAR2(100) NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('ProjectFactor');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD ProjectFactor NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('Level1ID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD Level1ID VARCHAR2(100) NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ProjectTicket') AND UPPER(column_name) = UPPER('Level2ID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_ProjectTicket ADD Level2ID VARCHAR2(100) NULL');
	END IF;
END;

/


DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE UPPER(SEQUENCE_NAME) = UPPER('HM_PROJECTTICKET_SEQ') AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count > 0 THEN
		EXECUTE IMMEDIATE 'DROP SEQUENCE HM_PROJECTTICKET_SEQ';
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Trigger_name) INTO p_Count from user_triggers where UPPER(Trigger_name) = UPPER('HM_PROJECTTICKET_TRIGGER');

	IF(p_Count > 0) THEN
		EXECUTE IMMEDIATE ('DROP TRIGGER HM_PROJECTTICKET_TRIGGER');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Constraint_Name) INTO p_Count from user_constraints where UPPER(Constraint_name) = UPPER('PK_PROJECTTICKET');

	IF(p_Count > 0) THEN
		EXECUTE IMMEDIATE ('ALTER TABLE hm_ProjectTicket DROP CONSTRAINT PK_PROJECTTICKET');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ProjectTicket') AND UPPER(column_name) = UPPER('ProjectTicketID');
	IF(p_Count > 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_ProjectTicket DROP COLUMN ProjectTicketID');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Contacts') AND UPPER(column_name) = UPPER('ADguid');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Contacts ADD ADguid VARCHAR2(255) NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Report');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_Report
			(
				ReportID NUMBER NOT NULL,
				ReportName VARCHAR2(150) NOT NULL,
				ReportView VARCHAR2(200) NOT NULL,
				IsVisible NUMBER DEFAULT 0 NOT NULL,
			 	Constraint PK_Report Primary Key (ReportID)
			)');
	END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_REPORT_SEQ'  ;

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_REPORT_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_REPORT_TRIGGER
	BEFORE INSERT ON HM_REPORT
    FOR EACH ROW
    BEGIN
        IF :NEW.REPORTID IS NULL THEN
            SELECT HM_REPORT_SEQ.NEXTVAL INTO :NEW.REPORTID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ProcessingType');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ProcessingType
			(
				processingtype_id NUMBER NOT NULL,
				description VARCHAR2(50) NOT NULL,
				sort NUMBER NULL,
				created DATE NOT NULL,
				updated DATE NULL,
				published NUMBER Default 1 NOT NULL,
			 	Constraint PK_ProcessingType Primary Key (processingtype_id)
			)');
	END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_PROCESSINGTYPE_SEQ' ;

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_PROCESSINGTYPE_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_PROCESSINGTYPE_TRIGGER
	BEFORE INSERT ON HM_PROCESSINGTYPE
    FOR EACH ROW
    BEGIN
        IF :NEW.PROCESSINGTYPE_ID IS NULL THEN
            SELECT HM_PROCESSINGTYPE_SEQ.NEXTVAL INTO :NEW.PROCESSINGTYPE_ID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ProcessingType') AND UPPER(column_name) = UPPER('published');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_ProcessingType ADD published NUMBER Default 1 NOT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_AuthLDAP') AND UPPER(column_name) = UPPER('Ordering');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_AuthLDAP ADD Ordering NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketEvent') AND UPPER(column_name) = UPPER('Processingtype');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketEvent ADD Processingtype NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketEvent') AND UPPER(column_name) = UPPER('Deleted');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketEvent ADD Deleted NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFromEmail');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketFromEmail
                (
                	ID NUMBER NOT NULL,
                	TicketID NUMBER NOT NULL,
                	Active NUMBER NULL,
                	MessageID VARCHAR2(255) NOT NULL,
                	ImportStatus VARCHAR2(10) NOT NULL,
                	CreateDate DATE NULL,
                	CreateUserID NUMBER NULL,
                	Constraint PK_TicketFromEmail Primary Key (ID)
                )');
	END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_TICKETFROMEMAIL_SEQ' ;

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_TICKETFROMEMAIL_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_TICKETFROMEMAIL_TRIGGER
	BEFORE INSERT ON HM_TICKETFROMEMAIL
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_TICKETFROMEMAIL_SEQ.NEXTVAL INTO :NEW.ID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketTemplate') AND UPPER(column_name) = UPPER('MonthOfYear');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketTemplate ADD MonthOfYear NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticket') AND UPPER(column_name) = UPPER('EditDate');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticket ADD EditDate DATE NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketEvent') AND UPPER(column_name) = UPPER('EventDate');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketEvent ADD EventDate DATE NULL');
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_RIGHTSSECTION_TRIGGER
	BEFORE INSERT ON HM_RIGHTSSECTION
    FOR EACH ROW
    BEGIN
        IF :NEW.RIGHTSSECTIONID IS NULL THEN
            SELECT HM_RIGHTSSECTION_SEQ.NEXTVAL INTO :NEW.RIGHTSSECTIONID
            FROM dual;
        END IF;
    END;

/


CREATE OR REPLACE TRIGGER HM_RIGHTSSECTION_TRIGGER
	BEFORE INSERT ON HM_RIGHTSSECTION
    FOR EACH ROW
    BEGIN
        IF :NEW.RIGHTSSECTIONID IS NULL THEN
            SELECT HM_RIGHTSSECTION_SEQ.NEXTVAL INTO :NEW.RIGHTSSECTIONID
            FROM dual;
        END IF;
    END;

/
CREATE OR REPLACE TRIGGER HM_RIGHTS_TRIGGER
	BEFORE INSERT ON HM_RIGHTS
    FOR EACH ROW
    BEGIN
        IF :NEW.RIGHTID IS NULL THEN
            SELECT HM_RIGHTS_SEQ.NEXTVAL INTO :NEW.RIGHTID
            FROM dual;
        END IF;
    END;

/

DROP TRIGGER HM_RIGHTS_TRIGGER

/


DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 613;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (613, 'Event loeschen', 16, 4);
END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 612;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (612, 'Aufwand ndern', 16, 3);
END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 611;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (611, 'EventDate ndern', 16, 2);
END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 610;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (610, 'Beschreibung ndern', 16, 1);
END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 603;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (603, 'Event loeschen', 15, 4);
END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 602;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (602, 'Aufwand ndern', 15, 3);
END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 601;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (601, 'EventDate ndern', 15, 2);
END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 600;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (600, 'Beschreibung ndern', 15, 1);
END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 61;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (61, 'Gertereservierung bearbeiten', 11, 3);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 610;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 610);
END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 611;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 611);
END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 612;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 612);
END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 613;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 613);
END IF;
END;

/


DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 61;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 61);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Configuration');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_Configuration
                (
                	ConfigurationID NUMBER NOT NULL ,
                	ConfigurationName VARCHAR2(255) NULL ,
                	Configuration CLOB NULL,
                	Constraint PK_Configuration Primary Key (ConfigurationID)
                )');
	END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_CONFIGURATION_SEQ' ;

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_CONFIGURATION_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_CONFIGURATION_TRIGGER
	BEFORE INSERT ON HM_CONFIGURATION
    FOR EACH ROW
    BEGIN
        IF :NEW.CONFIGURATIONID IS NULL THEN
            SELECT HM_CONFIGURATION_SEQ.NEXTVAL INTO :NEW.CONFIGURATIONID
            FROM dual;
        END IF;
    END;


/


DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Configuration WHERE ConfigurationName = 'selectableLists' AND Configuration IS NOT NULL;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Configuration (ConfigurationName, Configuration) VALUES ('selectableLists', 'a:1:{s:10:"Ticketlist";a:3:{s:7:"Columns";s:23:"0,1,2,3,4,5,6,7,9,12,13";s:5:"Sort1";a:2:{s:6:"Column";i:9;s:9:"Direction";i:0;}s:5:"Sort2";a:2:{s:6:"Column";N;s:9:"Direction";i:0;}}}');
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 410;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 410);
END IF;
END;


/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 411;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 411);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 410;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (410, 'Standardeinstellung Liste ndern', 13, 4);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 411;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (411, 'Benutzereinstellung Liste ndern', 13, 5);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Ticket WHERE EditDate IS NULL;
	IF(p_Count > 0) THEN
        UPDATE hm_Ticket SET EditDate = CreateDate WHERE EditDate IS NULL;
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Ticketevent WHERE EventDate IS NULL;
	IF(p_Count > 0) THEN
        UPDATE hm_Ticketevent SET EventDate = CreateDate WHERE EventDate IS NULL;
END IF;
END;

/


DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 110;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (110, 'Status erledigt setzen', 2, 24);
END IF;
END;

/


DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 111;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (111, 'Nur Erledigte schlieen', 2, 25);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 112;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (112, 'Erledigte Tickets bearbeiten', 2, 26);
END IF;
END;


/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 110;
	IF(p_Count = 0) THEN
				INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 110);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 112;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 112);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Contacts') AND UPPER(column_name) = UPPER('building');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Contacts ADD building Varchar2(50) NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Contacts') AND UPPER(column_name) = UPPER('room');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Contacts ADD room Varchar2(50) NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Contacts') AND UPPER(column_name) = UPPER('floor');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Contacts ADD floor Varchar2(50) NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilter') AND UPPER(column_name) = UPPER('CategoryID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketFilter ADD CategoryID NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilter') AND UPPER(column_name) = UPPER('TicketID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketFilter ADD TicketID NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilter') AND UPPER(column_name) = UPPER('GroupID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketFilter ADD GroupID NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 17;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (17, 'E-Mail an Kontakt anpassen', 2, 0);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Categories') AND UPPER(column_name) = UPPER('inCalendar');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Categories ADD inCalendar NUMBER DEFAULT 1 NOT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Categories') AND UPPER(column_name) = UPPER('NeedDevice');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Categories ADD NeedDevice NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Users') AND UPPER(column_name) = UPPER('changePW');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Users ADD changePW NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Users') AND UPPER(column_name) = UPPER('remfilters');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Users ADD remfilters NUMBER Default 1 NOT NULL');
	END IF;
END;

/
UPDATE hm_Contacts SET company = NULL WHERE company = ''
/
UPDATE hm_Ticket SET OnHold = NULL WHERE TicketStatusID = 3 AND OnHold IS NOT NULL
/
UPDATE hm_Ticket SET TicketStatusID = 8 WHERE ((SYSDATE - hm_Ticket.OnHold) > 0)
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 58;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (58, 'Nur Tickets der eigenen Firma anzeigen', 5, 2);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('HelpdeskCost');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE HelpdeskCost
                (
                	HelpdeskCostID NUMBER NOT NULL,
                	DateService DATE NOT NULL,
                	TicketNumber NUMBER NOT NULL,
                	Description VARCHAR2(255) NOT NULL,
                	CostCenter VARCHAR2(10) NULL,
                	Note VARCHAR2(300) NULL,
                	UnitCost NUMBER NOT NULL,
                	Amount NUMBER NOT NULL,
                	TotalCost NUMBER NOT NULL,
                	DomainName VARCHAR2(50) NULL,
                	HostName VARCHAR2(50) NULL,
                	Status NUMBER NOT NULL,
                	CreateDate DATE NOT NULL,
                	IsDeleted NUMBER NOT NULL,
                	DateProcessed DATE NULL,
                	EmployeeID NUMBER NULL,
                	ProcessRemark VARCHAR2(100) NULL,
                	DateDeleted DATE NULL,
                	TicketEventID NUMBER NULL,
                	CostGroupID NUMBER 0,
                        DeviceID NUMBER NULL,
                    Cat1IDForCostGroup NUMBER NULL,
                	Constraint PK_HelpdeskCost Primary Key (HelpdeskCostID)
                )');
	END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HELPDESKCOST_SEQ';
	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HELPDESKCOST_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HELPDESKCOST_TRIGGER
	BEFORE INSERT ON HELPDESKCOST
    FOR EACH ROW
    BEGIN
        IF :NEW.HELPDESKCOSTID IS NULL THEN
            SELECT HELPDESKCOST_SEQ.NEXTVAL INTO :NEW.HELPDESKCOSTID
            FROM dual;
        END IF;
    END;

/

UPDATE hm_ContactToEmployee SET published = 0 WHERE contactid in (
	SELECT contact_id from hm_Contacts WHERE published <> 1
)

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TimePeriod');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TimePeriod
                (
                	ID NUMBER NOT NULL,
                	Name VARCHAR2(30) NOT NULL,
                	start_date NUMBER NULL,
                	start_months NUMBER NULL,
                	start_weeks NUMBER NULL,
                	start_days NUMBER  NULL,
                	end_months NUMBER  NULL,
                	end_weeks NUMBER NULL,
                	end_days NUMBER  NULL,
                	published NUMBER NULL,
                	Constraint PK_TimePeriod Primary Key (ID)
                )');
	END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_TIMEPERIOD_SEQ';
	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_TIMEPERIOD_SEQ MINVALUE 1 START WITH 5 INCREMENT BY 1';
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Categories') AND UPPER(column_name) = UPPER('desiretime_minutes');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Categories ADD desiretime_minutes NUMBER DEFAULT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Categories') AND UPPER(column_name) = UPPER('desiretime_hours');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Categories ADD desiretime_hours NUMBER DEFAULT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Categories') AND UPPER(column_name) = UPPER('desiretime_days');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Categories ADD desiretime_days NUMBER DEFAULT NULL');
	END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Categories') AND UPPER(column_name) = UPPER('EscalationFirstHintSendMail');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Categories ADD EscalationFirstHintSendMail NUMBER DEFAULT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Categories') AND UPPER(column_name) = UPPER('EscalationSecondHintSendMail');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Categories ADD EscalationSecondHintSendMail NUMBER DEFAULT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Categories') AND UPPER(column_name) = UPPER('EscalationThirdHintSendMail');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Categories ADD EscalationThirdHintSendMail NUMBER DEFAULT NULL');
	END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilter') AND UPPER(column_name) = UPPER('Category2ID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketFilter ADD Category2ID NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilter') AND UPPER(column_name) = UPPER('TicketBasket');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketFilter ADD TicketBasket NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketBasket');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketBasket
                (
    	           UserID NUMBER NOT NULL,
    	           TicketID NUMBER NOT NULL,
    	           Constraint PK_TicketBasket Primary Key (UserID, TicketID)
                )'
            );
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CategoryForms');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_CategoryForms
			(
				FormID NUMBER NOT NULL,
				TableName VARCHAR2(100) NOT NULL,
				FormName VARCHAR2(100) NOT NULL,
				CategoryID NUMBER NOT NULL,
				Published NUMBER NOT NULL,
				FormData CLOB NULL,
				Deleted NUMBER NOT NULL,
				CreateDate DATE NULL,
				CreateUserID NUMBER NULL,
				UpdateDate DATE NULL,
				UpdateUserID NUMBER NULL,
                                SequenceName VARCHAR2(100) NULL,
                                TriggerName VARCHAR2(100) NULL,
			 	Constraint PK_CategoryForms Primary Key (FormID)
			)');
	END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE UPPER(SEQUENCE_NAME) = 'HM_CATEGORYFORMS_SEQ';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_CATEGORYFORMS_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_CATEGORYFORMS_TRIGGER
	BEFORE INSERT ON HM_CATEGORYFORMS
    FOR EACH ROW
    BEGIN
        IF :NEW.FORMID IS NULL THEN
            SELECT HM_CATEGORYFORMS_SEQ.NEXTVAL INTO :NEW.FORMID
            FROM dual;
        END IF;
    END;

/



CREATE OR REPLACE TRIGGER HM_RIGHTSSECTION_TRIGGER
	BEFORE INSERT ON HM_RIGHTSSECTION
    FOR EACH ROW
    BEGIN
        IF :NEW.RIGHTSSECTIONID IS NULL THEN
            SELECT HM_RIGHTSSECTION_SEQ.NEXTVAL INTO :NEW.RIGHTSSECTIONID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilter') AND UPPER(column_name) = UPPER('NoOnHold');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketFilter ADD NoOnHold NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('Hm_TicketFromEMail') AND UPPER(column_name) = UPPER('Active')  AND NULLABLE = 'N';
	IF(p_Count > 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE Hm_TicketFromEMail MODIFY Active NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticket') AND UPPER(column_name) = UPPER('InventoryNumber');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticket ADD InventoryNumber VARCHAR2 (50) NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Categories') AND UPPER(column_name) = UPPER('Prio');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Categories ADD Prio NUMBER DEFAULT 0 NOT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_AuthLDAP') AND UPPER(column_name) = UPPER('Filter');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_AuthLDAP ADD Filter VARCHAR2(300) NULL');
	END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 113;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (113, 'Bearbeitungsart anzeigen', 2, 9);
END IF;
END;

/


DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 113;
	IF(p_Count = 0) THEN
				INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 113);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_GroupLDAPGroup');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_GroupLDAPGroup
    (
    	GroupID NUMBER NOT NULL,
    	LDAPGroupDN VARCHAR2(500) NOT NULL,
    	Server VARCHAR2(500) NOT NULL,
    	Constraint PK_GroupLDAPGroup Primary Key (GroupID, Server)
    )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 62;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (62, 'Gertesuche (Active Directory)', 2, 2);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 62;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 62);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_LDAPDevices');
	IF(p_Count = 0) THEN
	   EXECUTE IMMEDIATE ('CREATE TABLE hm_LDAPDevices
    (
    	DeviceID NUMBER NOT NULL,
    	Name VARCHAR2(100) NOT NULL,
    	location VARCHAR2(100) NULL,
    	descr VARCHAR2(1000) NULL,
    	OS VARCHAR2(100) NULL,
    	Type VARCHAR2(100) NULL,
    	objectguid VARCHAR2(100) NOT NULL,
    	dn VARCHAR2(200) NULL,
    	Constraint PK_LDAPDevice Primary Key (DeviceID)
    )');
	END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_LDAPDEVICES_SEQ' AND UPPER(SEQUENCE_OWNER) = '';
	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_LDAPDEVICES_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_LDAPDEVICES_TRIGGER
	BEFORE INSERT ON HM_LDAPDEVICES
    FOR EACH ROW
    BEGIN
        IF :NEW.DeviceID IS NULL THEN
            SELECT HM_LDAPDEVICES_SEQ.NEXTVAL INTO :NEW.DeviceID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketLDAPDevice');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketLDAPDevice
    (
    	TicketID NUMBER  NULL,
        DeviceID NUMBER NOT NULL,
        SessionID VARCHAR2(64) NULL
    )');
	END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 522;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (522, 'Prioritt anzeigen', 2, 8);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 522;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 522);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 521;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (521, 'Flligkeitstermin anzeigen', 2, 8);
END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 521;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 521);
END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 524;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (524, 'Aufwand anzeigen', 2, 8);
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 524;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 524);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilter') AND UPPER(column_name) = UPPER('SupporterID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketFilter ADD SupporterID NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WF_Activity');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_WF_Activity
            (
            	ActivityID NUMBER NOT NULL,
            	WFIID NUMBER NOT NULL,
            	DefActivityID NUMBER NOT NULL,
            	TicketID NUMBER NULL,
            	DescriptionName VARCHAR2(100) NULL,
            	InitiatorID NUMBER NOT NULL,
            	GroupID NUMBER NULL,
            	Duration FLOAT NULL,
            	ShowOtherInformations NUMBER NULL,
            	TicketStatusID NUMBER NOT NULL,
            	NotificationType NUMBER NULL,
            	TaskType NUMBER NULL,
            	TaskText VARCHAR2(500) NULL,
            	Description VARCHAR2(100) NULL,
            	Expense NUMBER NULL,
            	TargetType NUMBER NULL,
            	TargetUserID NUMBER NULL,
            	TargetGroupID NUMBER NULL,
            	NotificationUserID NUMBER NULL,
            	NotificationGroupID NUMBER NULL,
            	TaskFormName VARCHAR2(50) NULL,
            	StartConID NUMBER NULL,
            	Starttime FLOAT NULL,
            	uniqID VARCHAR2(32) NULL,
            	FormData CLOB NULL,
            	Form CLOB NULL,
            	DesireTime FLOAT NULL,
            	showTicket NUMBER NULL,
            	Constraint PK_WF_Activity Primary Key (ActivityID)
            )');
	END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_WF_ACTIVITY_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_WF_ACTIVITY_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_WF_ACTIVITY_TRIGGER
	BEFORE INSERT ON HM_WF_ACTIVITY
    FOR EACH ROW
    BEGIN
        IF :NEW.ActivityID IS NULL THEN
            SELECT HM_WF_ACTIVITY_SEQ.NEXTVAL INTO :NEW.ActivityID
            FROM dual;
        END IF;
    END;

/


DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WFDef_Activity');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_WFDef_Activity
            (
            	ID NUMBER NOT NULL,
            	WFDID NUMBER NULL,
            	SessionID VARCHAR2(60) NULL,
            	Description VARCHAR2(100) NOT NULL,
            	TargetType NUMBER NULL,
            	TargetUserID NUMBER NULL,
            	TargetGroupID NUMBER NULL,
            	Duration FLOAT NOT NULL,
            	ShowPrevInformations NUMBER NULL,
            	NotificationType NUMBER NULL,
            	NotificationUserID NUMBER NULL,
            	NotificationGroupID NUMBER NULL,
            	TaskType NUMBER NOT NULL,
            	TaskText VARCHAR2(500) NULL,
            	TaskFormName VARCHAR2(50) NULL,
            	DesireTime FLOAT NULL,
            	StartConID NUMBER NULL,
            	Starttime FLOAT NULL,
            	uniqID VARCHAR2 (32) NULL,
            	Form CLOB NULL,
                CONSTRAINT PK_WFDef_Activity Primary Key (ID)
            )');
	END IF;
END;



/


DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_WFDEF_ACTIVITY_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_WFDEF_ACTIVITY_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_WFDEF_ACTIVITY_TRIGGER
	BEFORE INSERT ON HM_WFDEF_ACTIVITY
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_WFDEF_ACTIVITY_SEQ.NEXTVAL INTO :NEW.ID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WFDef_DependedActivitys');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_WFDef_DependedActivitys
            (
            	ActivityID NUMBER NOT NULL,
            	DependActivityID NUMBER NOT NULL
        	)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WFDefinitions');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_WFDefinitions
            (
            	ID NUMBER NOT NULL,
            	Description VARCHAR2(100) NOT NULL,
            	groups NUMBER NULL,
            	deleted NUMBER NULL,
            	published NUMBER NULL,
            	uniqID VARCHAR2(32) NULL,
            	Constraint PK_WFDefinitions Primary Key (ID)
            )');
	END IF;
END;



/


DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_WFDEFINITIONS_SEQ' AND UPPER(SEQUENCE_OWNER) = '';
	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_WFDEFINITIONS_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_WFDEFINITIONS_TRIGGER
	BEFORE INSERT ON HM_WFDEFINITIONS
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_WFDEFINITIONS_SEQ.NEXTVAL INTO :NEW.ID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WFInstanz');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_WFInstanz
            (
            	ID NUMBER NOT NULL,
            	WFDID NUMBER NULL,
            	Descr VARCHAR2(50) NOT NULL,
            	InitiatorID NUMBER NOT NULL,
            	SubstitudeID NUMBER NULL,
            	StartDate DATE NULL,
            	EndDate DATE NULL,
            	DateType NUMBER NOT NULL,
            	Active NUMBER NOT NULL,
            	CreateDate DATE NOT NULL,
            	uniqid VARCHAR2(32) NULL,
                Constraint PK_WFInstanz Primary Key (ID)
            )');
	END IF;
END;



/

DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_WFINSTANZ_SEQ' AND UPPER(SEQUENCE_OWNER) = '';
	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_WFINSTANZ_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_WFINSTANZ_TRIGGER
	BEFORE INSERT ON HM_WFINSTANZ
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_WFINSTANZ_SEQ.NEXTVAL INTO :NEW.ID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WFActive_DepActivities');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_WFActive_DepActivities
            (
            	AI_ID NUMBER NOT NULL,
            	DepAI_ID NUMBER NOT NULL
        	)');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_RightsSection WHERE UPPER(SectionName) = UPPER('Workflow');
	IF(p_Count = 0) THEN
            INSERT INTO hm_RightsSection (SectionName, SectionOrder)
            VALUES ('Workflow', 17);
END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 701;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (701, 'Alle Workflows anzeigen', 17, 0);
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 703;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (703, 'Workflows definieren', 17, 2);
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 704;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (704, 'Definitionen bearbeiten', 17, 4);
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 705;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (705, 'Workflows starten', 17, 6);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 701;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 701);
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 703;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 703);
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 704;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 704);
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 705;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 705);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 412;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (412, 'Kalender anzeigen', 13, 6);
END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 412;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 412);
END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 63;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (63, 'Nur Hauptkategorien anzeigen', 7, 4);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketTemplateGroups');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketTemplateGroups
    (
    	TicketTemplateID NUMBER NOT NULL,
    	GroupID NUMBER NOT NULL,
    	Constraint PK_TicketTemplateGroups Primary Key (TicketTemplateID, GroupID)
	)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Categories') AND UPPER(column_name) = UPPER('UseRootEscalation');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Categories ADD UseRootEscalation NUMBER DEFAULT 1 NOT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CategoryForms');
	IF(p_Count > 0 ) THEN
	DECLARE p_Count2 NUMBER;
	BEGIN
	   SELECT Count(Table_Name) INTO p_Count2 from user_tab_cols where UPPER(table_name) = UPPER('hm_CategoryForms') AND UPPER(column_name) = UPPER('Required');
        IF(p_Count2 = 0 ) THEN
            EXECUTE IMMEDIATE ('ALTER TABLE hm_CategoryForms ADD Required NUMBER NULL');
        END IF;
    END;
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Contacts') AND UPPER(column_name) = UPPER('sendEmails');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Contacts ADD sendEmails NUMBER DEFAULT 1 NOT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Contacts') AND UPPER(column_name) = UPPER('CostCenter');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Contacts ADD CostCenter VARCHAR2(255) NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 1005;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (1005, 'Kontaktliste anzeigen', 10, 6);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Contacts') AND UPPER(column_name) = UPPER('department');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Contacts ADD department VARCHAR2(255) NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticketfilter') AND UPPER(column_name) = UPPER('Config');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticketfilter ADD Config CLOB NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticket') AND UPPER(column_name) = UPPER('PrioAccepted');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticket ADD PrioAccepted NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticket') AND UPPER(column_name) = UPPER('SolutionDate');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticket ADD SolutionDate DATE NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 65;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (65, 'Nur Tickets der eigenen Abteilung anzeigen', 5, 8);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 114;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (114, 'Ticketexport per Mail', 2, 27);
END IF;
END;

/


DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CostRate');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_CostRate(
            	CostRateID NUMBER  NOT NULL,
            	CreateDate DATE NOT NULL,
            	CreateUserID NUMBER NULL,
            	CostRate FLOAT NOT NULL,
            	CostCurrencyID NUMBER NOT NULL,
            	CostEntityID NUMBER NOT NULL,
             Constraint PK_CostRate Primary Key (CostRateID)
             )');
	END IF;
END;

/
DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_COSTRATE_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_COSTRATE_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_COSTRATE_TRIGGER
	BEFORE INSERT ON HM_COSTRATE
    FOR EACH ROW
    BEGIN
        IF :NEW.CostRateID IS NULL THEN
            SELECT HM_WFINSTANZ_SEQ.NEXTVAL INTO :NEW.CostRateID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CostUsers');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_CostUsers(
            	UserID NUMBER NOT NULL,
            	CostGroupID NUMBER NOT NULL,
            	StartDate DATE NOT NULL
            )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CostCategories');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_CostCategories(
            	CategoryID NUMBER NOT NULL,
            	CostGroupID NUMBER NOT NULL,
            	StartDate DATE NOT NULL
            )');
	END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CostCurrency');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_CostCurrency(
            	CostCurrencyID NUMBER  NOT NULL,
            	Symbol VARCHAR2(10) NULL,
            	Name VARCHAR2(255) NOT NULL,
            	Shortname VARCHAR2(10) NULL,
             Constraint PK_CostCurrency Primary Key (CostCurrencyID)
             )');
	END IF;
END;

/
DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_COSTCURRENCY_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_COSTCURRENCY_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_COSTCURRENCY_TRIGGER
	BEFORE INSERT ON HM_COSTCURRENCY
    FOR EACH ROW
    BEGIN
        IF :NEW.CostCurrencyID IS NULL THEN
            SELECT HM_WFINSTANZ_SEQ.NEXTVAL INTO :NEW.CostCurrencyID
            FROM dual;
        END IF;
    END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CostDefault');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_CostDefault(
            	CostGroupID NUMBER NOT NULL,
            	StartDate DATE NOT NULL
            )');
	END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CostEntity');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_CostEntity(
            	CostEntityID NUMBER  NOT NULL,
            	Description VARCHAR2(100) NOT NULL,
            	PerMinute FLOAT NOT NULL,
             Constraint PK_CostEntity Primary Key (CostEntityID)
             )');
	END IF;
END;

/


DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_CostEntity WHERE Description = 'Stunde';
	IF(p_Count = 0) THEN
        INSERT INTO hm_CostEntity (CostEntityID,Description,PerMinute) VALUES (1, 'Stunde' ,0.0166666666666667);
END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_COSTENTITY_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_COSTENTITY_SEQ MINVALUE 1 START WITH 2 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_COSTENTITY_TRIGGER
	BEFORE INSERT ON HM_COSTENTITY
    FOR EACH ROW
    BEGIN
        IF :NEW.CostEntityID IS NULL THEN
            SELECT HM_WFINSTANZ_SEQ.NEXTVAL INTO :NEW.CostEntityID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_CostCurrency WHERE Name = 'Euro';
	IF(p_Count = 0) THEN
        INSERT INTO hm_CostCurrency (Symbol,Name,Shortname) VALUES ('&euro;', 'Euro', 'EUR');
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CostGroupRate');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_CostGroupRate(
            	CostGroupID NUMBER NOT NULL,
            	CostRateID NUMBER NOT NULL,
            	StartDate DATE NOT NULL
            )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CostGroup');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_CostGroup(
            	CostGroupID NUMBER  NOT NULL,
                Description VARCHAR2(100) NOT NULL,
            	Deleted NUMBER NULL,
             Constraint PK_CostGroup Primary Key (CostGroupID)
             )');
	END IF;
END;

/
DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_COSTGROUP_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_COSTGROUP_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_COSTGROUP_TRIGGER
	BEFORE INSERT ON HM_COSTGROUP
    FOR EACH ROW
    BEGIN
        IF :NEW.CostGroupID IS NULL THEN
            SELECT HM_COSTGROUP_SEQ.NEXTVAL INTO :NEW.CostGroupID
            FROM dual;
        END IF;
    END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketEvent') AND UPPER(column_name) = UPPER('CostGroupID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketEvent ADD CostGroupID NUMBER DEFAULT 0 NOT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketEvent') AND UPPER(column_name) = UPPER('CostRatePerMinute');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketEvent ADD CostRatePerMinute FLOAT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketEvent') AND UPPER(column_name) = UPPER('Cat1IDForCostGroup');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketEvent ADD Cat1IDForCostGroup NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketEvent') AND UPPER(column_name) = UPPER('ProjectCostRateSource');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketEvent ADD ProjectCostRateSource VARCHAR2(15) NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketEvent') AND UPPER(column_name) = UPPER('ProjectCostGroupID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketEvent ADD ProjectCostGroupID NUMBER DEFAULT 0 NOT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('HelpdeskCost') AND UPPER(column_name) = UPPER('TicketEventID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE HelpdeskCost ADD TicketEventID NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('HelpdeskCost') AND UPPER(column_name) = UPPER('DeviceID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE HelpdeskCost ADD DeviceID NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('HelpdeskCost') AND UPPER(column_name) = UPPER('CostGroupID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE HelpdeskCost ADD CostGroupID NUMBER DEFAULT 0 NOT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('HelpdeskCost') AND UPPER(column_name) = UPPER('Cat1IDForCostGroup');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE HelpdeskCost ADD Cat1IDForCostGroup NUMBER NULL');
	END IF;
END;


/


DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_MailToFromTicketEvent');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_MailToFromTicketEvent(
            	SendMailsForEventID NUMBER NOT NULL,
            	TicketEventID NUMBER NOT NULL,
            	eMail VARCHAR2(250) NOT NULL,
            	RealName VARCHAR2(250) NULL,
            	AddressSource VARCHAR2(10) NOT NULL,
            	Service VARCHAR2(10) NULL,
            Constraint PK_MailToFromTicketEvent Primary Key (SendMailsForEventID)
             )');
	END IF;
END;

/
DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_MAILTOFROMTICKETEVENT_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_MAILTOFROMTICKETEVENT_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_MAIL2TICKETEVENT_TRIGGER
	BEFORE INSERT ON HM_MAILTOFROMTICKETEVENT
    FOR EACH ROW
    BEGIN
        IF :NEW.SendMailsForEventID IS NULL THEN
            SELECT HM_MAILTOFROMTICKETEVENT_SEQ.NEXTVAL INTO :NEW.SendMailsForEventID
            FROM dual;
        END IF;
    END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_MailsSendTo');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_MailsSendTo(
            	MessageID NUMBER NOT NULL,
            	Recipient VARCHAR2(250) NULL,
            	Title VARCHAR2(500) NOT NULL,
            	TicketEventID NUMBER NOT NULL,
            	SentTo VARCHAR2(50) NOT NULL,
            	CreateDate DATE NOT NULL,
             Constraint PK_MailsSendTo Primary Key (MessageID)
             )');
	END IF;
END;

/
DECLARE row_count NUMBER;
BEGIN
	SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_MAILSSENDTO_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_MAILSSENDTO_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_MAILSSENDTO_TRIGGER
	BEFORE INSERT ON HM_MAILSSENDTO
    FOR EACH ROW
    BEGIN
        IF :NEW.MessageID IS NULL THEN
            SELECT HM_MAILSSENDTO_SEQ.NEXTVAL INTO :NEW.MessageID
            FROM dual;
        END IF;
    END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_MailRecipientsForEvent');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_MailRecipientsForEvent(
            	RecipientID NUMBER NOT NULL,
            	TicketEventID NUMBER NOT NULL,
            	eMail VARCHAR2(250) NOT NULL,
            	RealName VARCHAR2(250) NULL,
            	RecipientType VARCHAR2(10) NOT NULL,
             Constraint PK_MailRecipientsForEvent Primary Key (RecipientID)
             )');
	END IF;
END;

/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_MAILRECIPIENTSFOREVENT_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_MAILRECIPIENTSFOREVENT_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_MAILRECI4EVENT_TRIGGER
	BEFORE INSERT ON HM_MAILRECIPIENTSFOREVENT
    FOR EACH ROW
    BEGIN
        IF :NEW.RecipientID IS NULL THEN
            SELECT HM_MAILRECIPIENTSFOREVENT_SEQ.NEXTVAL INTO :NEW.RecipientID
            FROM dual;
        END IF;
    END;
/

UPDATE hm_TicketEvent SET CostGroupID = 0 WHERE CostGroupID IS NULL

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 115;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (115, 'Inventarnummer ndern', 2, 28);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 116;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (116, 'Tickets nicht schlieen', 2, 26);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticket') AND UPPER(column_name) = UPPER('KaufbInventoryNumber');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticket ADD KaufbInventoryNumber NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilter') AND UPPER(column_name) = UPPER('CreateUserID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketFilter ADD CreateUserID NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilter') AND UPPER(column_name) = UPPER('UpdateUserID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketFilter ADD UpdateUserID NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketTemplate') AND UPPER(column_name) = UPPER('ContactID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketTemplate ADD ContactID NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilter') AND UPPER(column_name) = UPPER('WorkOnDateStart');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketFilter ADD WorkOnDateStart DATE NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilter') AND UPPER(column_name) = UPPER('WorkOnDateEnd');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketFilter ADD WorkOnDateEnd DATE NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilter') AND UPPER(column_name) = UPPER('WorkOnDatePeriod');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketFilter ADD WorkOnDatePeriod NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 210;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (210, 'Tickets kopieren', 2, 28);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 210;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 210);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketReferences');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketReferences(
            	TicketID NUMBER NOT NULL,
            	ConnectedTicketID NUMBER NOT NULL,
            	OnHoldFlag NUMBER NULL,
             Constraint PK_TicketReferences Primary Key (TicketID, ConnectedTicketID)
             )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 211;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (211, 'Tickets verknpfen', 2, 29);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 211;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 211);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_MailAccounts');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_MailAccounts(
            	MailAccountID NUMBER NOT NULL,
            	MailServer VARCHAR2(300) NOT NULL,
            	MailUser VARCHAR2(300) NOT NULL,
            	MailPassword VARCHAR2(300) NOT NULL,
            	CategoryID NUMBER NULL,
            	ContactID NUMBER NULL,
            	SupporterID NUMBER NULL,
            	GroupID NUMBER NULL,
            	Active NUMBER NULL,
            	LeaveMessages NUMBER NULL,
             Constraint PK_MailAccounts Primary Key (MailAccountID)
             )');
	END IF;
END;

/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_MAILACCOUNTS_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_MAILACCOUNTS_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_MAILACCOUNTS_TRIGGER
	BEFORE INSERT ON HM_MAILACCOUNTS
    FOR EACH ROW
    BEGIN
        IF :NEW.MailAccountID IS NULL THEN
            SELECT HM_MAILACCOUNTS_SEQ.NEXTVAL INTO :NEW.MailAccountID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_MailTicketxContacts');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_MailTicketxContacts(
            	contact_id NUMBER NOT NULL,
            	user_id  NUMBER NOT NULL,
            	LastUseDate DATE NOT NULL,
            	CountUses NUMBER NOT NULL,
             Constraint PK_MailTicketxContacts Primary Key (contact_id, user_id)
             )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Contacts') AND UPPER(column_name) = UPPER('eMailTicketAddress');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Contacts ADD eMailTicketAddress NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketRequiredAction');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketRequiredAction(
            	TicketID NUMBER NOT NULL,
            	TicketEventID  NUMBER NOT NULL,
             Constraint PK_TicketRequiredAction Primary Key (TicketID, TicketEventID)
             )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Groups') AND UPPER(column_name) = UPPER('SupportGroup');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Groups ADD SupportGroup NUMBER NULL');
	END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CategoryMailSender');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_CategoryMailSender(
            	MailaddressID NUMBER NOT NULL,
            	MailAddress  VARCHAR2(500) NOT NULL,
            	CategoryID NUMBER NOT NULL,
            	UpdateDate DATE NULL,
            	AddressOrSubject NUMBER NOT NULL,
             Constraint PK_CategoryMailSender Primary Key (MailaddressID)
             )');
	END IF;
END;

/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_CATEGORYMAILSENDER_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_CATEGORYMAILSENDER_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_CATEGORYMAILSENDER_TRIGGER
	BEFORE INSERT ON HM_CATEGORYMAILSENDER
    FOR EACH ROW
    BEGIN
        IF :NEW.MailaddressID IS NULL THEN
            SELECT HM_CATEGORYMAILSENDER_SEQ.NEXTVAL INTO :NEW.MailaddressID
            FROM dual;
        END IF;
    END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_SubjectFilters');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_SubjectFilters(
            	ID NUMBER NOT NULL,
            	SubjectFilter  VARCHAR2(500) NOT NULL,
            	Active NUMBER NULL,
             Constraint PK_SubjectFilters Primary Key (ID)
             )');
	END IF;
END;

/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_SUBJECTFILTERS_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_SUBJECTFILTERS_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_SUBJECTFILTERS_TRIGGER
	BEFORE INSERT ON HM_SUBJECTFILTERS
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_SUBJECTFILTERS_SEQ.NEXTVAL INTO :NEW.ID
            FROM dual;
        END IF;
    END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WF_Activity') AND UPPER(column_name) = UPPER('showTicket');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_WF_Activity ADD showTicket NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 810;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (810, 'Formulare bearbeiten', 8, 3);
    END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CategoryForms') AND UPPER(column_name) = UPPER('TicketTemplateID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_CategoryForms ADD TicketTemplateID NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketTemplate') AND UPPER(column_name) = UPPER('RepeatDays');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketTemplate ADD RepeatDays NUMBER NULL');
	END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketTemplate') AND UPPER(column_name) = UPPER('LastCreation');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketTemplate ADD LastCreation DATE NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketForm');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketForm(
            	TicketID NUMBER NOT NULL,
            	FormID  NUMBER NOT NULL,
             Constraint PK_TicketForm Primary Key (TicketID, FormID)
             )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticket') AND UPPER(column_name) = UPPER('anonymous');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticket ADD anonymous NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ServicesData');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ServicesData
			(
                ServiceType VARCHAR2(10) NULL,
				StartDate DATE NULL,
				Version VARCHAR2(10) NULL,
				PathToService VARCHAR2(200) NULL,
                ServiceActive NUMBER NULL
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketTemplate') AND UPPER(column_name) = UPPER('OnetimePoint');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketTemplate ADD OnetimePoint DATE NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_SLADataCache');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_SLADataCache
			(
            	SLAID NUMBER NOT NULL,
            	Tickets NUMBER NOT NULL,
            	inTime NUMBER NULL,
            	outTime NUMBER NULL,
            	inTimePercent FLOAT NULL,
            	outTimePercent FLOAT NULL,
            	CacheTimestamp NUMBER NULL,
            	StartDate DATE NULL,
            	EndDate DATE NULL,
            	Constraint PK_SLADataCache Primary Key (SLAID)
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_SLADefinition');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_SLADefinition
			(
            	ID NUMBER NOT NULL,
            	Description VARCHAR2(100) NOT NULL,
            	SLAObjectTable VARCHAR2(50) NOT NULL,
            	SLAObjectField VARCHAR2(50) NOT NULL,
            	SLAObjectID NUMBER NOT NULL,
            	TimeType NUMBER NOT NULL,
            	ValidRangeBegin DATE NULL,
            	TargetStatus NUMBER NULL,
            	SLATime NUMBER NULL,
            	Active NUMBER NULL,
            	UpdateDate DATE NULL,
            	UpdateUserID NUMBER NULL,
            	CreateDate DATE NULL,
            	CreateUserID NUMBER NULL,
            	Constraint PK_SLADefinition Primary Key (ID)
			)');
	END IF;
END;

/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_SLADEFINITION_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_SLADEFINITION_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_SLADEFINITION_TRIGGER
	BEFORE INSERT ON HM_SLADEFINITION
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_SLADEFINITION_SEQ.NEXTVAL INTO :NEW.ID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_SLATimeTicket');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_SLATimeTicket
			(
            	TicketID NUMBER NOT NULL,
            	SLAID NUMBER NOT NULL,
            	EndDate DATE NULL,
            	StartDate DATE NULL,
            	CacheMinutes NUMBER NULL,
                isOutTime NUMBER NULL,
            	Constraint PK_SLATimeTicket Primary Key (TicketID, SLAID)
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketOnHoldStartStop');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketOnHoldStartStop
			(
            	OnHoldID NUMBER NOT NULL,
            	TicketID NUMBER NOT NULL,
            	OnHoldStart DATE NOT NULL,
            	OnHoldStop DATE NULL,
            	Constraint PK_TicketOnHoldStartStop Primary Key (OnHoldID, TicketID)
			)');
	END IF;
END;

/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_TICKETONHOLDSS_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_TICKETONHOLDSS_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;
/
CREATE OR REPLACE TRIGGER HM_TICKETONHOLDSS_TRIGGER
	BEFORE INSERT ON HM_TICKETONHOLDSTARTSTOP
    FOR EACH ROW
    BEGIN
        IF :NEW.OnHoldID IS NULL THEN
            SELECT HM_TICKETONHOLDSS_SEQ.NEXTVAL INTO :NEW.OnHoldID
            FROM dual;
        END IF;
    END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 302;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder) VALUES (302, 'SLA-Reports anzeigen', 3, 5);
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 303;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder) VALUES (303, 'SLAs bearbeiten', 3, 5);
	END IF;
END;

/


DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Company');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_Company
			(
            	CompanyID NUMBER NOT NULL,
            	company VARCHAR2(100) NULL,
            	Deleted NUMBER NULL,
            	Constraint PK_Company Primary Key (CompanyID)
			)');
	END IF;
END;

/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_COMPANY_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_COMPANY_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_COMPANY_TRIGGER
	BEFORE INSERT ON HM_COMPANY
    FOR EACH ROW
    BEGIN
        IF :NEW.CompanyID IS NULL THEN
            SELECT HM_COMPANY_SEQ.NEXTVAL INTO :NEW.CompanyID
            FROM dual;
        END IF;
    END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Contacts') AND UPPER(column_name) = UPPER('CompanyID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Contacts ADD CompanyID NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 215;
	IF(p_Count = 0) THEN
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (215, 'Gruppe ndern', 2, 1);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 216;
	IF(p_Count = 0) THEN
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (216, 'Supporter ndern', 2, 1);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 217;
	IF(p_Count = 0) THEN
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (217, 'Gruppe ist Pflichtfeld', 1, 2);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 218;
	IF(p_Count = 0) THEN
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (218, 'Supporter ist Pflichtfeld', 1, 2);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 66;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (66, '+ Tickets der eigenen Abteilung', 5, 10);
END IF;
END;

/




DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_SLATimeCache');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_SLATimeCache
			(
            	StartDate DATE NOT NULL,
            	EndDate DATE NOT NULL,
            	Minutes NUMBER NOT NULL,
            	Constraint PK_SLATimeCache Primary Key (StartDate, EndDate)
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketEvent') AND UPPER(column_name) = UPPER('IFrameID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketEvent ADD IFrameID VARCHAR2(13) NULL');
	END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketListCache');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketListCache
            (
            	UserID NUMBER NOT NULL,
            	Timestamp NUMBER NOT NULL,
            	HashValue VARCHAR2(32) NOT NULL,
            	TicketIDs CLOB NULL,
            	Part	NUMBER	NOT NULL,
            	Constraint PK_TicketListCache Primary Key (UserID, Timestamp, HashValue, Part)
            )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CRAttachment');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_CRAttachment
            (
            	AttachmentID NUMBER NOT NULL,
            	CRID NUMBER NOT NULL,
            	Constraint PK_CRAttachment Primary Key (AttachmentID, CRID)
            )');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Categories') AND UPPER(column_name) = UPPER('NeedDevice');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Categories ADD NeedDevice NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 59;
	IF(p_Count = 0) THEN
		INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
		VALUES (59, 'Geschlossene Tickets nicht anzeigen', 5, 10);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 67;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (67, 'Nur Tickets von Kontakten aus eigenen Gruppen', 5, 4);
END IF;
END;


/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count FROM hm_Rights WHERE RightID = 26 AND RightName = 'Alle Tickets bearbeiten (Supporter)';
	IF(p_Count = 0) THEN
        UPDATE hm_Rights SET RightsOrder =  RightsOrder + 2 WHERE RightsSectionID = 1;
        UPDATE hm_Rights SET RightsOrder = 0 WHERE RightID = 1;

        UPDATE hm_Rights SET RightsSectionID = 2 WHERE RightID = 51;
        UPDATE hm_Rights SET RightsOrder =  RightsOrder + 3 WHERE RightsSectionID = 2;
        UPDATE hm_Rights SET RightsOrder = 0 WHERE RightID = 26;
        UPDATE hm_Rights SET RightsOrder = 1 WHERE RightID IN (17, 16);
        UPDATE hm_Rights SET RightsOrder = 2 WHERE RightID IN (45, 13, 62);

        UPDATE hm_Rights SET RightName = 'Alle Tickets bearbeiten (Supporter)' WHERE RightID = 26;

        UPDATE hm_RightsSection SET SectionName = 'Eigene Bearbeitungen' WHERE RightsSectionID = 15;
        UPDATE hm_RightsSection SET SectionName = 'Alle Bearbeitungen' WHERE RightsSectionID = 16;

        UPDATE hm_Rights SET RightName = '+ Tickets der Gruppe(n)' WHERE RightID = 55;
        UPDATE hm_Rights SET RightName = '+ unkategorisierte Tickets' WHERE RightID = 101;
        UPDATE hm_Rights SET RightName = '+ Tickets der eigenen Firma' WHERE RightID = 56;
        UPDATE hm_Rights Set RightName = '+ Tickets der eigenen Abteilung' WHERE RightID = 66;

        UPDATE hm_Rights Set RightsOrder = 10 WHERE RightsSectionID = 5;
        UPDATE hm_Rights Set RightsOrder = 1 WHERE RightID = 50;
        UPDATE hm_Rights Set RightsOrder = 2 WHERE RightID = 58;
        UPDATE hm_Rights Set RightsOrder = 3 WHERE RightID = 65;
        UPDATE hm_Rights Set RightsOrder = 4 WHERE RightID = 67;
        UPDATE hm_Rights Set RightsOrder = 5 WHERE RightID = 29;
        UPDATE hm_Rights Set RightsOrder = 6 WHERE RightID = 28;
        UPDATE hm_Rights Set RightsOrder = 11 WHERE RightID = 59;
    END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Tags');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_Tags
			(
				ID NUMBER NOT NULL,
				Tag VARCHAR2(100) NOT NULL,
                Constraint PK_Tags Primary Key (ID, Tag)
			)');
	END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_TAGS_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_TAGS_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_TAGS_TRIGGER
	BEFORE INSERT ON HM_TAGS
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_TAGS_SEQ.NEXTVAL INTO :NEW.ID
            FROM dual;
        END IF;
    END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketTags');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketTags
			(
				TicketID NUMBER NOT NULL,
				TagID NUMBER NOT NULL,
				Constraint PK_TicketTags Primary Key (TicketID, TagID)
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 219;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (219, 'Schlagworte anzeigen', 2, 39);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 220;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (220, 'Schlagworte verwalten', 2, 40);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 221;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (221, 'Tickets archivieren', 2, 0);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 221;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 221);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticket') AND UPPER(column_name) = UPPER('archived');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticket ADD archived NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticket') AND UPPER(column_name) = UPPER('archivdate');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticket ADD archivdate DATE NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticket') AND UPPER(column_name) = UPPER('archivuserid');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticket ADD archivuserid NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 16;
	IF(p_Count = 0) THEN
		DELETE FROM hm_GroupRights WHERE Group_ID = 1 AND Right_ID = 16;
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 17;
	IF(p_Count = 0) THEN
		DELETE FROM hm_GroupRights WHERE Group_ID = 1 AND Right_ID = 17;
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 304;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (304, 'ChangeRequests anzeigen', 12, 5);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 304;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 304);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Tags');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_Tags
			(
                            CSSDefinition varchar2(300) NOT NULL,
                            CSSValue varchar2(4500) NOT NULL,
                            CreateDate DATE DEFAULT NULL,
                            Active NUMBER DEFAULT 1 ,
                            ID NUMBER NOT NULL,
                            Tag VARCHAR2(100) NOT NULL,
                            Constraint PK_Tags Primary Key (ID, Tag)
			)');
	END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_TAGS_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_TAGS_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_TAGS_TRIGGER
	BEFORE INSERT ON HM_TAGS
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_TAGS_SEQ.NEXTVAL INTO :NEW.ID
            FROM dual;
        END IF;
    END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Styles');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_Styles
			(
                            CSSDefinition VARCHAR2(300) NOT NULL,
                            CSSValue VARCHAR2(4000) NOT NULL,
                            CreateDate DATE DEFAULT SYSDATE NOT NULL,
                            Active NUMBER DEFAULT 1 ,
				Constraint PK_Styles Primary Key (CSSDefinition)
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_MailTemplates');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_MailTemplates
			(
                            MailType  VARCHAR2(300) NOT NULL,
                            Subject  VARCHAR2(300) NULL,
                            Content CLOB NULL,
                            CreateDate DATE DEFAULT SYSDATE NOT NULL,
                            Active NUMBER DEFAULT 1 ,
				Constraint PK_MailTemplates Primary Key (MailType)
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Messages');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_Messages
			(
                            ID  NUMBER NOT NULL,
                            Message  VARCHAR2(1000) NULL,
                            CreateDate DATE DEFAULT NULL,
                            Active NUMBER DEFAULT 1 ,
                            MessageTypeID NUMBER NOT NULL ,
                            CreateUserID NUMBER NULL ,
                                Constraint PK_Messages Primary Key (ID)
			)');
	END IF;
END;

/

DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_MESSAGES_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_MESSAGES_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_MESSAGES_TRIGGER
	BEFORE INSERT ON HM_MESSAGES
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_MESSAGES_SEQ.NEXTVAL INTO :NEW.ID
            FROM dual;
        END IF;
    END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_UserMessages');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_UserMessages
			(
                            UserID NUMBER NOT NULL,
                            MessageID  NUMBER NOT NULL,
                            ReadDate DATE  NULL,
                            Showed NUMBER  NULL,
                            Active NUMBER DEFAULT 1 ,
                            delivered NUMBER DEFAULT 0 ,
                            Constraint PK_UserMessages Primary Key (UserID, MessageID)
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count FROM hm_Rights WHERE RightID = 68;
	IF(p_Count = 0) THEN
            INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
            VALUES (68, '+ Tickets von anderen Supportern ausblenden', 5, 10);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count FROM hm_Rights WHERE RightID = 71;
	IF(p_Count = 0) THEN
            INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
            VALUES (71, 'Volle Kategorieauswahl', 2, 3);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TapiCalls');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TapiCalls
			(
                            PhoneNo  VARCHAR2(100) NOT NULL,
                            ContactID NUMBER NULL,
                            UserID NUMBER NOT NULL,
                            CallDate DATE NOT NULL,
                            Constraint PK_TapiCalls Primary Key (PhoneNo, UserID)
			)');
	END IF;
END;

/

CREATE OR REPLACE TRIGGER HM_RIGHTS_TRIGGER
	BEFORE INSERT ON HM_RIGHTS
    FOR EACH ROW
    BEGIN
        IF :NEW.RIGHTID IS NULL THEN
            SELECT HM_RIGHTS_SEQ.NEXTVAL INTO :NEW.RIGHTID
            FROM dual;
        END IF;
    END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_TicketStatus WHERE ID = 12;
	IF(p_Count = 0) THEN
		INSERT INTO hm_TicketStatus (ID, Descr) VALUES (12, 'SEND');
END IF;
END;


/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_TicketStatus WHERE ID = 13 ;
	IF(p_Count = 0) THEN
		INSERT INTO hm_TicketStatus (ID, Descr) VALUES (13, 'RESPONSE');
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilter') AND UPPER(column_name) = UPPER('FilterDescr');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketFilter ADD FilterDescr VARCHAR2(2000) NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilterGroups');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketFilterGroups
			(
                            FilterID NUMBER NOT NULL,
                            GroupID NUMBER NOT NULL,
                            Constraint PK_TFGroups Primary Key (FilterID, GroupID)
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketFilterUsers');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketFilterUsers
			(
                            FilterID NUMBER NOT NULL,
                            UserID NUMBER NOT NULL,
                            isDefault NUMBER NULL,
                            isFavorit NUMBER  NULL,
                            Constraint PK_TFUsers Primary Key (FilterID, UserID)
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_DashboardLinks');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_DashboardLinks
			(
                            URL VARCHAR2(200) NOT NULL,
                            Descr VARCHAR2(500) NULL,
                            Imagepath VARCHAR2(200) NULL,
                            Active NUMBER NULL,
                            Position NUMBER  NULL
			)');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WFDefinitions') AND UPPER(column_name) = UPPER('ProjectID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_WFDefinitions ADD ProjectID NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WFInstanz') AND UPPER(column_name) = UPPER('ProjectID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_WFInstanz ADD ProjectID NUMBER NULL');
	END IF;
END;
/


DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WFInstanz') AND UPPER(column_name) = UPPER('RefLvl2ID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_WFInstanz ADD RefLvl2ID NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WF_Activity') AND UPPER(column_name) = UPPER('ProjectID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_WF_Activity ADD ProjectID NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WFDef_Activity') AND UPPER(column_name) = UPPER('ProjectID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_WFDef_Activity ADD ProjectID NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WF_Activity') AND UPPER(column_name) = UPPER('ProjectID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_WF_Activity ADD ProjectID NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Rights') AND UPPER(column_name) = UPPER('SegmentID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Rights ADD SegmentID NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_RightsSegment');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_RightsSegment
			(
                            SegmentID NUMBER NOT NULL,
                            Descr VARCHAR2(500) NULL,
                            SectionID NUMBER NULL,
                            SegmentOrder NUMBER NULL
			)');
	END IF;
END;


/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count FROM hm_Rights WHERE RightID = 222;
	IF(p_Count = 0) THEN
            INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, SegmentID, RightsOrder)
            VALUES (222, 'Allgemeine Gruppenbenachrichtigung deaktivieren', 2, 14, 10);
END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count FROM hm_Rights WHERE RightID = 223;
	IF(p_Count = 0) THEN
            INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, SegmentID, RightsOrder)
            VALUES (223, 'Bearbeitungsart ist Pflichtfeld', 2, 17, 10);
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Users') AND UPPER(column_name) = UPPER('Signatur');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Users ADD Signatur VARCHAR2 (1000) NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Rights') AND UPPER(column_name) = UPPER('RightDescr');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Rights ADD RightDescr VARCHAR2 (1000) NULL');
	END IF;
END;
/
UPDATE hm_RightsSection SET SectionName = 'Zugriffsmanagement', SectionOrder = 10 WHERE RightsSectionID = 1
/
UPDATE hm_RightsSection SET SectionName = 'Tickets', SectionOrder = 20 WHERE RightsSectionID = 2
/
UPDATE hm_RightsSection SET SectionName = 'Module', SectionOrder = 30 WHERE RightsSectionID = 3
/
UPDATE hm_RightsSection SET SectionName = 'Administration', SectionOrder = 50 WHERE RightsSectionID = 4
/
DELETE FROM hm_RightsSection WHERE RightsSectionID > 4
/
DELETE FROM hm_RightsSegment
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (1, 'Asset.Desk', 10)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (2, 'Benutzer', 20)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (3, 'Dokumente', 30)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (4, 'Einstellungen', 40)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (5, 'Firmenstruktur', 50)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (6, 'Formulare', 60)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (7, 'Gerte', 70)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (8, 'Gruppen und Supporter', 80)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (9, 'ITIL', 90)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (10, 'Kalender', 100)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (11, 'Kategorien', 110)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (12, 'Knowledgebase', 120)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (13, 'Kontakte', 130)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (14, 'Mailversand', 140)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (15, 'Nachtrgliche nderungen', 150)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (16, 'News', 160)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (17, 'Pflichtfelder', 170)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (18, 'Projekt', 180)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (19, 'Referenzieren', 190)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (20, 'Reporting', 200)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (21, 'Schlieen', 210)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (22, 'Shoutbox', 220)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (23, 'Supporter', 630)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (24, 'Ticketdaten', 540)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (25, 'Ticketevents', 250)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (26, 'Ticketliste', 270)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (27, 'Tickets', 580)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (28, 'Tickets erstellen', 290)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (29, 'Ticketvorlagen', 300)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (30, 'Verwaltung', 310)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (31, 'Workflow', 320)
/
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (32, 'ITIL Service', 320)
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 0, SegmentID = 28, RightDescr = 'Benutzer mit diesem Recht drfen selbst Tickets in HEINZELMANN erstellen.' WHERE RightID = 1
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 11, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen den Kontakt eines Tickets nachtrglich ndern.' WHERE RightID = 2
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 9, SegmentID = 24, RightDescr = 'Dieses Recht blendet den Benutzern der entsprechenden Gruppen im Dialog fr Ticketdetails ein Fernglas-Symbol neben dem eingetragenen Kontakt ein. Ein Klick auf dieses Symbol listet alle bisherigen Tickets des Kontakts auf.' WHERE RightID = 3
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 12, SegmentID = 11, RightDescr = 'Benutzer mit diesem Recht drfen die Kategorisierung eines Tickets verndern.' WHERE RightID = 5
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 6, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen die Ticketflligkeit verndern.' WHERE RightID = 6
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen Prioritt des Tickets verndern.' WHERE RightID = 7
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 19, RightDescr = 'Benutzer mit diesem Recht knnen Tickets einem Masterticket zuordnen oder die Zuordnung entfernen.' WHERE RightID = 8
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen den Betreff (Kurzbeschreibung) eines Tickets verndern, unter welcher das Ticket in allen Listen gefhrt wird.' WHERE RightID = 9
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 3, RightDescr = 'Benutzer mit diesem Recht drfen einem Ticket Anlagen beifgen.' WHERE RightID = 10
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 3, RightDescr = 'Benutzer mit diesem Recht drfen Anlagen eines Tickets wieder entfernen.' WHERE RightID = 11
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht knnen Tickets zurckstellen (Status ON HOLD)' WHERE RightID = 12
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 7, RightDescr = 'Dieses Recht hat nur Wirkung in Verbindung mit einer Asset.Desk-Datenbank. Es erlaubt die Suche nach Gerten innerhalb der Asset.Desk-Datenbank, welche einem Ticket hinzugefgt werden knnen.' WHERE RightID = 13
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 3, SegmentID = 12, RightDescr = 'Berechtigt zur Anlage noch nicht freigegebener KB-Eintrge aus geschlossenen Tickets und ohne Ticketvorlage.' WHERE RightID = 15
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 1, SegmentID = 14, RightDescr = 'Ist dieses Recht gesetzt, so werden die Kontakte der betroffenen Gruppe nicht mehr automatisch per Email benachrichtigt, sobald eine nderung am Ticket erfolgt. Eine Information kann dann bei Bedarf versandt werden, wenn das Ticket bearbeitet wird. Hierzu muss das Hkchen bei <strong>E-Mail an den Kontakt gesetzt werden ' WHERE RightID = 16
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 1, SegmentID = 14, RightDescr = 'Dieses Recht erweitert das vorhergehende Recht <strong>Manueller E-Mail Versand an Kunden.   Hat ein Benutzer beide Rechte, so erhlt er beim Bearbeiten eines Tickets nach dem Aktivieren der Checkbox E-Mail an Kontakt ein erweitertes Fenster mit der Option, den Betreff der Nachricht sowie die Empfnger zu ndern.    Bei Ticketbearbeitungen werden die Auswahlfelder E-Mail an Kontakt, E-Mail an Support, CC und Betreff, die fr die abzuschickende Mail angezeigt, in der die Empfnger und der Betreff bearbeitet werden knnen.  Die Eingabe mehrere Empfnger-Adressen ist ebenfalls mglich, diese mssen lediglich mit Komma oder Semikolon getrennt eingegeben werden. Des Weiteren kann der Benutzer durch das Aktivieren der Checkbox Nur diese Beschreibung mit Benutzerkontakt senden die Informationen in der Benachrichtigungsmail auf den Text dieser nderung, die Daten des Benutzers und den Link zum Ticket reduzieren.' WHERE RightID = 17
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 1, SegmentID = 12, RightDescr = 'Erlaubt alle Ttigkeiten in der Knowledgebase, insbesondere die Freigabe und Deaktivierung von Artikeln, Zuweisung und Erstellung von Rubriken.' WHERE RightID = 19
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 6, SegmentID = 11, RightDescr = 'Benutzer mit diesem Recht drfen einem Ticket bei der Erstellung bis zu zwei Kategorien zuordnen.Allen Benutzern mssen diejenigen Kategorien zugeordnet sein, welche sie auswhlen drfen.' WHERE RightID = 20
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 6, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen einem Ticket einen gewnschten Flligkeitstermin geben, der von der Standard-Flligkeit abweicht.' WHERE RightID = 21
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 6, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen die Prioritt eines Tickets selbst bestimmen.' WHERE RightID = 22
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 6, SegmentID = 19, RightDescr = 'Benutzer mit diesem Recht drfen in einem Ticket ein anderes mit hnlichem oder gleichem Inhalt referenzieren. In der Datenbank wird dann eine Verbindung zwischen den beiden Tickets hergestellt.' WHERE RightID = 23
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 6, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen bei der Erstellung oder Bearbeitung eines Tickets  ihren hierfr bentigten zeitlichen Aufwand erfassen.' WHERE RightID = 24
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 6, SegmentID = 21, RightDescr = 'Benutzer mit diesem Recht drfen ein Ticket mit der Option Schnellschuss schon bei der Anlage schlieen. Dies macht Sinn, wenn sich z.B. bereits whrend der Fehlerdiagnose oder -suche, beim Gesprch mit dem Melder oder bei nachtrglicher Ticketanlage eine Weiterverfolgung des Tickets unntig wird, da der Vorfall bzw. das Problem bereits behoben ist.' WHERE RightID = 25
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 0, SegmentID = 23, RightDescr = 'Dieses Recht ist das zentrale Recht von HEINZELMANN. Es ermglicht den Gruppen, die dieses Recht erhalten, Tickets fr Dritte zu bearbeiten. Benutzer mit diesem Recht werden Supporter genannt.Durch die Lizenzierung von HEINZELMANN anhand der Supporter-Accounts entscheidet dieses Recht ber den Verbrauch der HEINZELMANN Lizenzen' WHERE RightID = 26
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 21, RightDescr = 'Ist dieses Recht gesetzt, drfen die Mitglieder der betreffenden Gruppe geschlossene Tickets wieder ffnen, sofern sie die Rechte haben, diese anzuzeigen.' WHERE RightID = 27
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 5, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen nur die Tickets, bei welchen er als Mitglied der zugewiesenen Gruppe, als Support-Mitarbeiter oder als Kontakt eingetragen ist.' WHERE RightID = 28
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 5, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen nur die Tickets, bei welchen er als Support-Mitarbeiter und - oder Kontakt eingetragen ist.' WHERE RightID = 29
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 1, SegmentID = 20, RightDescr = 'Ermglicht die Nutzung des Reiters Reporting. Der Umfang der angezeigten Reports wird ber die brigen Gruppenrechte gesteuert.' WHERE RightID = 30
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 12, RightDescr = 'Benutzer mit diesem Recht knnen freigegebene KB-Eintrge aufrufen und danach suchen.' WHERE RightID = 31
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 1, SegmentID = 5, RightDescr = 'Nur ohne Asset.DeskBenutzer mit diesem Recht drfen unter Verwaltung > Struktur eine Abteilungs-struktur definieren.' WHERE RightID = 32
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 2, SegmentID = 11, RightDescr = 'Berechtigt zur Zuordnung von Kategorien zu Benutzergruppen.' WHERE RightID = 33
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 1, SegmentID = 11, RightDescr = 'Berechtigt zur Anlage und Bearbeitung von Kategorien in HEINZELMANN.' WHERE RightID = 34
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 3, SegmentID = 11, RightDescr = 'Berechtigt zur Lschung von Kategorien.' WHERE RightID = 35
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 1, SegmentID = 4, RightDescr = 'Berechtigt zur Anzeige und Bearbeitung der in HEINZELMANN zur Verfgung stehenden Einstellungsmglichkeiten ' WHERE RightID = 36
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 2, SegmentID = 2, RightDescr = 'Benutzer mit diesem Recht drfen ihr Passwort zur Anmeldung an HEINZELMANN eigenstndig festlegen oder ndern (Verwaltung > Eigenes Passwort ndern).' WHERE RightID = 37
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 3, SegmentID = 2, RightDescr = 'Ermglicht die Anlage und Bearbeitung von Gruppen sowie deren Berechtigungen.' WHERE RightID = 38
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 4, SegmentID = 2, RightDescr = 'Berechtigt zur Lschung von Gruppen.' WHERE RightID = 39
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 1, SegmentID = 2, RightDescr = 'Berechtigt zur Anlage und Bearbeitung von Benutzerkonten in HEINZELMANN.' WHERE RightID = 40
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 2, SegmentID = 2, RightDescr = 'Berechtigt zur Lschung von Benutzerkonten.' WHERE RightID = 41
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 1, SegmentID = 13, RightDescr = 'Berechtigt zur Anlage und Bearbeitung von Kontakten.' WHERE RightID = 42
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 3, SegmentID = 13, RightDescr = 'Berechtigt zur Lschung von Kontakten.' WHERE RightID = 43
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 2, SegmentID = 13, RightDescr = 'Benutzer mit diesem Recht drfen Kontakte einem Benutzerkonto zuordnen.' WHERE RightID = 44
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 7, RightDescr = 'Benutzer mit dieses Recht drfen nur Gerte auswhlen und anzeigen lassen, die ihnen in Asset.Desk zugeordnet sind.Setzt das Recht Gertesuche voraus' WHERE RightID = 45
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 9, SegmentID = 16, RightDescr = 'Dieses Recht erlaubt die Bearbeitung und Einstellung von News auf der HEINZELMANN-Startseite.' WHERE RightID = 46
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 4, SegmentID = 13, RightDescr = 'Berechtigt zum Kontaktimport und -update.' WHERE RightID = 47
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 20, RightDescr = 'Zeigt in den Reports kostenbezogene Felder mit an.' WHERE RightID = 48
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 24, RightDescr = 'Ist dieses Recht gesetzt, wird ein Ticketersteller, falls es sich um einen Supporter handelt, im Feld Supporter automatisch vorausgewhlt.' WHERE RightID = 49
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 1, SegmentID = 27, RightDescr = 'Ein Benutzer mit diesem Recht sehen alle Tickets die angelegt wurden, selbst wenn zudem eines der anderen Ticketrechte wie z.B. Nur Tickets der eigenen Gruppe anzeigen aktiv ist.  Das Recht zu erteilen ist dann sinnvoll, wenn ein Gesamtberblick ber alle Tickets erhalten werden soll, z.B. zu Reporting-Zwecken. Meistens geschieht dies fr Benutzer, die selber keinen oder nur geringfgig Support leisten. Andernfalls kann der Effekt zu Problemen prozessualer und organisatorischer Natur fhren.  Ein Anwendungsbeispiel fr das Recht ist der Incident Manager. Mit dieser Option erhlt er einen Einblick auf alle Tickets und kann so ggf. einer Eskalation zuvor kommen und seinen weiteren Aufgaben (Berichtserstellung) nachkommen. Er kann weiterhin Mitglied einer allgemeinen (Support-)Benutzergruppe sein und zustzlich einer Management- oder Reportinggruppe mit dem Recht alle Tickets anzeigen zugeordnet werden.' WHERE RightID = 50
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 14, SegmentID = 24, RightDescr = 'Die Kategorie 2 wird fr die Benutzer mit diesem Recht nicht angezeigt.' WHERE RightID = 51
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 30, SegmentID = 24, RightDescr = 'Blendet das Feld Gruppe in den Details eines Tickets fr die betroffenen Benutzer ein. Benutzer sehen die zugewiesene Gruppe der Tickets.' WHERE RightID = 52
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 14, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht knnen einem Ticket bei Erstellung eine Benutzergruppe zuweisen, welche dafr zustndig sein soll.' WHERE RightID = 53
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 31, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht knnen Tickets einer Gruppe zuordnen.' WHERE RightID = 54
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 10, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen zustzlich die Tickets, welche einer ihrer Benutzergruppen zugewiesen wurden.' WHERE RightID = 55
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 10, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen zustzlich die Tickets von Kontakten, die derselben Firma angehren.' WHERE RightID = 56
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 25, RightDescr = 'Mit diesem Recht kann eine Ticketbearbeitung als intern gekennzeichnet werden. Der Eintrag ist daraufhin nur noch sichtbar fr:<br>-Den Ersteller des Eintrags<br>-Den Benutzern aus der zugeordneten Supportgruppe<br>-Den zugeordneten Support-Mitarbeiter<br>-Den Benutzern aus der Administrator-Gruppe ' WHERE RightID = 57
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 27, RightDescr = 'Ein Benutzer mit diesem Recht sehen nur die Tickets, deren zugeordnete Kontakte derselben Firma wie der des Benutzerkontakts zugehren.' WHERE RightID = 58
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 11, SegmentID = 27, RightDescr = 'Den Benutzern mit diesem Recht werden geschlossene Tickets nicht angezeigt.' WHERE RightID = 59
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 3, SegmentID = 20, RightDescr = 'Setzt das Zusatzmodul Erweitertes Reporting vorausBenutzer mit diesem Recht erhalten Zugriff auf das erweiterte Reporting mit frei definierbaren Views.' WHERE RightID = 60
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 3, SegmentID = 10, RightDescr = 'Setzt das Zusatzmodul Kalender vorausBenutzer mit diesem Recht knnen einem Kalender-Termin Gerte per Reservierung zuordnen bzw. diese Reservierungen aufheben.' WHERE RightID = 61
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 7, RightDescr = 'Erlaubt die Suche nach Gerten innerhalb eines Active Directory, welche einem Ticket hinzugefgt werden knnen.' WHERE RightID = 62
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 4, SegmentID = 11, RightDescr = 'Benutzer mit diesem Recht knnen bei der Kategorie-Zuordnung eines Tickets nur aus den Haupt-, nicht aus deren Unterkategorien zu whlen.' WHERE RightID = 63
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 3, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen nur die Tickets, deren zugeordnete Kontakte derselben Abteilung wie der des Benutzerkontakts zugehren.' WHERE RightID = 65
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 10, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen zustzlich die Tickets von Kontakten, die derselben Abteilung angehren.' WHERE RightID = 66
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 4, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen alle Tickets, deren zugeordnete Kontakte mit Benutzern verknpft sind, welche denselben Benutzergruppen zugehrig sind.' WHERE RightID = 67
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 10, SegmentID = 27, RightDescr = 'Tickets welche einem (anderen) Supporter zugeordnet sind werden nicht angezeigt.' WHERE RightID = 68
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 9, SegmentID = 27, RightDescr = 'Benutzer mit diesem zustzlichen Recht sehen Tickets, denen keine Gruppe zugewiesen ist.' WHERE RightID = 69
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 12, SegmentID = 11, RightDescr = 'Benutzer mit diesem Recht knnen im Ticket auch Kategorien whlen, die nicht der Benutzergruppe zugeordnet sind.   Das kann verwendet werden, wenn Benutzer generell nur ber die Tickets Ihrer Kategorien benachrichtig werden sollen bzw. nur diese angezeigt bekommen, aber dennoch Tickets anderen Kategorien zuordnen knnen sollen.' WHERE RightID = 71
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 14, SegmentID = 30, RightDescr = 'Benutzer mit diesem Recht drfen Tickets lschen. Die Option ist nach dem Aufruf der Details eines geschlossenen Tickets verfgbar.' WHERE RightID = 100
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 10, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen zustzlich Tickets, denen keine Kategorie zugeordnet ist.' WHERE RightID = 101
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 33, SegmentID = 21, RightDescr = 'Benutzer mit diesem Recht knnen Tickets auf den Status Erledigt (DONE) setzen.' WHERE RightID = 110
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 34, SegmentID = 21, RightDescr = 'Benutzer mit diesem Recht knnen Tickets mit dem Status Erledigt (DONE) schlieen.' WHERE RightID = 111
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 35, SegmentID = 21, RightDescr = 'Benutzer mit diesem Recht knnen Tickets mit dem Status Erledigt (DONE) weiter bearbeiten.' WHERE RightID = 112
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 18, SegmentID = 24, RightDescr = 'Dieses Recht ermglicht die Zuordnung einer Bearbeitungsart bei der Ticketerstellung oder -bearbeitung.' WHERE RightID = 113
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 36, SegmentID = 14, RightDescr = 'Kontakte lassen sich im Kontaktformular als Lieferant markieren. Diese Kontakte werden, wenn der Button E-Mail Ticketdaten in der Ticketdetailansicht geklickt wird, in einer Liste zur Empfngerauswahl angezeigt.Dieses Recht blendet diese Option in den Ticketdetails ein.' WHERE RightID = 114
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 37, SegmentID = 24, RightDescr = 'Benutzer knnen die im Ticket ausgewhlte Inventarnummer ndern' WHERE RightID = 115
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 35, SegmentID = 21, RightDescr = 'Benutzern mit diesem Recht ist es nicht mglich, Tickets zu schlieen.' WHERE RightID = 116
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 1, SegmentID = 1, RightDescr = 'Ohne dieses Recht werden dem Benutzer bei den Gertedetails die kommerziellen Asset-Daten zum jeweiligen Gert nicht angezeigt.' WHERE RightID = 200
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 1, RightDescr = 'Benutzer mit diesem Recht drfen die auf dem ausgewhlten Gert installierten Softwareprodukte (aus der Asset.Desk-Datenbank) einsehen.' WHERE RightID = 201
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 3, SegmentID = 1, RightDescr = 'Ermglicht den Einblick in die benutzerdefinierten Angaben zu dem entsprechenden Gert aus der Asset.Desk-Datenbank.' WHERE RightID = 202
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 34, SegmentID = 28, RightDescr = 'Benutzer mit diesem Recht erhalten die entsprechende Option in der Ticketdetailansicht. Damit werden die Eingaben des kopierten Tickets in ein neues Ticket-Formular bernommen.' WHERE RightID = 210
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 38, SegmentID = 19, RightDescr = 'Benutzer mit diesem Recht knnen Tickets miteinander verknpfen. ' WHERE RightID = 211
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 10, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen Tickets einer Gruppe zuweisen.' WHERE RightID = 215
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 10, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen Tickets einem Supporter zuweisen.' WHERE RightID = 216
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 8, SegmentID = 17, RightDescr = 'Dieses Recht macht die Angabe einer Gruppe bei der Ticketerstellung erforderlich.' WHERE RightID = 217
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 8, SegmentID = 17, RightDescr = 'Dieses Recht macht die Angabe eines Supporters bei der Ticketerstellung erforderlich.' WHERE RightID = 218
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 39, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht knnen Tickets mit Schlagworten (Tags) versehn oder die Verschlagwortung ndern.' WHERE RightID = 219
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 39, SegmentID = 30, RightDescr = 'Ermglicht das Anlegen neuer Schlagworte (Tags) fr die Ticketverschlagwortung' WHERE RightID = 220
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 0, SegmentID = 30, RightDescr = 'Ermglicht den Benutzer Tickets als Archiviert zu markieren. Archivierte Tickets werden in der normalen suche nicht mehr bercksichtigt.' WHERE RightID = 221
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 10, SegmentID = 14, RightDescr = 'Benutzer dieser Gruppe werden nicht benachrichtigt wenn die Empfnger nur anhand der Gruppe ermittelt werden.' WHERE RightID = 222
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 10, SegmentID = 17, RightDescr = 'Erforder das Recht Bearbeitungsart anzeigen. Benutzer mit diesem Recht mssen bei der Ticketerstellung oder -bearbeitung eine Bearbeitungsart whlen.' WHERE RightID = 223
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 1, SegmentID = 9, RightDescr = 'Mit diesem Recht kann ein Anwender neue Change Requests einstellen oder ein geschlossenes Ticket in einen Change Request umwandeln.' WHERE RightID = 300
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 2, SegmentID = 9, RightDescr = 'Benutzer mit diesem Recht knnen den ganzen Change Request-Prozess nach ITIL bearbeiten und abschlieen.' WHERE RightID = 301
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 5, SegmentID = 20, RightDescr = 'Mach fr den Benutzer mit diesem Recht den Menpunkt SLA Reporting im Reporting-Bereich sichtbar.  Hier lassen sich individuelle Service Level Agreements auflisten und jeweils detailliert betrachten, sowie gefilterte Listen fr Reporting Zwecke berprfen.  Zudem kann die angezeigte Liste als Excel-Datei exportiert werden.' WHERE RightID = 302
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 5, SegmentID = 20, RightDescr = 'Gibt einem Benutzer das Recht, SLAs ber den Button Neuer SLA in der SLA Reporting-Liste anzulegen. Auerdem darf dieser Anwender aufgelistete SLA editieren oder lschen.' WHERE RightID = 303
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 5, SegmentID = 9, RightDescr = 'Nur Benutzer mit diesem Recht knnen Change Requests sehen.' WHERE RightID = 304
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 1, SegmentID = 22, RightDescr = 'Mit diesem Recht wird dem Benutzer auf der Startseite die Shoutbox angezeigt. ber die Shoutbox hat er die Mglichkeit, mit anderen an HEINZELMANN angemeldeten Anwendern, die dieses Recht aufweisen, schnell zu kommunizieren.' WHERE RightID = 400
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 2, SegmentID = 29, RightDescr = 'Dieses Recht erlaubt das Erstellen von Ticketvorlagen.' WHERE RightID = 401
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 3, SegmentID = 28, RightDescr = 'Dieses Recht erlaubt die Erstellung von Tickets aus definierten Ticketvorlagen.' WHERE RightID = 402
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 4, SegmentID = 26, RightDescr = 'Benutzer mit diesem Recht drfen die standardmig verwendeten Spalten der Ticketliste fr alle Benutzer anpassen.' WHERE RightID = 410
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 5, SegmentID = 26, RightDescr = 'Benutzer mit diesem Recht drfen die verwendeten Spalten benutzerspezifisch anpassen.' WHERE RightID = 411
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 6, SegmentID = 10, RightDescr = 'Setzt das Zusatzmodul Kalender voraus Benutzer mit diesem Recht knnen den Menpunkt Kalender einsehen.' WHERE RightID = 412
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 1, SegmentID = 18, RightDescr = 'Dieses Recht erteilt den Zugriff auf die Projektliste und die damit verbundenen Tickets. Eine nderung der Projekte ist nicht mglich' WHERE RightID = 500
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 2, SegmentID = 18, RightDescr = 'Das Recht zur Erstellung eigener Projekte.' WHERE RightID = 501
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 3, SegmentID = 18, RightDescr = 'Das Recht zur Bearbeitung von Projekten.' WHERE RightID = 502
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 4, SegmentID = 18, RightDescr = 'Mit diesem Recht knnen die notwendigen Projekttypen fr die Projekte verwaltet werden.' WHERE RightID = 503
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 5, SegmentID = 18, RightDescr = 'Dieses Recht erteilt die Mglichkeit, Tickets einem Projekt zuzuordnen. Um mit dem Modul Projekte arbeiten zu knnen, mssen Tickets einem Projekt zugewiesen werden knnen.' WHERE RightID = 504
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 6, SegmentID = 18, RightDescr = 'Das Recht zur nderung der Zuordnung eines Projekts.' WHERE RightID = 505
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 17, SegmentID = 24, RightDescr = 'Blendet das Feld Flligkeit in den Ticketdetails ein. Benutzer knnen die Ticketflligkeit setzten.' WHERE RightID = 521
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 17, SegmentID = 24, RightDescr = 'Blendet das Feld Prioritt in den Ticketdetails ein. Benutzer knnen die Ticketprioritt ndern.' WHERE RightID = 522
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 17, SegmentID = 24, RightDescr = 'Hiermit wird in den Ticketdetails und bei der Ticketbearbeitung das Feld Aufwand eingeblendet. Benutzer knnen Aufwnde erfassen.' WHERE RightID = 524
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 1, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen auch nachtrglich noch Beschreibungen von Events abndern.' WHERE RightID = 600
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 2, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen das Datum eines Events bearbeiten.' WHERE RightID = 601
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 3, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen auch nachtrglich noch Aufwnde von Events ndern.' WHERE RightID = 602
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 4, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen Events lschen.' WHERE RightID = 603
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 1, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen auch nachtrglich noch Beschreibungen von Events abndern.' WHERE RightID = 610
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 2, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen das Datum eines Events bearbeiten.' WHERE RightID = 611
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 3, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen auch nachtrglich noch Aufwnde von Events ndern.' WHERE RightID = 612
/
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 4, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen Events lschen.' WHERE RightID = 613
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 0, SegmentID = 31, RightDescr = 'Dieses Recht erlaubt die Anzeige der Workflowliste.' WHERE RightID = 701
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 2, SegmentID = 31, RightDescr = 'Dieses Recht erlaubt es, neue Workflows zu definieren oder bestehende Definitionen zu bearbeiten.' WHERE RightID = 703
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 4, SegmentID = 31, RightDescr = 'Dieses Recht blendet das Untermen Definition bei Workflow ein bzw. aus.' WHERE RightID = 704
/
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 6, SegmentID = 31, RightDescr = 'Dieses Recht blendet das Untermen Verfgbare Workflows ein bzw. aus, mit dem Workflows gestartet werden knnen.' WHERE RightID = 705
/
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 3, SegmentID = 6, RightDescr = 'Setzt das Zusatzmodul Formular voraus Berechtigt zur Anzeige und Bearbeitung von Formularen (Verwaltung > Formulare).' WHERE RightID = 810
/
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 6, SegmentID = 13, RightDescr = 'Benutzer mit diesem Recht drfen die gesamte Kontaktliste einsehen.' WHERE RightID = 1005
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Users') AND UPPER(column_name) = UPPER('PwdChangeDate');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Users ADD PwdChangeDate DATE NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Snippet');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_Snippet
			(
                            ID  NUMBER NOT NULL,
                            Title  VARCHAR2(255) NOT NULL,
                            Snippet  VARCHAR2(1000) NOT NULL,
                            ispublic NUMBER DEFAULT 1 ,
                            CreateUserID NUMBER NOT NULL ,
                                Constraint PK_Snippet Primary Key (ID)
			)');
	END IF;
END;
/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_SNIPPET_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_SNIPPET_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;
/
CREATE OR REPLACE TRIGGER HM_SNIPPET_TRIGGER
	BEFORE INSERT ON HM_SNIPPET
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_SNIPPET_SEQ.NEXTVAL INTO :NEW.ID
            FROM dual;
        END IF;
    END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 224;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder, SegmentID, RightDescr)
        VALUES (224, 'Textbausteine verffentlichen', 2, 50, 30, 'Der Benutzer kann allgemein sichtbare Textbausteine anlegen. Diese knnen auch von anderen Benutzern im Heinzelmann verwendet werden.');
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 225;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder, SegmentID, RightDescr)
        VALUES (225, 'Textbausteine verwalten', 2, 55, 30, 'Der Benutzer kann auch Textbausteine von anderen Benutzern lschen.');
END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticket') AND UPPER(column_name) = UPPER('expExpense');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticket ADD expExpense NUMBER NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 230;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder, SegmentID, RightDescr)
        VALUES (230, 'Dokumentenpfad anzeigen', 2, 15, 3, 'Mit diesem Recht wird dem Benutzer der UNC-Pfad der Dokumente in der Dokumentenliste angezeigt.');
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CategoryMailSender') AND UPPER(column_name) = UPPER('GroupID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_CategoryMailSender ADD GroupID NUMBER NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketDeviceDate');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketDeviceDate(
            	TicketID NUMBER NOT NULL,
            	DeviceID  NUMBER NOT NULL,
                addDate DATE Default SYSDATE NOT NULL,
                removeDate DATE NULL 
             )');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketContactDate');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_TicketContactDate(
            	TicketID NUMBER NOT NULL,
            	ContactID  NUMBER NOT NULL,
                addDate DATE Default SYSDATE NOT NULL,
                removeDate DATE NULL 
             )');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 230;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder, SegmentID, RightDescr)
        VALUES (405, 'Supporter-Online anzeigen', 1, 2, 22, 'Mit diesem Recht bekommen Benutzer die derzeit angemeldeten Supporter auf der Startseite angezeigt.');
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketReferences') AND UPPER(column_name) = UPPER('sendMailToTicketID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketReferences ADD sendMailToTicketID NUMBER NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketReferences') AND UPPER(column_name) = UPPER('sendMailToConnectedTicketID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketReferences ADD sendMailToConnectedTicketID NUMBER NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ContactPhoneNo');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ContactPhoneNo(
            	ContactID NUMBER NOT NULL,
            	PhoneNo  VARCHAR2(1000) NOT NULL,
                Constraint PK_ContactPhoneNo Primary Key (ContactID)
             )');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ContactMailAddress');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ContactMailAddress(
            	ContactID NUMBER NOT NULL,
            	MailAddress  VARCHAR2(1000) NOT NULL,
                Constraint PK_ContactMailAddress Primary Key (ContactID)
             )');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WF_Activity') AND UPPER(column_name) = UPPER('sendReport');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_WF_Activity ADD sendReport NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_WFDef_Activity') AND UPPER(column_name) = UPPER('sendReport');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_WFDef_Activity ADD sendReport NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('invoiced_1');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD invoiced_1 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('invoiced_2');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD invoiced_2 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('invoiced_3');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD invoiced_3 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('invoiced_4');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD invoiced_4 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('invoiced_5');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD invoiced_5 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('invoiced_6');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD invoiced_6 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('invoiced_7');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD invoiced_7 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('invoiced_8');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD invoiced_8 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('invoiced_9');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD invoiced_9 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('invoiced_10');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD invoiced_10 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('invoiced_11');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD invoiced_11 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('invoiced_12');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD invoiced_12 NUMBER NULL');
	END IF;
END;


/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('deduction_1');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD deduction_1 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('deduction_2');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD deduction_2 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('deduction_3');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD deduction_3 NUMBER NULL');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Project') AND UPPER(column_name) = UPPER('deduction_4');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Project ADD deduction_4 NUMBER NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketEvent') AND UPPER(column_name) = UPPER('ProjectCostRatePerMinute');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketEvent ADD ProjectCostRatePerMinute FLOAT NULL');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketEvent') AND UPPER(column_name) = UPPER('ProjectFactor');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketEvent ADD ProjectFactor FLOAT NULL');
	END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_TicketDeviceDate') AND UPPER(column_name) = UPPER('ContactID');
	IF(p_Count = 1) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_TicketDeviceDate RENAME COLUMN ContactID TO DeviceID');
	END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_UserMessages') AND UPPER(column_name) = UPPER('delivered');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_UserMessages ADD delivered NUMBER DEFAULT 0 ');
	END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CategoryForms') AND UPPER(column_name) = UPPER('SequenceName');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_CategoryForms ADD SequenceName VARCHAR2(100) NULL');
	END IF;
END;

/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_CategoryForms') AND UPPER(column_name) = UPPER('TriggerName');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_CategoryForms ADD TriggerName VARCHAR2(100) NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Contacts') AND UPPER(column_name) = UPPER('MandantenID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Contacts ADD MandantenID NUMBER NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticket') AND UPPER(column_name) = UPPER('ServiceID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticket ADD ServiceID NUMBER NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticket') AND UPPER(column_name) = UPPER('SLAID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticket ADD SLAID NUMBER NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Ticket') AND UPPER(column_name) = UPPER('MajorIncident');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Ticket ADD MajorIncident NUMBER NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Mandant');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_Mandant
			(
                            ID  NUMBER NOT NULL,
                            Mandant  VARCHAR2(100) NOT NULL,
                            Deleted NUMBER DEFAULT 0 ,
                                Constraint PK_hm_Mandant Primary Key (ID)
			)');
	END IF;
END;
/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_MANDANT_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_MANDANT_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;
/
CREATE OR REPLACE TRIGGER HM_MANDANT_TRIGGER
	BEFORE INSERT ON HM_MANDANT
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_MANDANT_SEQ.NEXTVAL INTO :NEW.ID
            FROM dual;
        END IF;
    END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ServiceLvlAgreement');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ServiceLvlAgreement
			(
                            ID  NUMBER NOT NULL,
                            Mandant  VARCHAR2(100) NOT NULL,
                            ServiceID NUMBER NOT NULL ,
                            ServiceLvlID NUMBER NOT NULL ,
                            CompanyID NUMBER NOT NULL ,
                            MandantID NUMBER NULL ,
                            Department VARCHAR2(300) NULL,
                            Startdate DATE DEFAULT SYSDATE NOT NULL,
                            Enddate DATE DEFAULT SYSDATE NOT NULL,
                                Constraint PK_hm_SLA Primary Key (ID)
			)');
	END IF;
END;
/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_SERVICELVLAGREEMENT_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_SERVICELVLAGREEMENT_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;
/
CREATE OR REPLACE TRIGGER HM_SERVICELVLAGREEMENT_TRIGGER
	BEFORE INSERT ON HM_SERVICELVLAGREEMENT
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_SERVICELVLAGREEMENT_SEQ.NEXTVAL INTO :NEW.ID
            FROM dual;
        END IF;
    END;


/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ServiceLevel');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ServiceLevel
			(
	ID NUMBER  NOT NULL ,
	Title VARCHAR2(300) NOT NULL,
        PrioID int NULL,
        Mon NUMBER DEFAULT 0 NOT NULL ,
        Tue NUMBER DEFAULT 0 NOT NULL ,
        Wed NUMBER DEFAULT 0 NOT NULL ,
        Thu NUMBER DEFAULT 0 NOT NULL ,
        Fri NUMBER DEFAULT 0 NOT NULL ,
        Sat NUMBER DEFAULT 0 NOT NULL ,
        Sun NUMBER DEFAULT 0 NOT NULL ,
        MonFrom1 VARCHAR2(5) NULL,
        MonUntil1 VARCHAR2(5) NULL,
        MonFrom2 VARCHAR2(5) NULL,
        MonUntil2 VARCHAR2(5) NULL,
        TueFrom1 VARCHAR2(5) NULL,
        TueUntil1 VARCHAR2(5) NULL,
        TueFrom2 VARCHAR2(5) NULL,
        TueUntil2 VARCHAR2(5) NULL,
        WedFrom1 VARCHAR2(5) NULL,
        WedUntil1 VARCHAR2(5) NULL,
        WedFrom2 VARCHAR2(5) NULL,
        WedUntil2 VARCHAR2(5) NULL,
        ThuFrom1 VARCHAR2(5) NULL,
        ThuUntil1 VARCHAR2(5) NULL,
        ThuFrom2 VARCHAR2(5) NULL,
        ThuUntil2 VARCHAR2(5) NULL,
        FriFrom1 VARCHAR2(5) NULL,
        FriUntil1 VARCHAR2(5) NULL,
        FriFrom2 VARCHAR2(5) NULL,
        FriUntil2 VARCHAR2(5) NULL,
        SatFrom1 VARCHAR2(5) NULL,
        SatUntil1 VARCHAR2(5) NULL,
        SatFrom2 VARCHAR2(5) NULL,
        SatUntil2 VARCHAR2(5) NULL,
        SunFrom1 VARCHAR2(5) NULL,
        SunUntil1 VARCHAR2(5) NULL,
        SunFrom2 VARCHAR2(5) NULL,
        SunUntil2 VARCHAR2(5) NULL ,
                                Constraint PK_hm_ServiceLevel Primary Key (ID)
			)');
	END IF;
END;
/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_SERVICELEVEL_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_SERVICELEVEL_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;
/
CREATE OR REPLACE TRIGGER HM_SERVICELEVEL_TRIGGER
	BEFORE INSERT ON HM_SERVICELEVEL
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_SERVICELEVEL_SEQ.NEXTVAL INTO :NEW.ID
            FROM DUAL;
        END IF;
    END;


/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ServiceLog');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ServiceLog
			(
        ID NUMBER NOT NULL , 
	ServiceID NUMBER NOT NULL ,
        CreateUserID NUMBER NULL,
        CreateDate DATE DEFAULT SYSDATE NOT NULL,
        Message VARCHAR2(2000) NULL,
                                Constraint PK_hm_ServiceLog Primary Key (ID)
			)');
	END IF;
END;
/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_SERVICELOG_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_SERVICELOG_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;
/
CREATE OR REPLACE TRIGGER HM_SERVICELOG_TRIGGER
	BEFORE INSERT ON HM_SERVICELOG
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_SERVICELOG_SEQ.NEXTVAL INTO :NEW.ID
            FROM DUAL;
        END IF;
    END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ServicePManagerGroup');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ServicePManagerGroup
			(
	ServiceID NUMBER NOT NULL ,
	GroupID NUMBER NOT NULL,
                                Constraint PK_hm_ServicePManagerGroup Primary Key (ServiceID,GroupID)
			)');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ServiceIManagerGroup');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ServiceIManagerGroup
			(
	ServiceID NUMBER NOT NULL ,
	GroupID NUMBER NOT NULL,
                                Constraint PK_hm_ServiceIManagerGroup Primary Key (ServiceID,GroupID)
			)');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ServiceManagerGroup');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ServiceManagerGroup
			(
	ServiceID NUMBER NOT NULL ,
	GroupID NUMBER NOT NULL,
                                Constraint PK_hm_ServiceManagerGroup Primary Key (ServiceID,GroupID)
			)');
	END IF;
END;
/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ServiceType');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ServiceType
			(
	ID NUMBER  NOT NULL ,
	Title VARCHAR2(300) NOT NULL,
        Descr VARCHAR2(2000) NOT NULL,
        Active NUMBER DEFAULT 1 NOT NULL,
                                Constraint PK_hm_ServiceType Primary Key (ID)
			)');
	END IF;
END;
/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_SERVICETYPE_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_SERVICETYPE_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;
/
CREATE OR REPLACE TRIGGER HM_SERVICETYPE_TRIGGER
	BEFORE INSERT ON HM_SERVICETYPE
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_SERVICETYPE_SEQ.NEXTVAL INTO :NEW.ID
            FROM DUAL;
        END IF;
    END;
/


DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_ConnectedService');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_ConnectedService
			(
	ServiceID NUMBER NOT NULL ,
        ConnectedServiceID NUMBER NOT NULL ,
                                Constraint PK_hm_ConnectedService Primary Key (ServiceID,ConnectedServiceID)
			)');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Service');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('CREATE TABLE hm_Service
			(
	ID NUMBER  NOT NULL ,
	Title VARCHAR2(300) NOT NULL,
        Descr VARCHAR2(2000)  NULL,
        Risks VARCHAR2(2000)  NULL,
	ServiceTypeID NUMBER NULL,
        Status NUMBER DEFAULT 0 NOT NULL,
        Problem NUMBER DEFAULT 0 NOT NULL,
        MaturityLevel NUMBER DEFAULT 1 NOT NULL,
        CategoryID1 NUMBER NULL,
        CategoryID2 NUMBER NULL,
        CreateUserID NUMBER NULL,
        CreateDate DATE DEFAULT SYSDATE NOT NULL,
        UpdateUserID NUMBER NULL,
        UpdateDate DATE DEFAULT SYSDATE NOT NULL,
	ticketshortdescr VARCHAR2(300) NOT NULL,
        ticketdescr VARCHAR2(2000)  NULL,
        Constraint PK_hm_Service Primary Key (ID)
			)');
	END IF;
END;
/
DECLARE row_count NUMBER;
BEGIN
    SELECT COUNT(*) INTO row_count FROM ALL_SEQUENCES WHERE SEQUENCE_NAME = 'HM_SERVICE_SEQ' AND UPPER(SEQUENCE_OWNER) = '';

	IF row_count = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE HM_SERVICE_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1';
	END IF;
END;
/
CREATE OR REPLACE TRIGGER HM_SERVICE_TRIGGER
	BEFORE INSERT ON HM_SERVICE
    FOR EACH ROW
    BEGIN
        IF :NEW.ID IS NULL THEN
            SELECT HM_SERVICE_SEQ.NEXTVAL INTO :NEW.ID
            FROM DUAL;
        END IF;
    END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 820;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder, SegmentID, RightDescr)
        VALUES (820, 'Servicetickets anlegen', 3, 10, 32, 'Benutzer mit diesem Recht drfen Servicetickets anlegen.');
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_Rights WHERE RightID = 821;
	IF(p_Count = 0) THEN
        INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder, SegmentID, RightDescr)
        VALUES (821, 'Services verwalten', 3, 15, 32, 'Benutzer mit diesem Recht drfen Services anlegen und bearbeiten.');
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 820;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 820);
END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(*) INTO p_Count from hm_GroupRights WHERE group_id = 1 AND right_id = 821;
	IF(p_Count = 0) THEN
		INSERT INTO hm_GroupRights (group_id, right_id) VALUES (1, 821);
END IF;
END;

/

DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_News') AND UPPER(column_name) = UPPER('Deleted');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_News ADD Deleted NUMBER DEFAULT 0');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Contacts') AND UPPER(column_name) = UPPER('NativeGUID');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Contacts ADD NativeGUID VARCHAR2(50) NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Users') AND UPPER(column_name) = UPPER('PushMessageCreate');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Users ADD PushMessageCreate NUMBER DEFAULT 0 NOT NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Users') AND UPPER(column_name) = UPPER('PushMessageEdit');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Users ADD PushMessageEdit NUMBER DEFAULT 0 NOT NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Users') AND UPPER(column_name) = UPPER('PushMessageAssign');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Users ADD PushMessageAssign NUMBER DEFAULT 0 NOT NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Users') AND UPPER(column_name) = UPPER('PushMessageClose');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Users ADD PushMessageClose NUMBER DEFAULT 0 NOT NULL');
	END IF;
END;
/
DECLARE p_Count NUMBER;
BEGIN
	SELECT Count(Table_Name) INTO p_Count from user_tab_cols where UPPER(table_name) = UPPER('hm_Users') AND UPPER(column_name) = UPPER('PushMessageEscalation');
	IF(p_Count = 0) THEN
			EXECUTE IMMEDIATE ('ALTER TABLE hm_Users ADD PushMessageEscalation NUMBER DEFAULT 0 NOT NULL');
	END IF;
END;
