<html>
    <head>
        <meta http-equiv="content-type" content="text/html; charset=[% $charset %]">
        <title>[% $user->gettext('Workflow Report') %]</title>
        <link rel="stylesheet" type="text/css" href="styles/[% $CSSTEMPLATE %]/css/screen.css" />
        <style type="text/css" media="print">
            html, body {
                width: 210mm;
                height: 297mm;
            }
            form {
                display : none;
            }
        </style>
    </head>
    <body id="PopUpForm" style="text-align:center;padding-top:8px;padding-bottom:8px;background-color:#FFF;height:auto;">
        <!-- Component Ticket begin -->
        <form style="padding-bottom: 8px;">
            <input type="button" class="button button-green" onclick="print();" value="[% $user->gettext('Drucken') %]" />
        </form>
        <div id="content" >
            <div class="wrapper">
                <div class="border" >
                    <table width="100%" class="listview formview" cellspacing="0" border="0" >
                        <thead>
                            <tr>
                                <th colspan="2">
                                    <strong>
                                        [% $user->gettext('Workflow') %]
                                    </strong>
                                </th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr class="[% cycle values="odd,even" %]">
                                <td>[% $user->gettext('Bezeichnung') %] :</td>
                                <td>[% $WFI.Descr %] </td>
                            </tr>
                            <tr class="[% cycle %]">
                                <td>[% $user->gettext('Initiator') %] :</td>
                                <td>[% $WFI.Username %] ([% $WFI.Name %])</td>
                            </tr>
                            <tr class="[% cycle %]">
                                <td>[% $user->gettext('Stellvertreter') %] :</td>
                                <td>[% $WFI.sUsername %] ([% $WFI.sName %])</td>
                            </tr>
                            <tr class="[% cycle %]">
                                <td>[% $user->gettext('Startdatum') %] :</td>
                                <td>[% $WFI.StartDate  %]</td>
                            </tr>
                            <tr class="[% cycle %]">
                                <td>[% $user->gettext('Enddatum') %] :</td>
                                <td>[% $WFI.EndDate %]</td>
                            </tr>
                            <tr class="[% cycle %]">
                                <td>[% $user->gettext('Status') %] :</td>
                                <td>[% $user->gettext($WFI.Status) %]</td>
                            </tr>
                            <tr class="[% cycle %]">
                                <td>[% $user->gettext('Anzahl der Aktivitten') %] :</td>
                                <td>[% $WFI.countActivities %]</td>
                            </tr>
                        </tbody>
                    </table>

                    <br />
                    <table width="100%" class="listview formview" cellspacing="0" border="0" >
                        <thead>
                            <tr>
                                <th colspan="5">
                                    <strong>
                                        [% $user->gettext('Aktivitten') %]
                                    </strong>
                                </th>

                            </tr>

                            <tr class="fields">
                                <td>[% $user->gettext('Bezeichnung') %]</td>
                                <td>[% $user->gettext('Erstellt am') %]</td>
                                <td>[% $user->gettext('Letzte Bearbeitung') %]</td>
                                <td>[% $user->gettext('Adressat') %]</td>
                                <td>[% $user->gettext('Status') %]</td>
                            </tr>
                        </thead>
                        <tbody>
                            [% foreach from=$WFI.aGantt item=activity %]
                                [% cycle values="odd,even" assign="tr_color" %]
                                [% if $activity.StatusID != 10 && $activity.StatusID != 15 && $activity.StatusID != 14 %]
                                    <tr class="[% $tr_color %]">
                                        <td valign="top" style="white-space:normal;" rowspan="2">[% $activity.Descr %]</td>
                                        <td valign="top" nowrap="nowrap">&nbsp;[% $activity.StartDate|date_format:"%d.%m.%Y %H:%M" %]&nbsp;</td>
                                        <td valign="top" nowrap="nowrap">&nbsp;[% $activity.EndDate|date_format:"%d.%m.%Y %H:%M" %]&nbsp;</td>
                                        [% if $activity.O->TargetType == 1 %]
                                            <td valign="top" nowrap="nowrap">&nbsp;[% $activity.tuser_username %] ([% $activity.tuser_name %])&nbsp;</td>
                                        [% else %]
                                            <td valign="top" nowrap="nowrap">&nbsp;Gruppe: [% $activity.tgroup_name %] </td>
                                        [% /if %]
                                        <td valign="top" nowrap="nowrap">&nbsp;[% $user->gettext($activity.Status) %]&nbsp;</td>
                                    </tr>
                                    <tr class="[% $tr_color %]">

                                        <td  colspan="4">
                                            &nbsp;
                                            [% if $activity.O->TaskType == 2 %]
                                                [% $activity.O->showFormContent() %]
                                            [% else %]
                                                [% $activity.O->TaskText %]
                                            [% /if %]
                                            &nbsp;
                                        </td>
                                    </tr>
                                [% /if %]
                            [% /foreach %]
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </body>
</html>
