<?php

//error_reporting(E_ALL);
//ini_set('display_errors', 1);

/**
 * start.php
 *
 * @author Jan Kpke <j.koepke@fair-computer.de>
 *
 */
class tapi extends FR_Auth_User {

    private $JSON = true;
    private $PhoneNo = false;
    private $clearNo = '';
    //Test:
    public $TimeArray = array();
    public $TimeArray2 = array();

    // {{{ __default
    public function __construct() {
        parent::__construct();

        $this->PhoneNo = (isset($_REQUEST['phoneno']) && '' != $_REQUEST['phoneno']) ? $_REQUEST['phoneno'] : false;

        $this->TimeArray["Start"] = microtime(true);
    }

    // }}}
    // {{{ __default
    public function __default() {
        //if (!$this->user->hasRight(36)){ header('Location: index.php');}

        if ($this->PhoneNo) {
            $clearPhoneNumber = $this->clearPhoneNumber($this->PhoneNo);
            $this->clearNo = $clearPhoneNumber;
            $ContactIDs = $this->getContactIDByPhoneNo();
            $this->storeCall($clearPhoneNumber);

            if ($this->JSON) {
                $JSONData = $this->getContactData($ContactIDs);

                header('Cache-Control: no-cache, must-revalidate');
                header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
                header('Content-type: application/json');
                $this->TimeArray["Daten senden - Start..."] = microtime(true);

                $this->TimeArray["Daten:"] = $JSONData;
                echo $JSONData;
                $this->TimeArray["Daten senden - ...Fertig"] = microtime(true);
                $this->TimeArray2["Daten senden"] = $this->TimeArray["Daten senden - ...Fertig"] - $this->TimeArray["Daten senden - Start..."];
                $this->TimeArray2["Gesamt"] = microtime(true) - $this->TimeArray["Start"];

$this->log->log("PerformanceTest: ".print_r($this->TimeArray, true), PEAR_LOG_DEBUG);
$this->log->log("PerformanceTest: ".print_r($this->TimeArray2, true), PEAR_LOG_DEBUG);
                exit;
            } else {
                $this->set('javascript', array("includes/js/jquery.dataTables.min.js"));
                $this->set('styles', array(
                    "styles/default/css/jquery.dataTables.css",
                    "styles/default/css/jquery-ui.css"
                ));
                $this->set('origPhoneno', $this->PhoneNo);
                $this->set('searchPhoneNo', $clearPhoneNumber);
                $this->set('lastCalls', $this->getCalls($clearPhoneNumber));

                return $this->showContact($ContactIDs);
            }
        } else {
            $this->log->log("Keine Telefonnumer bergeben");
            echo json_encode("");
            exit;
        }
    }

    /**
     * Ermittelt Kontakte fr die bermittelte Telefonnummer.
     *
     * Es die Nummer (nur Ziffern, keine fhrenden Nullen) wird mit den Phone und Mobil Nummern aus dem HM verglichen.
     * Wird kein Kontakt gefunden, wird die Suche nochmals mit der um die letzten 3 Stellen gekrzten Nummer durchgefhrt.
     *
     * @param type $PhoneNo
     * @return type
     */
    private function getContactIDByPhoneNo() {
        $ContactIDs = array();
        $PhoneNo = $this->clearNo;
        $this->TimeArray["KontaktIDs ermitteln (Neues Verfahren) Start..."] = microtime(true);
        //Ansatz mit ComputetColumns und Index:
        $sql = sprintf('SELECT DISTINCT Contact_id '
                . 'FROM hm_Contacts '
                . "WHERE published = 1 AND ( TapiMobil = %s OR TapiPhone = %s %s) ", $this->db->quoteSmart($PhoneNo), $this->db->quoteSmart($PhoneNo), $this->addExtendedNumbers($PhoneNo));
        $res = $this->db->query($sql);
        $this->TimeArray["KontaktIDs ermitteln (Neues Verfahren) ...Fertig"] = microtime(true);
        $this->TimeArray2["KontaktIDs ermitteln (Neues Verfahren)"] = $this->TimeArray["KontaktIDs ermitteln (Neues Verfahren) ...Fertig"] - $this->TimeArray["KontaktIDs ermitteln (Neues Verfahren) Start..."];
        $this->TimeArray2["SQL (Neues Verfahren)"] = $sql;

        //Gibt es die Spalten nicht, herkmmlich suchen:
        if (DB::isError($res)) {
            $this->TimeArray["KontaktIDs ermitteln (Altes Verfahren) Start..."] = microtime(true);
            $sql = sprintf('SELECT DISTINCT Contact_id '
                    . 'FROM hm_Contacts '
                    . "WHERE published = 1 AND %s AND
                    (
                            REPLACE(LTRIM(REPLACE(
                                    (replace(replace(replace(replace(replace(replace(mobil, '/', ''), '-', ''), ')', ''), '(', ''),'+', ''), ' ', '') )
                            , '0', ' ')), ' ', '0')
                            LIKE %s
                    ) OR (
                             REPLACE(LTRIM(REPLACE(
                                    (replace(replace(replace(replace(replace(replace(phone, '/', ''), '-', ''), ')', ''), '(', ''),'+', ''), ' ', ''))
                            , '0', ' ')), ' ', '0')
                            LIKE %s)", ($this->db->phptype == 'oci8') ? "( mobil IS NOT NULL OR phone IS NOT NULL )" : "( mobil <> '' OR phone <> '' )", $this->db->quoteSmart($PhoneNo), $this->db->quoteSmart($PhoneNo));

            $res = $this->db->query($sql);
            $this->TimeArray["KontaktIDs ermitteln (Altes Verfahren) ...Fertig"]
                    = microtime(true);
            $this->TimeArray2["KontaktIDs ermitteln (Altes Verfahren)"] = $this->TimeArray["KontaktIDs ermitteln (Altes Verfahren) ...Fertig"] - $this->TimeArray["KontaktIDs ermitteln (Altes Verfahren) Start..."];
            $this->TimeArray2["SQL (Altes Verfahren)"] = $sql;
        }

        if (!DB::isError($res)) {
            //Aus der Liste der Kontakte die richtige Nummer finden und KontaktID zurckliefern.
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $ContactIDs[] = $row['contact_id'];
            }

            if (!count($ContactIDs) && false !== strpos($PhoneNo, '49')) {
                $this->TimeArray["KontaktIDs ermitteln (ohne Lndervorwahl 49) Start..."]
                        = microtime(true);

                $PhoneNo = ltrim($PhoneNo, '49');

                //Ansatz mit ComputetColumns und Index:
                $sql = sprintf('SELECT DISTINCT Contact_id '
                        . 'FROM hm_Contacts '
                        . "WHERE published = 1 AND ( TapiMobil = %s OR TapiPhone = %s %s) ", $this->db->quoteSmart($PhoneNo), $this->db->quoteSmart($PhoneNo), $this->addExtendedNumbers($PhoneNo));
                $res = $this->db->query($sql);
                $this->TimeArray2["KontaktIDs Neues Verfahren ohne Lndervorwahl 49 SQL"]
                        = $sql;
                //Gibt es die Spalten nicht, herkmmlich suchen:
                if (DB::isError($res)) {

                    $sql = sprintf('SELECT DISTINCT Contact_id '
                            . 'FROM hm_Contacts '
                            . "WHERE published = 1 AND
                (
                        REPLACE(REPLACE(LTRIM(REPLACE(
                                (replace(replace(replace(replace(replace(replace(mobil, '/', ''), '-', ''), ')', ''), '(', ''),'+', ''), ' ', '') )
                        , '0', ' ')), ' ', '0'), '490', '')
                        LIKE %s
                ) OR (
                         REPLACE(REPLACE(LTRIM(REPLACE(
                                (replace(replace(replace(replace(replace(replace(phone, '/', ''), '-', ''), ')', ''), '(', ''),'+', ''), ' ', ''))
                        , '0', ' ')), ' ', '0'), '490', '')
                        LIKE %s)", $this->db->quoteSmart($PhoneNo . '%'), $this->db->quoteSmart($PhoneNo . '%'));

                    $res = $this->db->query($sql);
                }
                if (!DB::isError($res)) {
                    //Aus der Liste der Kontakte die richtige Nummer finden und KontaktID zurckliefern.
                    while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                        $ContactIDs[] = $row['contact_id'];
                    }
                }
                $this->TimeArray["KontaktIDs ermitteln (ohne Lndervorwahl 49) ...Fertig"]
                        = microtime(true);
                $this->TimeArray2["KontaktIDs ermitteln (ohne Lndervorwahl 49)"]
                        = $this->TimeArray["KontaktIDs ermitteln (ohne Lndervorwahl 49) ...Fertig"] - $this->TimeArray["KontaktIDs ermitteln (ohne Lndervorwahl 49) Start..."];
            }



            if (isset($_REQUEST['cutno']) && 0 == $_REQUEST['cutno']) {
                $this->TimeArray["KontaktIDs ermitteln (gekrzte Nummer) Start..."]
                        = microtime(true);
//Dt. Lndervorwahl entfernen:
                //Wenn keine Kontakte mit der vollen (gesuberten) nummer gefunden wurden, suche ohne die letzten 3 Stellen:
                if (!count($ContactIDs) && false !== strpos($PhoneNo, '49')) {
                    $PhoneNo = str_replace('49', '', $PhoneNo);

                    //Ansatz mit ComputetColumns und Index:
                    $sql = sprintf('SELECT DISTINCT Contact_id '
                            . 'FROM hm_Contacts '
                            . "WHERE published = 1 AND ( TapiMobil = %s OR TapiPhone = %s ) ", $this->db->quoteSmart($PhoneNo), $this->db->quoteSmart($PhoneNo));
                    $res = $this->db->query($sql);

                    //Gibt es die Spalten nicht, herkmmlich suchen:
                    if (DB::isError($res)) {

                        $sql = sprintf('SELECT DISTINCT Contact_id '
                                . 'FROM hm_Contacts '
                                . "WHERE published = 1 AND
                (
                        REPLACE(LTRIM(REPLACE(
                                (replace(replace(replace(replace(replace(replace(mobil, '/', ''), '-', ''), ')', ''), '(', ''),'+', ''), ' ', '') )
                        , '0', ' ')), ' ', '0')
                        LIKE %s
                ) OR (
                         REPLACE(LTRIM(REPLACE(
                                (replace(replace(replace(replace(replace(replace(phone, '/', ''), '-', ''), ')', ''), '(', ''),'+', ''), ' ', ''))
                        , '0', ' ')), ' ', '0')
                        LIKE %s)", $this->db->quoteSmart($PhoneNo . '%'), $this->db->quoteSmart($PhoneNo . '%'));

                        $res = $this->db->query($sql);
                    }
                    if (!DB::isError($res)) {
                        //Aus der Liste der Kontakte die richtige Nummer finden und KontaktID zurckliefern.
                        while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                            $ContactIDs[] = $row['contact_id'];
                        }
                    }
                }

                //Wenn keine Kontakte mit der vollen (gesuberten) nummer gefunden wurden, suche ohne die letzten 3 Stellen:
                if (!count($ContactIDs) && strlen($PhoneNo) > 4) {
                    $PhoneNo = substr($PhoneNo, 0, -3);

                    //Ansatz mit ComputetColumns und Index:
                    $sql = sprintf('SELECT DISTINCT Contact_id '
                            . 'FROM hm_Contacts '
                            . "WHERE published = 1 AND ( TapiMobil = %s OR TapiPhone = %s %s) ", $this->db->quoteSmart($PhoneNo), $this->db->quoteSmart($PhoneNo), $this->addExtendedNumbers($PhoneNo));
                    $res = $this->db->query($sql);

                    //Gibt es die Spalten nicht, herkmmlich suchen:
                    if (DB::isError($res)) {
                        $sql = sprintf('SELECT DISTINCT Contact_id '
                                . 'FROM hm_Contacts '
                                . "WHERE published = 1 AND
                (
                        REPLACE(LTRIM(REPLACE(
                                (replace(replace(replace(replace(replace(replace(mobil, '/', ''), '-', ''), ')', ''), '(', ''),'+', ''), ' ', '') )
                        , '0', ' ')), ' ', '0')
                        LIKE %s
                ) OR (
                         REPLACE(LTRIM(REPLACE(
                                (replace(replace(replace(replace(replace(replace(phone, '/', ''), '-', ''), ')', ''), '(', ''),'+', ''), ' ', ''))
                        , '0', ' ')), ' ', '0')
                        LIKE %s)", $this->db->quoteSmart($PhoneNo . '%'), $this->db->quoteSmart($PhoneNo . '%'));

                        $res = $this->db->query($sql);
                    }
                    if (!DB::isError($res)) {
                        //Aus der Liste der Kontakte die richtige Nummer finden und KontaktID zurckliefern.
                        while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                            $ContactIDs[] = $row['contact_id'];
                        }
                    }
                }
                $this->TimeArray["KontaktIDs ermitteln (gekrzte Nummer) ...Fertig"]
                        = microtime(true);
                $this->TimeArray2["KontaktIDs ermitteln (gekrzte Nummer)"] = $this->TimeArray["KontaktIDs ermitteln (gekrzte Nummer) ...Fertig"] - $this->TimeArray["KontaktIDs ermitteln (gekrzte Nummer) Start..."];
            }
        } else {
            $this->log->log("TAPI: Fehler bei der Kontaktsuche fr Nummer [$PhoneNo]. Message: " . $res->getMessage());
        }
        return $ContactIDs;
    }

    private function addExtendedNumbers($Number) {
        $tmp = array();
        $addWhere = '';
        if (defined("TAPIFILTER") && trim(TAPIFILTER) != '') {
            $extensions = explode(',', TAPIFILTER);
            foreach ($extensions as $ext) {
                $NewNumber = '';
                $ext = str_replace('"', '', $ext);
                $NewNumber = $ext . $Number;
                $tmp[] = sprintf(" ( phone = '%s' OR TapiPhone = '%s' ) ", trim($NewNumber), $this->clearPhoneNumber($NewNumber));
            }
            $addWhere = ' OR (' . implode(' OR ', $tmp) . ' )';
        }
        return $addWhere;
    }

    private function clearPhoneNumber($PhoneNo) {
        $PhoneNo = trim($PhoneNo);
        // ersetzt ein fhrendes Plus durch 00
        $PhoneNo = preg_replace('/\A\+/', '00', $PhoneNo);
        // entfernt Nicht-Ziffern
        $PhoneNo = preg_replace('/[^0-9]+/', '', $PhoneNo);
        //Fhrende Nullen weg:
        $PhoneNo = ltrim($PhoneNo, '0');

        return $PhoneNo;
    }

    private function getContactDataForID($ContactID) {
        $ContactData = array();
        if ($ContactID) {
            $ContactData = $this->getContact($ContactID);
            $ContactData['tickets'] = $this->getTickets($ContactID);
            $ContactData['devices'] = $this->getDevices($ContactID);
        }
        return $ContactData;
    }

    /**
     * getContact()
     *
     * @author Dirk Herbes <d.herbes@fair-computer.de>
     */
    private function getContact($ContactID) {
        $this->TimeArray["Kontaktdaten ermitteln - Start..."] = microtime(true);
        $contact = array();

        $sql = 'SELECT  personalno, contact_id, name, street, plz,
                    city, state, country, fax, phone, user_id, important,
                    com_position, published, misc, mobil, email, ' .
                $this->DB_CONVERT('updated') . ' ChangeTime, building, room,
                    floor, sendEmails, CostCenter, department, eMailTicketAddress,
                    hm_Contacts.CompanyID, hm_Company.Company  ' .
                'FROM hm_Contacts
                    LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
		WHERE published = 1 AND contact_id = ' . (int) $ContactID;

        $row = $this->db->getRow($sql, DB_FETCHMODE_ASSOC);
        if (!DB::isError($row) && count($row)) {

            if (isset($row['changetime'])) {
                $row['changetime'] = strtotime($row['changetime']);
            }

            foreach ($row as $key => $val) {
                if (is_string($val) && !is_numeric($val)) {
                    if ($this->JSON) {
                        $row[$key] = utf8_encode($val);
                    } else {
                        $row[$key] = $this->tools->HTMLSpecialchars($val);
                    }
                }
            }
            $contact = $row;
        }
        $this->TimeArray["Kontaktdaten ermitteln - ...Fertig"] = microtime(true);
        $this->TimeArray2["Kontaktdaten ermitteln"] = $this->TimeArray["Kontaktdaten ermitteln - ...Fertig"] - $this->TimeArray["Kontaktdaten ermitteln - Start..."];
        return $contact;
    }

    private function getTickets($ContactID) {
        $this->TimeArray["Kontakttickets ermitteln - Start..."] = microtime(true);
        $Tickets = array();
        if ($ContactID) {
            $sql = sprintf(' SELECT  hm_Ticket.ID, TicketDescr, %s TicketDesireDate, '
                    . '%s OnHold, %s EditDate, %s CreateDate, hm_TicketPrio.Descr Prio, '
                    . 'hm_Ticket.TicketPrioID, hm_TicketStatus.Descr Status '
                    . 'FROM hm_Ticket '
                    . 'LEFT JOIN hm_TicketPrio ON hm_Ticket.TicketPrioID = hm_TicketPrio.TicketPrioID '
                    . 'LEFT JOIN hm_TicketStatus ON hm_Ticket.TicketStatusID = hm_TicketStatus.ID '
                    . 'WHERE hm_Ticket.ContactID = %u ', $this->DB_CONVERT('hm_Ticket.TicketDesireDate'), $this->DB_CONVERT('hm_Ticket.OnHold'), $this->DB_CONVERT('hm_Ticket.EditDate'), $this->DB_CONVERT('hm_Ticket.CreateDate'), $ContactID);

            $sql .= ' AND (' . $this->user->getRightFilter() . ')';

            $sql .= ' ORDER BY hm_Ticket.EditDate DESC ';
            $res = $this->db->query($sql);
            if (DB::isError($res)) {
                //echo "Fehler bei Ticketabfrage... SQL: $sql";
            } else {
                while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                    if ($this->JSON) {
                        foreach ($row as $key => $value) {
                            $Tickets['TicketID_' . $row['id']][$key] = utf8_encode(html_entity_decode($value));
                        }
                    } else {
                        $Tickets['TicketID_' . $row['id']] = $row;
                    }
                }
            }
        }
        $this->TimeArray["Kontakttickets ermitteln - ...Fertig"] = microtime(true);
        $this->TimeArray2["Kontakttickets ermitteln"] = $this->TimeArray["Kontakttickets ermitteln - ...Fertig"] - $this->TimeArray["Kontakttickets ermitteln - Start..."];
        return $Tickets;
    }

    private function showContact($ContactID) {
        $this->pageTemplateFile = 'iframe.tpl';
        $this->tplFile = 'ContactData.tpl';
        if ($ContactID) {
            $Contact = $this->getContactDataForID($ContactID);
            $Tickets = $this->getTickets($ContactID);
            $this->set('Contact', $Contact);
            $this->set('Tickets', $Tickets);
        }
        $this->set('PopUp', TRUE);
    }

    private function storeCall($PhoneNo) {
        $this->TimeArray["Anruf Speichern - Start..."] = microtime(true);
        $sql = sprintf('INSERT INTO hm_TapiCalls (PhoneNo, UserID, CallDate ) VALUES (%s, %u, %s) ', $this->db->quoteSmart($PhoneNo), $this->user->UserID, $this->DB_DATE('now()'));
        $res = $this->db->query($sql);
        $this->TimeArray["Anruf Speichern - ...Fertig"] = microtime(true);
        $this->TimeArray2["Anruf Speichern"] = $this->TimeArray["Anruf Speichern - ...Fertig"] - $this->TimeArray["Anruf Speichern - Start..."];
    }

    private function getCalls($PhoneNo) {
        $this->TimeArray["Anrufe ermitteln - Start..."] = microtime(true);
        $Calls = array();
        $sql = sprintf('SELECT PhoneNo, UserID, %s CallDate FROM hm_TapiCalls WHERE PhoneNo = %s AND UserID = %u ORDER BY CallDate DESC', $this->DB_CONVERT('CallDate'), $this->db->quoteSmart($PhoneNo), $this->user->UserID);
        $res = $this->db->query($sql);
        if (DB::isError($res)) {
            $this->log->log('Fehler beim Laden der PhoneNo [' . $PhoneNo . ']. Message: ' . $res->getMessage(), PEAR_LOG_ERR);
        } else {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $Calls[] = $row['calldate'];
            }
        }
        $this->TimeArray["Anrufe ermitteln - ...Fertig"] = microtime(true);
        $this->TimeArray2["Anrufe ermitteln"] = $this->TimeArray["Anrufe ermitteln - ...Fertig"] - $this->TimeArray["Anrufe ermitteln - Start..."];
        //nur den letzten:
        return (isset($Calls[1])) ? $Calls[1] : false;
    }

    private function getContactData($ContactIDs) {
        $ContactData = array();
        if (count($ContactIDs)) {
            $LastCall = $this->getCalls($this->clearNo);
            foreach ($ContactIDs as $ContactID) {
                $ContactData[$ContactID]['Contact'] = $this->getContactDataForID($ContactID);
                $ContactData[$ContactID]['Contact']['lastCall'] = $LastCall;
                if (count($ContactData[$ContactID]['Contact']) < 3) {
                    unset($ContactData[$ContactID]);
                }
            }
        }
        $ContactData['rights'] = $this->getUserRights();
        $ContactData['templates'] = $this->getTicketTemplates();
        if ($this->JSON) {
            return json_encode($ContactData);
        } else {
            return $ContactData;
        }
    }

    /**
     * Ermittelt die Gerte der mit dem Kontakt verknpften Mitarbeiter aus der Asset.Desk-Tabelle.
     * @author Jan Kpke <j.koepke-computer.de>
     */
    private function getDevices($ContactID) {
        $Devices = array();
        $LogGroupView = 3; //Asset.Desk-Spezifisch...
        $LogGroupID = 0; //??
        $contact_employees = $this->user->getContactEmployees($ContactID);
        if (count($contact_employees) > 0) {
            $where = array();
            $RootID = $this->db->getOne(sprintf('SELECT RootID FROM LogGroupRoot
                    WHERE LogGroupView = %u', $LogGroupView));
            $node = $this->db->getRow(sprintf('SELECT RootID, Lft, Rgt
                    FROM LogGroup WHERE RootID = %u AND LogGroupID = %u', $RootID, $LogGroupID), DB_FETCHMODE_ASSOC);
            if (!DB::isError($node) && count($node) == 3) {

                $res = $this->db->query(sprintf('SELECT RefID FROM
                        LogGroup WHERE RefType = 3 AND RootID = %u AND
                        Lft > %u AND Rgt < %u', $node['rootid'], $node['lft'], $node['rgt']));

                if (!DB::isError($res)) {
                    while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                        $list[] = $row['refid'];
                    }
                }
                if (count($list)) {
                    $where[] = sprintf('Device.DeviceID IN (%s)', join(',', $list));
                }
            }
            $where[] = sprintf('(DeviceMDLogGroup.EmployeeID IN (%s))', join(',', $contact_employees));
            $sql = 'SELECT DeviceMDLogGroup.EmployeeID, Device.DeviceID, Device.Hostname, CommercialDevData.InventoryNo,
                                    DeviceType.TypeName, DeviceType.DeviceTypeID TypeID, Device.DeviceName,
                                    Device.Model, Device.Manufacturer, Device.Type,
                                    Device.DomainName
                                FROM Device
                                INNER JOIN DeviceMDLogGroup ON Device.DeviceID = DeviceMDLogGroup.DeviceID
                                INNER JOIN DeviceType ON Device.DeviceTypeID = DeviceType.DeviceTypeID
                                LEFT JOIN CommercialDevData ON CommercialDevData.DeviceID = Device.DeviceID';
            if (count($where) > 0) {
                $sql .= ' WHERE ' . join(' AND ', $where);
            }

            $res = $this->db->query($sql);
            if (!DB::isError($res)) {
                $shownDevices = array();
                while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
//JK, 29.03.2011: Wenn Gert mit der ID schon angezeigt wurde, nicht noch eimal anzeigen:
                    if (in_array((int) $row['deviceid'], $shownDevices)) {
                        continue;
                    }

                    $shownDevices[] = (int) $row['deviceid'];

                    $row['filename'] = str_pad((int) $row['typeid'], 2, '0', STR_PAD_LEFT);

                    foreach ($row as $key => $value) {
                        $Devices[$row['deviceid']][$key] = utf8_encode($value);
                    }
                }
            }
        }
        return $Devices;
    }

    private function getUserRights() {
        $Rights['addContact'] = ($this->user->hasRight(42)) ? true : false;
        $Rights['showContactList'] = ($this->user->hasRight(1005)) ? true : false;
        return $Rights;
    }

    private function getTicketTemplates() {
        $templates = array();
        $sql = sprintf('SELECT DISTINCT TT.TicketTemplateID, TT.ShortDescr
                FROM hm_TicketTemplate TT
                	LEFT JOIN hm_TicketTemplateGroups TG ON TG.TicketTemplateID = TT.TicketTemplateID
                WHERE (TT.SerialTicket IS NULL or TT.SerialTicket = 0)
                	AND (TG.GroupID is NULL OR TG.GroupID in (%s) )
                ORDER BY TT.ShortDescr', join(',', $this->user->UserGroups));
        $res = $this->db->query($sql);
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $templates[$row['tickettemplateid']]['name'] = utf8_encode($row['shortdescr']);
                $templates[$row['tickettemplateid']]['id'] = $row['tickettemplateid'];
            }
        }
        return $templates;
    }

}

?>
