<!DOCTYPE html>
<html lang="de">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <!-- Meta, title, CSS, favicons, etc. -->
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <title>Helpdesk [% $PageTitle %]</title>
        <link rel="SHORTCUT ICON" href="images/favicon.ico" />

        <!-- Bootstrap -->

        [% if $LESSStylePath %]
            <link rel="stylesheet" type="text/css" href="[% $LESSStylePath %]" />
        [% else %]
            <link href="styles/bootstrap/css/bootstrap.min.css" rel="stylesheet">
            <link href="styles/bootstrap/css/custom.css" rel="stylesheet">
        [% /if %]

        <script type="text/javascript" src="includes/js/jquery-1.12.4.min.js"></script>
        <script src="includes/js/ajax.js"></script>
        <script type="text/javascript" src="includes/js/jquery-ui.min.js"></script>
        <link rel="stylesheet" type="text/css" href="styles/default/css/jquery-ui.css" media="screen" />        
        <script type="text/javascript" src="includes/js/noty/packaged/jquery.noty.packaged.min.js"></script>
            <script type="text/javascript" src="includes/js/bootstrap-multiselect/dist/js/bootstrap-multiselect.js"></script>
<link rel="stylesheet" type="text/css" href="includes/js/bootstrap-multiselect/dist/css/bootstrap-multiselect.css" media="screen" />            
            <script type="text/javascript" src="includes/js/fancybox/jquery.fancybox.pack.js"></script>        
<link rel="stylesheet" type="text/css" href="includes/js/fancybox/jquery.fancybox.css" media="screen" />
        [% foreach from=$originPathStyles item=style %]<link rel="stylesheet" type="text/css" href="[% $style %]" media="screen" />[% /foreach %]
        [% foreach from=$styles item=style %]<link rel="stylesheet" type="text/css" href="[% $style %]" media="screen" />[% /foreach %]
        [% foreach from=$printstyles item=style %]<link rel="stylesheet" type="text/css" href="[% $style %]" media="print" />[% /foreach %]



        <script type="text/javascript">
            var ts_lang = '[% $user->language_type %]';
        </script>
        [% foreach from=$javascript item=js %]<script type="text/javascript" src="[% $js %]"></script>[% /foreach %]

    </head>


    <body>
        [%*
        <div class="container-fluid">
            <div class="row">
                <div class="col-xs-6">
                    <a href="index.php" >
                        [% if $smarty.const.LOGO != '' && $smarty.const.LOGO != 'LOGO' %]
                            <img src="[% $smarty.const.LOGO %]" title="[% $user->Security->Company %]" alt="[% $user->Security->Company %]" />
                        [% else %]
                            <img src="styles/[% $CSSTEMPLATE %]/images/logo.gif" title="[% $user->Security->Company %]" alt="[% $user->Security->Company %]" />
                        [% /if %]
                    </a>
                </div>

                <div class="col-xs-6 pull-right">
                    <div class="pull-right">
                        [% if $user->Username %]

                            <div class="dropdown">
                                <button class="btn btn-default dropdown-toggle" type="button" id="dropdownMenu1" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">
                                    [% $user->Username %] ([% $user->FullName %])
                                    <span class="caret"></span>
                                </button>
                                <ul class="dropdown-menu" aria-labelledby="dropdownMenu1">
                                    <li><a href="index.php?module=user&event=edit&id=[% $user->UserID %]"> Profil</a></li>
                                    <li role="separator" class="divider"></li>                            
                                    <li>
                                        <a href="index.php?module=login&amp;event=logout"><i class="fa fa-sign-out pull-right"></i>[% $user->gettext('Abmelden') %]</a>
                                    </li>  
                                </ul>
                            </div>                       
                        [% /if %]
                    </div>
                </div>
            </div>
*%]                    

            <!-- Static navbar -->
            <nav class="navbar navbar-default">

                <div class="navbar-header">
                    <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
                        <span class="sr-only">Menu umschalten</span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>     
                    
                    <a href="index.php" class="navbar-brand">
                        [% if $smarty.const.LOGO != '' && $smarty.const.LOGO != 'LOGO' %]
                            <img src="[% $smarty.const.LOGO %]" title="[% $user->Security->Company %]" alt="[% $user->Security->Company %]" />
                        [% else %]
                            <img src="styles/[% $CSSTEMPLATE %]/images/logo.gif" title="[% $user->Security->Company %]" alt="[% $user->Security->Company %]" />
                        [% /if %]
                    </a>                    
                </div>
                <div id="navbar" class="navbar-collapse collapse">
                    <ul class="nav navbar-nav">

                        [% $user->getMenu() %]
                    </ul>
             
                    <ul class="nav navbar-nav navbar-right">
                        [% if $user->Username %]
                            <li>
                                <form action="index.php?module=ticket&amp;event=search"  method="get" class="navbar-form navbar-right">
                                    <input type="hidden" name="module" value="ticket" />
                                    <input type="hidden" name="event" value="search" />

                                    <input type="text" name="id" class="form-control" maxlength="100" autocomplete="off" title="[% $user->gettext('Suche nach TicketID �ffnet das Ticket, wenn dieses sichtbar ist.') %]" placeholder="[% $user->gettext('Suche') %]" />
                                </form>
                            </li>

                            <li role="presentation" class="dropdown">
                                <a href="javascript:;" class="dropdown-toggle info-number" data-toggle="dropdown" aria-expanded="false">
                                    <i class="fa fa-envelope-o"></i>
                                    <span class="badge bg-green">[% $messages|@count %]</span>
                                </a>
                                <ul id="menu1" class="dropdown-menu list-unstyled msg_list" role="menu">
                                    [% foreach from=$messages item=message %]
                                        <li>
                                            <a>
                                                <span class="image"><img src="images/img.jpg" alt="Profil Image"></span>
                                                <span>
                                                    <span>John Smith</span>
                                                    <span class="time">3 mins ago</span>
                                                </span>
                                                <span class="message">
                                                    [% $message.text %]
                                                </span>
                                            </a>
                                        </li>
                                    [% /foreach %]
                                </ul>
                                </li>   
                                <li role="presentation" class="dropdown">
                                
           

                            <div class="dropdown  navbar-form">
                                <button class="btn btn-default dropdown-toggle" type="button" id="dropdownMenu1" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">
                                    [% $user->Username %] ([% $user->FullName %])
                                    <span class="caret"></span>
                                </button>
                                <ul class="dropdown-menu" aria-labelledby="dropdownMenu1">
                                    <li><a href="index.php?module=user&event=edit&id=[% $user->UserID %]"> Profil</a></li>
                                    <li role="separator" class="divider"></li>                            
                                    <li>
                                        <a href="index.php?module=login&amp;event=logout"><i class="fa fa-sign-out pull-right"></i>[% $user->gettext('Abmelden') %]</a>
                                    </li>  
                                </ul>
                            </div>                       
                               
                                                             
                                         </li>            
                        [% /if %]

                        [% if 'login' == $module || $pwdrecover %]
                            <li>
                                [% if $VisibleNewsArticle || $VisibleKBArticle || $LinkList|@count > 0 || $pwdrecover %]
                                    <form class="navbar-form navbar-left" autocomplete="off" action="[% $action %]" method="post" role="login">
                                        <div class="form-group">
                                            <input type="text" id="lx_small_username" value="[% $Username %]" name="lx_username" class="textbox [% if $errorno == 1 %]error[% /if %]" placeholder="[% $user->gettext('Benutzername') %]" size="25" maxlength="255" autocomplete="off" />

                                            <input type="password" name="lx_password" value="[% $Password %]" class="textbox [% if $errorno == 2 %]error[% /if %]" placeholder="[% $user->gettext('Passwort') %]" size="25" maxlength="50" autocomplete="off" />
                                            [% if $showDomains && $domains|@count > 0 %]

                                                <select size="1" name="lx_domain" class="textbox">
                                                    [% html_options options=$domains %]
                                                    <option value="">[% $user->gettext('&gt;&gt; ohne Domain &lt;&lt;') %]</option>
                                                </select>
                                            [% /if %]

                                            <input type="submit" class="btn btn-default" style="height: 1.8em;padding: 1px;" value="Login" />
                                            [% if $errorno == 2 || $errorno == 1 %]
                                                <span class="error"> [% $error %] </span>
                                            [% /if %]
                                            <br/>                                                
                                            <button class="btn btn-primary btn-sm" type="button" data-toggle="collapse" data-target="#moreLoginOptions" aria-expanded="false" aria-controls="moreLoginOptions">
                                                Mehr Optionen
                                            </button>

                                        </div>
                                        <div class="collapse" id="moreLoginOptions">
                                            [% if $remember_me == 1 %]

                                                <label>[% $user->gettext('Anmeldung merken') %]:

                                                    <input type="checkbox" name="lx_rememberme" class="checkbox" value="1" /></label>
                                                [% /if %]

                                            [% if $MailActive && $PwdRecover %]

                                                <input type="button" class="btn btn-default" style="height: 1.8em;padding: 1px;" onclick="window.location.href = 'index.php?module=login&event=pwdrecover';" value="[% $user->gettext('Passwort vergessen ?') %]" />
                                            [% /if %]
                                            [% if $UserCreate && $MailActive %]

                                                <input type="button" class="btn btn-default" style="height: 1.8em;padding: 1px;" onclick="window.location.href = 'index.php?module=login&event=createuser';" value="[% $user->gettext('Registrieren') %]" />
                                            [% /if %]
                                        </div>
                                    </form>
                                [% else %]
                                    <a href="index.php" class="btn btn-primary">[% $user->gettext('Anmelden') %]</a>
                                [% /if %]
                            </li>
                        [% else %]
                            [% if $ShowMessages %]
                                <li>                                    
                                    &nbsp;&#124;&nbsp;
                                    <a href="#" class="MessageDialog" id="Messages">[% $user->gettext('Nachrichten') %] (<span id="MessageCount"></span>) <span id="NewMessages"></span></a>
                                    <span id="MessageBox" ></span>                                    
                                </li>
                            [% /if %]                                
                        [% /if %]
                    </ul>
                </div><!--/.nav-collapse -->
            </nav>

            [% if $user->UserID %]
                [% if ($user->LicenceExpired || $user->LicenceExceed) && $user->inGroup(1) %]

                    <div class="row">
                        <div class="col-xs-12">
                            <div class="expired">                            
                                [% if $user->LicenceExpired %]

                                    [% if $user->NoVersionLicence %]
                                        [% $user->gettext('Ihre Lizenz ist nicht f�r die HEINZELMANN Version g�ltig. Bitte wenden Sie sich an den Vertrieb...') %]
                                    [% else %]
                                        [% $user->gettext('Ihre Lizenz ist abgelaufen. Bitte wenden Sie sich an den Vertrieb...') %]
                                    [% /if %]

                                [% else %]

                                    [% $user->gettext('Es k&ouml;nnen maximal ') %]
                                    [% $user->licavai %]
                                    [% $user->gettext(' Benutzer Tickets bearbeiten.<br />Sie haben das Recht aber ') %]
                                    [% $user->licused %]
                                    [% $user->gettext(' Benutzern gegeben.') %]

                                [% /if %]      
                            </div>                    
                        </div>
                    </div>
                [% /if %]
            [% /if %]

            <!-- ###MENU### end -->


            <div class="main_container">
                <div class="body">
                                                            
                    [% $content %]

                    <!-- footer content -->                     
                    <footer class="footer_fixed">
                        <div class="pull-left">
                            &copy; [% $smarty.now|date_format:"%Y" %] FCS Fair Computer Systems GmbH
                        </div>
                        <div class="pull-right">
                            Version: [% $user->Version->RELEASE %] &#124; [% if $user->Security->Company %][% 'Lizenziert f&uuml;r:' %] [% $user->Security->Company %][% /if %]
                        </div>
                    </footer>
                    <!-- /footer content -->
                </div>

            </div>
        </div><!--/.container-fluid -->   
        <!-- Bootstrap -->
        <script src="styles/bootstrap/js/bootstrap.min.js"></script>


        [% foreach from=$postBodyJS item=js %]<script type="text/javascript" src="[% $js %]"></script>[% /foreach %]
        

<link href="includes/js/bootstrap3-editable/css/bootstrap-editable.css" rel="stylesheet">
<script type="text/javascript" src="includes/js/bootstrap3-editable/js/bootstrap-editable.min.js"></script>

    </body>

</html>
