/*1*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'sla_time')
ALTER TABLE [dbo].[hm_Categories] ADD
    [sla_time] [int] NULL
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_TicketSupporter]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketSupporter](
	[TicketID] [int] NOT NULL,
	[UserID] [int] NOT NULL,
	[addDate] [datetime]  DEFAULT GETDATE() NOT NULL,
 CONSTRAINT [PK_hm_TicketSupporter] PRIMARY KEY CLUSTERED 
(
	[TicketID] ASC,
	[UserID] ASC
)
) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_TicketGroup]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketGroup](
	[TicketID] [int] NOT NULL,
	[GroupID] [int] NOT NULL,
	[addDate] [datetime] DEFAULT GETDATE() NULL,
 CONSTRAINT [PK_hm_TicketGroup] PRIMARY KEY CLUSTERED 
(
	[TicketID] ASC,
	[GroupID] ASC
)
) ON [PRIMARY]

GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_TicketTemplateSupporter]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketTemplateSupporter](
	[TicketTemplateID] [int] NOT NULL,
	[UserID] [int] NOT NULL,
 CONSTRAINT [PK_hm_TicketTempSupporter] PRIMARY KEY CLUSTERED 
(
	[TicketTemplateID] ASC,
	[UserID] ASC
)
) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_TicketTemplateGroup]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketTemplateGroup](
	[TicketTemplateID] [int] NOT NULL,
	[GroupID] [int] NOT NULL,
 CONSTRAINT [PK_hm_TicketTempGroup] PRIMARY KEY CLUSTERED 
(
	[TicketTemplateID] ASC,
	[GroupID] ASC
)
) ON [PRIMARY]
GO



/*2*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'notice_time1')
ALTER TABLE [dbo].[hm_Categories] ADD
    [notice_time1] [int] NULL
GO
/*3*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'notice_time2')
ALTER TABLE [dbo].[hm_Categories] ADD
    [notice_time2] [int] NULL
GO
/*4*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_Interest]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
    CREATE TABLE [dbo].[hm_Interest] (
        [user_id] [bigint] NULL ,
        [ticket_id] [bigint] NULL
    ) ON [PRIMARY];
GO
/*5*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'IX_HMINTEREST')
CREATE  INDEX [IX_HMINTEREST] ON [dbo].[hm_Interest]([ticket_id], [user_id]) ON [PRIMARY]
GO
/*6*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_CalEvent]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CalEvent] (
    [CalEventID] [bigint] IDENTITY (1, 1) NOT NULL ,
    [CalEventStartDate] [datetime] NOT NULL ,
    [CalEventEndDate] [datetime] NULL ,
    [CalEventName] [varchar] (100) NOT NULL ,
    [CalEventDescription] [text] NULL ,
    [CalEventLocation] [varchar] (100) NULL ,
    [CalEventStartDay] [tinyint] NOT NULL ,
    [CalEventStartMonth] [tinyint] NOT NULL ,
    [CalEventStartYear] [int] NOT NULL ,
    [CalEventEndDay] [tinyint] NULL ,
    [CalEventEndMonth] [tinyint] NULL ,
    [CalEventEndYear] [int] NULL ,
    [CalEventOwnerID] [bigint] NOT NULL ,
    [CalEventCreateDate] [datetime] NOT NULL ,
    [CalEventUpdateUserID] [bigint] NULL ,
    [CalEventUpdateDate] [datetime] NULL ,
    [CalEventUniqID] [varchar] (50) NULL ,
    [CalEventDateDay] [tinyint] NOT NULL CONSTRAINT [DF_hm_CalEvent_CalEventDateDay] DEFAULT (0),
    [CalEventRepeatMode] [tinyint] NOT NULL CONSTRAINT [DF_hm_CalEvent_CalEventRepeatMode] DEFAULT (0),
    [CalEventRepeatEnd] [int] NULL ,
    [CalEventRepeatEvery] [tinyint] NOT NULL CONSTRAINT [DF_hm_CalEvent_CalEventRepeatEvery] DEFAULT (1),
    [CalEventRepeatConfig] [varchar] (20) NULL,
    CONSTRAINT [PK_hm_CalEvent] PRIMARY KEY  CLUSTERED
    (
        [CalEventID]
    ))  ON [PRIMARY]
GO
/*7*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_CalEventGroups]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CalEventGroups] (
    [CalEventID] [bigint] NOT NULL ,
    [CalEventGroupID] [bigint] NOT NULL
) ON [PRIMARY]

GO

/*12*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_TicketFilter]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketFilter] (
    [FilterID] [bigint] IDENTITY (1, 1) NOT NULL,
    [FilterName] [varchar] (50) NOT NULL ,
    [IsDefault] [tinyint] NOT NULL CONSTRAINT [DF_TicketFilter_IsDefault] DEFAULT (0),
    [UserID] [bigint] NOT NULL ,
    [CreateDateStart] [datetime] NULL ,
    [CreateDateEnd] [datetime] NULL ,
    [UpdateDateStart] [datetime] NULL ,
    [UpdateDateEnd] [datetime] NULL ,
    [OnHold] [datetime] NULL ,
    [Display] [varchar] (15) NULL ,
    [StatusID] [bigint] NULL ,
    [Filter] [varchar] (50) NULL ,
    [Sorting] [varchar] (20) NULL ,
    [Sortorder] [varchar] (5) NULL ,
    [MyTickets] [tinyint] NULL ,
    [DesireDateStart] [datetime] NULL ,
    [DesireDateEnd] [datetime] NULL ,
    [EntriesPerPage] [bigint] NULL CONSTRAINT [DF_TicketFilter_EntriesPerPage] DEFAULT (20),
    [FilterList] [tinyint] NULL ,
    [Master] [tinyint] NULL ,
    [PrioID] [bigint] NULL,
	[CategoryID] [bigint] NULL,
	[TicketID] [bigint] NULL,
    [WorkOnDateStart] [datetime] NULL,
    [WorkOnDateEnd] [datetime] NULL
	    CONSTRAINT [PK_TicketFilter] PRIMARY KEY  CLUSTERED
    (
        [FilterID]
    ))  ON [PRIMARY]

GO
/*13*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'FilterList')
ALTER TABLE [dbo].[hm_TicketFilter] ADD
    [FilterList] [tinyint] NULL
GO
/*14*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'Master')
ALTER TABLE [dbo].[hm_TicketFilter] ADD
    [Master] [tinyint] NULL
GO

/*19*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketEvent' AND COLUMN_NAME = 'NotPublic')
    ALTER TABLE [dbo].[hm_TicketEvent] ADD [NotPublic] [tinyint] NULL
GO
/*20*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'image')
    ALTER TABLE [dbo].[hm_Contacts] ADD [image] [varchar] (255) NULL
GO
/*21*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'personalno')
    ALTER TABLE [dbo].[hm_Contacts] ADD [personalno] [varchar] (20) NULL
GO
/*22*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'PrioID')
    ALTER TABLE [dbo].[hm_TicketFilter] ADD [PrioID] [bigint] NULL;
GO
/*23*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_TicketHistory]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketHistory] (
    [TicketHistoryID] [bigint] IDENTITY (1, 1) NOT NULL ,
    [ID] [bigint] NULL,
    [ContactID] [bigint] NULL ,
    [GroupID] [bigint] NULL ,
    [SupporterID] [bigint] NULL ,
    [TicketDesireDate] [datetime] NULL ,
    [OnHold] [datetime] NULL ,
    [TicketDescr] [varchar] (500) NULL ,
    [TicketPrioID] [bigint] NULL ,
    [TicketStatusID] [int] NULL ,
    [TicketReferenzID] [bigint] NULL ,
    [CategoryID1] [bigint] NULL ,
    [CategoryID2] [bigint] NULL ,
    [Published] [tinyint] NULL ,
    [Expense] [int] NULL ,
    [CreateDate] [datetime] NULL ,
    [CreateUserID] [bigint] NULL ,
    [UpdateDate] [datetime] NULL ,
    [UpdateUserID] [bigint] NULL ,
    [EscalationLevel] [tinyint] NULL ,
    [EscalationDate] [datetime] NULL ,
    [EscalationType] [tinyint] NULL ,
    [UniqID] [varchar] (20) NULL ,
    [EOSToDo] [tinyint] NULL,
    [Handover] [varchar] (255) NULL
) ON [PRIMARY]
GO
/*24*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'EOSToDo')
    ALTER TABLE [dbo].[hm_Ticket] ADD [EOSToDo] [tinyint] NULL;
GO
/*25*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'Handover')
    ALTER TABLE [dbo].[hm_Ticket] ADD [Handover] [varchar] (255) NULL;
GO
/*26*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'PK_TicketHistory')
ALTER TABLE [dbo].[hm_TicketHistory] WITH NOCHECK ADD
    CONSTRAINT [PK_TicketHistory] PRIMARY KEY  CLUSTERED
    (
        [TicketHistoryID]
    )  ON [PRIMARY]
GO
/*27*/
IF EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[tr_TicketHistory]') AND OBJECTPROPERTY(id, N'IsTrigger') = 1)
DROP TRIGGER tr_TicketHistory
GO
/*28*/
CREATE TRIGGER tr_TicketHistory ON hm_Ticket FOR INSERT, UPDATE
AS INSERT INTO hm_TicketHistory (ID, ContactID, GroupID, SupporterID,
    TicketDesireDate, OnHold, TicketDescr, TicketPrioID, TicketStatusID,
    TicketReferenzID, CategoryID1, CategoryID2, Published, Expense, CreateDate,
    CreateUserID, UpdateDate, UpdateUserID, EscalationLevel, EscalationDate,
    EscalationType, UniqID, EOSToDo, Handover)
  SELECT ID, ContactID, GroupID, SupporterID, TicketDesireDate, OnHold,
    TicketDescr, TicketPrioID, TicketStatusID, TicketReferenzID, CategoryID1,
    CategoryID2, Published, Expense, CreateDate, CreateUserID, UpdateDate,
    UpdateUserID, EscalationLevel, EscalationDate, EscalationType, UniqID,
    EOSToDo, Handover FROM inserted
GO
/*29*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_RightsSection] WHERE SectionName = 'Asset.Desk')
INSERT INTO [dbo].[hm_RightsSection] (SectionName, SectionOrder) VALUES ('Asset.Desk', 11)
GO
/*30*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_RightsSection] WHERE SectionName = 'ITIL')
INSERT INTO [dbo].[hm_RightsSection] (SectionName, SectionOrder) VALUES ('ITIL', 12)
GO
/*31*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 14)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (14, 'Ticketerstbearbeitung', 2, 0)
GO
/*32*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 15)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (15, 'Knowledgebaseeintrge erstellen', 4, 3)
GO
/*33*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 300)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (300, 'Tickets einstufen', 12, 1)
GO
/*34*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 301)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (301, 'ChangeRequest Manager (CRM)', 12, 2)
GO
/*35*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 16)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (16, 'Manueller E-Mail Versand an Kunden', 2, 0)
GO
/*36*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 100)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (100, 'Tickets lschen', 2, 5)
GO
/*37*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 101)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (101, 'Nur Tickets mit Kategorien anzeigen', 5, 3)
GO
/*38*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 200)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (200, 'Kommerzielle Daten anzeigen (Gert)', 11, 1)
GO
/*39*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 50)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (50, 'Alle Tickets anzeigen', 5, 4)
GO
/*40*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 201)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (201, 'Software anzeigen (Gert)', 11, 2)
GO
/*41*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 202)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (202, 'Benutzerdefinierte Felder anzeigen (Gert)', 11, 3)
GO
/*42*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 14 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 14)
GO
/*43*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 15 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 15)
GO
/*45*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 100 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 100)
GO
/*46*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 200 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 200)
GO
/*47*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 201 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 201)
GO
/*48*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 202 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 202)
GO
/*50*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'DefaultGroupID')
ALTER TABLE [dbo].[hm_Categories] ADD
    [DefaultGroupID] [bigint] NULL
GO
/*51*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationFirstHintPercent')
ALTER TABLE [dbo].[hm_Categories] ADD
    [EscalationFirstHintPercent] [int] NULL
GO
/*52*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationSecondHintPercent')
ALTER TABLE [dbo].[hm_Categories] ADD
    [EscalationSecondHintPercent] [int] NULL
GO
/*53*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationThirdHintPercent')
ALTER TABLE [dbo].[hm_Categories] ADD
    [EscalationThirdHintPercent] [int] NULL
GO
/*54*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationFirstStepMinutes')
ALTER TABLE [dbo].[hm_Categories] ADD
    [EscalationFirstStepMinutes] [int] NULL
GO
/*56*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationSecondStepMinutes')
ALTER TABLE [dbo].[hm_Categories] ADD
    [EscalationSecondStepMinutes] [int] NULL
GO
/*57*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationFirstStepAddEmail')
ALTER TABLE [dbo].[hm_Categories] ADD
    [EscalationFirstStepAddEmail] [varchar] (255) NULL
GO
/*58*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationSecondStepAddEmail1')
ALTER TABLE [dbo].[hm_Categories] ADD
    [EscalationSecondStepAddEmail1] [varchar] (255) NULL
GO
/*59*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationSecondStepAddEmail2')
ALTER TABLE [dbo].[hm_Categories] ADD
    [EscalationSecondStepAddEmail2] [varchar] (255) NULL
GO
/*60*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_TicketDesireDateChange]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketDesireDateChange] (
    [TicketID] [bigint] NOT NULL ,
    [DesireDate] [datetime] NOT NULL ,
    [OnHold] [datetime] NULL ,
    [UserID] [bigint] NOT NULL
) ON [PRIMARY]
GO
/*61*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'PK_hm_TicketDesireDateChange')
ALTER TABLE [dbo].[hm_TicketDesireDateChange] WITH NOCHECK ADD
    CONSTRAINT [PK_hm_TicketDesireDateChange] PRIMARY KEY  CLUSTERED
    (
        [TicketID]
    )  ON [PRIMARY]
GO
/*62*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'AuthLDAP')
    ALTER TABLE [dbo].[hm_Users] ADD [AuthLDAP] [varchar] (255) NULL;
GO
/*63*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'ADguid')
    ALTER TABLE [dbo].[hm_Users] ADD [ADguid] [varchar] (255) NULL;
GO
/*65*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_AuthLDAP]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE hm_AuthLDAP(
	[AuthLDAPTUID] [bigint] IDENTITY(1,1) NOT NULL,
	[LDAPType] [tinyint] NOT NULL CONSTRAINT [DF_hm_AuthLDAP_LDAPType]  DEFAULT ((1)),
	[Server] [varchar](50) NOT NULL,
	[Port] [bigint] NULL,
	[Domain] [varchar](50) NOT NULL,
	[BaseDN] [varchar](100) NOT NULL,
	[LDAPUser] [varchar](200) NULL,
	[LDAPPassword] [varchar](200) NULL,
	[Ordering] [int] NULL,
	[Filter] [varchar](300)  NULL
 ) ON [PRIMARY]
GO
/*66*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'PK_hm_AuthLDAP')
ALTER TABLE [dbo].[hm_AuthLDAP] WITH NOCHECK ADD
 CONSTRAINT [PK_hm_AuthLDAP] PRIMARY KEY CLUSTERED
(
	[AuthLDAPTUID] ASC
) ON [PRIMARY]
GO
/*67*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_NewsGroups]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_NewsGroups] (
    [NewsGroupsID] [bigint] IDENTITY (1, 1) NOT NULL ,
    [NewsID] [bigint] NOT NULL ,
    [GroupID] [bigint] NOT NULL
) ON [PRIMARY]
GO
/*68*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_News' AND COLUMN_NAME = 'NewsGroupID')
ALTER TABLE [dbo].[hm_News] ADD [NewsGroupID] [int] NULL
GO
/*69*/
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_News' AND COLUMN_NAME = 'NewsGroupID')
INSERT INTO [hm_NewsGroups] (NewsID, GroupID) SELECT NewsID, NewsGroupID FROM [hm_News] WHERE NewsGroupID IS NOT NULL AND NewsGroupID > 0
GO
/*70*/
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_News' AND COLUMN_NAME = 'NewsGroupID')
ALTER TABLE [dbo].[hm_News] DROP COLUMN [NewsGroupID]
GO
/*71*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'TicketDesireUpdateDate')
ALTER TABLE [dbo].[hm_Ticket] ADD
	[TicketDesireUpdateDate] [datetime] NULL
GO
/*72*/
ALTER TABLE [dbo].[hm_Users]
  ALTER COLUMN email [varchar] (255) NULL
GO
/*73*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'DesireDatePeriod')
ALTER TABLE [dbo].[hm_TicketFilter] ADD
    [DesireDatePeriod] [tinyint] NULL
GO
/*74*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'CreateDatePeriod')
ALTER TABLE [dbo].[hm_TicketFilter] ADD
    [CreateDatePeriod] [tinyint] NULL
GO
/*75*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'UpdateDatePeriod')
ALTER TABLE [dbo].[hm_TicketFilter] ADD
    [UpdateDatePeriod] [tinyint] NULL
GO
/*76*/

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'InformContact')
ALTER TABLE [dbo].[hm_Categories] ADD
    [InformContact] [tinyint] NULL
GO
/*78*/

ALTER TABLE [dbo].[hm_Users]
  ALTER COLUMN username [varchar] (255) NOT NULL
GO
/*79*/

IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_TicketTemplate]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketTemplate] (
    [TicketTemplateID] [bigint] IDENTITY (1, 1) NOT NULL ,
    [ShortDescr] [varchar] (255) NOT NULL ,
    [LongDescr] [text] NULL ,
    [GroupID] [bigint] NULL,
    [SupporterID] [bigint] NULL,
    [Category1ID] [bigint] NULL,
    [Category2ID] [bigint] NULL,
    [PrioID] [bigint] NULL,
    [CreateDate] [datetime] NOT NULL,
    [CreateUserID] [bigint] NOT NULL,
    [UpdateDate] [datetime] NULL,
    [UpdateUserID] [bigint] NULL,
    [RepeatMode] [tinyint] NULL,
    [DaysOfWeek] [varchar] (20) NULL ,
    [DayOfMonth] [tinyint] NULL ,
    [StartTimePoint] [varchar] (20) NULL ,
    [OnetimePoint] [datetime] NULL ,
    [SerialTicket] [tinyint] NULL,
    [LastCreation] [datetime] NULL,
    [RepeatDays] [tinyint] NULL
) ON [PRIMARY]
GO
/*80*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'IsProblem')
    ALTER TABLE [dbo].[hm_Ticket] ADD [IsProblem] [tinyint] NULL;
GO
/*81*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_RightsSection] WHERE SectionName = 'Sonstiges')
INSERT INTO [dbo].[hm_RightsSection] (SectionName, SectionOrder) VALUES ('Sonstiges', 13)
GO
/*82*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 400)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (400, 'Shoutboxzugriff', 13, 1)
GO
/*83*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 401)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (401, 'Ticketvorlagen erstellen', 13, 2)
GO
/*84*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 402)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (402, 'Tickets aus Vorlagen erstellen', 13, 3)
GO
/*85*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 300 and group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 300)
GO
/*86*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 301 and group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 301)
GO
/*87*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 400 and group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 400)
GO
/*88*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 401 and group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 401)
GO
/*89*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 402 and group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 402)
GO
/*90*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_Shoutbox]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_Shoutbox] (
    [UserID] [bigint] NOT NULL,
    [Message] [text] NOT NULL ,
    [CreateDate] [datetime] NOT NULL
) ON [PRIMARY]
GO
/*91*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'Config')
    ALTER TABLE [dbo].[hm_Users] ADD [Config] [text] NULL;
GO
/*92*/

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketTemplate' AND COLUMN_NAME = 'RepeatMode')
	ALTER TABLE [dbo].[hm_TicketTemplate] ADD [RepeatMode] [tinyint] NULL;
GO
/*93*/

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketTemplate' AND COLUMN_NAME = 'DaysOfWeek')
	ALTER TABLE [dbo].[hm_TicketTemplate] ADD [DaysOfWeek] [varchar] (20) NULL;
GO
/*94*/

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketTemplate' AND COLUMN_NAME = 'DayOfMonth')
	ALTER TABLE [dbo].[hm_TicketTemplate] ADD [DayOfMonth] [tinyint] NULL;
GO
/*95*/

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketTemplate' AND COLUMN_NAME = 'StartTimePoint')
	ALTER TABLE [dbo].[hm_TicketTemplate] ADD [StartTimePoint] [varchar] (20) NULL;
GO
/*96*/

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketTemplate' AND COLUMN_NAME = 'OnetimePoint')
	ALTER TABLE [dbo].[hm_TicketTemplate] ADD [OnetimePoint] [datetime] NULL;
GO
/*97*/

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketTemplate' AND COLUMN_NAME = 'SerialTicket')
	ALTER TABLE [dbo].[hm_TicketTemplate] ADD [SerialTicket] [tinyint] NULL;
GO
/*98*/

IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_ChangeRequest]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ChangeRequest](
    [ChangeRequestID] [bigint] IDENTITY(1,1) NOT NULL,
    [RequesterID] [bigint] NOT NULL,
    [DateOfApplication] [datetime] NOT NULL,
    [Initiator] [varchar](200) NOT NULL,
    [Subject] [varchar](200) NOT NULL,
    [ReminderNo] [int] NOT NULL,
    [Priority] [tinyint] NOT NULL,
    [Consequences] [tinyint] NOT NULL,
    [SystemsConcerned] [text] NULL,
    [Summary] [text] NULL,
    [Category1ID] [bigint] NOT NULL,
    [Category2ID] [bigint] NOT NULL,
    [Phase] [tinyint] NOT NULL,
    [CreateDate] [datetime] NOT NULL,
    [CreateUserID] [bigint] NOT NULL,
    [UpdateDate] [datetime] NULL,
    [UpdateUserID] [bigint] NULL,
    [DenyReason] [text] NULL
) ON [PRIMARY]
GO
/*99*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_ChangeRequestProgress]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ChangeRequestProgress](
    [ChangeRequestProgressID] [bigint] IDENTITY(1,1) NOT NULL,
    [ChangeRequestID] [bigint] NOT NULL,
    [ReminderNo] [int] NULL,
    [Priority] [tinyint] NULL,
    [Category1ID] [bigint] NULL,
    [Category2ID] [bigint] NULL,
    [RealizationPeriod] [int] NULL,
    [SystemPeriod] [int] NULL,
    [Consequences] [tinyint] NULL,
    [CABRequired] [tinyint] NULL,
    [Clearing] [tinyint] NULL,
    [Accepted] [tinyint] NULL,
    [Recovery] [tinyint] NULL,
    [BriefDowntime] [tinyint] NULL,
    [Successful] [tinyint] NULL,
    [SystemsConcerned] [text] NULL,
    [Summary] [text] NULL,
    [ProcessesConcerned] [text] NULL,
    [CustomerConcerned] [text] NULL,
    [CABUsers] [text] NULL,
    [DenyReason] [text] NULL,
    [DenyConsequences] [text] NULL,
    [Release] [text] NULL,
    [Comment] [text] NULL,
    [RecoveryReason] [text] NULL,
    [Testers] [text] NULL,
    [FailedReason] [text] NULL,
    [BuilderID] [bigint] NULL,
    [Phase] [tinyint] NULL,
    [RealizationDate] [datetime] NULL,
    [CABDeadline] [datetime] NULL,
    [ExpectInvestment] [float] NULL,
    [ClearingBy] [varchar](200) NULL,
    [CreateDate] [datetime] NOT NULL,
    [CreateUserID] [bigint] NOT NULL,
    [UpdateDate] [datetime] NULL,
    [UpdateUserID] [bigint] NULL,
    [CabNotify] [tinyint] NULL
) ON [PRIMARY]
GO
/*100*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_ChangeRequestAttachment]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ChangeRequestAttachment](
    [AttachmentID] [bigint] IDENTITY(1,1) NOT NULL,
    [ChangeRequestID] [bigint] NULL,
    [ReminderNo] [int] NULL,
    [Phase] [tinyint] NULL,
    [FileName] [varchar](255) NULL,
    [ChangedFileName] [varchar](255) NULL,
    [FileExtension] [varchar](50) NULL,
    [FileSize] [bigint] NULL,
    [Width] [int] NULL,
    [Height] [int] NULL,
    [CreateDate] [datetime] NOT NULL,
    [CreateUserID] [bigint] NOT NULL,
    [UpdateDate] [datetime] NULL,
    [UpdateUserID] [bigint] NULL,
    [Removed] [tinyint] NULL,
    [ShortDescr] [varchar](200) NULL,
    [LongDescr] [text] NULL,
    [URL] [varchar](255) NULL
) ON [PRIMARY]
GO
/*101*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[HelpdeskCost]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[HelpdeskCost](
    [HelpdeskCostID] [bigint] IDENTITY(1,1) NOT NULL,
    [DateService] [datetime] NOT NULL,
    [TicketNumber] [bigint] NOT NULL,
    [Description] [varchar] (255) NOT NULL ,
    [CostCenter] [varchar] (10) NULL ,
    [Note] [varchar] (300) NULL ,
    [UnitCost] [decimal] (10,2) NOT NULL,
    [Amount] [decimal] (10,2)  NOT NULL,
    [TotalCost] [decimal] (10,2) NOT NULL,
    [DomainName] [varchar] (50) NULL ,
    [HostName] [varchar] (50) NULL ,
    [Status] [int] NOT NULL,
    [CreateDate] [datetime] NOT NULL ,
    [IsDeleted] [int] NOT NULL,
    [DateProcessed] [datetime] NULL ,
    [EmployeeID] [int] NULL ,
    [ProcessRemark] [varchar] (100) NULL ,
    [DateDeleted] [datetime] NULL,
    [TicketEventID] [int] NULL,
    [CostGroupID] [int] NULL DEFAULT (0),
    [Cat1IDForCostGroup] [int] NULL,
    [DeviceID] [int] NULL,
    CONSTRAINT [PK_HelpdeskCost] PRIMARY KEY  CLUSTERED
	(
		[HelpdeskCostID]
	))  ON [PRIMARY]
GO
/*102*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketEvent' AND COLUMN_NAME = 'Invoiced')
ALTER TABLE [dbo].[hm_TicketEvent] ADD
    [Invoiced] [tinyint] NULL
GO
/*103*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'Problem')
ALTER TABLE [dbo].[hm_TicketFilter] ADD
    [Problem] [tinyint] NULL
GO
/*104*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'Deleted')
ALTER TABLE [dbo].[hm_Users] ADD
    [Deleted] [tinyint] NULL
GO
/*105*/
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'Deleted')
    UPDATE hm_Users SET Deleted = 0 WHERE Deleted IS NULL
GO

/*107*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 51)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (51, 'Kategorie 2 ausblenden', 5, 5)
GO
/*108*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'UserGroupID')
ALTER TABLE [dbo].[hm_Ticket] ADD
    [UserGroupID] [bigint] NULL
GO
/*109*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 52)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (52, 'Benutzergruppe anzeigen', 2, 21)
GO
/*110*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 53)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (53, 'Benutzergruppe anlegen', 1, 8)
GO
/*111*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 54)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (54, 'Benutzergruppe bearbeiten', 2, 22)
GO
/*112*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 55)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (55, 'Nur Tickets der Benutzergruppe', 5, 6)
GO
/*113*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 56)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (56, 'Alle Tickets der Firma anzeigen', 5, 7)
GO
/*118*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'ProjectCostRate')
    ALTER TABLE [dbo].[hm_Users] ADD [ProjectCostRate] [DECIMAL] (10,2) NULL
GO
/*119*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_RightsSection] WHERE RightsSectionID = 14)
    INSERT INTO [dbo].[hm_RightsSection] (SectionName, SectionOrder) VALUES ('Projektverwaltung', 14)
GO
/*120*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 500)
   INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (500, 'Zugriff auf Projektverwaltung', 14, 1)
GO
/*121*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 501)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (501, 'Projekte erstellen', 14, 2)
GO
/*122*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 502)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (502, 'Projekte bearbeiten', 14, 3)
GO
/*123*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 503)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (503, 'Projekttypen verwalten', 14, 4)
GO
/*124*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 504)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (504, 'Ticket einem Projekt zuordnen', 14, 5)
GO
/*125*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 505)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (505, 'Projektzuordnung bearbeiten', 14, 6)
GO
/*126*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 500)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 500)
GO
/*127*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 501)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 501)
GO
/*128*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 502)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 502)
GO
/*129*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 503)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 503)
GO
/*130*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 504)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 504)
GO
/*131*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 505)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 505)
GO
/*132*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_CalEvent' AND COLUMN_NAME = 'CalDeviceID')
    ALTER TABLE [dbo].[hm_CalEvent] ADD [CalDeviceID] [BIGINT] NULL
GO
/*133*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 57)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (57, 'Interne Notiz verfassen', 2, 0)
GO
/*134*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 57)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 57)
GO
/*180*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_Project]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_Project](
    [ProjectID] [bigint] IDENTITY(1,1) NOT NULL,
    [ProjectTypeID] [bigint] NOT NULL,
    [ProjectName] [varchar](255) NOT NULL,
    [ProjectFactor] [decimal](10, 2) NULL,
    [Description] [text] NULL,
    [EmployeeID] [bigint] NULL,
    [CostCenterID] [bigint] NULL,
    [Active] [tinyint] NOT NULL CONSTRAINT [DF_hm_Project_Active]  DEFAULT ((1)),
    [StartDate] [datetime] NULL,
    [EndDate] [datetime] NULL,
    [EstimatedBudget] [decimal](10, 2) NULL,
    [UsedBudget] [decimal](10, 2) NULL,
    [CreateUserID] [bigint] NULL,
    [CreateUser] [varchar](100) NULL,
    [CreateDate] [datetime] NULL,
    [UpdateUserID] [bigint] NULL,
    [UpdateUser] [varchar](100) NULL,
    [UpdateDate] [datetime] NULL,
    [Level1ID] [varchar](100) NULL
) ON [PRIMARY]
GO
/*135*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'ProjectFactor')
    ALTER TABLE [dbo].[hm_Project] ADD [ProjectFactor] [DECIMAL] (10,2) NULL
GO
/*137*/
IF EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 58)
    DELETE FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 58
GO
/*144*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 51)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (51, 'Kategorie 2 ausblenden', 5, 5)
GO

/*146*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 52)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (52, 'Benutzergruppe anzeigen', 2, 21)
GO
/*147*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 53)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (53, 'Benutzergruppe anlegen', 1, 8)
GO
/*148*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 54)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (54, 'Benutzergruppe bearbeiten', 2, 22)
GO
/*149*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 55)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (55, 'Nur Tickets der Benutzergruppe', 5, 6)
GO
/*150*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 56)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (56, 'Alle Tickets der Firma anzeigen', 5, 7)
GO
/*152*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_ProjectTypeCostCenter]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ProjectTypeCostCenter](
    [ProjectTypeID] [bigint] NOT NULL,
    [CostCenterID] [bigint] NOT NULL
) ON [PRIMARY]
GO
/*156*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_RightsSection] WHERE RightsSectionID = 14)
    INSERT INTO [dbo].[hm_RightsSection] (SectionName, SectionOrder) VALUES ('Projektverwaltung', 14)
GO
/*158*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 501)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (501, 'Projekte erstellen', 14, 2)
GO
/*159*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 502)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (502, 'Projekte bearbeiten', 14, 3)
GO
/*160*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 503)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (503, 'Projekttypen verwalten', 14, 4)
GO
/*161*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 504)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (504, 'Ticket einem Projekt zuordnen', 14, 5)
GO
/*162*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 505)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (505, 'Projektzuordnung bearbeiten', 14, 6)
GO
/*163*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 500)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 500)
GO
/*164*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 501)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 501)
GO
/*165*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 502)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 502)
GO
/*166*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 503)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 503)
GO
/*167*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 504)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 504)
GO
/*168*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 505)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 505)
GO
/*170*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 57)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (57, 'Interne Notiz verfassen', 2, 0)
GO
/*171*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 57)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 57)
GO
/*172*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'ProjectFactor')
    ALTER TABLE [dbo].[hm_Project] ADD [ProjectFactor] [DECIMAL] (10,2) NULL
GO
/*176*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_Project_Ref_Definition]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_Project_Ref_Definition](
    [ProjectRefDefinitionID] [bigint] IDENTITY(1,1) NOT NULL,
    [TableRef] [varchar](100) NOT NULL,
    [Active] [tinyint] NOT NULL,
    [SourceTable] [varchar](100) NOT NULL,
    [SourceIDField] [varchar](100) NOT NULL,
    [SourceNumberField] [varchar](100) NOT NULL,
    [SourceLabelField] [varchar](100) NOT NULL,
    [SourceNumberFieldRef] [varchar](100) NULL,
    [Name] [varchar](100) NOT NULL,
) ON [PRIMARY]
GO
/*177*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_ProjectTypeLevel1]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ProjectTypeLevel1] (
    [ProjectTypeID] [bigint] NOT NULL,
    [Level1ID] [varchar](100) NOT NULL
) ON [PRIMARY]
GO
/*178*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_ProjectLevel2]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ProjectLevel2] (
    [ProjectID] [bigint] NOT NULL,
    [Level2ID] [varchar](100) NOT NULL
) ON [PRIMARY]
GO
/*179*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_ProjectType]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ProjectType](
    [ProjectTypeID] [bigint] IDENTITY(1,1) NOT NULL,
    [TypeName] [varchar](255) NOT NULL,
    [Description] [text] NULL,
    [Active] [tinyint] NOT NULL CONSTRAINT [DF_hm_ProjectType_Active]  DEFAULT ((1)),
    [Level2ID] [varchar](100) NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_ProjectType' AND COLUMN_NAME = 'Level2ID')
    ALTER TABLE [dbo].[hm_ProjectType] ADD [Level2ID] [varchar](100) NULL
GO
/*181*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_ProjectTicket]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ProjectTicket](
    [ProjectID] [bigint] NOT NULL,
    [TicketID] [bigint] NOT NULL,
    [ProjectCosts] [decimal](10, 2) NULL,
    [Level2ID] [varchar](100) NOT NULL,
) ON [PRIMARY]
GO
/*182*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_ProjectTicket' AND COLUMN_NAME = 'Level2ID')
    ALTER TABLE [dbo].[hm_ProjectTicket] ADD [Level2ID] [varchar](100) NULL
GO
/*183*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'Level1ID')
    ALTER TABLE [dbo].[hm_Project] ADD [Level1ID] [varchar](100) NULL
GO
/*184*/
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_ProjectTicket' AND COLUMN_NAME = 'ProjectTicketID')
    ALTER TABLE [dbo].[hm_ProjectTicket] DROP COLUMN [ProjectTicketID]
GO
/*186*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 60)
  INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (60, 'Erweitertes Reporting anzeigen', 3, 3)
GO
/*187*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'ADguid')
  ALTER TABLE [dbo].[hm_Contacts] ADD [ADguid] [varchar] (255) NULL
GO
/*188*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketEvent' AND COLUMN_NAME = 'Processingtype')
ALTER TABLE [dbo].[hm_TicketEvent] ADD
    Processingtype bigint NULL
GO
/*189*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_ProcessingType]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ProcessingType] (
	[processingtype_id] [bigint] IDENTITY (1, 1) NOT NULL ,
	[description] [varchar] (50)NOT NULL ,
	[sort] [int]  NULL ,
	[created] [datetime] NOT NULL ,
	[updated] [datetime] NULL,
	[published] [tinyint] NOT NULL DEFAULT ((1))
) ON [PRIMARY]
GO
/*190*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_ProcessingType' AND COLUMN_NAME = 'published')
ALTER TABLE [dbo].[hm_ProcessingType] ADD
    [published] [tinyint] NOT NULL DEFAULT ((1))
GO
/*191*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_AuthLDAP' AND COLUMN_NAME = 'Ordering')
    ALTER TABLE [dbo].[hm_AuthLDAP] ADD [Ordering] [int] NULL;
GO
/*192*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Report')
CREATE TABLE [dbo].[hm_Report](
      [ReportID] [bigint] IDENTITY(1,1) NOT NULL,
      [ReportName] [varchar](150) NOT NULL,
      [ReportView] [varchar](200) NOT NULL,
      [IsVisible] [tinyint] NOT NULL
) ON [PRIMARY]
GO
/*193*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketTemplate' AND COLUMN_NAME = 'MonthOfYear')
ALTER TABLE [dbo].[hm_TicketTemplate] ADD
    [MonthOfYear] [tinyint] NULL
GO
/*194*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketEvent' AND COLUMN_NAME = 'EventDate')
ALTER TABLE [dbo].[hm_TicketEvent] ADD
    [EventDate] [datetime] NULL,
    [Deleted] [tinyint] NULL
GO
/*195*/
UPDATE hm_TicketEvent SET EventDate = UpdateDate WHERE EventDate IS NULL
GO
/*196*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_RightsSection] WHERE SectionName = 'Eigene Events')
INSERT INTO [dbo].[hm_RightsSection] (SectionName, SectionOrder) VALUES ('Eigene Events', 15)
GO
/*197*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_RightsSection] WHERE SectionName = 'Alle Events')
INSERT INTO [dbo].[hm_RightsSection] (SectionName, SectionOrder) VALUES ('Alle Events', 16)
GO
/*198*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 600)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (600, 'Beschreibung ndern', 15, 1)
GO
/*199*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 601)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (601, 'EventDate ndern', 15, 2)
GO
/*200*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 602)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (602, 'Aufwand ndern', 15, 3)
GO
/*201*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 603)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (603, 'Event lschen', 15, 4)
GO
/*202*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 610)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (610, 'Beschreibung ndern', 16, 1)
GO
/*203*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 611)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (611, 'EventDate ndern', 16, 2)
GO
/*204*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 612)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (612, 'Aufwand ndern', 16, 3)
GO
/*205*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 613)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (613, 'Event lschen', 16, 4)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 114)
INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (114, 'Ticketexport per Mail', 2, 27)
GO
/*206*/
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'EditDate')
ALTER TABLE [dbo].[hm_Ticket] ADD
    [EditDate] [datetime] NULL
GO
/*207*/
UPDATE hm_Ticket SET EditDate = CreateDate WHERE EditDate IS NULL
GO
/*208*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 610)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 610)
GO
/*209*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 611)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 611)
GO
/*210*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 612)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 612)
GO
/*211*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 613)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 613)
GO

/*212*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 410)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (410, 'Standardeinstellung Liste ndern', 13, 4)
GO
/*213*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 411)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (411, 'Benutzereinstellung Liste ndern', 13, 5)
GO
/*214*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 410)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 410)
GO
/*215*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 411)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 411)
GO
/*216*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_Configuration]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
    CREATE TABLE [dbo].[hm_Configuration] (
    	[ConfigurationID] [int] IDENTITY (1, 1) NOT NULL ,
    	[ConfigurationName] [varchar] (255) NULL ,
    	[Configuration] [text] NULL
    ) ON [PRIMARY]
GO
/*217*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Configuration] WHERE ConfigurationName = 'selectableLists' AND Configuration IS NOT NULL)
    INSERT INTO [dbo].[hm_Configuration] (ConfigurationName, Configuration) VALUES ('selectableLists', 'a:1:{s:10:"Ticketlist";a:3:{s:7:"Columns";s:23:"0,1,2,3,4,5,6,7,9,12,13";s:5:"Sort1";a:2:{s:6:"Column";i:9;s:9:"Direction";i:0;}s:5:"Sort2";a:2:{s:6:"Column";N;s:9:"Direction";i:0;}}}')
GO
/*219*/
if NOT exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_TicketFromEmail]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketFromEmail] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[TicketID] [bigint] NOT NULL ,
	[MessageID] [varchar] (255) NOT NULL ,
	[ImportStatus] [varchar] (10) NULL ,
	[CreateDate] [datetime] NULL ,
	[CreateUserID] [bigint] NULL,
        [Active] [int] NULL
) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFromEmail' AND COLUMN_NAME = 'Active')
    ALTER TABLE [dbo].[hm_TicketFromEmail] ADD [Active] [int] NULL
GO
/*220*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 61)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (61, 'Gertereservierung bearbeiten', 11, 3)
GO
/*221*/
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE group_id = 1 AND right_id = 61)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 61)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 110)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (110, 'Status Erledigt setzen', 2, 24);
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 111)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (111, 'Nur Erledigte schlieen', 2, 25);
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 112)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (112, 'Erledigte weiter bearbeiten', 2, 26);
GO

IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 110 AND group_id = 1)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 110)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 112 AND group_id = 1)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 112)
GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'building')
    ALTER TABLE [dbo].[hm_Contacts] ADD [building] [varchar] (50) NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'room')
    ALTER TABLE [dbo].[hm_Contacts] ADD [room] [varchar] (50) NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_TicketStatus] WHERE ID = 9 AND Descr = 'DONE')
    INSERT INTO hm_TicketStatus (Descr) VALUES ('DONE')
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'floor')
    ALTER TABLE [dbo].[hm_Contacts] ADD [floor] [varchar] (50) NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'CategoryID')
ALTER TABLE [dbo].[hm_TicketFilter] ADD
    [CategoryID] [bigint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'TicketID')
ALTER TABLE [dbo].[hm_TicketFilter] ADD
    [TicketID] [bigint] NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 17)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (17, 'E-Mail an Kontakt anpassen', 2, 0);
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'inCalendar')
ALTER TABLE [dbo].[hm_Categories] ADD
    [inCalendar] [tinyint] NOT NULL DEFAULT ((1))
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'changePW')
ALTER TABLE [dbo].[hm_Users] ADD
    [changePW] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'remfilters')
ALTER TABLE [dbo].[hm_Users] ADD
    [remfilters] [tinyint] NOT NULL DEFAULT (1)
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'GroupID')
ALTER TABLE [dbo].[hm_TicketFilter] ADD
    [GroupID] [bigint] NULL
GO
/*leere Firmen in Contacts sollten NULL sein*/
UPDATE hm_Contacts SET company = NULL WHERE company = ''
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 58)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (58, 'Nur Tickets der eigenen Firma anzeigen', 5, 1);
GO
/* Geschlossene Tickets sind nicht mehr OnHold */
UPDATE hm_Ticket SET OnHold = NULL WHERE TicketStatusID = 3 AND OnHold IS NOT NULL
GO
/* Tickets die OnHold sind, bekommen auch den Status OnHold (8)*/
UPDATE hm_Ticket SET TicketStatusID = 8 WHERE (DATEDIFF(MINUTE,  GETDATE() , hm_Ticket.OnHold) > 0)
GO
/*Entfernte Kontakte auch in der CTE-Tabelle als entfernt markieren */
UPDATE hm_ContactToEmployee SET published = 0 WHERE contactid in (
	SELECT contact_id from hm_Contacts WHERE published <> 1
)
GO
if NOT exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_TimePeriod]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TimePeriod](
	[ID] [int] IDENTITY(5,1) NOT NULL ,
	[Name] [varchar](30) NOT NULL,
	[start_date] [int] NULL,
	[start_months] [int] NULL,
	[start_weeks] [int] NULL,
	[start_days] [int] NULL,
	[end_months] [int] NULL,
	[end_weeks] [int] NULL,
	[end_days] [int] NULL,
	[published] [tinyint] NULL
) ON [PRIMARY]

GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'desiretime_minutes')
ALTER TABLE [dbo].[hm_Categories] ADD [desiretime_minutes] [int] NULL

GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'desiretime_hours')
ALTER TABLE [dbo].[hm_Categories] ADD [desiretime_hours] [int] NULL

GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'desiretime_days')
ALTER TABLE [dbo].[hm_Categories] ADD [desiretime_days] [int] NULL
GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationFirstHintSendMail')
	ALTER TABLE [dbo].[hm_Categories] ADD [EscalationFirstHintSendMail] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationSecondHintSendMail')
	ALTER TABLE [dbo].[hm_Categories] ADD [EscalationSecondHintSendMail] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationThirdHintSendMail')
	ALTER TABLE [dbo].[hm_Categories] ADD [EscalationThirdHintSendMail] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'Category2ID')
ALTER TABLE [dbo].[hm_TicketFilter] ADD
    [Category2ID] [bigint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'TicketBasket')
ALTER TABLE [dbo].[hm_TicketFilter] ADD
    [TicketBasket] [tinyint] NULL
GO

IF NOT exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_TicketBasket]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
    CREATE TABLE [dbo].[hm_TicketBasket](
    	[UserID] [int] NOT NULL,
    	[TicketID] [int] NOT NULL,
    PRIMARY KEY CLUSTERED
    (
    	[UserID] ASC,
    	[TicketID] ASC
    )) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'NoOnHold')
ALTER TABLE [dbo].[hm_TicketFilter] ADD
    [NoOnHold] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'InventoryNumber')
ALTER TABLE [dbo].[hm_Ticket] ADD
    [InventoryNumber] [varchar](50) NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'Prio')
ALTER TABLE [dbo].[hm_Categories] ADD
    [Prio] [tinyint] NOT NULL DEFAULT ((0))
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_AuthLDAP' AND COLUMN_NAME = 'Filter')
    ALTER TABLE [dbo].[hm_AuthLDAP] ADD [Filter] [varchar] (300) NULL
GO
IF NOT exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_GroupLDAPGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_GroupLDAPGroup](
	[GroupID] [int] NOT NULL,
	[LDAPGroupDN] [varchar](500) NOT NULL,
	[Server] [varchar](500) NOT NULL,
 CONSTRAINT [PK_hm_GroupLDAPGroup] PRIMARY KEY CLUSTERED
(
	[GroupID] ASC,
	[Server] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 113)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (113, 'Bearbeitungsart anzeigen', 2, 9)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 113 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 113)

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_LDAPDevices]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_LDAPDevices](
	[DeviceID] [int] IDENTITY(1,1) NOT NULL,
	[Name] [varchar](100) NOT NULL,
	[location] [varchar](100) NULL,
	[descr] [varchar](1000) NULL,
	[OS] [varchar](100) NULL,
	[Type] [varchar](100) NULL,
	[objectguid] [varchar](32) NOT NULL,
	[dn] [varchar](200) NULL,
 CONSTRAINT [PK_hm_LDAPDevice] PRIMARY KEY CLUSTERED
(
	[DeviceID] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_TicketLDAPDevice]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketLDAPDevice](
	[TicketID] [int] NULL,
	[DeviceID] [int] NOT NULL,
	[SessionID] [varchar](64) NULL
) ON [PRIMARY]

GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 62)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (62, 'Gertesuche (Active Directory)', 2, 2)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 62 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 62)
GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_WFDef_Activity]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_WFDef_Activity](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[WFDID] [int] NULL,
	[SessionID] [varchar](60) NULL,
	[Description] [varchar](100) NOT NULL,
	[TargetType] [tinyint] NULL,
	[TargetUserID] [int] NULL,
	[TargetGroupID] [int] NULL,
	[Duration] [float] NOT NULL,
	[ShowPrevInformations] [tinyint] NULL,
	[NotificationType] [tinyint] NULL,
	[NotificationUserID] [int] NULL,
	[NotificationGroupID] [int] NULL,
	[TaskType] [tinyint] NOT NULL,
	[TaskText] [varchar](500) NULL,
	[TaskFormName] [varchar](50) NULL,
	[DesireTime] [float] NULL,
	[StartConID] [tinyint] NULL,
	[Starttime] [float] NULL,
	[UniqID] [varchar](32) NULL,
	[Form] [text] NULL,
 CONSTRAINT [PK_hm_WFDef_Activity] PRIMARY KEY CLUSTERED
(
	[ID] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_WFDef_DependedActivitys]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_WFDef_DependedActivitys](
	[ActivityID] [int] NOT NULL,
	[DependActivityID] [int] NOT NULL
) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_WFDefinitions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_WFDefinitions](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[Description] [varchar](100) NOT NULL,
	[groups] [int] NULL,
	[deleted] [tinyint] NULL,
	[published] [tinyint] NULL,
	[uniqID] [varchar](32) NULL,
 CONSTRAINT [PK_hm_WFDefinitions] PRIMARY KEY CLUSTERED
(
	[ID] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_WFInstanz]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_WFInstanz](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[WFDID] [int] NULL,
	[Descr] [varchar](50) NOT NULL,
	[InitiatorID] [int] NOT NULL,
	[SubstitudeID] [int] NULL,
	[StartDate] [datetime] NULL,
	[EndDate] [datetime] NULL,
	[DateType] [tinyint] NOT NULL,
	[Active] [tinyint] NOT NULL,
	[CreateDate] [datetime] NOT NULL,
	[uniqid] [varchar](32) NULL,
        [ProjectID] [int] NULL,
        [RefLvl2ID] [int] NULL,
[Canceled] [int] DEFAULT 0 NOT NULL,
[UpdateDate] [datetime] NULL,
[UpdateUserID] [bigint] NULL,
[ContactID] [int] NULL
 CONSTRAINT [PK_hm_WFInstanz] PRIMARY KEY CLUSTERED
(
	[ID] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_WorkflowDefActivitys]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_WorkflowDefActivitys](
	[WFID] [int] NOT NULL,
	[ActivityID] [int] NOT NULL,
	[SessionID] [varchar](100) NULL,
 CONSTRAINT [PK_hm_WorkflowDefActivitys] PRIMARY KEY CLUSTERED
(
	[WFID] ASC
)) ON [PRIMARY]

GO

IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 522)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (522, 'Prioritt anzeigen', 2, 8);
GO

IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 521)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (521, 'Flligkeitstermin anzeigen', 2, 8);
GO

IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 524)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (524, 'Aufwand anzeigen', 2, 8);
GO

IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 522 AND group_id = 1)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 522)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 521 AND group_id = 1)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 521)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 524 AND group_id = 1)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 524)
GO
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationCreateDatePercent')
ALTER TABLE [dbo].[hm_Categories] DROP COLUMN [EscalationCreateDatePercent]
GO
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationOnHoldPercent')
ALTER TABLE [dbo].[hm_Categories] DROP COLUMN [EscalationOnHoldPercent]
GO
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationStep3Email')
ALTER TABLE [dbo].[hm_Categories] DROP COLUMN [EscalationStep3Email]
GO
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'EscalationStep5Email')
ALTER TABLE [dbo].[hm_Categories] DROP COLUMN [EscalationStep5Email]
GO
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'published')
ALTER TABLE [dbo].[hm_Categories] ALTER COLUMN [published] [tinyint] NULL

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_WFActive_DepActivities]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_WFActive_DepActivities](
	[AI_ID] [int] NOT NULL,
	[DepAI_ID] [int] NOT NULL,
 CONSTRAINT [PK_hm_WFActive_DepActivities] PRIMARY KEY CLUSTERED
(
	[AI_ID] ASC,
	[DepAI_ID] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_WF_Activity]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_WF_Activity](
	[ActivityID] [int] IDENTITY(1,1) NOT NULL,
	[WFIID] [int] NOT NULL,
	[DefActivityID] [int] NOT NULL,
	[TicketID] [int] NULL,
	[DescriptionName] [varchar](300) NULL,
	[InitiatorID] [int] NOT NULL,
	[GroupID] [int] NULL,
	[Duration] [float] NULL,
	[ShowOtherInformations] [tinyint] NULL,
	[TicketStatusID] [int] NOT NULL,
	[NotificationType] [tinyint] NULL,
	[TaskType] [int] NULL,
	[TaskText] [varchar](500) NULL,
	[Description] [varchar](300) NULL,
	[Expense] [int] NULL,
	[TargetType] [tinyint] NULL,
	[TargetUserID] [int] NULL,
	[TargetGroupID] [int] NULL,
	[NotificationUserID] [int] NULL,
	[NotificationGroupID] [int] NULL,
	[TaskFormName] [varchar](50) NULL,
	[StartConID] [tinyint] NULL,
	[Starttime] [float] NULL,
	[uniqID] [varchar](32) NULL,
	[FormData] [text] NULL,
	[Form] [text] NULL,
	[DesireTime] [float] NULL,
	[showTicket] [tinyint] NULL,
        [ProjectID] [int] NULL,
 CONSTRAINT [PK_hm_WF_Activity] PRIMARY KEY CLUSTERED
(
	[ActivityID] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_TicketStatus] WHERE ID = 10 AND Descr = 'WAITING')
    INSERT INTO hm_TicketStatus (Descr) VALUES ('WAITING')
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_TicketStatus] WHERE ID = 11 AND Descr = 'IMPOSSIBLE')
    INSERT INTO hm_TicketStatus (Descr) VALUES ('IMPOSSIBLE')
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_RightsSection] WHERE SectionName = 'Workflow')
INSERT INTO [dbo].[hm_RightsSection] (SectionName, SectionOrder) VALUES ('Workflow', 17)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 703)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (703, 'Workflows definieren', 17, 2)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 705)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (705, 'Workflows starten', 17, 6)
GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'SupporterID')
    ALTER TABLE [dbo].[hm_TicketFilter] ADD [SupporterID] [bigint] NULL;
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 703 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 703)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 705 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 705)
GO
ALTER TABLE [dbo].[hm_Ticket]
  ALTER COLUMN [TicketDescr] [varchar] (500) NULL
GO
ALTER TABLE [dbo].[hm_TicketHistory]
  ALTER COLUMN [TicketDescr] [varchar] (500) NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 412)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (412, 'Kalender anzeigen', 13, 6)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 412 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 412)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 63)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (63, 'Nur Hauptkategorien anzeigen', 7, 4)

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_TicketTemplateGroups]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketTemplateGroups](
	[TicketTemplateID] [int] NOT NULL,
	[GroupID] [int] NOT NULL,
 CONSTRAINT [PK_hm_TemplateGroups] PRIMARY KEY CLUSTERED
(
	[TicketTemplateID] ASC,
	[GroupID] ASC
)) ON [PRIMARY]

GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'UseRootEscalation')
ALTER TABLE [dbo].[hm_Categories] ADD [UseRootEscalation] [tinyint] NOT NULL DEFAULT (1)

GO

IF EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_CategoryForms]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
    IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_CategoryForms' AND COLUMN_NAME = 'Required')
        ALTER TABLE [dbo].[hm_CategoryForms] ADD [Required] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'sendEmails')
  ALTER TABLE [dbo].[hm_Contacts] ADD [sendEmails] [tinyint] NOT NULL DEFAULT (1)
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'CostCenter')
  ALTER TABLE [dbo].[hm_Contacts] ADD [CostCenter] [varchar](255) NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 1005)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (1005, 'Kontaktliste anzeigen', 10, 6)
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'department')
  ALTER TABLE [dbo].[hm_Contacts] ADD [department] [varchar](255) NULL

GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'Config')
  ALTER TABLE [dbo].[hm_TicketFilter] ADD [Config] [text] NULL

GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'SolutionDate')
  ALTER TABLE [dbo].[hm_Ticket] ADD [SolutionDate] [datetime] NULL

GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'PrioAccepted')
  ALTER TABLE [dbo].[hm_Ticket] ADD [PrioAccepted] [tinyint] NULL

GO

IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 65)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (65, 'Nur Tickets der eigenen Abteilung anzeigen', 5, 8)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 66)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (66, 'Auch Tickets der eigenen Abteilung anzeigen', 5, 8)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 67)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (67, 'Nur Tickets von Kontakten aus eigenen Gruppen', 5, 9)
GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketEvent' AND COLUMN_NAME = 'CostGroupID')
    ALTER TABLE [dbo].[hm_TicketEvent] ADD [CostGroupID] [int] NULL DEFAULT (0)
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketEvent' AND COLUMN_NAME = 'CostRatePerMinute')
    ALTER TABLE [dbo].[hm_TicketEvent] ADD [CostRatePerMinute] [float] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketEvent' AND COLUMN_NAME = 'Cat1IDForCostGroup')
    ALTER TABLE [dbo].[hm_TicketEvent] ADD [Cat1IDForCostGroup] [int] NULL
GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CostCategories]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CostCategories](
	[CategoryID] [bigint] NOT NULL,
	[CostGroupID] [int] NOT NULL,
	[StartDate] [datetime] NOT NULL
) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CostCurrency]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CostCurrency](
	[CostCurrencyID] [int] IDENTITY(1,1) NOT NULL,
	[Symbol] [varchar](10) NULL,
	[Name] [varchar](255) NOT NULL,
	[Shortname] [varchar](10) NULL,
 CONSTRAINT [PK_hm_CostCurreny] PRIMARY KEY CLUSTERED
(
	[CostCurrencyID] ASC
))ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CostDefault]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CostDefault](
	[CostGroupID] [int] NOT NULL,
	[StartDate] [datetime] NOT NULL
) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CostEntity]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CostEntity](
	[CostEntityID] [int] IDENTITY(1,1) NOT NULL,
	[Description] [varchar](100) NOT NULL,
	[PerMinute] [float] NOT NULL,
 CONSTRAINT [PK_hm_CostEntitys] PRIMARY KEY CLUSTERED
(
	[CostEntityID] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CostGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CostGroup](
	[CostGroupID] [int] IDENTITY(1,1) NOT NULL,
	[Description] [varchar](100) NOT NULL,
	[Deleted] [tinyint] NULL,
 CONSTRAINT [PK_CostType] PRIMARY KEY CLUSTERED
(
	[CostGroupID] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CostGroupRate]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CostGroupRate](
	[CostGroupID] [int] NOT NULL,
	[CostRateID] [int] NOT NULL,
	[StartDate] [datetime] NOT NULL
) ON [PRIMARY]

GO
INSERT INTO HM_CostGroupRate (CostGroupID, CostRateID, StartDate) VALUES (0,0,'20000101')
GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CostRate]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CostRate](
	[CostRateID] [int] IDENTITY(1,1) NOT NULL,
	[CreateDate] [datetime] NOT NULL,
	[CreateUserID] [int] NULL,
	[CostRate] [float] NOT NULL,
	[CostCurrencyID] [int] NOT NULL,
	[CostEntityID] [int] NOT NULL,
 CONSTRAINT [PK_CostRate] PRIMARY KEY CLUSTERED
(
	[CostRateID] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CostUsers]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CostUsers](
	[UserID] [bigint] NOT NULL,
	[CostGroupID] [int] NOT NULL,
	[StartDate] [datetime] NOT NULL
) ON [PRIMARY]
GO
IF EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CostCurrency]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
    IF NOT EXISTS (SELECT * FROM [dbo].[hm_CostCurrency] WHERE Name = 'Euro')
        INSERT INTO [dbo].[hm_CostCurrency] ([Symbol],[Name],[Shortname]) VALUES ('&#8364;', 'Euro', 'EUR')

GO
IF EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CostCurrency]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
    IF NOT EXISTS (SELECT * FROM [dbo].[hm_CostCurrency] WHERE Shortname = 'USD')
        INSERT INTO [dbo].[hm_CostCurrency] ([Symbol],[Name],[Shortname]) VALUES ('&#36;', 'Dollar', 'USD')

GO
IF EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CostCurrency]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
    IF NOT EXISTS (SELECT * FROM [dbo].[hm_CostCurrency] WHERE Shortname = 'CHF')
        INSERT INTO [dbo].[hm_CostCurrency] ([Symbol],[Name],[Shortname]) VALUES ('CHF', 'Schweizer Franken', 'CHF')

GO
IF EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CostEntity]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
    IF NOT EXISTS (SELECT * FROM [dbo].[hm_CostEntity] WHERE Description = 'Stunde')
            INSERT INTO [dbo].[hm_CostEntity] ([Description],[PerMinute]) VALUES ('Stunde' ,0.0166666666666667)

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_ProjectCostTicketEvent]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ProjectCostTicketEvent](
	[ProjectID] [bigint] NOT NULL,
	[CostRatePerMinute] [float] NOT NULL,
	[TicketEventID] [bigint] NOT NULL,
	[Expense] [int] NOT NULL,
	[CreateDate] [datetime] NOT NULL,
	[UpdateDate] [datetime] NOT NULL,
	[CreateUserID] [int] NOT NULL,
	[UpdateUserID] [int] NOT NULL,
    [ProjectFactor] [float] NOT NULL DEFAULT (1),
 CONSTRAINT [PK_hm_ProjectCostTicketEvent] PRIMARY KEY CLUSTERED
(
	[ProjectID] ASC,
	[TicketEventID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketEvent' AND COLUMN_NAME = 'ProjectCostRatePerMinute')
    ALTER TABLE [dbo].[hm_TicketEvent] ADD [ProjectCostRatePerMinute] [float] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketEvent' AND COLUMN_NAME = 'ProjectFactor')
    ALTER TABLE [dbo].[hm_TicketEvent] ADD [ProjectFactor] [float] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketEvent' AND COLUMN_NAME = 'ProjectCostGroupID')
    ALTER TABLE dbo.hm_TicketEvent ADD [ProjectCostGroupID] int NULL DEFAULT (0)
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketEvent' AND COLUMN_NAME = 'ProjectCostRateSource')
    ALTER TABLE dbo.hm_TicketEvent ADD [ProjectCostRateSource] varchar(15) NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='HelpdeskCost' AND COLUMN_NAME = 'TicketEventID')
    ALTER TABLE dbo.HelpdeskCost ADD [TicketEventID] [int] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='HelpdeskCost' AND COLUMN_NAME = 'DeviceID')
    ALTER TABLE dbo.HelpdeskCost ADD [DeviceID] [int] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='HelpdeskCost' AND COLUMN_NAME = 'CostGroupID')
    ALTER TABLE dbo.HelpdeskCost ADD [CostGroupID] [int] NULL DEFAULT (0)
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='HelpdeskCost' AND COLUMN_NAME = 'Cat1IDForCostGroup')
    ALTER TABLE [dbo].[HelpdeskCost] ADD [Cat1IDForCostGroup] [int] NULL
GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_MailRecipientsForEvent]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_MailRecipientsForEvent](
	[RecipientID] [bigint] IDENTITY(1,1) NOT NULL,
	[TicketEventID] [bigint] NOT NULL,
	[eMail] [varchar](250) NOT NULL,
	[RealName] [varchar](250) NULL,
	[RecipientType] [varchar](10) NOT NULL
) ON [PRIMARY]

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_MailsSendTo]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_MailsSendTo](
	[MessageID] [bigint] IDENTITY(1,1) NOT NULL,
	[Recipient] [varchar](250) NULL,
	[Title] [varchar](500) NOT NULL,
	[TicketEventID] [bigint] NOT NULL,
	[SentTo] [varchar](50) NOT NULL,
	[CreateDate] [datetime] NOT NULL,
 CONSTRAINT [PK_hm_MailsSendTo] PRIMARY KEY CLUSTERED
(
	[MessageID] ASC
)) ON [PRIMARY]

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_MailToFromTicketEvent]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_MailToFromTicketEvent](
	[SendMailsForEventID] [bigint] IDENTITY(1,1) NOT NULL,
	[TicketEventID] [bigint] NOT NULL,
	[eMail] [varchar](250) NOT NULL,
	[RealName] [varchar](250) NULL,
	[AddressSource] [varchar](10) NOT NULL,
	[Service] [varchar](10) NULL
) ON [PRIMARY]

GO

UPDATE hm_TicketEvent SET CostGroupID = 0 WHERE CostGroupID IS NULL

GO

IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 115)
INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (115, 'Inventarnummer ndern', 2, 28);

GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'KaufbInventoryNumber')
ALTER TABLE [dbo].[hm_Ticket] ADD
    [KaufbInventoryNumber] [bigint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'CreateUserID')
    ALTER TABLE [dbo].[hm_TicketFilter] ADD [CreateUserID] [bigint] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'UpdateUserID')
    ALTER TABLE [dbo].[hm_TicketFilter] ADD [UpdateUserID] [bigint] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketTemplate' AND COLUMN_NAME = 'ContactID')
	ALTER TABLE [dbo].[hm_TicketTemplate] ADD [ContactID] [bigint] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'WorkOnDatePeriod')
ALTER TABLE [dbo].[hm_TicketFilter] ADD [WorkOnDatePeriod] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'WorkOnDateStart')
ALTER TABLE [dbo].[hm_TicketFilter] ADD [WorkOnDateStart] [datetime] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'WorkOnDateEnd')
ALTER TABLE [dbo].[hm_TicketFilter] ADD [WorkOnDateEnd] [datetime] NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 210)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (210, 'Tickets kopieren', 1, 28)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 210 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 210)
GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_TicketReferences]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketReferences] (
	[TicketID] [bigint] NOT NULL ,
	[ConnectedTicketID] [bigint] NOT NULL ,
	[OnHoldFlag] [tinyint] NULL ,
 CONSTRAINT [PK_TicketReferences] PRIMARY KEY CLUSTERED
(
	[TicketID] ASC,
	[ConnectedTicketID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 211)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (211, 'Tickets verknpfen', 2, 29)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 211 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 211)
GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_MailAccounts]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_MailAccounts](
	[MailAccountID] [int] NOT NULL IDENTITY(1,1),
	[MailServer] [varchar](300) NOT NULL,
	[MailUser] [varchar](300) NOT NULL,
	[MailPassword] [varchar](300) NOT NULL,
	[CategoryID] [int] NULL,
	[ContactID] [int] NULL,
	[SupporterID] [int] NULL,
	[GroupID] [int] NULL,
	[Active] [tinyint] NULL,
	[LeaveMessages] [tinyint] NULL,
 CONSTRAINT [PK_hm_MailAccounts] PRIMARY KEY CLUSTERED
(
	[MailAccountID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_MailTicketxContacts]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_MailTicketxContacts](
	[contact_id] [int] NOT NULL,
	[user_id] [int] NOT NULL,
	[LastUseDate] [datetime] NOT NULL,
	[CountUses] [int] NOT NULL,
 CONSTRAINT [PK_hm_MailTicketxContacts] PRIMARY KEY CLUSTERED
(
	[contact_id] ASC,
	[user_id] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'eMailTicketAddress')
    ALTER TABLE [dbo].[hm_Contacts] ADD [eMailTicketAddress] [int] NULL

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_TicketRequiredAction]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketRequiredAction](
	[TicketID] [int] NOT NULL,
	[TicketEventID] [int] NOT NULL,
 CONSTRAINT [PK_TicketRequiredAction] PRIMARY KEY CLUSTERED
(
	[TicketID] ASC,
	[TicketEventID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Groups' AND COLUMN_NAME = 'SupportGroup')
    ALTER TABLE [dbo].[hm_Groups] ADD [SupportGroup] [int] NULL

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CategoryMailSender]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CategoryMailSender](
	[MailaddressID] [int] IDENTITY(1,1) NOT NULL,
	[MailAddress] [varchar](500) NOT NULL,
	[CategoryID] [int] NOT NULL,
	[UpdateDate] [smalldatetime] NULL,
	[AddressOrSubject] [tinyint] NULL,
 CONSTRAINT [PK_CategoryMailAddress] PRIMARY KEY CLUSTERED
(
	[MailaddressID] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CRProjectCRs]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CRProjectCRs](
	[ProjectID] [int] NOT NULL,
	[CRID] [int] NOT NULL,
	[UpdateDate] [datetime] NOT NULL DEFAULT GETDATE(),
	[removed] [int] NULL,
    [SessionID] [varchar](32) NULL,
 CONSTRAINT [PK_hm_CRProjectCRs] PRIMARY KEY CLUSTERED
(
	[ProjectID] ASC,
	[CRID] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CRProjects]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CRProjects](
	[ProjectID] [int] NOT NULL IDENTITY(1,1),
	[ProjectName] [varchar](300) NOT NULL,
	[Descr] [varchar](2000) NULL,
	[CoordinatorID] [int] NULL,
	[published] [int] NULL DEFAULT (1),
 CONSTRAINT [PK_hm_CRProjects] PRIMARY KEY CLUSTERED
(
	[ProjectID] ASC
)) ON [PRIMARY]

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CRProcesses]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CRProcesses](
	[ProcessID] [int] IDENTITY(1,1) NOT NULL,
	[ProcessName] [varchar](300) NULL,
	[Descr] [varchar](2000) NULL,
	[UpdateDate] [datetime] NULL DEFAULT (getdate()),
	[UpdateUserID] [int] NULL,
	[CoordinatorID] [int] NULL,
	[ContactID] [int] NULL,
 CONSTRAINT [PK_hm_CRProcesses2] PRIMARY KEY CLUSTERED
(
	[ProcessID] ASC
) ) ON [PRIMARY]

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CRComponents]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CRComponents](
	[ComponentID] [int] NOT NULL IDENTITY(1,1),
	[ComponentName] [varchar](300) NULL,
	[Descr] [varchar](2000) NULL,
    [ProcessID] [int] NOT NULL,
	[UpdateDate] [datetime] NULL DEFAULT GetDate(),
	[UpdateUserID] [int] NULL,
 CONSTRAINT [PK_hm_CRComponents] PRIMARY KEY CLUSTERED
(
	[ComponentID] ASC
)) ON [PRIMARY]

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CRVersions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CRVersions](
	[VersionID] [int] IDENTITY(1,1) NOT NULL,
	[VersionName] [varchar](300) NULL,
	[Descr] [varchar](2000) NULL,
	[ProcessID] [int] NOT NULL,
	[UpdateDate] [datetime] NULL DEFAULT (getdate()),
	[UpdateUserID] [int] NULL,
 CONSTRAINT [PK_hm_CRVersions] PRIMARY KEY CLUSTERED
(
	[VersionID] ASC
)) ON [PRIMARY]

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CRs]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CRs](
	[CRID] [int] IDENTITY(1,1) NOT NULL,
	[ShortDescr] [varchar](500) NOT NULL,
	[LongDescr] [varchar](2000) NULL,
	[WhoEntered] [int] NOT NULL,
	[CreateDate] [datetime] NOT NULL,
	[UpdateDate] [datetime] NULL,
	[SolutionDate] [datetime] NULL,
	[RememberDate] [datetime] NULL,
	[OnHoldDate] [datetime] NULL,
	[ProcedureID] [int] NULL,
	[ComponentID] [int] NULL,
	[NewVersionID] [int] NULL,
	[VersionID] [int] NULL,
	[CoordinatorID] [int] NULL,
	[CRTypeID] [int] NULL,
	[PrioID] [int] NULL,
	[IsError] [int] NOT NULL,
	[ErrorLevel] [int] NULL,
	[ErrorRepro] [int] NULL,
	[ExpenseCat] [int] NULL,
	[ExpensePT] [float] NULL,
	[ExpenseEUR] [float] NULL,
	[ContractorID] [int] NULL,
	[StatusID] [int] NULL,
 CONSTRAINT [PK_hm_CRs] PRIMARY KEY CLUSTERED
(
	[CRID] ASC
)) ON [PRIMARY]

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CRApplicant]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CRApplicant](
	[CRID] [int] NOT NULL,
	[ContactID] [int] NOT NULL,
 CONSTRAINT [PK_hm_CRApplicant] PRIMARY KEY CLUSTERED
(
	[CRID] ASC,
	[ContactID] ASC
)) ON [PRIMARY]

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CREvents]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CREvents](
	[EventID] [int] IDENTITY(1,1) NOT NULL,
    [CRID] [bigint] NOT NULL,
	[EventDescr] [varchar](5000) NULL DEFAULT 'No description',
	[EventType] [int] NOT NULL DEFAULT 1,
	[CreateDate] [datetime] NOT NULL DEFAULT (getdate()),
	[CreateUserID] [int] NOT NULL,
 CONSTRAINT [PK_hm_CREvents] PRIMARY KEY CLUSTERED
(
	[EventID] ASC
)) ON [PRIMARY]
GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CRAttachment]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CRAttachment](
	[AttachmentID] [int] NOT NULL,
	[CRID] [int] NOT NULL,
 CONSTRAINT [PK_hm_CRAttachment] PRIMARY KEY CLUSTERED
(
	[AttachmentID] ASC,
	[CRID] ASC
)) ON [PRIMARY]

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CRCABs]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CRCABs](
	[CRID] [int] NOT NULL,
	[ContactID] [int] NOT NULL,
	[SessionID] [varchar](64) NULL,
 CONSTRAINT [PK_hm_CRCABs] PRIMARY KEY CLUSTERED
(
	[CRID] ASC,
	[ContactID] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_RightsSection] WHERE SectionName = 'Change Request')
INSERT INTO hm_RightsSection (SectionName, SectionOrder) VALUES ('Change Request', 18);
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 801)
INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder) VALUES (801, 'CR-Admin', 18, 10)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 802)
INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder) VALUES (802, 'ChangeRequest erstellen', 18, 15)
GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CRRoleListDef]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CRRoleListDef](
	[Role] [varchar](50) NOT NULL,
	[Headers] [varchar](5000) NOT NULL,
 CONSTRAINT [PK_hm_CRRoleListDef] PRIMARY KEY CLUSTERED
(
	[Role] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CRSendMessage]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CRSendMessage](
	[CRID] [bigint] NOT NULL,
	[EventID] [bigint] NULL,
	[Role] [varchar](50) NOT NULL,
	[UserID] [bigint] NULL,
	[ContactID] [bigint] NULL,
	[CreateDate] [datetime] NOT NULL DEFAULT (GETDATE())
) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_CREvents' AND COLUMN_NAME = 'VisibleCAB')
ALTER TABLE dbo.hm_CREvents ADD
	VisibleCAB tinyint NULL,
	VisibleContractor tinyint NULL
GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CRProjectProtocol]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CRProjectProtocol](
	[ID] [bigint] IDENTITY(1,1) NOT NULL ,
	[ProjectID] [int] NOT NULL,
	[CRID] [bigint] NOT NULL,
	[Action] [tinyint] NOT NULL,
 CONSTRAINT [PK_hm_CRProjectProtocol] PRIMARY KEY CLUSTERED
(
	[ID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 803)
INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder) VALUES (803, 'Verfahren verwalten', 18, 20)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 804)
INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder) VALUES (804, 'Projekte verwalten', 18, 25)
GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_CRConnectedCRs]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_CRConnectedCRs](
	[CRID] [bigint] NOT NULL,
	[ConnectedCRID] [bigint] NOT NULL,
	[connectdate] [datetime] NULL,
 CONSTRAINT [PK_hm_CRConnectedCRs] PRIMARY KEY CLUSTERED
(
	[CRID] ASC,
	[ConnectedCRID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_SubjectFilters]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_SubjectFilters](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[SubjectFilter] [varchar](500)  NOT NULL,
	[Active] [tinyint] NULL,
 CONSTRAINT [PK_hm_SubjectFilters] PRIMARY KEY CLUSTERED
(
	[ID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WF_Activity' AND COLUMN_NAME = 'showTicket')
ALTER TABLE dbo.hm_WF_Activity ADD
	showTicket tinyint NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 810)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (810, 'Formulare bearbeiten', 8, 3);
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_CategoryForms]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
    CREATE TABLE [dbo].[hm_CategoryForms] (
        [FormID] [bigint] IDENTITY (1, 1) NOT NULL ,
        [TableName] [varchar] (100) ,
        [FormName] [varchar] (100) NOT NULL ,
        [CategoryID] [bigint] NOT NULL ,
        [Published] [tinyint] NOT NULL ,
        [FormData] [text] ,
        [Deleted] [tinyint] NOT NULL ,
        [CreateDate] [datetime] NULL ,
        [CreateUserID] [bigint] NULL ,
        [UpdateDate] [datetime] NULL ,
        [UpdateUserID] [bigint] NULL ,
        [Required] [tinyint] NULL,
        [TicketTemplateID] [int] NULL,
        [SequenceName] [varchar] (100) ,
        [TriggerName] [varchar] (100)
    ) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
IF EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_CategoryForms]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
    IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_CategoryForms' AND COLUMN_NAME = 'TicketTemplateID')
        ALTER TABLE [dbo].[hm_CategoryForms] ADD [TicketTemplateID] [int] NULL;
GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketTemplate' AND COLUMN_NAME = 'RepeatDays')
	ALTER TABLE [dbo].[hm_TicketTemplate] ADD [RepeatDays] [tinyint] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketTemplate' AND COLUMN_NAME = 'LastCreation')
	ALTER TABLE [dbo].[hm_TicketTemplate] ADD [LastCreation] [datetime] NULL;

GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_TicketForm]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
    CREATE TABLE [dbo].[hm_TicketForm] (
        [TicketID] [bigint] NOT NULL ,
        [FormID] [bigint] NOT NULL,
 CONSTRAINT [PK_hm_TicketForm] PRIMARY KEY CLUSTERED
(
	[TicketID] ASC,
	[FormID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 116)
INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (116, 'Tickets nicht schlieen', 2, 26);

GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'anonymous')
ALTER TABLE [dbo].[hm_Ticket] ADD
    [anonymous] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_ServicesData]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
    CREATE TABLE [dbo].[hm_ServicesData] (
        [ServiceType] [varchar](20) NULL,
    	[StartDate] [datetime] NULL,
    	[Version] [varchar](10) NULL,
    	[PathToService] [varchar](200) NULL,
    	[ServiceActive] [tinyint] NULL
    )
GO

/*SLA*/
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_SLADataCache]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_SLADataCache](
	[SLAID] [int] NOT NULL,
	[Tickets] [int] NOT NULL,
	[inTime] [int] NULL,
	[outTime] [int] NULL,
	[inTimePercent] [float] NULL,
	[outTimePercent] [float] NULL,
	[CacheTimestamp] [bigint] NULL,
    [StartDate] [datetime] NULL,
	[EndDate] [datetime] NULL,
 CONSTRAINT [PK_hm_SLADataCache_1] PRIMARY KEY CLUSTERED
(
	[SLAID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_SLADefinition]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_SLADefinition](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[Description] [varchar](100) NOT NULL,
	[SLAObjectTable] [varchar](50) NOT NULL,
	[SLAObjectField] [varchar](50) NOT NULL,
	[SLAObjectID] [int] NOT NULL,
	[TimeType] [int] NOT NULL,
	[ValidRangeBegin] [datetime] NULL,
	[TargetStatus] [int] NULL,
	[SLATime] [int] NULL,
	[Active] [int] NULL,
	[UpdateDate] [datetime] NULL,
	[UpdateUserID] [int] NULL,
	[CreateDate] [datetime] NULL,
	[CreateUserID] [int] NULL,
 CONSTRAINT [PK_hm_SLADefinition] PRIMARY KEY CLUSTERED
(
	[ID] ASC
)) ON [PRIMARY]

GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_SLATimeTicket]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_SLATimeTicket](
	[TicketID] [int] NOT NULL,
	[SLAID] [int] NOT NULL,
	[EndDate] [datetime] NULL,
	[StartDate] [datetime] NULL,
	[CacheMinutes] [bigint] NULL,
    [isOutTime] [tinyint] NULL,
 CONSTRAINT [PK_hm_SLATimeTicket] PRIMARY KEY CLUSTERED
(
	[TicketID] ASC,
	[SLAID] ASC
) ) ON [PRIMARY]

GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_TicketOnHoldStartStop]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketOnHoldStartStop](
	[OnHoldID] [bigint] IDENTITY(1,1) NOT NULL,
	[TicketID] [bigint] NOT NULL,
	[OnHoldStart] [datetime] NOT NULL,
	[OnHoldStop] [datetime] NULL,
 CONSTRAINT [PK_hm_TicketOnHoldStartStop_1] PRIMARY KEY CLUSTERED
(
	[OnHoldID] ASC,
	[TicketID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 302)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (302, 'SLA-Reports anzeigen', 3, 5)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 303)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (303, 'SLAs bearbeiten', 3, 5)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_Company]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_Company](
	[CompanyID] [bigint] IDENTITY(1,1) NOT NULL,
	[company] [varchar](100) NULL,
	[Deleted] [tinyint] NULL,
 CONSTRAINT [PK_hm_Company] PRIMARY KEY CLUSTERED
(
	[CompanyID] ASC
) ) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'CompanyID')
    ALTER TABLE [dbo].[hm_Contacts] ADD [CompanyID] [int] NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 215)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (215, 'Gruppe ndern', 2, 1)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 216)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (216, 'Supporter ndern', 2, 1)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 217)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (217, 'Gruppe ist Pflichtfeld', 1, 2)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 218)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
        VALUES (218, 'Supporter ist Pflichtfeld', 1, 2)
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_SLATimeTicket' AND COLUMN_NAME = 'isOutTime')
    ALTER TABLE [dbo].[hm_SLATimeTicket] ADD [isOutTime] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_SLATimeCache]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_SLATimeCache](
	[StartDate] [datetime] NOT NULL,
	[EndDate] [datetime]NOT NULL,
	[Minutes] [bigint] NOT NULL,
 CONSTRAINT [PK_hm_SLATimeCache] PRIMARY KEY CLUSTERED
(
	[StartDate] ASC,
	[EndDate] ASC
) ) ON [PRIMARY]

GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketEvent' AND COLUMN_NAME = 'IFrameID')
    ALTER TABLE [dbo].[hm_TicketEvent] ADD [IFrameID] varchar(13) NULL

GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_TicketListCache]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketListCache](
	[UserID] [int] NOT NULL,
	[Timestamp] [int] NOT NULL,
	[HashValue] [varchar](32) NOT NULL,
	[TicketIDs] [text] NULL,
	[Part]	[int]	NOT NULL
 CONSTRAINT [PK_hm_TicketListCache] PRIMARY KEY CLUSTERED
(
	[UserID] ASC,
	[Timestamp] ASC,
	[HashValue] ASC,
	[Part] ASC
) ) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Categories' AND COLUMN_NAME = 'NeedDevice')
    ALTER TABLE [dbo].[hm_Categories] ADD [NeedDevice] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 59)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder) VALUES (59, 'Geschlossene Tickets nicht anzeigen', 5, 10)
GO
--Rechte ndern
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 26 AND RightName = 'Alle Tickets bearbeiten (Supporter)')
BEGIN
    UPDATE hm_Rights SET RightsOrder =  RightsOrder + 2 WHERE RightsSectionID = 1
    UPDATE hm_Rights SET RightsOrder = 0 WHERE RightID = 1

    UPDATE hm_Rights SET RightsSectionID = 2 WHERE RightID = 51
    UPDATE hm_Rights SET RightsOrder =  RightsOrder + 3 WHERE RightsSectionID = 2
    UPDATE hm_Rights SET RightsOrder = 0 WHERE RightID = 26
    UPDATE hm_Rights SET RightsOrder = 1 WHERE RightID IN (17, 16)
    UPDATE hm_Rights SET RightsOrder = 2 WHERE RightID IN (45, 13, 62)

    UPDATE hm_Rights SET RightName = 'Alle Tickets bearbeiten (Supporter)' WHERE RightID = 26

    UPDATE hm_RightsSection SET SectionName = 'Eigene Bearbeitungen' WHERE RightsSectionID = 15
    UPDATE hm_RightsSection SET SectionName = 'Alle Bearbeitungen' WHERE RightsSectionID = 16

    --Workflow-Rechte lschen
    DELETE FROM hm_RightsSection WHERE RightsSectionID = 18
    DELETE FROM hm_Rights WHERE RightsSectionID = 18

    UPDATE hm_Rights SET RightName = '+ Tickets der Gruppe(n)' WHERE RightID = 55
    UPDATE hm_Rights SET RightName = '+ unkategorisierte Tickets' WHERE RightID = 101
    UPDATE hm_Rights SET RightName = '+ Tickets der eigenen Firma' WHERE RightID = 56
    UPDATE hm_Rights Set RightName = '+ Tickets der eigenen Abteilung' WHERE RightID = 66

    UPDATE hm_Rights Set RightsOrder = 10 WHERE RightsSectionID = 5
    UPDATE hm_Rights Set RightsOrder = 1 WHERE RightID = 50
    UPDATE hm_Rights Set RightsOrder = 2 WHERE RightID = 58
    UPDATE hm_Rights Set RightsOrder = 3 WHERE RightID = 65
    UPDATE hm_Rights Set RightsOrder = 4 WHERE RightID = 67
    UPDATE hm_Rights Set RightsOrder = 5 WHERE RightID = 29
    UPDATE hm_Rights Set RightsOrder = 6 WHERE RightID = 28
    UPDATE hm_Rights Set RightsOrder = 11 WHERE RightID = 59
END


GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_Tags]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_Tags](
	[ID] [bigint] IDENTITY(1,1) NOT NULL,
	[Tag] [varchar](100) NOT NULL
 CONSTRAINT [PK_hm_Tags] PRIMARY KEY CLUSTERED
(
	[ID] ASC,
    [Tag] ASC
) ) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_TicketTags]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketTags](
	[TicketID] [bigint] NOT NULL,
	[TagID] [bigint] NOT NULL
 CONSTRAINT [PK_hm_TicketTags] PRIMARY KEY CLUSTERED
(
	[TicketID] ASC,
    [TagID] ASC
) ) ON [PRIMARY]

GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 219)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (219, 'Schlagworte', 2, 39);
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 220)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (220, 'Schlagworte bearbeiten', 2, 40);
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'archived')
ALTER TABLE [dbo].[hm_Ticket] ADD [archived] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'archivdate')
ALTER TABLE [dbo].[hm_Ticket] ADD [archivdate] [datetime] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'archivuserid')
ALTER TABLE [dbo].[hm_Ticket] ADD [archivuserid] [int] NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 221)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (221, 'Tickets archivieren', 2, 0)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 221 AND group_id = 1)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 221)
GO
DELETE FROM hm_GroupRights WHERE Group_ID = 1 AND Right_ID = 16;
GO
DELETE FROM hm_GroupRights WHERE Group_ID = 1 AND Right_ID = 17;
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 304)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (304, 'ChangeRequests anzeigen', 12, 5)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 304 AND group_id = 1)
    INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 304)
GO
UPDATE hm_News SET UpdateDate = CreateDate WHERE UpdateDate IS NULL
GO


IF EXISTS (SELECT * FROM sys.objects WHERE type = 'P' AND name = 'hm_sp_AdminNews')
   DROP PROCEDURE hm_sp_AdminNews;
GO

CREATE PROCEDURE hm_sp_AdminNews
    @NewsTitle varchar(200)
    , @NewsHeader varchar(2000)
    , @NewsContent varchar(4000)
AS
    SET NOCOUNT ON;

    DECLARE @NewsID INT;
    SET @NewsID = 0;

    IF NOT EXISTS (SELECT * FROM [dbo].[hm_News] WHERE Title = @NewsTitle)
    BEGIN
    INSERT INTO [dbo].[hm_News]
               ([Title]
               ,[Intro]
               ,[Main]
               ,[Autor]
               ,[CreateUser]
               ,[CreateUserID]
               ,[CreateDate]
               ,[UpdateUser]
               ,[UpdateUserID]
               ,[UpdateDate]
               ,[Published])
         VALUES
               (@NewsTitle
               ,@NewsHeader
               ,@NewsContent
               ,'Fair Computer Systems GmbH'
               ,'admin'
               ,1
               ,GETDATE()
               ,NULL
               ,NULL
               ,GETDATE()
               ,1);
		SET @NewsID = (SELECT MAX(NewsID) FROM  [dbo].[hm_News] WHERE Title = @NewsTitle);

        IF (@NewsID > 0)
        BEGIN
            INSERT INTO hm_NewsGroups (NewsID, GroupID) VALUES ( @NewsID, 1);
        END
    END
GO

EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 3.2', @NewsHeader = N'nderungen und Korrekturen in der Version 3.2', @NewsContent = N'Die Heinzelmann-Version 3.2 enthlt einige grundlegende nderungen.<br />Die Styles wurden verndert, so dass die Bedinung des Ticketmodules auf kleinen Bildschirmen (Smartphones) kompfortabler mglich ist.<br />Desweiteren wurde das Framework hinter den Kulisen gendert, was unter anderem zur folge hat, dass die Linkstruktur (Die URLs in der Adresszeile) gendert wurde.<br /><br />[b] Achtung: Durch die Stylenderung wurden die CSS-Dateien gendert. Falls Sie angepasste Styles in den Einstellungen Eingetragen haben mssen Sie die nderungen der neuen default-Styles bernehmen damit der Heinzelmann bei Ihnen richtig dargestellt wird.<br /><br /> Desweiteren ist es evtl. notwendig, den Browsercache zu leeren oder die Heinzelmann-Seiten im Browser mit "Strg + F5" neu zu laden.[/b]<br /><br /> Weitere nderungen:<br /><br /> (+) Settings Automatischer Logout nach X Minuten Inaktivitt.<br />(-) Employee Import & Update von LDAP-Usern zeigte nicht alle Benutzer an, wenn mehrere LDAP-Server eingetragen sind.<br />(-) Ticket Checkbox "E-Mail an Kontakt" wird nicht angezeigt, wenn Mailversand deaktiviert oder Inaktiv angezeigt, wenn Mailversand im Kontakt deaktiviert ist.<br />(-) Ticket, Formwizard: Ticketbearbeitung mit Pflichtfeld-Formularen (aus Formular-Baustein) war mglich<br />(-) Ticket: "Zurckstellungsdatum erhalten" standardmig gesetzt<br />(-) Ticket, M2T: Laden von HMTL-Mail-Events per Include (statt IFrame)<br />(-) Ticketliste: Merken der Suche "Ohne Abhngige Tickets"<br />(-) Ticket:Bltterfunktion in Ticketansicht korrigiert<br />(-) Ticketliste:Durch eine Korrektur der Rechte-Filterung werden ggf. weniger Tickets angezeigt:      Das Recht " + unkategorisierte Tickets" war gesetzt, wenn KEIN "Nur-Recht" gewhlt war.<br />(+) Gruppen:    Zuweisung von Benutzern in Gruppen im Gruppenformular.<br />(-) Tickets:    Zuweisung eines (Child-)Tickets an ein geschlossenes (Master-)Ticket ist nicht mehr mglich.<br />(-) Tickets:    Ticket-Selbstreferenzierungen durch SQL-Updatescript entfernen <br />(-) Ticketliste:Spalten "Telefonnummer" und "MobilNummer" des Kontaktes in Ticketliste aufgenommen<br />(+) Neues Framework:Modulaufrufe laufen nun ber neue URLs: Z. B. modules=ticket&event=newTicket statt bisher option=ticket&task=new<br />(+) styles: Responsive Ansichten auf der Startseite und im Ticketmodul.' ;
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 3.2.1', @NewsHeader = N'nderungen und Korrekturen in der Version 3.2.1', @NewsContent = N'Das Update auf die Version 3.2.1 enthlt folgende Korrekturen:<br />(+) news nderungen werden nun als News fr Benutzer aus der Administratorgruppe auf der Startseite angezeigt<br />(-) login Absturz nach fehlerhaften Loginversuch mit Domne (LDAP)<br />(-) ticketliste Schlagworte zur Suche wurden in der Ticketliste nicht angezeigt<br />(-) device Gertefilter-Checkboxen bei Gerteauswahl funktionierten nicht<br />(-) ticket Beim editieren von Ticketbearbeitung fehlte die Checkbox zum beibehalten des Zurckgestellt-Status<br />(-) ticket Beim editieren von Ticketbearbeitung fehlte die Checkbox zum beibehalten des Zurckgestellt-Status<br />(+) installation Es wird die aktuelle HM Release-Nummer in DB eingetragen<br />[b](+) ChangeRequest Neues Recht: "ChangeRequests anzeigen" - Nur mit diesem Recht kann ein Benutzer Change Request sehen.[/b]' ;
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 3.2.2', @NewsHeader = N'nderungen und Korrekturen in der Version 3.2.2', @NewsContent = N'
Das Update auf die Version 3.2.2 enthlt folgende Korrekturen:
<br />
(-) ticket: Gruppenauswahl bei Aktion "Tickets kopieren" war fehlerhaft.
(-) ticketlist: Fehler in Suche mit Datum von / bis.
(-) ticketlist: Gespeicherter Suchfilter wurde z.T. ohne "Eintrge pro Seite" geladen
(-) ticket: Aufruf mit alten URLs "option=ticket&task=details" leitet auf "module=ticket&event=show" weiter um mit den "alten" Links kompatibel zu sein.
(-) ticket,css: Styleanpassungen fr Ticketverlauf-Header
(-) category: Hauptkategorie 1 automatisch zuweisen bei Auswahl von Kategorie 2 wenn "Kategorie 2 ist von 1 abhngig" gesetzt
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 3.2.3', @NewsHeader = N'nderungen und Korrekturen in der Version 3.2.3', @NewsContent = N'
Das Update auf die Version 3.2.3 enthlt folgende Korrekturen:
<br />
(-) contact:    Kontaktzuordnung nach Asset.Desk im Kontakt-Formular funktionierte nicht.
(+) project:    Projekte knnen gelscht werden.
(+) reporting:  Zeitaufwand wird im Excel-Export angezeigt.
<br />';
GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_Styles]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_Styles](
	[CSSDefinition] [varchar](300) NOT NULL,
	[CSSValue] [varchar](4500) NOT NULL,
	[CreateDate] [datetime] DEFAULT Getdate() NOT NULL,
        [Active] [tinyint] DEFAULT 1 ,

 CONSTRAINT [PK_hm_Styles] PRIMARY KEY CLUSTERED
(
	[CSSDefinition] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_MailTemplates]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_MailTemplates](
	[MailType] [varchar](300) NOT NULL,
        [Subject] [varchar](300) NULL,
	[Content] [text] NULL,
	[CreateDate] [datetime] DEFAULT Getdate() NOT NULL,
        [Active] [tinyint] DEFAULT 1 ,

 CONSTRAINT [PK_hm_MailTemplates] PRIMARY KEY CLUSTERED
(
	[MailType] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_Messages]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_Messages](
	[ID] [bigint] IDENTITY(1,1) NOT NULL,
        [Message] [varchar](1000) NULL,
	[CreateDate] [datetime] DEFAULT Getdate() NOT NULL,
        [Active] [tinyint] DEFAULT 1 ,
        [MessageTypeID] [tinyint] NOT NULL ,
        [CreateUserID] [int] NULL ,
 CONSTRAINT [PK_hm_Messages] PRIMARY KEY CLUSTERED
(
	[ID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_UserMessages]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_UserMessages](
	[UserID] [int] NOT NULL,
        [MessageID] [bigint] NOT NULL,
	[ReadDate] [datetime]  NULL,
        [Showed] [tinyint]  NULL,
        [Active] [tinyint] DEFAULT 1 ,
        [delivered] [tinyint] DEFAULT 0 ,

 CONSTRAINT [PK_hm_UserMessages] PRIMARY KEY CLUSTERED
(
	[UserID] ASC,
        [MessageID] ASC
)) ON [PRIMARY]
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 3.2.4', @NewsHeader = N'nderungen und Korrekturen in der Version 3.2.4', @NewsContent = N'
Das Update auf die Version 3.2.4 enthlt folgende Korrekturen:
<br />
(-) kb:         Titel der KB-Eintrge werden in den Listen und Suchergebnissen nicht mehr gekrzt.
(-) employee:   Beim Import von Benutzern aus dem AD wird kein Passwort mehr abgefragt.
(-) ticketlist: Keine Supporterauswahl im Suchformular wenn bestimmte Ticket-Rechte gesetzt waren.
(-) inc:        Ungenutztes Modul entfernt.
<br />';
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_TicketStatus] WHERE ID = 12 AND Descr = 'SEND')
    INSERT INTO hm_TicketStatus (Descr) VALUES ('SEND')
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_TicketStatus] WHERE ID = 13 AND Descr = 'RESPONSE')
    INSERT INTO hm_TicketStatus (Descr) VALUES ('RESPONSE')
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 68)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (68, '+ Tickets von anderen Supportern ausblenden', 5, 10)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 71)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
    VALUES (71, 'Volle Kategorieauswahl', 2, 3)
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 3.3', @NewsHeader = N'nderungen und Korrekturen in der Version 3.3', @NewsContent = N'
Das Update auf die Version 3.3 enthlt folgende Neuheiten und nderungen:
<br />
(+) Styles:         Optik anpassen in den Einstellungen
(+) Devices:        Vereinfachte Gerteauswahl
(+) Escalation:     Innerhalb der Supportzeit knnen nun Pausezeiten definiert werden.
(+) Status:         Status RESPONSE eingefhrt fr Tickets, welche vom Kontakt bearbeitet wurden
(-) Vorlagen:       Supporter mit dem Recht "Supporter vorblenden" berschrieben vorgewhlte Supporter aus Vorlagen
(+) Ticket:         Empfngerauswahl bei "Manueller Kontaktbenachrichtigung" bersichtlicher gestaltet
(+) Ticket:         Dokumentenupload bei Ticketbearbeitung
(-) Ticket:         Autovervollstndigung der Kontakte zeigt nun alle Treffer an
(+) Reports:        In den Reports kann unterschieden werden, ab alle Tickets ausgerwertet werden sollen oder nur als "Problem" eingestufte Tickets oder nur "nicht als Problem" eingestufte Tickets.
(+) Nachrichten:    Zustzlich zu ggf. per eMail gesendeten Benachrichtigungen gibt es Heinzelmanninterne Nachrichten ber Eskalation und Bearbeitungen.
(+) Settings:       Es kann ein Fernwartungsprogramme zum herunterladen aus dem Heinzelmann bereitgestellt werden.
(+) TAPI:           Bereitstellung der Schnittstelle fr den TAPI-Client
(-) Workflow:       Korrekturen am Workflowmodul
(-) Vorlage:        Vorlagen lassen sich nicht mehr nur von Supportergruppen auswhlen.
(-) Listenansicht:  Benutzerdefinierte Liste lsst sich wieder bearbeiten.
(+) Reports:        "Erstellt am" in Ticketlisten aufgenommen.
(-) ticket:         Speichern von Dokumenten bei der Ticketanlage funktionierte nicht
(-) calender:       Editieren von Reservierungen anderer Benutzer funktionierte nicht
<br />';
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_TapiCalls]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TapiCalls](
    [PhoneNo] [varchar](100) NOT NULL,
    [ContactID] [bigint] NULL,
    [UserID] [bigint] NOT NULL,
    [CallDate] [datetime] NOT NULL
 CONSTRAINT [PK_hm_TapiCalls] PRIMARY KEY CLUSTERED
(
	[PhoneNo] ASC,
    [UserID] ASC,
    [CallDate] ASC
) ) ON [PRIMARY]
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 3.3.1', @NewsHeader = N'nderungen und Korrekturen in der Version 3.3.1', @NewsContent = N'
Das Update auf die Version 3.3.1 enthlt folgende Korrekturen:
<br />
(-) Styles:         Logo ging beim erneuten Speichern der Styledefinition verloren.
(-) Login:          Weiterleitung auf die eingestellte Startseite funktionierte nicht (Ticketliste als Startseite muss neu definiert werden).
(-) Ticket:         Keine Kontaktbenachrichtigung mehr bei Interner Notiz durch manueller Empfngerauswahl
(-) Formular:       Bei der Ticketerstellung wurden in den Formularen z.T. Daten aus zuvor erstellten Tickets angezeigt.
(-) Ticketliste:    Beim der Aktualisierung der Ticketliste wurde die Ticketanzahl nicht mit aktualisiert.
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 3.3.2', @NewsHeader = N'nderungen und Korrekturen in der Version 3.3.2', @NewsContent = N'
Das Update auf die Version 3.3.2 enthlt folgende Korrekturen:
<br />
(-) Ticket:         Fehler beim wiederholten Aufruf des Gertereiters im Formular fr neue Tickets
(-) Ticket:         Ticketbearbeitungen mit Bearbeitungsdatum lieen sich nicht speichern
<br />';

EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 3.3.3', @NewsHeader = N'nderungen und Korrekturen in der Version 3.3.3', @NewsContent = N'
Das Update auf die Version 3.3.3 enthlt folgende Korrekturen:
<br />
(-) Ticket:         Tickets des Kontaktes anzeigen bei Ticketerstellung korrigiert(Fernglas-Icon)
(-) Ticket:         Die interpretation angepasster Mail-Benachrichtigungen schlug z.T. fehl.
(+) Users:          Lizenzprfung bei Benutzerzuordnung in Supportergruppen
(-) Allgemein:      Zum Teil fehlten Texte, welche Umlaute enthalten (htmlspecialchars & htmlentities mssen ab PHP 5.4 mit Charset-Definition aufgerufen werden)
(-) Ticketliste:    Sortierung nach "Zu Bearbeiten am" funktionierte nicht.
(-) Ticket:         Auswahl von CC-Empfngern bei Ticketbearbeitung wenn Recht "Mail an Kontakt anpassen" und CC-Empfnger enthalten
(-) Users, Contacts:Ausgrauen von Mailadressen in der Benutzer, bzw. Kontaktliste, wenn Benachrichtigungsversand an den Benutzer / Kontakt deaktiviert
<br />';
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 3.3.4', @NewsHeader = N'nderungen und Korrekturen in der Version 3.3.4', @NewsContent = N'
Das Update auf die Version 3.3.4 enthlt folgende Korrekturen:
<br />
(-) Ticket:         Gesperrte und gelschte Benutzer wurden in der Empfngerauswahl fr Supporterbenachrichtigungen bei Ticketbearbeitungen angezeigt.
(+) Ticket:         Die bei der Ticketerstellung gewhlte Bearbeitungsart wird bei Ticketbearbeitungen in der Bearbeitungsart-Auswahl vorausgewhlt.
(-) Installation:   Updateskript fr Oracle enthielt Fehler.
(+) Ticket:         Nach der Aktion "Ticket schlieen" wird auf die Ticketliste weitergeleitet.
<br />';

GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketFilter' AND COLUMN_NAME = 'FilterDescr')
    ALTER TABLE [dbo].[hm_TicketFilter] ADD [FilterDescr] [varchar](4500) NULL

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_TicketFilterGroups]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketFilterGroups](
	[FilterID] [int] NOT NULL,
        [GroupID] [int] NOT NULL,
 CONSTRAINT [PK_hm_TFGroups] PRIMARY KEY CLUSTERED
(
	[FilterID] ASC,
        [GroupID] ASC
)) ON [PRIMARY]

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_TicketFilterUsers]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketFilterUsers](
	[FilterID] [int] NOT NULL,
        [UserID] [int] NOT NULL,
        [isDefault] [tinyint] NULL,
        [isFavorit] [tinyint] NULL,
 CONSTRAINT [PK_hm_TFUsers] PRIMARY KEY CLUSTERED
(
	[FilterID] ASC,
        [UserID] ASC
)) ON [PRIMARY]

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_ContactMailAddress]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ContactMailAddress](
	[ContactID] [int] NOT NULL,
        [MailAddress] [varchar](300) NOT NULL,
        [Descr] [varchar](300) NULL,
 CONSTRAINT [PK_hm_ContactMailAddress] PRIMARY KEY CLUSTERED
(
	[ContactID] ASC,
        [MailAddress] ASC

)) ON [PRIMARY]

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_ContactPhoneNo]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ContactPhoneNo](
	[ContactID] [int] NOT NULL,
        [PhoneNo] [varchar](300) NOT NULL,
        [Descr] [varchar](300) NULL,
        [TapiPhoneNo] AS CAST(REPLACE(LTRIM(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(PhoneNo, '/', ''),'-', ''),')', ''),'(', ''),'+', ''),' ', ''),'0', ' ')),' ', '0') AS Varchar(300) )
 CONSTRAINT [PK_hm_ContactPhoneNo] PRIMARY KEY CLUSTERED
(
	[ContactID] ASC,
        [PhoneNo] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Rights' AND COLUMN_NAME = 'RightDescr')
    ALTER TABLE [dbo].[hm_Rights] ADD [RightDescr] [varchar](5000) NULL
GO
UPDATE hm_Rights SET RightDescr = 'Ein Benutzer mit diesem Recht sehen alle Tickets die angelegt wurden, selbst wenn zudem eines der anderen Ticketrechte wie z.B. <strong>Nur Tickets der eigenen Gruppe anzeigen</strong> aktiv ist.
<strong>Das Recht zu erteilen ist dann sinnvoll, wenn ein Gesamtberblick ber alle Tickets erhalten werden soll, z.B. zu Reporting-Zwecken. Meistens geschieht dies fr Benutzer, die selber keinen oder nur geringfgig Support leisten. Andernfalls kann der Effekt zu Problemen prozessualer und organisatorischer Natur fhren.</strong>
Ein Anwendungsbeispiel fr das Recht ist der Incident Manager. Mit dieser Option erhlt er einen Einblick auf alle Tickets und kann so ggf. einer Eskalation zuvor kommen und seinen weiteren Aufgaben (Berichtserstellung) nachkommen. Er kann weiterhin Mitglied einer allgemeinen (Support-)Benutzergruppe sein und zustzlich einer Management/Reporting-Gruppe mit dem Recht <strong>alle Tickets anzeigen</strong> zugeordnet werden.' WHERE RightID = 50
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 69)
INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder)
VALUES (69, '+ Tickets ohne Gruppe anzeigen', 5, 9)
GO
UPDATE hm_Rights SET RightDescr = 'Benutzer mit diesem zustzlichen Recht sehen Tickets, denen keine Gruppe zugewiesen ist.' WHERE RightID = 69

GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_DashboardLinks]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_DashboardLinks](
	[URL] [varchar] (200) NOT NULL,
        [Descr] [varchar] (500) NULL,
        [Imagepath] [varchar] (200) NULL,
        [Active] [tinyint] NULL,
        [Position] [int] NOT NULL
)
GO
UPDATE hm_CostCurrency SET Symbol = '&#8364;' WHERE Shortname = 'EUR'
GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Rights' AND COLUMN_NAME = 'SegmentID')
    ALTER TABLE [dbo].[hm_Rights] ADD [SegmentID] [int] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFDefinitions' AND COLUMN_NAME = 'ProjectID')
    ALTER TABLE [dbo].[hm_WFDefinitions] ADD [ProjectID] [int] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WF_Activity' AND COLUMN_NAME = 'ProjectID')
    ALTER TABLE [dbo].[hm_WF_Activity] ADD [ProjectID] [int] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFDef_Activity' AND COLUMN_NAME = 'ProjectID')
    ALTER TABLE [dbo].[hm_WFDef_Activity] ADD [ProjectID] [int] NULL
GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFInstanz' AND COLUMN_NAME = 'ProjectID')
    ALTER TABLE [dbo].[hm_WFInstanz] ADD [ProjectID] [int] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFInstanz' AND COLUMN_NAME = 'RefLvl2ID')
    ALTER TABLE [dbo].[hm_WFInstanz] ADD [RefLvl2ID] [int] NULL
GO

IF NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[hm_RightsSegment]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_RightsSegment](
	[SegmentID] [int] NOT NULL,
	[Descr] [varchar](100) NOT NULL,
	[SectionID] [int] NULL,
	[SegmentOrder] [int] NULL
) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 222)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, SegmentID, RightsOrder, RightDescr)
    VALUES (222, 'Allgemeine Gruppenbenachrichtigung deaktivieren', 2, 14, 10, 'Benutzer dieser Gruppe werden nicht benachrichtigt wenn die Empfnger nur anhand der Gruppe ermittelt werden.')
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'Signatur')
    ALTER TABLE [dbo].[hm_Users] ADD [Signatur] [varchar](5000) NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 223)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, SegmentID, RightsOrder, RightDescr)
    VALUES (223, 'Bearbeitungsart ist Pflichtfeld', 2, 17, 10, 'Erforder das Recht <strong>Bearbeitungsart anzeigen</strong>. Benutzer mit diesem Recht mssen bei der Ticketerstellung oder -bearbeitung eine Bearbeitungsart whlen.')
GO
UPDATE hm_RightsSection SET SectionName = 'Zugriffsmanagement', SectionOrder = 10 WHERE RightsSectionID = 1
GO
UPDATE hm_RightsSection SET SectionName = 'Tickets', SectionOrder = 20 WHERE RightsSectionID = 2
GO
UPDATE hm_RightsSection SET SectionName = 'Module', SectionOrder = 30 WHERE RightsSectionID = 3
GO
UPDATE hm_RightsSection SET SectionName = 'Administration', SectionOrder = 50 WHERE RightsSectionID = 4
GO
DELETE FROM hm_RightsSection WHERE RightsSectionID > 4
GO
DELETE FROM hm_RightsSegment
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (1, 'Asset.Desk', 10)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (2, 'Benutzer', 20)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (3, 'Dokumente', 30)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (4, 'Einstellungen', 40)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (5, 'Firmenstruktur', 50)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (6, 'Formulare', 60)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (7, 'Gerte', 70)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (8, 'Gruppe / Supporter', 80)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (9, 'ITIL', 90)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (10, 'Kalender', 100)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (11, 'Kategorien', 110)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (12, 'Knowledgebase', 120)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (13, 'Kontakte', 130)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (14, 'Mailversand', 140)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (15, 'Nachtrgliche nderungen', 150)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (16, 'News', 160)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (17, 'Pflichtfelder', 170)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (18, 'Projekt', 180)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (19, 'Referenzieren', 190)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (20, 'Reporting', 200)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (21, 'Schlieen', 210)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (22, 'Shoutbox', 220)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (23, 'Supporter', 630)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (24, 'Ticketdaten', 540)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (25, 'Ticketevents', 250)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (26, 'Ticketliste', 270)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (27, 'Tickets', 580)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (28, 'Tickets erstellen', 290)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (29, 'Ticketvorlagen', 300)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (30, 'Verwaltung', 310)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (31, 'Workflow', 320)
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (33, 'Mandanten', 320)
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 0, SegmentID = 28, RightDescr = 'Benutzer mit diesem Recht drfen selbst Tickets in HEINZELMANN erstellen.' WHERE RightID = 1
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 11, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen den Kontakt eines Tickets nachtrglich ndern.' WHERE RightID = 2
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 9, SegmentID = 24, RightDescr = 'Dieses Recht blendet den Benutzern der entsprechenden Gruppen im Dialog fr Ticketdetails ein Fernglas-Symbol neben dem eingetragenen Kontakt ein. Ein Klick auf dieses Symbol listet alle bisherigen Tickets des Kontakts auf.' WHERE RightID = 3
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 12, SegmentID = 11, RightDescr = 'Benutzer mit diesem Recht drfen die Kategorisierung eines Tickets verndern.' WHERE RightID = 5
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 6, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen die Ticketflligkeit verndern.' WHERE RightID = 6
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen Prioritt des Tickets verndern.' WHERE RightID = 7
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 19, RightDescr = 'Benutzer mit diesem Recht knnen Tickets einem Masterticket zuordnen oder die Zuordnung entfernen.' WHERE RightID = 8
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen den Betreff (Kurzbeschreibung) eines Tickets verndern, unter welcher das Ticket in allen Listen gefhrt wird.' WHERE RightID = 9
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 3, RightDescr = 'Benutzer mit diesem Recht drfen einem Ticket Anlagen beifgen.' WHERE RightID = 10
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 3, RightDescr = 'Benutzer mit diesem Recht drfen Anlagen eines Tickets wieder entfernen.' WHERE RightID = 11
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht knnen Tickets zurckstellen (Status ON HOLD)' WHERE RightID = 12
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 7, RightDescr = 'Dieses Recht hat nur Wirkung in Verbindung mit einer Asset.Desk-Datenbank. Es erlaubt die Suche nach Gerten innerhalb der Asset.Desk-Datenbank, welche einem Ticket hinzugefgt werden knnen.' WHERE RightID = 13
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 3, SegmentID = 12, RightDescr = 'Berechtigt zur Anlage noch nicht freigegebener KB-Eintrge aus geschlossenen Tickets und ohne Ticketvorlage.' WHERE RightID = 15
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 1, SegmentID = 14, RightDescr = 'Ist dieses Recht gesetzt, so werden die Kontakte der betroffenen Gruppe nicht mehr automatisch per Email benachrichtigt, sobald eine nderung am Ticket erfolgt. Eine Information kann dann bei Bedarf versandt werden, wenn das Ticket bearbeitet wird. Hierzu muss das Hkchen bei <strong>E-Mail an den Kontakt</strong> gesetzt werden ' WHERE RightID = 16
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 1, SegmentID = 14, RightDescr = 'Dieses Recht erweitert das vorhergehende Recht <strong>Manueller E-Mail Versand an Kunden</strong>.   Hat ein Benutzer beide Rechte, so erhlt er beim Bearbeiten eines Tickets nach dem Aktivieren der Checkbox <strong>E-Mail an Kontakt</strong> ein erweitertes Fenster mit der Option, den Betreff der Nachricht sowie die Empfnger zu ndern.    Bei Ticketbearbeitungen werden die Auswahlfelder <strong>E-Mail an Kontakt</strong>, <strong>E-Mail an Support</strong>, <strong>CC</strong> und <strong>Betreff</strong>, die fr die abzuschickende Mail angezeigt, in der die Empfnger und der Betreff bearbeitet werden knnen.  Die Eingabe mehrere Empfnger-Adressen ist ebenfalls mglich, diese mssen lediglich mit Komma oder Semikolon getrennt eingegeben werden. Des Weiteren kann der Benutzer durch das Aktivieren der Checkbox <strong>Nur diese Beschreibung mit Benutzerkontakt senden</strong> die Informationen in der Benachrichtigungsmail auf den Text dieser nderung, die Daten des Benutzers und den Link zum Ticket reduzieren.' WHERE RightID = 17
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 1, SegmentID = 12, RightDescr = 'Erlaubt alle Ttigkeiten in der Knowledgebase, insbesondere die Freigabe und Deaktivierung von Artikeln, Zuweisung und Erstellung von Rubriken.' WHERE RightID = 19
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 6, SegmentID = 11, RightDescr = 'Benutzer mit diesem Recht drfen einem Ticket bei der Erstellung bis zu zwei Kategorien zuordnen.<strong>Allen Benutzern mssen diejenigen Kategorien zugeordnet sein, welche sie auswhlen drfen.</strong>' WHERE RightID = 20
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 6, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen einem Ticket einen gewnschten Flligkeitstermin geben, der von der Standard-Flligkeit abweicht.' WHERE RightID = 21
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 24, RightName = 'Prioritt setzen', RightDescr = 'Benutzer mit diesem Recht drfen die Prioritt eines Tickets selbst bestimmen.' WHERE RightID = 22
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 6, SegmentID = 19, RightDescr = 'Benutzer mit diesem Recht drfen in einem Ticket ein anderes mit hnlichem/gleichem Inhalt referenzieren. In der Datenbank wird dann eine Verbindung zwischen den beiden Tickets hergestellt.' WHERE RightID = 23
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 6, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen bei der Erstellung/Bearbeitung eines Tickets  ihren hierfr bentigten zeitlichen Aufwand erfassen.' WHERE RightID = 24
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 6, SegmentID = 21, RightDescr = 'Benutzer mit diesem Recht drfen ein Ticket mit der Option <strong>Schnellschuss</strong> schon bei der Anlage schlieen. Dies macht Sinn, wenn sich z.B. bereits whrend der Fehlerdiagnose / -suche, beim Gesprch mit dem Melder oder bei nachtrglicher Ticketanlage eine Weiterverfolgung des Tickets unntig wird, da der Vorfall bzw. das Problem bereits behoben ist.' WHERE RightID = 25
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 0, SegmentID = 23, RightDescr = 'Dieses Recht ist das zentrale Recht von HEINZELMANN. Es ermglicht den Gruppen, die dieses Recht erhalten, Tickets fr Dritte zu bearbeiten. Benutzer mit diesem Recht werden <strong>Supporter</strong> genannt.<strong>Durch die Lizenzierung von HEINZELMANN anhand der Supporter-Accounts entscheidet dieses Recht ber den Verbrauch der HEINZELMANN Lizenzen</strong>' WHERE RightID = 26
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 21, RightDescr = 'Ist dieses Recht gesetzt, drfen die Mitglieder der betreffenden Gruppe geschlossene Tickets wieder ffnen, sofern sie die Rechte haben, diese anzuzeigen.' WHERE RightID = 27
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 5, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen nur die Tickets, bei welchen er als Mitglied der zugewiesenen Gruppe, als Support-Mitarbeiter oder als Kontakt eingetragen ist.' WHERE RightID = 28
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 5, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen nur die Tickets, bei welchen er als Support-Mitarbeiter und/oder Kontakt eingetragen ist.' WHERE RightID = 29
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 1, SegmentID = 20, RightDescr = 'Ermglicht die Nutzung des Reiters <strong>Reporting</strong>. Der Umfang der angezeigten Reports wird ber die brigen Gruppenrechte gesteuert.' WHERE RightID = 30
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 12, RightDescr = 'Benutzer mit diesem Recht knnen freigegebene KB-Eintrge aufrufen und danach suchen.' WHERE RightID = 31
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 1, SegmentID = 5, RightDescr = '<strong>Nur ohne Asset.Desk</strong>Benutzer mit diesem Recht drfen unter <strong>Verwaltung > Struktur</strong> eine Abteilungs-struktur definieren.' WHERE RightID = 32
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 2, SegmentID = 11, RightDescr = 'Berechtigt zur Zuordnung von Kategorien zu Benutzergruppen.' WHERE RightID = 33
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 1, SegmentID = 11, RightDescr = 'Berechtigt zur Anlage und Bearbeitung von Kategorien in HEINZELMANN.' WHERE RightID = 34
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 3, SegmentID = 11, RightDescr = 'Berechtigt zur Lschung von Kategorien.' WHERE RightID = 35
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 1, SegmentID = 4, RightDescr = 'Berechtigt zur Anzeige und Bearbeitung der in HEINZELMANN zur Verfgung stehenden Einstellungsmglichkeiten ' WHERE RightID = 36
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 2, SegmentID = 2, RightDescr = 'Benutzer mit diesem Recht drfen ihr Passwort zur Anmeldung an HEINZELMANN eigenstndig festlegen oder ndern (<strong>Verwaltung > Eigenes Passwort ndern</strong>).' WHERE RightID = 37
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 3, SegmentID = 2, RightDescr = 'Ermglicht die Anlage und Bearbeitung von Gruppen sowie deren Berechtigungen.' WHERE RightID = 38
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 4, SegmentID = 2, RightDescr = 'Berechtigt zur Lschung von Gruppen.' WHERE RightID = 39
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 1, SegmentID = 2, RightDescr = 'Berechtigt zur Anlage und Bearbeitung von Benutzerkonten in HEINZELMANN.' WHERE RightID = 40
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 2, SegmentID = 2, RightDescr = 'Berechtigt zur Lschung von Benutzerkonten.' WHERE RightID = 41
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 1, SegmentID = 13, RightDescr = 'Berechtigt zur Anlage und Bearbeitung von Kontakten.' WHERE RightID = 42
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 3, SegmentID = 13, RightDescr = 'Berechtigt zur Lschung von Kontakten.' WHERE RightID = 43
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 2, SegmentID = 13, RightDescr = 'Benutzer mit diesem Recht drfen Kontakte einem Benutzerkonto zuordnen.' WHERE RightID = 44
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 7, RightDescr = 'Benutzer mit dieses Recht drfen nur Gerte auswhlen / anzeigen lassen, die ihnen in Asset.Desk zugeordnet sind.<strong>Setzt das Recht Gertesuche voraus</strong>' WHERE RightID = 45
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 9, SegmentID = 16, RightDescr = 'Dieses Recht erlaubt die Bearbeitung und Einstellung von News auf der HEINZELMANN-Startseite.' WHERE RightID = 46
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 4, SegmentID = 13, RightDescr = 'Berechtigt zum Kontaktimport und -update.' WHERE RightID = 47
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 20, RightDescr = 'Zeigt in den Reports kostenbezogene Felder mit an.' WHERE RightID = 48
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 24, RightDescr = 'Ist dieses Recht gesetzt, wird ein Ticketersteller, falls es sich um einen Supporter handelt, im Feld <strong>Supporter</strong> automatisch vorausgewhlt.' WHERE RightID = 49
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 1, SegmentID = 27, RightDescr = 'Ein Benutzer mit diesem Recht sehen alle Tickets die angelegt wurden, selbst wenn zudem eines der anderen Ticketrechte wie z.B. <strong>Nur Tickets der eigenen Gruppe anzeigen</strong> aktiv ist.  <strong>Das Recht zu erteilen ist dann sinnvoll, wenn ein Gesamtberblick ber alle Tickets erhalten werden soll, z.B. zu Reporting-Zwecken. Meistens geschieht dies fr Benutzer, die selber keinen oder nur geringfgig Support leisten. Andernfalls kann der Effekt zu Problemen prozessualer und organisatorischer Natur fhren.</strong>  Ein Anwendungsbeispiel fr das Recht ist der Incident Manager. Mit dieser Option erhlt er einen Einblick auf alle Tickets und kann so ggf. einer Eskalation zuvor kommen und seinen weiteren Aufgaben (Berichtserstellung) nachkommen. Er kann weiterhin Mitglied einer allgemeinen (Support-)Benutzergruppe sein und zustzlich einer Management/Reporting-Gruppe mit dem Recht <strong>alle Tickets anzeigen</strong> zugeordnet werden.' WHERE RightID = 50
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 14, SegmentID = 24, RightDescr = 'Die Kategorie 2 wird fr die Benutzer mit diesem Recht nicht angezeigt.' WHERE RightID = 51
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 30, SegmentID = 24, RightDescr = 'Blendet das Feld <strong>Gruppe</strong> in den Details eines Tickets fr die betroffenen Benutzer ein. Benutzer sehen die zugewiesene Gruppe der Tickets.' WHERE RightID = 52
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 14, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht knnen einem Ticket bei Erstellung eine Benutzergruppe zuweisen, welche dafr zustndig sein soll.' WHERE RightID = 53
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 31, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht knnen Tickets einer Gruppe zuordnen.' WHERE RightID = 54
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 10, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen zustzlich die Tickets, welche einer ihrer Benutzergruppen zugewiesen wurden.' WHERE RightID = 55
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 10, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen zustzlich die Tickets von Kontakten, die derselben Firma angehren.' WHERE RightID = 56
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 9, SegmentID = 25, RightDescr = 'Mit diesem Recht kann eine Ticketbearbeitung als intern gekennzeichnet werden. Der Eintrag ist daraufhin nur noch sichtbar fr:  <ul>    <li>Den Ersteller des Eintrags</li>    <li>Den Benutzern aus der zugeordneten Supportgruppe</li>     <li>Den zugeordneten Support-Mitarbeiter</li>    <li>Den Benutzern aus der Administrator-Gruppe</li>  </ul> ' WHERE RightID = 57
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 27, RightDescr = 'Ein Benutzer mit diesem Recht sehen nur die Tickets, deren zugeordnete Kontakte derselben Firma wie der des Benutzerkontakts zugehren.' WHERE RightID = 58
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 11, SegmentID = 27, RightDescr = 'Den Benutzern mit diesem Recht werden geschlossene Tickets nicht angezeigt.' WHERE RightID = 59
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 3, SegmentID = 20, RightDescr = '<strong>Setzt das Zusatzmodul Erweitertes Reporting voraus</strong>Benutzer mit diesem Recht erhalten Zugriff auf das erweiterte Reporting mit frei definierbaren Views.' WHERE RightID = 60
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 3, SegmentID = 10, RightDescr = '<strong>Setzt das Zusatzmodul Kalender voraus</strong>Benutzer mit diesem Recht knnen einem Kalender-Termin Gerte per Reservierung zuordnen bzw. diese Reservierungen aufheben.' WHERE RightID = 61
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 7, RightDescr = 'Erlaubt die Suche nach Gerten innerhalb eines Active Directory, welche einem Ticket hinzugefgt werden knnen.' WHERE RightID = 62
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 4, SegmentID = 11, RightDescr = 'Benutzer mit diesem Recht knnen bei der Kategorie-Zuordnung eines Tickets nur aus den Haupt-, nicht aus deren Unterkategorien zu whlen.' WHERE RightID = 63
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 3, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen nur die Tickets, deren zugeordnete Kontakte derselben Abteilung wie der des Benutzerkontakts zugehren.' WHERE RightID = 65
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 10, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen zustzlich die Tickets von Kontakten, die derselben Abteilung angehren.' WHERE RightID = 66
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 4, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen alle Tickets, deren zugeordnete Kontakte mit Benutzern verknpft sind, welche denselben Benutzergruppen zugehrig sind.' WHERE RightID = 67
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 10, SegmentID = 27, RightDescr = 'Tickets welche einem (anderen) Supporter zugeordnet sind werden nicht angezeigt.' WHERE RightID = 68
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 9, SegmentID = 27, RightDescr = 'Benutzer mit diesem zustzlichen Recht sehen Tickets, denen keine Gruppe zugewiesen ist.' WHERE RightID = 69
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 12, SegmentID = 11, RightDescr = 'Benutzer mit diesem Recht knnen im Ticket auch Kategorien whlen, die nicht der Benutzergruppe zugeordnet sind.   Das kann verwendet werden, wenn Benutzer generell nur ber die Tickets Ihrer Kategorien benachrichtig werden sollen bzw. nur diese angezeigt bekommen, aber dennoch Tickets anderen Kategorien zuordnen knnen sollen.' WHERE RightID = 71
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 14, SegmentID = 30, RightDescr = 'Benutzer mit diesem Recht drfen Tickets lschen. Die Option ist nach dem Aufruf der Details eines geschlossenen Tickets verfgbar.' WHERE RightID = 100
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 10, SegmentID = 27, RightDescr = 'Benutzer mit diesem Recht sehen zustzlich Tickets, denen keine Kategorie zugeordnet ist.' WHERE RightID = 101
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 33, SegmentID = 21, RightDescr = 'Benutzer mit diesem Recht knnen Tickets auf den Status Erledigt (DONE) setzen.' WHERE RightID = 110
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 34, SegmentID = 21, RightDescr = 'Benutzer mit diesem Recht knnen Tickets mit dem Status Erledigt (DONE) schlieen.' WHERE RightID = 111
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 35, SegmentID = 21, RightDescr = 'Benutzer mit diesem Recht knnen Tickets mit dem Status Erledigt (DONE) weiter bearbeiten.' WHERE RightID = 112
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 18, SegmentID = 24, RightDescr = 'Dieses Recht ermglicht die Zuordnung einer Bearbeitungsart bei der Ticketerstellung oder -bearbeitung.' WHERE RightID = 113
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 36, SegmentID = 14, RightDescr = 'Kontakte lassen sich im Kontaktformular als Lieferant markieren. Diese Kontakte werden, wenn der Button <strong>E-Mail Ticketdaten</strong> in der Ticketdetailansicht geklickt wird, in einer Liste zur Empfngerauswahl angezeigt.Dieses Recht blendet diese Option in den Ticketdetails ein.' WHERE RightID = 114
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 37, SegmentID = 24, RightDescr = 'Benutzer knnen die im Ticket ausgewhlte Inventarnummer ndern' WHERE RightID = 115
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 35, SegmentID = 21, RightDescr = 'Benutzern mit diesem Recht ist es nicht mglich, Tickets zu schlieen.' WHERE RightID = 116
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 1, SegmentID = 1, RightDescr = 'Ohne dieses Recht werden dem Benutzer bei den Gertedetails die kommerziellen Asset-Daten zum jeweiligen Gert nicht angezeigt.' WHERE RightID = 200
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 2, SegmentID = 1, RightDescr = 'Benutzer mit diesem Recht drfen die auf dem ausgewhlten Gert installierten Softwareprodukte (aus der <strong>Asset.Desk</strong>-Datenbank) einsehen.' WHERE RightID = 201
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 3, SegmentID = 1, RightDescr = 'Ermglicht den Einblick in die benutzerdefinierten Angaben zu dem entsprechenden Gert aus der Asset.Desk-Datenbank.' WHERE RightID = 202
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 34, SegmentID = 28, RightDescr = 'Benutzer mit diesem Recht erhalten die entsprechende Option in der Ticketdetailansicht. Damit werden die Eingaben des kopierten Tickets in ein neues Ticket-Formular bernommen.' WHERE RightID = 210
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 38, SegmentID = 19, RightDescr = 'Benutzer mit diesem Recht knnen Tickets miteinander verknpfen. ' WHERE RightID = 211
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 10, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen Tickets einer Gruppe zuweisen.' WHERE RightID = 215
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 10, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht drfen Tickets einem Supporter zuweisen.' WHERE RightID = 216
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 8, SegmentID = 17, RightDescr = 'Dieses Recht macht die Angabe einer Gruppe bei der Ticketerstellung erforderlich.' WHERE RightID = 217
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 8, SegmentID = 17, RightDescr = 'Dieses Recht macht die Angabe eines Supporters bei der Ticketerstellung erforderlich.' WHERE RightID = 218
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 39, SegmentID = 24, RightDescr = 'Benutzer mit diesem Recht knnen Tickets mit Schlagworten (Tags) versehn oder die Verschlagwortung ndern.' WHERE RightID = 219
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 39, SegmentID = 30, RightDescr = 'Ermglicht das Anlegen neuer Schlagworte (Tags) fr die Ticketverschlagwortung' WHERE RightID = 220
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 0, SegmentID = 30, RightDescr = 'Ermglicht den Benutzer Tickets als Archiviert zu markieren. Archivierte Tickets werden in der normalen suche nicht mehr bercksichtigt.' WHERE RightID = 221
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 10, SegmentID = 14, RightDescr = 'Benutzer dieser Gruppe werden nicht benachrichtigt wenn die Empfnger nur anhand der Gruppe ermittelt werden.' WHERE RightID = 222
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 10, SegmentID = 17, RightDescr = 'Erforder das Recht <strong>Bearbeitungsart anzeigen</strong>. Benutzer mit diesem Recht mssen bei der Ticketerstellung oder -bearbeitung eine Bearbeitungsart whlen.' WHERE RightID = 223
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 1, SegmentID = 9, RightDescr = 'Mit diesem Recht kann ein Anwender neue Change Requests einstellen oder ein geschlossenes Ticket in einen Change Request umwandeln.' WHERE RightID = 300
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 2, SegmentID = 9, RightDescr = 'Benutzer mit diesem Recht knnen den ganzen Change Request-Prozess nach ITIL bearbeiten und abschlieen.' WHERE RightID = 301
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 5, SegmentID = 20, RightDescr = 'Mach fr den Benutzer mit diesem Recht den Menpunkt <strong>SLA Reporting</strong> im <strong>Reporting</strong>-Bereich sichtbar.  Hier lassen sich individuelle Service Level Agreements auflisten und jeweils detailliert betrachten, sowie gefilterte Listen fr Reporting Zwecke berprfen.  Zudem kann die angezeigte Liste als Excel-Datei exportiert werden.' WHERE RightID = 302
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 5, SegmentID = 20, RightDescr = 'Gibt einem Benutzer das Recht, SLAs ber den Button <strong>Neuer SLA</strong> in der SLA Reporting-Liste anzulegen. Auerdem darf dieser Anwender aufgelistete SLA editieren oder lschen.' WHERE RightID = 303
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 5, SegmentID = 9, RightDescr = 'Nur Benutzer mit diesem Recht knnen Change Requests sehen.' WHERE RightID = 304
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 1, SegmentID = 22, RightDescr = 'Mit diesem Recht wird dem Benutzer auf der Startseite die Shoutbox angezeigt. ber die Shoutbox hat er die Mglichkeit, mit anderen an HEINZELMANN angemeldeten Anwendern, die dieses Recht aufweisen, schnell zu kommunizieren.' WHERE RightID = 400
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 2, SegmentID = 29, RightDescr = 'Dieses Recht erlaubt das Erstellen von Ticketvorlagen.' WHERE RightID = 401
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 3, SegmentID = 28, RightDescr = 'Dieses Recht erlaubt die Erstellung von Tickets aus definierten Ticketvorlagen.' WHERE RightID = 402
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 4, SegmentID = 26, RightDescr = 'Benutzer mit diesem Recht drfen die standardmig verwendeten Spalten der Ticketliste fr alle Benutzer anpassen.' WHERE RightID = 410
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 5, SegmentID = 26, RightDescr = 'Benutzer mit diesem Recht drfen die verwendeten Spalten benutzerspezifisch anpassen.' WHERE RightID = 411
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 6, SegmentID = 10, RightDescr = '<strong>Setzt das Zusatzmodul Kalender voraus </strong>Benutzer mit diesem Recht knnen den Menpunkt <strong>Kalender</strong> einsehen.' WHERE RightID = 412
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 1, SegmentID = 18, RightDescr = 'Dieses Recht erteilt den Zugriff auf die Projektliste und die damit verbundenen Tickets. Eine nderung der Projekte ist nicht mglich' WHERE RightID = 500
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 2, SegmentID = 18, RightDescr = 'Das Recht zur Erstellung eigener Projekte.' WHERE RightID = 501
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 3, SegmentID = 18, RightDescr = 'Das Recht zur Bearbeitung von Projekten.' WHERE RightID = 502
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 4, SegmentID = 18, RightDescr = 'Mit diesem Recht knnen die notwendigen Projekttypen fr die Projekte verwaltet werden.' , RightName = 'Projekttypen verwalten' WHERE RightID = 503
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 5, SegmentID = 18, RightDescr = 'Dieses Recht erteilt die Mglichkeit, Tickets einem Projekt zuzuordnen. Um mit dem Modul Projekte arbeiten zu knnen, mssen Tickets einem Projekt zugewiesen werden knnen.' WHERE RightID = 504
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 6, SegmentID = 18, RightDescr = 'Das Recht zur nderung der Zuordnung eines Projekts.' WHERE RightID = 505
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 17, SegmentID = 24, RightDescr = 'Blendet das Feld <strong>Flligkeit<strong> in den Ticketdetails ein. Benutzer knnen die Ticketflligkeit setzten.' WHERE RightID = 521
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 17, SegmentID = 24, RightDescr = 'Blendet das Feld <strong>Prioritt</strong> in den Ticketdetails ein. Benutzer knnen die Ticketprioritt ndern.' WHERE RightID = 522
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 17, SegmentID = 24, RightDescr = 'Hiermit wird in den Ticketdetails und bei der Ticketbearbeitung das Feld <strong>Aufwand</strong> eingeblendet. Benutzer knnen Aufwnde erfassen.' WHERE RightID = 524
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 1, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen auch nachtrglich noch Beschreibungen von Events abndern.' WHERE RightID = 600
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 2, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen das Datum eines Events bearbeiten.' WHERE RightID = 601
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 3, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen auch nachtrglich noch Aufwnde von Events ndern.' WHERE RightID = 602
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 4, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen Events lschen.' WHERE RightID = 603
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 1, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen auch nachtrglich noch Beschreibungen von Events abndern.' WHERE RightID = 610
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 2, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen das Datum eines Events bearbeiten.' WHERE RightID = 611
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 3, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen auch nachtrglich noch Aufwnde von Events ndern.' WHERE RightID = 612
GO
UPDATE hm_Rights SET RightsSectionID = 2, RightsOrder = 4, SegmentID = 15, RightDescr = 'Benutzer mit diesem Recht drfen Events lschen.' WHERE RightID = 613
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 2, SegmentID = 31, RightName = 'Workflows verwalten', RightDescr = 'Dieses Recht erlaubt es, neue Workflows zu definieren oder bestehende Definitionen zu bearbeiten.' WHERE RightID = 703
GO
UPDATE hm_Rights SET RightsSectionID = 3, RightsOrder = 6, SegmentID = 31, RightDescr = 'Dieses Recht ermglicht es Benutzern definierte Workflows zu starten.' WHERE RightID = 705
GO
UPDATE hm_Rights SET RightsSectionID = 4, RightsOrder = 3, SegmentID = 6, RightDescr = '<strong>Setzt das Zusatzmodul Formular voraus </strong>Berechtigt zur Anzeige und Bearbeitung von Formularen (<strong>Verwaltung > Formulare</strong>).' WHERE RightID = 810
GO
UPDATE hm_Rights SET RightsSectionID = 1, RightsOrder = 6, SegmentID = 13, RightDescr = 'Benutzer mit diesem Recht drfen die gesamte Kontaktliste einsehen.' WHERE RightID = 1005
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.0', @NewsHeader = N'nderungen und Korrekturen in der Version 4.0', @NewsContent = N'
Das Update auf die Version 4.0 enthlt folgende nderungen:
<br />
(+) Loginseite:     News, KB-Artikel und Links knnen auf der Loginseite angezeigt werden.
(+) Ticket:         Editor fr Ticketbearbeitungen
(+) Ticket:         nderung der Supporter- / Gruppenzuweisung mit Kommentar
(+) Tickets:        Neues Recht "Bearbeitungsart als Pflichtfeld"
(+) Ticket:         Ticketverlauf gekrzt anzeigen
(+) Ticket:         Childtickets erhalten Kategorien, Supporter & Gruppe des Mastertickets
(+) Ticketliste:    Suchformular und Filter einfacher aufrufbar
(+) Ticketliste:    Suchfilter fr andere Gruppen freizugeben
(+) Rechte:         Rechtesortierung verbessert
(+) Kontakt:        Mglichkeit, weitere Telefonnummern fr den TAPI-Client und Mailadressen fr den M2T-Funktion im Kontakt zu hinterlegen
(+) Kontakt:        Bei der Kontaktanlage wird geprft, ob ein hnlich benannter Kontakt schon existiert. Funktion zur Doupletenzusammenfhrung
(+) Messages:       HM-Interne Benachrichtigungen knnen auch ausserhalb des Browserfensters angezeigt werden
(+) Mitarb.-Import: Der Heinzelmann-Dienst kann automatisch Mitarbeiter aus Asset.Desk oder ActiveDirectory importieren oder aktualisieren
(+) Kalender:       Reservierung von Gerten direkt aus der Gertebersicht im Ticket
(+) Tickets:        Signaturen in Benachrichtigungen anhngen.
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.0.1', @NewsHeader = N'nderungen und Korrekturen in der Version 4.0.1', @NewsContent = N'
Das Update auf die Version 4.0.1 enthlt folgende nderungen:
<br />
(-) Ticketliste:    Schlagwort-Auswahl in der Minisuche als Auswahlliste
(-) Ticket:         Fehler bei der Ermittlung der Benachrichtigungsempfnger ber die Gruppe
(-) Ticket:         DeviceID in Asset.Desk-Kostentabelle aufgenommen
(-) Ticket:         Bearbeitungsdatumauswahl lag hinter dem Bearbeitungsfeld bei Ticketbeasrbeitung
(-) Ticket:         Bilder aus dem Editor als Anhang speichern bei Ticketerstellung
(+) Kategorie:      Prfung des Kategorienamens bei Erstellung nach vorhanden Kategorien
(+) Eskalation:     Besondere Eskalationsbenachr. auch fr Ticketsupporter bei Stufe 4 u. 5
(+) User:           Verwendete Ticketsichtbarkeitsfilter anzeigen
(-) User:           Benutzerrechteansicht strukturiert
(-) Rechte:         "Ticket Neu"-Aufruf wurde z.T. ohne das entsprechende Recht "Tickets erstellen" angezeigt, ebenso "Ticket aus Vorlage erstellen"
(+) Workflow:       Mit Projekt und Kostenstellt je Instanz
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.0.2', @NewsHeader = N'nderungen und Korrekturen in der Version 4.0.2', @NewsContent = N'
Das Update auf die Version 4.0.2 enthlt folgende nderungen:
<br />
(+) Reporting:      Reporting "Je Schlagwort" zugefgt
(-) Ticket:         Wird ein Ticket in einem Schritt bearbeitet und geschlossen, werden die Benachrichtigungsempfnger im Bearbeitungsevent nun mit angezeigt.
(-) Login:          Weiterleitung nach Abmeldung und ReLogin
(-) Update:         LESS-Styles nach Update neu kompilieren
(-) Install:        HM-Benachrichtigungstabellen bei SQL-New
(-) Ticket:         Wird ein Ticket in einem Schritt bearbeitet und geschlossen, werden die Benachrichtigungsempfnger im Bearbeitungsevent nun mit angezeigt.
(-) Kategorie:      Fehler bei Neuanlage von Kategorien
(-) Ticket:         Gesamten Verlauf anzeigen
(+) Ticket:         Verknpfte Tickets im Reiter
(-) Ticket:         Links korrigiert bei hnlichen Tickets
(-) Ticket:         Events verkleinern funtionierte nicht, wenn Ticketdetails aufgerufen wurden
(-) Upload:         Download von Dateien von Loginseite
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.0.3', @NewsHeader = N'nderungen und Korrekturen in der Version 4.0.3', @NewsContent = N'
Das Update auf die Version 4.0.3 enthlt folgende nderungen:
<br />
(-) Login:          Anmeldung von aus LDAP/AD importierte Benutzer funktionierte nicht.
(-) Ticket:         Mehr BBCode-Tags (Tabellen, mailto,...) werden geparst
(-) Ticketliste:    Standardfilter wieder definierbar
(-) Ticket:         Zum Teil variierte die Schriftgre in Druckansichten.
(-) Ticket:         Dialog fr Supporter- & Gruppenwechsel vergrert
(-) Ticketevent:    Empfngerauswahl-Autocomplet im Textfeld zeigte nicht alle Kontakte an
(+) Startseite:     Auswahl & Anordnung der Elemente auf der Startseite
(+) Startseite:     Linkliste und Updateinfo als Element zugefgt
(-) PHP-Errorlog:   Meldungen mit Status Notices oder Deprecated sollten nicht mehr mitgeloggt werden.
(-) Ticket:         Benachrichtigungsversand mit angepassten Templates korrigiert.
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.0.5', @NewsHeader = N'nderungen und Korrekturen in der Version 4.0.5', @NewsContent = N'
Das Update auf die Version 4.0.5 enthlt folgende nderungen:
<br />
(-) Ticket:         Manuelle Empfngerauswahl CC-Empfnger als Mehrfachauswahl mit Checkboxen.
(+) Settings:       Neuen Reiter Ticket erstellt und Optionen aus Reiter Allgemein ausgelagert.
(-) Ticket:         Verlauf: Weiterlesen-Funktion in den Einstellungen konfigurierbar.
(-) Ticket:         Liste der abhngigen Tickets wurden bei angepassten Styles nicht bercksichtigt.
(+) Device:         Anzeige der Inventarnummer in den Gertelisten
(-) Projekte:       Projektnamen mit Umlauten wurden in der Ticketansicht: Projektauswahl nicht angezeigt.
<br />';
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'PwdChangeDate')
    ALTER TABLE [dbo].[hm_Users] ADD [PwdChangeDate] [datetime] DEFAULT GETDATE() NULL
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_Snippet]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_Snippet] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[Title] [varchar] (255) NOT NULL ,
	[Snippet] [varchar](MAX) NOT NULL ,
	[ispublic] [smallint] NULL ,
        [CreateUserID] [int] NOT NULL
 CONSTRAINT [PK_hm_Snippet] PRIMARY KEY CLUSTERED
(
	[ID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 224)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder, SegmentID, RightDescr)
    VALUES (224, 'Textbausteine verffentlichen', 2, 50, 30, 'Der Benutzer kann allgemein sichtbare Textbausteine anlegen. Diese knnen auch von anderen Benutzern im Heinzelmann verwendet werden.');
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 225)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder, SegmentID, RightDescr)
    VALUES (225, 'Textbausteine verwalten', 2, 55, 30, 'Der Benutzer kann auch Textbausteine von anderen Benutzern lschen.');
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'expExpense')
    ALTER TABLE [dbo].[hm_Ticket] ADD [expExpense] [int] NULL
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.0.6', @NewsHeader = N'nderungen und Korrekturen in der Version 4.0.6', @NewsContent = N'
Das Update auf die Version 4.0.6 enthlt folgende nderungen:
<br />
(-) Ticketliste:    Wurden bei einer Suche keine Tickets gefunden, wurden z.T. alle Tickets in der Liste geladen und fehlerhaft angezeigt.
(+) Auth:           Einstellung, dass Passwrter nach einer bestimmten Zeit neu gesetzt werden mssen.
<br />';
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 230)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder, SegmentID, RightDescr)
    VALUES (230, 'Dokumentenpfad anzeigen', 2, 15, 3, 'Mit diesem Recht wird dem Benutzer der UNC-Pfad der Dokumente in der Dokumentenliste angezeigt.');
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.0.7', @NewsHeader = N'nderungen und Korrekturen in der Version 4.0.7', @NewsContent = N'
Das Update auf die Version 4.0.7 enthlt folgende nderungen:
<br />
(+) Reporting:      Report "Je Gruppe" zugefgt
(-) Ticket:         "Letzte Tickets des Kontaktes" wurden z.T. mit falschen Tickets angezeigt
(-) Diverses:       Gruppen, Supporter, Firmen und Kontakte mit Umlauten im Namen wurden z.T. nicht angezeigt (PHP 5.5)
(-) Ticket:         Kontaktsuche in bestehnden Tickets zeigte nicht alle gefundenen Kontakte an.
(+) Upload:         Neues Recht "Dokumentenpfad anzeigen": In der Dokumenten-Liste eines Tickets wird mit diesem Recht der Pfad zum Speicherort des Dokuments angezeigt (UNC-Pfad).         
(-) Ticket:         Die Schriftgre beim Ausgedruckten von Tickets wurde erhht.
(-) Ticket:         Z.T. wurde der Bearbeiten-Button angezeigt, auch wenn eine Bearbeitung des Tickets nicht mglich war.
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.0.8', @NewsHeader = N'nderungen und Korrekturen in der Version 4.0.8', @NewsContent = N'
Das Update auf die Version 4.0.8 enthlt folgende nderungen:
<br />
(-) Login:          Je Rubrik wurden nur 10 KB-Artikel angezeigt.
(-) Ticketliste:    Standardfilter und aktuelle geladener Filter werden angezeigt
(-) Ticketliste:    Datepicker im Suchformular wieder anzeigen
(-) Vorlagen:       Ticketerstellung aus Vorlagen mit WYSIWYG-Editor, Gerte des Kontaktes und Bildern aus Zwischenablage
(+) Mailversand:    Benachrichtigung an Supporter differenzierter einstellbar 
<br />
<p>
<b>Hinweis</b>
Die Supporter-Benachrichtigungen sollten sich auch ohne Anpassungen weiterhin so verhalten wie bisher.<br />
In den Einstellungen im <b>Reiter Email</b> ist die bisherige Einstellung voreingestellt.<br />
Beachten Sie, dass auch bei der neuen Empfngerauswahl die Benutzereinstellung "Erhlt Emails" Vorrang hat, also Supporter, die dort den Mailempfang deaktiviert haben auch weiterhin keine automatischen Benachrichtigungs-Emails erhalten.
</p>';
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_CategoryMailSender' AND COLUMN_NAME = 'GroupID')
    ALTER TABLE [dbo].[hm_CategoryMailSender] ADD [GroupID] [int] NULL
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_TicketDeviceDate]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketDeviceDate](
	[TicketID] [int] NOT NULL,
	[DeviceID] [int] NOT NULL,
	[addDate] [datetime]  DEFAULT GETDATE() NOT NULL,
	[removeDate] [datetime] NULL
) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_TicketContactDate]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketContactDate](
	[TicketID] [int] NOT NULL,
	[ContactID] [int] NOT NULL,
	[addDate] [datetime] DEFAULT GETDATE() NULL,
	[removeDate] [datetime] NULL
) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 405)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder, SegmentID, RightDescr)
    VALUES (405, 'Supporter-Online anzeigen', 1, 2, 22, 'Mit diesem Recht bekommen Benutzer die derzeit angemeldeten Supporter auf der Startseite angezeigt.');
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketReferences' AND COLUMN_NAME = 'sendMailToTicketID')
    ALTER TABLE [dbo].[hm_TicketReferences] ADD [sendMailToTicketID] [int] NULL

GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketReferences' AND COLUMN_NAME = 'sendMailToConnectedTicketID')
    ALTER TABLE [dbo].[hm_TicketReferences] ADD [sendMailToConnectedTicketID] [int] NULL

GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.0', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.0', @NewsContent = N'
Das Update auf die Version 4.1.0 enthlt folgende nderungen:
<br />
(+) Startseite:     Damit die eingeloggten Supporter angezeigt werden, muss das Gruppenrecht "Supporter-Online" muss dazu gesetzt sein.
(+) Ticket:         Multisupporter: Einem Ticket knnen mehrere Gruppen und Supporter zugewiesen werden.
(+) Workflow:       Workflows knnen nun als Adressaten den Workflow-Ersteller zugewiesen bekommen
(+) Workflow:       Adressaten fr Nachfolger-Aktivitten knnen in vorhergehender Aktivitt gewhlt werden.
(+) Ticket:         Benachrichtigung bei Bearbeitung von verknpften Ticket aktivierbar.
(+) Ticket:         Verknpftes Ticket erstellen.
(+) Ticket:         Aufwandsschtzung im Ticket: Ein voraussichtlichen Zeitbedarf kann eingetragen werden.
(+) Ticket:         Textbausteine zur Auswahl bei Ticketbearbeitung & Erstellung
(-) Ticket:         Ticketliste der verknpften Tickets sortierbar
(-) KB:             Paging in der Rubrik-Ansicht funktionierte nicht
<br />';
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WF_Activity' AND COLUMN_NAME = 'sendReport')
    ALTER TABLE [dbo].[hm_WF_Activity] ADD [sendReport] [int] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFDef_Activity' AND COLUMN_NAME = 'sendReport')
    ALTER TABLE [dbo].[hm_WFDef_Activity] ADD [sendReport] [int] NULL
GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'invoiced_1')
    ALTER TABLE [dbo].[hm_Project] ADD [invoiced_1] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'invoiced_2')
    ALTER TABLE [dbo].[hm_Project] ADD [invoiced_2] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'invoiced_3')
    ALTER TABLE [dbo].[hm_Project] ADD [invoiced_3] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'invoiced_4')
    ALTER TABLE [dbo].[hm_Project] ADD [invoiced_4] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'invoiced_5')
    ALTER TABLE [dbo].[hm_Project] ADD [invoiced_5] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'invoiced_6')
    ALTER TABLE [dbo].[hm_Project] ADD [invoiced_6] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'invoiced_7')
    ALTER TABLE [dbo].[hm_Project] ADD [invoiced_7] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'invoiced_8')
    ALTER TABLE [dbo].[hm_Project] ADD [invoiced_8] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'invoiced_9')
    ALTER TABLE [dbo].[hm_Project] ADD [invoiced_9] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'invoiced_10')
    ALTER TABLE [dbo].[hm_Project] ADD [invoiced_10] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'invoiced_11')
    ALTER TABLE [dbo].[hm_Project] ADD [invoiced_11] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'invoiced_12')
    ALTER TABLE [dbo].[hm_Project] ADD [invoiced_12] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'deduction_1')
    ALTER TABLE [dbo].[hm_Project] ADD [deduction_1] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'deduction_2')
    ALTER TABLE [dbo].[hm_Project] ADD [deduction_2] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'deduction_3')
    ALTER TABLE [dbo].[hm_Project] ADD [deduction_3] [money] NULL;
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Project' AND COLUMN_NAME = 'deduction_4')
    ALTER TABLE [dbo].[hm_Project] ADD [deduction_4] [money] NULL;
GO
ALTER TABLE hm_EscalationAction ALTER COLUMN ActionItem VARCHAR(300)
GO
ALTER TABLE hm_TicketStatus ALTER COLUMN Descr VARCHAR(20)
GO
ALTER TABLE hm_MailRecipientsForEvent ALTER COLUMN eMail VARCHAR(250)
GO
ALTER TABLE hm_MailRecipientsForEvent ALTER COLUMN RealName VARCHAR(250)
GO
ALTER TABLE hm_MailRecipientsForEvent ALTER COLUMN RecipientType VARCHAR(10)
GO
ALTER TABLE hm_MailToFromTicketEvent ALTER COLUMN eMail VARCHAR(250)
GO
ALTER TABLE hm_MailToFromTicketEvent ALTER COLUMN RealName VARCHAR(250)
GO
ALTER TABLE hm_MailToFromTicketEvent ALTER COLUMN AddressSource VARCHAR(10)
GO
ALTER TABLE hm_MailToFromTicketEvent ALTER COLUMN Service VARCHAR(10)
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.1', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.1', @NewsContent = N'
Das Update auf die Version 4.1.1 enthlt folgende nderungen:
<br />
(-) Ticket:         Ticketdetailansicht von Tickets aus E-Mails wurde z.T. nicht korrekt angezeigt
(-) Ticket:         Gruppen und Supporter wurden bei "Ticket kopieren" nicht bernommen
(-) Ticket:         Bei Ticketbernahme durch einen Supporter wird jetzt ggf. die Gruppe entfernt (Wenn neuer Supporter nicht Mitglied)
(-) Ticket:         Interne Notizen waren nicht fr die Supporter sichtbar
(-) Ticket:         Dokumentendaten bearbeiten funktionierte nicht
(-) Ticket:         Kontaktauswahl bei Ticketbearbeitung (mit Oracle)
(-) Ticketliste:    Excel Export hatte Lcken zwischen Tickets
(-) Ticketliste:    Suche nach Tickets ohne Supporter zeigte nicht alle an.
(-) Einstellung:    Pausenzeiten in den Supportzeiten lieen sich nicht entfernen
(-) Workflow:       Fehler bei der Anlage von Workflow-Definitionen
(-) Workflow:       Initiator ist nicht mehr Kontakt der Aktivitten
(-) Workflow:       Sortierung der Aktivitten korrigiert
(-) Upload:         Bearbeitung von Dokumenteninformationen korrigiert
(-) Formulare:      Formularbreite und Buttongre korrigiert
(-) Formulare:      Nicht freigegebene Formulare wurden bei Kategoriezuweisung angezeigt
(-) Formulare:      Maximale Anzahl an Auswahlmglichkeiten von 25 auf 50 erhht
(-) Style:          Angepasste Styles wurden nicht in allen Seiten bercksichtigt (Druckansichten, Uploadformular)
(-) Ticketlisten, Reporting: Z.T. wurden Tickets doppelt angezeigt.
(-) Allgemein (Oracle): Ein Teil der DB-Abfragen funktionierte nicht, wenn auf Vorhandensein einer Mailadresse geprft wurde
(-) Allgemein:      bersetzungen gepflegt
(-) Allgemein:      Filter in diversen Auswahllisten zugefgt
(-) Kontakte:       Benutzerdatenimport aus CSV-Dateien korrigiert
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.2', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.2', @NewsContent = N'
Das Update auf die Version 4.1.2 enthlt folgende nderungen:
<br />
(-) Allg.:          bersetzungen gepflegt
(+) Einstellung:    Mail2Ticket - Nur Tickets bearbeiten
(-) Einstellung:    Gruppen- & Kontaktauswahl bei E-Mail zu Ticket Einstellungen korrigiert
(-) Ticket:         Sammelbearbeitungen funktionierten z.T. nicht
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.3', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.3', @NewsContent = N'
Das Update auf die Version 4.1.3 enthlt folgende nderungen:
<br />
(+) Einstellungen:  E-Mail in Ticket: Neue Option zum getrennten aktivieren der Verarbeitungsfilter "Generierte Mails nicht verarbeiten" und per Betrefffilter (ggf. -nderung in den Einstellungen kontrollieren)
(-) Ticket:         Anpassungen in der Druckansicht
(+) Allgemein:      Wird aus den Benutzereinstellungen keine Sprache ermittelt (z.B. Loginformular), wird diese ber die Browsereinstellungen ermittelt.
(-) Ticketliste:    Sammelbearbeitung funktionierte z.T. nicht korrekt.
<br />';
GO
ALTER TABLE [dbo].[hm_Contacts] ALTER COLUMN room [varchar] (255) NULL
GO
ALTER TABLE [dbo].[hm_Contacts] ALTER COLUMN floor [varchar] (255) NULL
GO
ALTER TABLE [dbo].[hm_Contacts] ALTER COLUMN building [varchar] (255) NULL
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.4', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.4', @NewsContent = N'
Das Update auf die Version 4.1.4 enthlt folgende nderungen:
<br />
(+) Ticket:         Druckansicht gendert (Ersteller, Datum, Status oberhalb des Textes)
(-) Ticket:         Keine zustzlichen Leerzeichen innerhalb von Strings mehr (um Formatierungstags zu erhalten)
(-) Ticket:         Paging der Dokumentenliste funktionierte ab Seite 3 nicht
(-) Employee:       ActiveDirectory-GUID wurde bei Kontakte- und Benutzerupdate und - Import zum Teil nicht mit bertragen
(+) Formular:       Sortierbarkeit der Formularliste
(+) Vorlagen:       Sortierbarkeit der Vorlagenliste
(-) Rechte:         Fehler beim Recht "Nur Tickets aus eigener Gruppe"
(-) Ticketliste:    Suche nach Tickets mit Supportern UND "Ohne Supporter" zeigte z.T. nicht alle Tickets (Ohne Supporter) an.
(-) Ticketliste:    De-Archivierung archivierter Tickets funktionierte nicht
(-) Ticketliste:    Sammelbearbeitung - OnHold-Datum setzten funktionierte nicht (nur Oracle)
(-) Ticketliste:    Sammelbearbeitung - Kategoriewechsel funktionierte nicht (nur Oracle)
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.5', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.5', @NewsContent = N'
Das Update auf die Version 4.1.5 enthlt folgende nderungen:
<br />
(+) Employee:       Wenn ein Benutzer im LDAP als ausgeschieden markiert ist, wird der Kontakt auch im HM deaktiviert.
(+) Employee:       Mitarbeiterimport: Filter zum ausblenden bereits importierter Benutzer oder Kontakte
(-) Allgemein:      Fehler beim Mailversand (z. B. bei Ticketbearbeitungen) werden besser abgefangen
(-) Allgemein:      Englische bersetzungen nachgepflegt
(+) Ticket:         Bessere Auswahl von Gruppen und Supportern zur Ticketzuweisung
(-) Ticket:         (Masterticket) Bei zuweisung eines Mastertickets erhlt das Childticket die Gruppen und Supporter des Mastertickets
(-) Ticket:         (Masterticket) Bei bernahme eines Mastertickets durch einen Supporter (durch das bernahme-Icon) erhalten die Childtickets die selben Gruppen & Supporter wie das Masterticket
(+) Ticket:         Einfache Upload-Funktion mehrer Dokumente durch Drag''n Drop in einem bestehenden Ticket
(-) Workflow:       Aktivitten mit dem Status IMPOSSIBLE werden ausgeblendet wenn nach "Aktiven" Tickets gesucht wird.
(-) Workflow:       Fehlermeldungen bei der Definition von WF-Aktivitten werden angeziegt.
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.6', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.6', @NewsContent = N'
Das Update auf die Version 4.1.6 enthlt folgende nderungen:
<br />
(-) Ticket:         Neuladen der Javascript-Dateien im Ticketmodul nach Heinzelmann-Update (Lsung des Cache-Problems)
(-) Ticket:         Ticketbearbeitung mit "Manueller Empfngerauswahl": Kontakt-Empfnger werden bei "Internen Notizen" wieder abgewhlt
(-) Ticket:         Korrekturen bei der Supporter- und Gruppenauswahl in bestehnden Tickets
(-) Workflow:       Optische verbesserung des gesendeten Reports
(-) Allgemein:      In der Version 4.1.5 wurden die Popup-Benachrichtigungen (oben Rechts) auch angezeigt, wenn diese eigentlich deaktiviert sind.
(-) Ticket:         Werden einem Ticket neue Supportergruppen zugewiesen erhalten die Mitglieder dieser Gruppen darber die Mail-Benachrichtigung auch, wenn die Einstellung "Gruppe nur benachrichtigen, wenn kein Supporter zugewiesen ist" gesetzt ist.
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.7', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.7', @NewsContent = N'
Das Update auf die Version 4.1.7 enthlt folgende nderungen:
<br />
(+) Ticket:         Der Status RESPONSE wird auch gesetzt, wenn Nicht-Supporter das Ticket bearbeiten
(-) Knowledgebase:  Suche mit weniger als 4 Buchstaben lieferte keine Ergebnisse
(-) Vorlagen:       Die Vorlagenliste zeigte nur die ersten 15 Vorlagen an
(-) Ticket:         Bei Kategorieabhngiger Flligkeitszeit wurde diese beim Kategoriewechsel durch Texteingabe nicht angepasst.
(-) Employee:       Manueller Benutzerimport aus LDAP zeigte keine Benutzer mehr an.
(-) Employee:       Manuelles Benutzerupdate aus LDAP - Im AD als ausgeschieden markierte Benutzer und Kontakte werden deaktiviert.
(-) Ticketliste:    Umlautproblem in der Ticketvorschau korrigiert
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.8', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.8', @NewsContent = N'
Das Update auf die Version 4.1.8 enthlt folgende nderungen:
<br />
(+) Ticket:         Tickets knnen vom "Kontakt" geschlossen werden - ggf. mit Recht "Tickets nicht schliessen" entgegenwirken
(+) Ticket:         Flligkeitsdatum wird bei Kategoriewechsel neu berechnet
(-) Ticket:         Externe Links werden in neuen Tabs geffnet
(-) Ticket:         Supporterauswahl per Tastatur vereinfacht
(-) Ticket:         Ticketerstellung: Bei einem Kategoriewechsel mit Formular wurde der Formularreiter der bisherigen Kategorie z.T. nicht entfernt.
(-) Ticketliste:    Ticketfilter wurden bei der Erstellung ohne die freigegebenen Gruppen gespeichert
(-) Ticketliste:    Kopien von Ticketfiltern bernahmen nicht alle freigegebenen Gruppen
(-) Ticketliste:    Ticketfilter eines Benutzers werden bei gleichen Namen berschrieben
(-) Ticketliste:    Z.T. wurden Sonderzeichen und Umlaute nicht korrekt dargestellt (Ticketvorschau und Sammelbearbeitung)
(-) Formulare:      Deutlicheres hervorheben unausgefllter Pflichtfelder
(-) Vorlagen:       Liste mit Auswahl "Eintrge pro Seite"
(-) Vorlagen:       In Ticketvorlagen eingetragene Supporter & Gruppen wurden bei nderungen an den Vorlagen nicht entfernt
<br />';
GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_UserMessages' AND COLUMN_NAME = 'delivered')
    ALTER TABLE [dbo].[hm_UserMessages] ADD [delivered] [tinyint] DEFAULT 0 
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.9', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.9', @NewsContent = N'
Das Update auf die Version 4.1.9 enthlt folgende nderungen:
<br />
(+) Ticket:         Standard-Gruppe & Supporter fr Ticketerstellung
(-) Allgemein:      Menu-Punkt Verwaltung->Kontakte->LDAP-Import war auch ohne LDAP-Modul sichtbar
(-) Mobile Ansicht: Suchformular in ticketliste funktionierte nicht
(-) Vorlagen:       Kontakt aus Vorlage entfernen
(-) Workflow:       Formulare mit Umlauten im Namen zeigten die gespeicherten Daten ggf. nicht mehr an
(-) Ticket:         Ticketnavigation in der Detailansicht funktionierte nach Ticketreferenzierung nicht mehr
(-) Einstellung:    Prfung nach verfgbaren Update deaktivierbar.
(-) Ticket:         Im Ticketverlauf wurden u.U. die Protokol-Events nicht mehr angezeigt
(-) Kontakte:       Firmen-Verwaltungsliste korrigiert
(-) Ticket:         Supporterbenachrichtigung an gewhlte Empfnger ohne Supporter,Gruppe o. Kategorie funktionierte nicht
<br />';
GO
IF EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_CategoryForms]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
    IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_CategoryForms' AND COLUMN_NAME = 'SequenceName')
        ALTER TABLE [dbo].[hm_CategoryForms] ADD [SequenceName] [varchar](100) NULL;
GO
IF EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_CategoryForms]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
    IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_CategoryForms' AND COLUMN_NAME = 'TriggerName')
        ALTER TABLE [dbo].[hm_CategoryForms] ADD [TriggerName] [varchar](100) NULL;
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.10', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.10', @NewsContent = N'
Das Update auf die Version 4.1.10 enthlt folgende nderungen:
<br />
(-) Upload:         Wurden mehrere Dateien mit gleicher Dateiendung per DragNDrop hochgeladen, haben sich diese z.T. ohne Fehlermeldung berschrieben.
(-) Ticket:         Der WYSIWYG-Editor funktioniert in windows Edge nicht korrekt. Als Workaround ist dieser nun durch den Benutzer deaktivierbar.
(-) Ticketliste:    Zeichensatz- und Positionsprobleme bei der Ticketvorschau (Tooltip) in der Ticketliste
(-) Ticketliste:    Erneutes Laden einer gefilterten Ticketliste zeigte u.U. andere Suchergebnisse an als zuvor. Ebenso beim Zurckgehen aus einem Ticket in eine gefilterte Liste.
(-) Formular:       Formularanlage in Oracle-DB korrigiert. Z.T. wurden zu lange Tabellennamen erlaubt, was zu Fehlern bei der anlage fhrte.
(-) Formular:       Lschen von leeren formular-Definition lscht diese aus der Datenbank.
<br />';
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_Service]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_Service](
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[Title] varchar(300) NOT NULL,
        [Descr] varchar(5000)  NULL,
        [Risks] varchar(5000)  NULL,
	[ServiceTypeID] [int] NULL,
        [Status] [tinyint] DEFAULT 0 NOT NULL,
        [Problem] [tinyint] DEFAULT 0 NOT NULL,
        [MaturityLevel] [tinyint] DEFAULT 1 NOT NULL,
        [CategoryID1] [int] NULL,
        [CategoryID2] [int] NULL,
        [CreateUserID] [bigint] NULL,
        [CreateDate] [datetime] DEFAULT GETDATE() NOT NULL,
        [UpdateUserID] [bigint] NULL,
        [UpdateDate] [datetime] DEFAULT GETDATE() NOT NULL
 CONSTRAINT [PK_hm_Service] PRIMARY KEY CLUSTERED
(
	[ID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Service' AND COLUMN_NAME = 'ticketshortdescr')
    ALTER TABLE [dbo].[hm_Service] ADD [ticketshortdescr] varchar(300) NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Service' AND COLUMN_NAME = 'ticketdescr')
    ALTER TABLE [dbo].[hm_Service] ADD [ticketdescr] varchar(5000)  NULL
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_ConnectedService]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ConnectedService](
	[ServiceID] [bigint] NOT NULL ,
        [ConnectedServiceID] [bigint] NOT NULL 
 CONSTRAINT [PK_hm_ConnectedService] PRIMARY KEY CLUSTERED
(
	[ServiceID] ASC,
        [ConnectedServiceID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_ServiceType]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ServiceType](
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[Title] varchar(300) NOT NULL,
        [Descr] varchar(5000) NOT NULL,
        [Active] [tinyint] DEFAULT 1 NOT NULL
 CONSTRAINT [PK_hm_ServiceType] PRIMARY KEY CLUSTERED
(
	[ID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_ServiceManagerGroup]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ServiceManagerGroup](
	[ServiceID] [bigint] NOT NULL ,
	[GroupID] [bigint] NOT NULL
 CONSTRAINT [PK_hm_ServiceManagerGroup] PRIMARY KEY CLUSTERED
(
	[ServiceID] ASC,
        [GroupID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_ServicePManagerGroup]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ServicePManagerGroup](
	[ServiceID] [bigint] NOT NULL ,
	[GroupID] [bigint] NOT NULL
 CONSTRAINT [PK_hm_ServicePManagerGroup] PRIMARY KEY CLUSTERED
(
	[ServiceID] ASC,
        [GroupID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_ServiceIManagerGroup]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ServiceIManagerGroup](
	[ServiceID] [bigint] NOT NULL ,
	[GroupID] [bigint] NOT NULL
 CONSTRAINT [PK_hm_ServiceIManagerGroup] PRIMARY KEY CLUSTERED
(
	[ServiceID] ASC,
        [GroupID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_ServiceEscalationGroup]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ServiceEscalationGroup](
	[ServiceID] [bigint] NOT NULL ,
	[EscalationLvl] [int] NOT NULL,
        [GroupID] [bigint] NOT NULL,
        [sendMail] [tinyint] DEFAULT 1 NOT NULL
 CONSTRAINT [PK_hm_ServiceEscalationGroup] PRIMARY KEY CLUSTERED
(
	[ServiceID] ASC,
        [EscalationLvl] ASC,
        [GroupID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_ServiceLog]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ServiceLog](
        [ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[ServiceID] [bigint] NOT NULL ,
        [CreateUserID] [bigint] NULL,
        [CreateDate] [datetime] DEFAULT GETDATE() NOT NULL,
        [Message] varchar(5000) NULL
 CONSTRAINT [PK_hm_ServiceLog] PRIMARY KEY CLUSTERED
(
	[ID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketPrio' AND COLUMN_NAME = 'Color')
ALTER TABLE [dbo].[hm_TicketPrio] ADD
    [Color] varchar(50) NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketPrio' AND COLUMN_NAME = 'published')
ALTER TABLE [dbo].[hm_TicketPrio] ADD
    [published] tinyint DEFAULT 1 NOT NULL
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_ServiceLevel]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ServiceLevel](
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[Title] varchar(300) NOT NULL,
        [PrioID] int NULL,
        [Mon] [tinyint] DEFAULT 0 NOT NULL ,
        [Tue] [tinyint] DEFAULT 0 NOT NULL ,
        [Wed] [tinyint] DEFAULT 0 NOT NULL ,
        [Thu] [tinyint] DEFAULT 0 NOT NULL ,
        [Fri] [tinyint] DEFAULT 0 NOT NULL ,
        [Sat] [tinyint] DEFAULT 0 NOT NULL ,
        [Sun] [tinyint] DEFAULT 0 NOT NULL ,
        [MonFrom1] varchar(5) NULL,
        [MonUntil1] varchar(5) NULL,
        [MonFrom2] varchar(5) NULL,
        [MonUntil2] varchar(5) NULL,
        [TueFrom1] varchar(5) NULL,
        [TueUntil1] varchar(5) NULL,
        [TueFrom2] varchar(5) NULL,
        [TueUntil2] varchar(5) NULL,
        [WedFrom1] varchar(5) NULL,
        [WedUntil1] varchar(5) NULL,
        [WedFrom2] varchar(5) NULL,
        [WedUntil2] varchar(5) NULL,
        [ThuFrom1] varchar(5) NULL,
        [ThuUntil1] varchar(5) NULL,
        [ThuFrom2] varchar(5) NULL,
        [ThuUntil2] varchar(5) NULL,
        [FriFrom1] varchar(5) NULL,
        [FriUntil1] varchar(5) NULL,
        [FriFrom2] varchar(5) NULL,
        [FriUntil2] varchar(5) NULL,
        [SatFrom1] varchar(5) NULL,
        [SatUntil1] varchar(5) NULL,
        [SatFrom2] varchar(5) NULL,
        [SatUntil2] varchar(5) NULL,
        [SunFrom1] varchar(5) NULL,
        [SunUntil1] varchar(5) NULL,
        [SunFrom2] varchar(5) NULL,
        [SunUntil2] varchar(5) NULL,
	[DesireTime] [int] DEFAULT 0 NOT NULL,
	[esclvl_1] [int] DEFAULT 0 NOT NULL,
	[esclvl_2] [int] DEFAULT 0 NOT NULL,
	[esclvl_3] [int] DEFAULT 0 NOT NULL,
	[esclvl_4] [int] DEFAULT 0 NOT NULL,
	[esclvl_5] [int] DEFAULT 0 NOT NULL, 
 CONSTRAINT [PK_hm_ServiceLevel] PRIMARY KEY CLUSTERED
(
	[ID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_ServiceLvlAgreement]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_ServiceLvlAgreement](
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
        [ServiceID] [bigint] NOT NULL ,
        [ServiceLvlID] [bigint] NOT NULL ,
        [CompanyID] [bigint] NOT NULL ,
        [MandantID] [bigint] NULL ,
	[Department] varchar(300) NULL,
        [Startdate] datetime DEFAULT GETDATE() NOT NULL,
        [Enddate] datetime DEFAULT GETDATE() NOT NULL,
 CONSTRAINT [PK_hm_ServiceLvlAgreement] PRIMARY KEY CLUSTERED
(
	[ID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_Mandant]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_Mandant](
	[ID] [bigint] IDENTITY(1,1) NOT NULL,
	[Mandant] [varchar](100) NULL,
	[Deleted] [tinyint] DEFAULT 0 NOT NULL,
 CONSTRAINT [PK_hm_Mandant] PRIMARY KEY CLUSTERED
(
	[ID] ASC
) ) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'MandantenID')
    ALTER TABLE [dbo].[hm_Contacts] ADD [MandantenID] [int] DEFAULT 0 NULL
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.11', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.11', @NewsContent = N'
Das Update auf die Version 4.1.11 enthlt folgende nderungen:
<br />
(+) TAPI:           Erweiterung der bermittelten anrufenden Nummer um definierbare Zustze.
(+) Ticket:         WYSIWYG-Ausblenden-Button deaktivierbar.
(+) LDAP:           Hinweis auf fehlerhafte Verbindungsdaten bei LDAP-Update und -Import.
(+) User:           Sprachauswahl fr eigenen Benutzer nderbar.
(-) Employee:       LDAP Mitarbeiterimport & Update: Fehlermeldung bei LDAP-Verbindungsfehlern 
(+) Employee:       LDAP Mitarbeiterimport & Update: Spracheinstellung aus Directory wird bernommen (de oder en)
(+) Project:        Gesamter Aufwand der Projekttickets eines Projekts wird angezeigt.
(+) TAPI:           Ergnzende Telefonnummern zur Rufnummernprfung zugefgt.
(-) Settings:       WYSIWYG-Button in den Einstellungen entfernbar gemacht.
(-) Ticket:         Darstellung von BBCode-Formatierungen funktionierte nicht mehr.
(-) Ticket:         WYSIWYG-Editor aktualisiert
<br />';
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'ServiceID')
    ALTER TABLE [dbo].[hm_Ticket] ADD [ServiceID] [int] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'SLAID')
    ALTER TABLE [dbo].[hm_Ticket] ADD [SLAID] [int] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'MajorIncident')
    ALTER TABLE [dbo].[hm_Ticket] ADD [MajorIncident] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'NativeGUID')
    ALTER TABLE hm_Contacts ADD NativeGUID as LOWER(SUBSTRING(ADGuid, 7, 2) + SUBSTRING(ADGuid, 5, 2) + SUBSTRING(ADGuid, 3, 2) + SUBSTRING(ADGuid, 1, 2) + SUBSTRING(ADGuid, 12, 2) + SUBSTRING(ADGuid, 10, 2) + SUBSTRING(ADGuid, 17, 2) + SUBSTRING(ADGuid, 15, 2) + Replace(SUBSTRING(ADGuid, 20, 17), '-', ''))
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.12', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.12', @NewsContent = N'
Das Update auf die Version 4.1.12 enthlt folgende nderungen:
<br />
(-) Ticketliste:    Performance gesteigert.
(-) Ticket:         Ticket per Mail versenden - Betreffsdefinition funktionierte nicht korrekt.
(-) Ticket:         Kontaktbenachrichtigung bei Ticketerstellung trotz anderslautender Einstellung.
(+) Employee:       Verknpfung zw. Asset.Desk-Mitarbeiter und Kontakt auch bei LDAP-Import & -Update.
(-) Ticket:         Kategorieauswahl fr Kategorie 2 war bei Texteingabe nicht anhngig von Kategorie 1. 
(-) Ticketliste:    Sortierung aus angepassten Ticketlisten wurde nicht angewendet.
(-) Ticketliste:    Suchfilter wurden z.T. nicht korrekt geladen bei Auswahl in der Minisuche.
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.1.13', @NewsHeader = N'nderungen und Korrekturen in der Version 4.1.13', @NewsContent = N'
Das Update auf die Version 4.1.13 enthlt folgende nderungen:
<br />
(-) Ticket:         Interne Notizen wurden z.T. nicht angezeigt.
(+) Einstellungen:  Standardwert fr "Kontakt erhlt Emails" bei Kontaktanlage definierbar.
(-) Installation:   Fehler im DB-Skript zum Anlegen der Datenbank.
(-) Ticketliste:    Anzeige aller verwendeten Kategorien als Suchkriterium
<br />';
GO
INSERT INTO hm_RightsSegment (SegmentID, Descr, SegmentOrder) VALUES (32, 'ITIL Service', 320)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 820)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder, SegmentID, RightDescr)
    VALUES (820, 'Servicetickets anlegen', 3, 10, 32, 'Benutzer mit diesem Recht drfen Servicetickets anlegen.');
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 821)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder, SegmentID, RightDescr)
    VALUES (821, 'Services verwalten', 3, 15, 32, 'Benutzer mit diesem Recht drfen Services anlegen und bearbeiten.');
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 820 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 820)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 821 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 821)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[hm_TicketEscalation]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_TicketEscalation](
	[TicketID] [bigint] NOT NULL,
	[Esc_Lvl_1] [datetime] NULL,
	[Esc_Lvl_2] [datetime] NULL,
	[Esc_Lvl_3] [datetime] NULL,
	[Esc_Lvl_4] [datetime] NULL,
	[Esc_Lvl_5] [datetime] NULL,
	[currentlvl] [int] DEFAULT 0 NOT NULL ,
	[reached_lvl_1] [datetime] NULL,
	[reached_lvl_2] [datetime] NULL,
	[reached_lvl_3] [datetime] NULL,
	[reached_lvl_4] [datetime] NULL,
	[reached_lvl_5] [datetime] NULL,
	[DesireTime] [datetime] NULL
) ON [PRIMARY]

GO
IF object_id('[FK_hm_TicketEscalation_hm_Ticket]') IS NULL
ALTER TABLE [dbo].[hm_TicketEscalation]  WITH CHECK ADD  CONSTRAINT [FK_hm_TicketEscalation_hm_Ticket] FOREIGN KEY([TicketID])
REFERENCES [dbo].[hm_Ticket] ([ID])
GO
IF object_id('[FK_hm_TicketEscalation_hm_Ticket]') IS NULL
ALTER TABLE [dbo].[hm_TicketEscalation] CHECK CONSTRAINT [FK_hm_TicketEscalation_hm_Ticket]
GO
UPDATE hm_Users SET PwdChangeDate = GETDATE() WHERE PwdChangeDate IS NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_News' AND COLUMN_NAME = 'Deleted')
    ALTER TABLE [dbo].[hm_News] ADD [Deleted] [tinyint] NOT NULL Default 0
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.2', @NewsHeader = N'nderungen und Korrekturen in der Version 4.2', @NewsContent = N'
Das Update auf die Version 4.2 enthlt folgende nderungen:
<br />
(-) Dokumente:      nderung der Dokumentendetails im Ticket-Reiter Dokumente funktionierte z.T. nicht
(-) Ticketliste:    Benutzerdefinierte Ticketliste wurde erst bei Logout in der Benutzerkonfiguration gespeichert.
(-) Ticketliste:    Excel- & CSV-Export nun mit Supportern & Gruppe.
(-) Ticketliste:    Im Suchformular wurden als Auswahl fr Kategorie 1 die ermittelten Daten fr Kategorie 2 angezeigt.
(-) Benutzerliste:  Filterung nach Gruppe und "Nur Supporter" funktionierte nicht.
(-) Employee:       Beim Mitarbeiterimport (LDAP und Asset.Desk) wurden keine Kontakte angelegt.
(-) News:           Paging in der Nachrichtenliste merkte sich die Werte nicht
(-) Ticket:         Beim Gruppen- und Supporterwechsel werden die Benachrichtigungen erst beim Schlieen der Auswahlliste versandt.
(-) Ticketliste:    Benutzer ohne Kontakt konnten Tickets ohne Kontakt sehen.
(-) Ticket:         Wurden Mastertickets erledigt, wurde der Status nicht in Childtickets bernommen.
(-) Ticket:         Im Ticketreiter "Letzte Tickets" wurden die Tickets ohne Umlaute und Supporter angezeigt.
(-) Ticket:         Bei der Funktion "Ticket bernehmen" durch das Icon neben der Suporterauswahl wird der eigene Benutzer nun zustzlich zu ggf. vorhandenen Supportern zugefgt. 
                    Die gewhlten Gruppen bleiben erhalten, sofern der Benutzer in mindestens einer der Gruppen Mitglied ist (Also mit der aktuellen Gruppenasuwahl whlbar ist). 
                    Ansonsten werden alle Gruppen entfernt.
(-) Ticketliste:    Die Ticketliste des Kontakts, die neben dem Kontaktfeld in der Ticket-Detailansicht durch das Fernglas aufgerufen wird, wurde mit den Suchdaten der letzten Ticketsuche aus der normalen Ticketliste angewendet
(-) Ticket:         Beim Entfernen der Kategorie 2 wurde u. U. die Kategorie 1 mit entfernt.
(-) Ticket:         Bei Ticketerstellung zugefgte Gerte wurden nicht gespeichert.
(-) Kategorien:     Gewhlte Kategorien konnten bei der Ticketerstellung und in den Vorlagen nur gendert aber nicht entfernt werden.
(-) Settings:       Heinzelmann-URL in Asset.Desk wieder verfgbar (Links zu Tickets).
<br/>
Der aktuelle Heinzelmann-Dienst fr die Version liegt unter http://iccm.fair-computer.de/heinzelmann/HM-Dienste/ zum Download bereit.
<h3>Ab der Version 4.2. ist das neue Heinzelmann Zusatzmodul ITIL Service enthalten</h3>
Informationen zu dem Modul finden Sie auf <a href="http://www.fair-computer.de/de/produkte/heinzelmann/zusatzmodule/itil-service.html">unserer Internetseite</a>.

<br />';
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'PushMessageCreate')
    ALTER TABLE [dbo].[hm_Users] ADD [PushMessageCreate] [tinyint] DEFAULT 0 NOT NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'PushMessageEdit')
    ALTER TABLE [dbo].[hm_Users] ADD [PushMessageEdit] [tinyint] DEFAULT 0 NOT NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'PushMessageAssign')
    ALTER TABLE [dbo].[hm_Users] ADD [PushMessageAssign] [tinyint] DEFAULT 0 NOT NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'PushMessageClose')
    ALTER TABLE [dbo].[hm_Users] ADD [PushMessageClose] [tinyint] DEFAULT 0 NOT NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'PushMessageEscalation')
    ALTER TABLE [dbo].[hm_Users] ADD [PushMessageEscalation] [tinyint] DEFAULT 0 NOT NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_ServiceLevel' AND COLUMN_NAME = 'DesireTime')
    ALTER TABLE [dbo].[hm_ServiceLevel] ADD [DesireTime] [int] DEFAULT 0 NOT NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_ServiceLevel' AND COLUMN_NAME = 'esclvl_1')
    ALTER TABLE [dbo].[hm_ServiceLevel] ADD [esclvl_1] [int] DEFAULT 0 NOT NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_ServiceLevel' AND COLUMN_NAME = 'esclvl_2')
    ALTER TABLE [dbo].[hm_ServiceLevel] ADD [esclvl_2] [int] DEFAULT 0 NOT NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_ServiceLevel' AND COLUMN_NAME = 'esclvl_3')
    ALTER TABLE [dbo].[hm_ServiceLevel] ADD [esclvl_3] [int] DEFAULT 0 NOT NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_ServiceLevel' AND COLUMN_NAME = 'esclvl_4')
    ALTER TABLE [dbo].[hm_ServiceLevel] ADD [esclvl_4] [int] DEFAULT 0 NOT NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_ServiceLevel' AND COLUMN_NAME = 'esclvl_5')
    ALTER TABLE [dbo].[hm_ServiceLevel] ADD [esclvl_5] [int] DEFAULT 0 NOT NULL 
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_ServiceLevel] WHERE ID = 1)
INSERT INTO hm_ServiceLevel (Title, PrioID, DesireTime, esclvl_1, esclvl_2, esclvl_3, esclvl_4, esclvl_5, Mon , Tue , Wed , Thu , Fri , Sat , Sun,MonFrom1, MonUntil1, MonFrom2, MonUntil2, TueFrom1, TueUntil1, TueFrom2, TueUntil2, WedFrom1, WedUntil1, WedFrom2, WedUntil2, ThuFrom1, ThuUntil1, ThuFrom2, ThuUntil2, FriFrom1, FriUntil1, FriFrom2, FriUntil2, SatFrom1, SatUntil1, SatFrom2, SatUntil2, SunFrom1, SunUntil1, SunFrom2, SunUntil2) VALUES ( 'Bronze', 1, 16, 240, 480, 720, 960, 1200, 1, 1, 1, 1, 1, 0, 0, '09:00', '12:00', '13:00', '17:00', '09:00', '12:00', '13:00', '17:00', '09:00', '12:00', '13:00', '17:00', '09:00', '12:00', '13:00', '17:00', '09:00', '12:00', '13:00', '17:00', '', '', '', '', '', '', '', '')
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_ServiceLevel] WHERE ID = 2)
INSERT INTO hm_ServiceLevel (Title, PrioID, DesireTime, esclvl_1, esclvl_2, esclvl_3, esclvl_4, esclvl_5, Mon , Tue , Wed , Thu , Fri , Sat , Sun,MonFrom1, MonUntil1, MonFrom2, MonUntil2, TueFrom1, TueUntil1, TueFrom2, TueUntil2, WedFrom1, WedUntil1, WedFrom2, WedUntil2, ThuFrom1, ThuUntil1, ThuFrom2, ThuUntil2, FriFrom1, FriUntil1, FriFrom2, FriUntil2, SatFrom1, SatUntil1, SatFrom2, SatUntil2, SunFrom1, SunUntil1, SunFrom2, SunUntil2) VALUES ( 'Silber', 2, 10, 120, 300, 480, 600, 720, 1, 1, 1, 1, 1, 0, 0, '08:00', '', '', '17:00', '08:00', '', '', '17:00', '08:00', '', '', '17:00', '08:00', '', '', '17:00', '08:00', '', '', '17:00', '', '', '', '', '', '', '', '') 
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_ServiceLevel] WHERE ID = 3)
INSERT INTO hm_ServiceLevel (Title, PrioID, DesireTime, esclvl_1, esclvl_2, esclvl_3, esclvl_4, esclvl_5, Mon , Tue , Wed , Thu , Fri , Sat , Sun,MonFrom1, MonUntil1, MonFrom2, MonUntil2, TueFrom1, TueUntil1, TueFrom2, TueUntil2, WedFrom1, WedUntil1, WedFrom2, WedUntil2, ThuFrom1, ThuUntil1, ThuFrom2, ThuUntil2, FriFrom1, FriUntil1, FriFrom2, FriUntil2, SatFrom1, SatUntil1, SatFrom2, SatUntil2, SunFrom1, SunUntil1, SunFrom2, SunUntil2) VALUES ( 'Gold', 3, 8, 60, 180, 360, 480, 600, 1, 1, 1, 1, 1, 0, 0, '08:00', '', '', '17:00', '08:00', '', '', '17:00', '08:00', '', '', '17:00', '08:00', '', '', '17:00', '08:00', '', '', '17:00', '', '', '', '', '', '', '', '') 
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Users' AND COLUMN_NAME = 'RandomUserID2')
ALTER TABLE [dbo].[hm_Users] ADD [RandomUserID2] varchar(50) NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_TicketStatus] WHERE ID = 14 AND Descr = 'CANCELED')
    INSERT INTO hm_TicketStatus (Descr) VALUES ('CANCELED')
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFInstanz' AND COLUMN_NAME = 'UpdateUserID')
ALTER TABLE [dbo].[hm_WFInstanz] ADD [UpdateUserID] [bigint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFInstanz' AND COLUMN_NAME = 'UpdateDate')
ALTER TABLE [dbo].[hm_WFInstanz] ADD [UpdateDate] [datetime] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFInstanz' AND COLUMN_NAME = 'Canceled')
ALTER TABLE [dbo].[hm_WFInstanz] ADD [Canceled] [int] DEFAULT 0 NOT NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFDef_DependedActivitys' AND COLUMN_NAME = 'Field')
ALTER TABLE dbo.hm_WFDef_DependedActivitys ADD
	[Field] varchar(500) NULL,
	[Value] varchar(500) NULL,
        [SessionID] [varchar](64) NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFDef_DependedActivitys' AND COLUMN_NAME = 'OrCondition')
ALTER TABLE dbo.hm_WFDef_DependedActivitys ADD
	[OrCondition] [tinyint] DEFAULT 0 NOT NULL
GO
IF EXISTS (SELECT * FROM sys.foreign_keys WHERE object_id = OBJECT_ID(N'dbo.PK_hm_WFDef_DependedActivitys') AND parent_object_id = OBJECT_ID(N'dbo.hm_WFDef_DependedActivitys'))
ALTER TABLE dbo.hm_WFDef_DependedActivitys DROP CONSTRAINT PK_hm_WFDef_DependedActivitys
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFActive_DepActivities' AND COLUMN_NAME = 'Field')
ALTER TABLE dbo.hm_WFActive_DepActivities ADD
	[Field] varchar(500) NULL,
	[Value] varchar(500) NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFActive_DepActivities' AND COLUMN_NAME = 'OrCondition')
ALTER TABLE dbo.hm_WFActive_DepActivities ADD
    [OrCondition] [tinyint] DEFAULT 0 NOT NULL
GO
IF EXISTS (SELECT * FROM sys.foreign_keys WHERE object_id = OBJECT_ID(N'dbo.PK_hm_WFActive_DepActivities') AND parent_object_id = OBJECT_ID(N'dbo.hm_WFActive_DepActivities'))
    ALTER TABLE dbo.hm_WFActive_DepActivities DROP CONSTRAINT PK_hm_WFActive_DepActivities
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_TicketStatus] WHERE ID = 15 AND Descr = 'SKIPPED')
    INSERT INTO hm_TicketStatus (Descr) VALUES ('SKIPPED')
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.2.1', @NewsHeader = N'nderungen und Korrekturen in der Version 4.2.1', @NewsContent = N'
Das Update auf die Version 4.2.1 enthlt folgende nderungen:
<br />
(-) Ticket:         Flligkeitstermin wurde falsch gesetzt wenn der Ticketersteller nicht das Recht "Flligkeitstermin anzeigen" hat.
(+) APP:            Push-Messages fr iOS-Heinzelmann-APP
(+) APP:            Benutzer knnen in APP und Web-Heinzelmann parallel angemeldet sein.
(-) Rechte:         Das Recht "+ unkategorisierte Tickets anzeigen" zeigte in Kombination mit dem Recht "Nur Tickets der einen Gruppe anzeigen" nur unkategoriesierte Tickets an.
<br />';
GO
/*Backup der ADef-FormularDefinitionen */
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_WFActDefFormHistory]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_WFActDefFormHistory](
	[ActivityDefID] [int] NOT NULL,
	[Form] varchar(max) NULL,
	[UpdateDate] [datetime] DEFAULT GETDATE() NULL
) ON [PRIMARY]
GO
IF EXISTS (SELECT * FROM [dbo].[sysobjects] WHERE id = object_id(N'[dbo].[tr_WFActDefFormHistory]') AND OBJECTPROPERTY(id, N'IsTrigger') = 1)
DROP TRIGGER tr_WFActDefFormHistory
GO
CREATE TRIGGER tr_WFActDefFormHistory on hm_WFDef_Activity
AFTER UPDATE 
AS
insert into
   hm_WFActDefFormHistory (ActivityDefID, Form, UpdateDate)
select
   i.ID, t.Form, getDate()
from
   inserted as i,
   hm_WFDef_Activity as t
where
   i.id = t.id
GO
UPDATE hm_WFDef_Activity SET sendReport = 0 WHERE sendReport = 0
GO
UPDATE hm_WFDef_Activity SET sendReport = 1 WHERE sendReport = 1
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFDef_Activity' AND COLUMN_NAME = 'LoopsAllowed')
    ALTER TABLE [dbo].[hm_WFDef_Activity] ADD [LoopsAllowed] [int] DEFAULT 0 NOT NULL
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_WFGroups]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_WFGroups](
	[WFDID] [int] NOT NULL,
	[GroupID] [int] NOT NULL,
	[addDate] [datetime] DEFAULT GETDATE() NULL,
 CONSTRAINT [PK_hm_WFGroups] PRIMARY KEY CLUSTERED 
(
	[WFDID] ASC,
	[GroupID] ASC
)
) ON [PRIMARY]
GO
ALTER TABLE hm_WFDefinitions ALTER COLUMN Description VARCHAR(300)
GO
ALTER TABLE hm_WF_Activity ALTER COLUMN Description VARCHAR(300)
GO
ALTER TABLE hm_WF_Activity ALTER COLUMN DescriptionName VARCHAR(300)
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.3', @NewsHeader = N'nderungen und Korrekturen in der Version 4.3', @NewsContent = N'
Das Update auf die Version 4.3 enthlt folgende nderungen:
<br />
(+) Workflow:       Verzweigungen zugefgt
(+) Workflow:       Schleifen zugefgt
(+) Workflow:       Oder-Bedinung zugefgt
(-) Knowledgebase:  Vorschau korrigiert
<br/>
Der aktuelle Heinzelmann-Dienst fr die Version liegt unter http://iccm.fair-computer.de/heinzelmann/HM-Dienste/ zum Download bereit.
<h3>In der Version 4.3. haben wir das Workflow Modul erweitert</h3>
Informationen zu dem Modul finden Sie auf <a href="http://www.fair-computer.de/de/produkte/heinzelmann/zusatzmodule/workflow.html">unserer Internetseite</a> und im <a href="http://iccm.fair-computer.de/heinzelmann/Heinzelmann_Handbuch.pdf#page=96">Handbuch (PDF, ab Seite 96)</a>.
<br />';
GO
DELETE FROM hm_Rights WHERE RightID = 701
GO
DELETE FROM hm_Rights WHERE RightID = 704
GO
DELETE from hm_GroupRights WHERE Right_ID = 701
GO
DELETE from hm_GroupRights WHERE Right_ID = 704
GO

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFInstanz' AND COLUMN_NAME = 'ContactID')
    ALTER TABLE [dbo].[hm_WFInstanz] ADD [ContactID] [int] NULL
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.3.1', @NewsHeader = N'nderungen und Korrekturen in der Version 4.3.1', @NewsContent = N'
Das Update auf die Version 4.3.1 enthlt folgende nderungen:
<br />
(-) Reporting:      Supporterauswahl enthielt nicht alle Supporter
(-) Vorlagen:       Kein Feedback bei manueller Ticketerstellung
(-) Reporting:      Reporting Ticketweitergabe zeigt nach der Supporterauswahl nicht alle Tickets an
(-) Workflow:       Korrekturen und Verbesserungen der neuen Funktionen
(+) Workflow:       Aktivitts-Typ Benachrichtigung zugefgt: EMail statt Ticket als Aktion.
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.3.2', @NewsHeader = N'nderungen und Korrekturen in der Version 4.3.2', @NewsContent = N'
Das Update auf die Version 4.3.2 enthlt folgende nderungen:
<br />
(-) Ticket: 		Rckmeldung ber Ticketerstellung, wenn erstelltes Ticket fr Benutzer nicht sichtbar
(-) Ticketliste: 	Minisuche zuckte beim laden der Ticketliste 
(-) Ticket: 		Umlaute im Dokumentenreiter wurden nicht korrekt angezeigt
(-) Vorlagen:		Fehler nach Schnellschuss aus Vorlage korrigiert
(-) Ticket:			Support- & Gruppenauswahl: Filterstring wird nach Auswahl entfernt 
<br />';
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'idx_TicketData1')
CREATE NONCLUSTERED INDEX [idx_TicketData1]
ON [dbo].[hm_Ticket] ([Published],[archived],[TicketStatusID],[TicketReferenzID])
INCLUDE ([ID])
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'idx_TG_TicketID')
CREATE NONCLUSTERED INDEX [idx_TG_TicketID] ON [dbo].[hm_TicketGroup] 
(
	[TicketID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'idx_hm_TS_TicketID')
CREATE NONCLUSTERED INDEX [idx_hm_TS_TicketID] ON [dbo].[hm_TicketSupporter] 
(
	[TicketID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'idx_Ticket_Contacts')
CREATE UNIQUE NONCLUSTERED INDEX [idx_Ticket_Contacts] ON [dbo].[hm_Ticket] 
(
	[ContactID] DESC,
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'idx_WFActivty_TicketID')
CREATE UNIQUE NONCLUSTERED INDEX [idx_WFActivty_TicketID] ON [dbo].[hm_WF_Activity] 
(
	[TicketID] ASC,
	[ActivityID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'idx_WFActivity_WFI')
CREATE UNIQUE NONCLUSTERED INDEX [idx_WFActivity_WFI] ON [dbo].[hm_WF_Activity] 
(
	[WFIID] ASC,
	[ActivityID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_MailAccounts' AND COLUMN_NAME = 'maildomain')
ALTER TABLE [dbo].[hm_MailAccounts] ADD
    [maildomain] [varchar] (100) NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_MailAccounts' AND COLUMN_NAME = 'SecureConnection')
ALTER TABLE [dbo].[hm_MailAccounts] ADD
    [SecureConnection] [varchar] (10) NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_MailAccounts' AND COLUMN_NAME = 'ResponseToSender')
ALTER TABLE [dbo].[hm_MailAccounts] ADD
    [ResponseToSender] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_MailAccounts' AND COLUMN_NAME = 'CatForSender')
ALTER TABLE [dbo].[hm_MailAccounts] ADD
    [CatForSender] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_MailAccounts' AND COLUMN_NAME = 'checkAutoReplys')
ALTER TABLE [dbo].[hm_MailAccounts] ADD
    [checkAutoReplys] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_MailAccounts' AND COLUMN_NAME = 'UseIFrame')
ALTER TABLE [dbo].[hm_MailAccounts] ADD
    [UseIFrame] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_MailAccounts' AND COLUMN_NAME = 'TicketEditOnly')
ALTER TABLE [dbo].[hm_MailAccounts] ADD
    [TicketEditOnly] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_MailAccounts' AND COLUMN_NAME = 'subjectfilter')
ALTER TABLE [dbo].[hm_MailAccounts] ADD
    [subjectfilter] [tinyint] NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_MailAccounts' AND COLUMN_NAME = 'replyaddress')
ALTER TABLE [dbo].[hm_MailAccounts] ADD
    [replyaddress] [varchar] (100) NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_MailAccounts' AND COLUMN_NAME = 'replyname')
ALTER TABLE [dbo].[hm_MailAccounts] ADD
    [replyname] [varchar] (100) NULL
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.3.3', @NewsHeader = N'nderungen und Korrekturen in der Version 4.3.3', @NewsContent = N'
Das Update auf die Version 4.3.3 enthlt folgende nderungen:
<br />
(-) Reporting:          Erweitertes Reporting funktionierte nicht in der IonCube-Version
(-) Ticketvorlagen:     Feedback bei manueller Ticketerstellung aus Vorlagen korrigiert.
(-) Ticketvorlagen:     Auswahl der Vorlagen kann gefiltert werden
(-) Workflow:           Bei dynamischer Zuweisung aus Vorgngeraktivitt konnte der Adressat seine Aktivitten nicht bearbeiten.
(-) Ticketliste:        Filterauswahl wurde bei zu langer Liste nicht mehr korrekt angezeigt.
(-) Auth:               Die Passwort-Abgelaufen Funktion konnte bersprungen werden. Des weiteren muss jetzt ein anderes Passwort als das Bisherige gewhlt werden.
(-) Ticketliste:        Fr Gruppen freigegebene Filter werden nun in einem eigenen Abschnitt angezeigt.
(-) Ticketliste:        Als Favorit gekennzeichnet Filter die fr Gruppen freigegebene wurden, wurden bei allen Benutzern als Favorit angezeigt
(-) Ticketliste:        Filter nach Workflow-Definitionen
(-) Ticket:             In der Druckansicht wurden Formulare, die den gleichen Feldtitel trugen nur einmal angezeigt.
(-) Mitarbeiterimport:  Import aus CSV-Datei um diverse Felder erweitert
<br />';
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Ticket' AND COLUMN_NAME = 'LocationStructureID')
    ALTER TABLE [dbo].[hm_Ticket] ADD [LocationStructureID] [bigint] NULL;
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 825)
    INSERT INTO hm_Rights (RightID, RightName, RightsSectionID, RightsOrder, SegmentID, RightDescr)
    VALUES (825, 'Firmenstruktur im Ticket anzeigen', 2, 33, 24, 'Benutzer mit diesem Recht knnen einen Ort aus der Asset.Desk-Struktur im Ticket hinterlegen');
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 825 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 825)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'IX_hmTicket_1')
CREATE NONCLUSTERED INDEX [IX_hmTicket_1] ON [dbo].[hm_Ticket]
(
 [archived] ASC,
 [TicketStatusID] ASC,
 [TicketReferenzID] ASC
)
INCLUDE (  [ID],
 [ContactID],
 [TicketDescr],
 [CategoryID1],
 [CategoryID2],
 [EditDate],
 [InventoryNumber]) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'IX_Ticket_1')
CREATE NONCLUSTERED INDEX [IX_Ticket_1] ON [dbo].[hm_Ticket]
(
 [ContactID] ASC,
 [CategoryID2] ASC,
 [CategoryID1] ASC,
 [ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'IX_TicketAttachment_1')
CREATE NONCLUSTERED INDEX [IX_TicketAttachment_1] ON [dbo].[hm_TicketAttachment]
(
 [TicketID] ASC,
 [AttachmentID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'IX_TicketEvent_1')
CREATE NONCLUSTERED INDEX [IX_TicketEvent_1] ON [dbo].[hm_TicketEvent]
(
 [TicketID] ASC,
 [TicketStatusID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'IX_TicketGroup_1')
CREATE NONCLUSTERED INDEX [IX_TicketGroup_1] ON [dbo].[hm_TicketGroup]
(
 [TicketID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO
IF NOT EXISTS (SELECT * FROM [dbo].[sysindexes] WHERE name = 'IX_TicketSupporter_1')
CREATE NONCLUSTERED INDEX [IX_TicketSupporter_1] ON [dbo].[hm_TicketSupporter]
(
 [UserID] ASC,
 [TicketID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.3.4', @NewsHeader = N'nderungen und Korrekturen in der Version 4.3.4', @NewsContent = N'
Das Update auf die Version 4.3.4 enthlt folgende nderungen:
<br />
(-) Ticket:             Das AAA aus den Supporterbenachrichtigungen entfernt
(-) Ticket:             Mail-Bearbeitungen von Referenztickets werden im Masterticket eingetragen. Das Childticket bleibt geschlossen. (Bentigt HM-Service 5.0.6)
(+) Ticket:             Im Ticket kann ein Ort aus der Asset.Desk-Struktur gespeichert werden.
(-) Ticket:             Der Betreff von Benachrichtigungsmails mit angepassten Templates enthlt nicht mehr "Kontakt: " oder "Supporter: "
(+) Devices:            In der Gerteauswahl und -anzeige im Ticket wird der physikalischer Pfad zum Gert angezeigt
(-) Ticketliste:        Groe Umlaute wurden in der Ticketliste z.T. falsch angezeigt.
(+) Ticketliste:        Zuweisung zu Masterticket in der Sammelbearbeitung.
(+) Einstellungen:      Einstellungen zustzliche Mailaccounts erweitert (Dienst v5.0.6 erforderlich)
(-) Kontakt:            Firmen Verwalten funktionierte nur mit LDAP-Modul.
(+) Allgemein:          CHF und USD als Whrung zugefgt
(-) Knowledgebase:      Zu breite Artikel rutschten unter die rechte Spalte.
(+) Kalender:           Flligkeitsdatum von Tickets lassen sich per DragnDrop ndern
(-) TAPI:               Wird aus einem TAPI-Ereignis mit ermittelten Kontakt ein Ticket aus Vorlage aufgerufen, wird der Anrufer als Kontakt eingetragen.
(-) TAPI:               Anrufe ohne bermittelte Rufnummer fhrten zu einer Fehlermeldung im TAPI-Client (Neue Version des TAPI-Clients ntig)
(-) Workflow:           Bedingungen mit Ober-Verknpfung  aus gleichem Formular wurden bei Auswahl nur einer Option nicht gestartet.
<br />';
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_WFReportTabSet]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_WFReportTabSet](
	[WFDID] [int] NOT NULL,
	[user_id] [bigint] NOT NULL,
	[data] varchar(max) NULL,
 CONSTRAINT [PK_hm_WFReportTabSet] PRIMARY KEY CLUSTERED 
(
	[WFDID] ASC,
	[user_id] ASC
)) ON [PRIMARY]
GO
ALTER TABLE hm_WFInstanz ALTER COLUMN Descr VARCHAR(150)
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_TicketLocation]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE dbo.hm_TicketLocation
	(
	TicketID bigint NOT NULL,
	Active tinyint NOT NULL,
	Createuserid bigint NOT NULL,
	Createdate datetime NOT NULL,
	RoomID bigint NOT NULL,
	FloorID bigint NOT NULL,
	BuildingID bigint NOT NULL,
	LocationID bigint NOT NULL,
        LocationLogGroupID bigint NULL
	)  ON [PRIMARY]
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.3.4.1', @NewsHeader = N'nderungen und Korrekturen in der Version 4.3.4.1', @NewsContent = N'
Das Update auf die Version 4.3.4.1 enthlt folgende nderungen:
<br />
(+) Ticket:             Keine Bearbeitung mglich, wenn Kategorie Pflichtfeld ist und nicht gewhlt wurde
(+) Tickets:            Asset.Desk Standortdaten im Ticket verwenden
(-) Workflow:           Im Aktivitts-Formular bergabefelder von Auswahllisten anzeigen
(-) Ticket:             Kosten bei Ticketanlage wurden nicht eingetragen
(-) Workflow:           Projektverknpfung wurde nicht in Aktivitten bernommen
<br />';
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_WFDef_Activity' AND COLUMN_NAME = 'AdressSourceActivity')
    ALTER TABLE [dbo].[hm_WFDef_Activity] ADD [AdressSourceActivity] [varchar](max) NULL
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 506)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder, RightDescr, SegmentID) VALUES (506, 'Kostenbetrge erfassen', 3, 8, 'Benutzer mit diesem Recht knnen bei einer Ticketbearbeitung direkt Betrge in das zugeordnete Projet buchen.', 18)
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_TicketEvent' AND COLUMN_NAME = 'ProjectFixCosts')
    ALTER TABLE [dbo].[hm_TicketEvent] ADD [ProjectFixCosts] [float] DEFAULT 0
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Mandant' AND COLUMN_NAME = 'published')
ALTER TABLE dbo.hm_Mandant ADD
	published tinyint NOT NULL DEFAULT 1,
	CompanyCode bigint NULL,
	created datetime NULL,
	updated datetime NULL,
        SendFromAdress varchar(max) NULL
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_MandantGroups]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[hm_MandantGroups](
	MandantenID int NOT NULL,
	GroupID int NOT NULL
 CONSTRAINT [PK_hm_MandantGroups] PRIMARY KEY CLUSTERED 
(
	[MandantenID] ASC,
	[GroupID] ASC
)) ON [PRIMARY]
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 850)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder, RightDescr, SegmentID) VALUES (850, 'Mandanten verwalten', 3, 10, 'Benutzer mit diesem Recht knnen Mandanten anlegen, zuweisen und bearbeiten', 33)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 851)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder, RightDescr, SegmentID) VALUES (851, 'Mandantenzuordnung ndern', 3, 10, 'Erlaubt es Benutzern, die Mandantenzuordnung in Tickets zu ndern', 33)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 850 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 850)
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[hm_TicketMandant]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE dbo.hm_TicketMandant
	(
	MandantenID bigint NOT NULL,
	TicketID bigint NOT NULL,
	Createdate datetime DEFAULT GETDATE() NOT NULL,
Active int DEFAULT 1 NOT NULL
	)  ON [PRIMARY]
GO
  Set Identity_Insert hm_Mandant On
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Mandant] WHERE ID = 0)
  Insert INTO hm_Mandant (ID, Mandant, CompanyCode) Values (0, ' Ohne Mandant ', 0)
GO
  Set Identity_Insert hm_Mandant Off
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.3.5', @NewsHeader = N'nderungen und Korrekturen in der Version 4.3.5', @NewsContent = N'
Das Update auf die Version 4.3.5 enthlt folgende nderungen:
<br />
(+) Neues Modul:        Mandantenzuordnung fr Kontakte
(+) Projekt:            Fixe Betrge durch Ticketevents im Projekt verbuchen
(+) Ticket:             Benachrichtigungen knnen mit Dokumenten und Bildern gesendet werden.
(+) Formular:           Benachtichtigung ber nderungen in Ticket-Formularen.
(+) Workflow:           Neues Formularelement: Adressierung nachfolgender Aktivitten durch Benutzerauswahl
(+) Vorlagen:           Erstellen einer Ticketvorlage aus bestehnden Tickets
(+) Ticketliste:        Statusfilterung nun mit "Nur Aktive (ohne OnHold)" und "Nur Aktive (mit OnHold)"
(-) Knowledgebase:      Angehangene Dokumente wurden z.T. nicht korrekt angezeigt.
(-) Workflow:           Reload der Aktivitt nach Speichern einer Bearbeitung.
(-) Workflow:           Aktivitts-Ticket: Anzeige von Kosten in Bearbeitungsliste
(-) Workflow:           Korrekturen an der Darstellung der Formulardaten aus vorherigen Aktivitten (bergabefelder, Trennzeichen)
<br />';
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_Rights] WHERE RightID = 852)
    INSERT INTO [dbo].[hm_Rights] (RightID, RightName, RightsSectionID, RightsOrder, RightDescr, SegmentID) VALUES (852, 'Mandant anzeigen', 3, 5, 'Zeigt den zugewiesenen Mandanten oder die Mandantenauswahl in Tickets an', 33)
GO
IF NOT EXISTS (SELECT * FROM [dbo].[hm_GroupRights] WHERE right_id = 852 AND group_id = 1)
INSERT INTO [dbo].[hm_GroupRights] (group_id, right_id) VALUES (1, 852)
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.3.5.1', @NewsHeader = N'nderungen und Korrekturen in der Version 4.3.5.1', @NewsContent = N'
Das Update auf die Version 4.3.5.1 enthlt folgende nderungen:
<br />
(-) Kontakte:           Kontakte liesen sich ohne Mandant nicht anlegen
(-) Ticketliste:        Fr die Spalte Mandanten wurde nur der Header, nicht die eigentliche Spalte angezeigt.
(-) Ticket:             Bei Ticketerstellung mit zugewiesenem Kontakt wurde der Mandant des Kontaktes nicht im Ticket eingetragen
(-) Ticket:             Mandantenfeld wird im Ticket nur noch mit Gruppenrecht "Mandant anzeigen" angezeigt - dieses ggf. den entsprechenden Gruppen zufgen.
(-) Workflow:           bergabefelder wurden z.T. nicht angezeigt.
(-) Workflow:           Dokumentenansicht aus Vorgnger-Aktivitten funktionierte z.T. nicht.
(-) Formular:           nderungen in Ticket-Formularen wurde bei Erstbefllung und nderungen der Radio-Auswahl nicht protokolliert und Benachrichtigungen nicht gesendet.
(-) Ticket:             Zeichenfehler und bersetzungen in Symbolleiste vom WYSIWYG-Editor
<br />';
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'Prename')
    ALTER TABLE [dbo].[hm_Contacts] ADD [Prename] [varchar] (255) NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'Surname')
    ALTER TABLE [dbo].[hm_Contacts] ADD [Surname] [varchar] (255) NULL
GO
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME ='hm_Contacts' AND COLUMN_NAME = 'Salutation')
    ALTER TABLE [dbo].[hm_Contacts] ADD [Salutation] [varchar] (50) NULL
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.3.5.3', @NewsHeader = N'nderungen und Korrekturen in der Version 4.3.5.3', @NewsContent = N'
Das Update auf die Version 4.3.5.3 enthlt folgende nderungen:
<br />
(-) Reporting           Im Report Tickets je Kategorie (kumulativ) griff der Datumsfilter nicht.
(-) User:               Einstellung "Standard bei Benutzeranlage: Benutzer erhlt Mails" steuert Mailempfang bei Benutzeranlage-Formular
(+) Kontakte:           Anrede, Vornamen und Nachnamen knnen gepflegt, aus LDAP importiert und via Platzhalter in Mailtemplates verwendet werden.
(-) Formulare:          Z.T. wurden Daten gespeicherter Formulare in neuen Tickets wieder angezeigt. 
<br />';
GO
EXECUTE hm_sp_AdminNews @NewsTitle = N'Heinzelmann-Version 4.3.5.4', @NewsHeader = N'nderungen und Korrekturen in der Version 4.3.5.4', @NewsContent = N'
Das Update auf die Version 4.3.5.4 enthlt folgende nderungen:
<br />
(+) Workflow:           Gefilterte Benutzerliste zur Adressatenauswahl.
(-) Workflow:           Aktivitten wurden nicht-Supporter nicht angezeigt, wenn deren Gruppe eingetragen war.
(-) Settings:           M2T-Zuweisungsfilter (Gruppe / Kategorie je Betreff / Absender) wurde nicht richtig angezeigt.
(-) Ticket:             Benachrichtigungsmail wurde bei Ticketerstellung an eigenen Kontakt gesendet.
(+) Ticket:             Wenn der Zurckstellungstermin erreicht wurde, bekommt das Ticket nun den Status Aktive und ein Protokoll-Event.
(-) Ticket:             ticketdetail-Druckansicht korrigiert.
(-) Vorlagen:           LDAP-Gerteauswahl wurde in Vorlagen nicht angezeigt.
<br />';


