<?php

//error_reporting(E_ALL);
//ini_set('display_errors', 1);

/**
 * reporting.php
 * Heinzelmann-Reports.
 *
 * @author Dirk Herbes <d.herbes@fair-computer.de>
 *
 */
class reporting extends FR_Auth_User {

    public $DBVersion = 2;
    public $EntriesPerPage = 20;
    public $startdate;
    public $enddate;
    public $StundenSatz = 0;
    public $MinutenSatz = 0;
    public $showArchivedWhere = '';
    public $Debug = false;

    // {{{ __default
    public function __construct() {
        parent::__construct();


        $this->set('javascript', array(
            'includes/js/jquery-ui-timepicker-addon.js'
        ));

        if ($this->user->hasRight(30)) {
            $event = (isset($_REQUEST['event']) && '' != trim($_REQUEST['event'])) ? $_REQUEST['event'] : '';
            //Reports je Kontakt, Benutzer & Supporter fr BHS nicht anzeigen.
            if (defined('HMCOMPANY') && (HMCOMPANY == 'MESSE DSSELDORF' || HMCOMPANY == 'BHS BAD HOMBURGER SERVICEGESELLSCHAFT') &&
                    in_array($event, array('tcon', 'tuser', 'tsupporter'))) {
                header('Location: index.php');
            }
            $this->StundenSatz = (defined('STUNDENSATZ')) ? STUNDENSATZ : 0;
            $this->MinutenSatz = $this->StundenSatz / 60;

            //JK: Auswahl fr Spaltenanzeige
            $_SESSION['Reporting']['showdays'] = true;
            $_SESSION['Reporting']['showhours'] = isset($_REQUEST['showhours']) ? true : false;
            $_SESSION['Reporting']['showminutes'] = isset($_REQUEST['showminutes']) ? true : false;
            $this->set('showdays', $_SESSION['Reporting']['showdays']);
            $this->set('showhours', $_SESSION['Reporting']['showhours']);
            $this->set('showminutes', $_SESSION['Reporting']['showminutes']);

            if (!isset($_REQUEST['startdate']) &&
                    !isset($_SESSION['Reporting']['startdate'])) {
                $_SESSION['Reporting']['startdate'] = date('01.m.Y');
            } else if (isset($_REQUEST['startdate'])) {
                $_SESSION['Reporting']['startdate'] = $_REQUEST['startdate'];
            }

            if (!isset($_REQUEST['enddate']) &&
                    !isset($_SESSION['Reporting']['enddate'])) {
                $_SESSION['Reporting']['enddate'] = date('t.m.Y');
            } else if (isset($_REQUEST['enddate'])) {
                $_SESSION['Reporting']['enddate'] = $_REQUEST['enddate'];
            }

            if (isset($_REQUEST['filter'])) {
                $_SESSION['Reporting']['filter'] = trim($_REQUEST['filter']);
            } else if ($this->user->remFilters != 1) {
                //Suchfilter lschen
                $_SESSION['Reporting']['filter'] = '';
            }

            if (defined('HMCOMPANY')) {
                $this->set('hmcompany', HMCOMPANY);
            }

            //jk, 28.11.2013: Archivierte anzeigen?
            if (isset($_REQUEST['showArchived'])) {
                if ((isset($_REQUEST['showArchived']) && 1 == $_REQUEST['showArchived'])) {
                    //Mit Archiv
                    $this->showArchivedWhere = '';
                    $_SESSION['Reporting']['showArchivedWhere'] = ' 1 = 1 ';
                    $this->set('showArchived', 1);
                } else if ((isset($_REQUEST['showArchived']) && 2 == $_REQUEST['showArchived'])) {
                    //Nur Archiv
                    $this->showArchivedWhere = ' AND hm_Ticket.Archived = 1 ';
                    $_SESSION['Reporting']['showArchivedWhere'] = ' hm_Ticket.Archived = 1 ';
                    $this->set('showArchived', 2);
                } else {
                    $this->showArchivedWhere = ' AND hm_Ticket.Archived IS NULL ';
                    unset($_SESSION['Reporting']['showArchivedWhere']);
                    $this->set('showArchived', false);
                }
            }

            //jk, 28.11.2013: Archivierte anzeigen?
            if (isset($_REQUEST['IncidentProblem'])) {
                if ((isset($_REQUEST['IncidentProblem']) && 1 == $_REQUEST['IncidentProblem'])) {
                    //Nur Vorflle
                    $this->showArchivedWhere .= ' AND (hm_Ticket.isProblem = 0 OR hm_Ticket.isProblem IS NULL) ';
                    $_SESSION['Reporting']['showArchivedWhere'] .= ' AND (hm_Ticket.isProblem = 0 OR hm_Ticket.isProblem IS NULL) ';
                    $this->set('IncidentProblem', 1);
                } else if ((isset($_REQUEST['IncidentProblem']) && 2 == $_REQUEST['IncidentProblem'])) {
                    //Nur Probleme
                    $this->showArchivedWhere .= ' AND hm_Ticket.isProblem = 1 ';
                    $_SESSION['Reporting']['showArchivedWhere'] .= ' AND hm_Ticket.isProblem = 1 ';
                    $this->set('IncidentProblem', 2);
                } else {
                    $this->showArchivedWhere .= ' ';
                    //unset($_SESSION['Reporting']['showArchivedWhere']);
                    $this->set('IncidentProblem', false);
                }
            }


            if (!isset($_REQUEST['showArchived']) && !isset($_SESSION['Reporting']['showArchivedWhere'])) {
                $_SESSION['Reporting']['showArchivedWhere'] = ' hm_Ticket.Archived IS NULL ';
            }

            $this->set('rel_path', _HM_RELPATH);
            $this->set('ReportingAction', @$_REQUEST['action']);
            $this->set('printstyles', array('styles/' . CSSTEMPLATE .
                '/css/print.css'));
            $this->set('today', date('d.m.Y'));
            $this->set('yesterday', date('d.m.Y', strtotime("-1 day")));
            $this->set('lastweek', date('d.m.Y', strtotime("-1 week")));
            $this->set('lastmonth_start', date('01.m.Y', strtotime("-1 month")));
            $this->set('lastmonth_end', date('t.m.Y', strtotime("-1 month")));
            $this->set('startdate', $_SESSION['Reporting']['startdate']);
            $this->set('enddate', $_SESSION['Reporting']['enddate']);
            $this->set('sid', @$_REQUEST['sid']);
            $this->set('report_type', $event);

            $this->startdate = $this->tools->ToUnixTimestamp(
                    $_SESSION['Reporting']['startdate'] . ' 00:00:00');
            $this->enddate = $this->tools->ToUnixTimestamp(
                    $_SESSION['Reporting']['enddate'] . ' 00:00:00');

            if ($this->enddate < $this->startdate) {
                $this->startdate = $this->tools->ToUnixTimestamp(
                        $_SESSION['Reporting']['enddate'] . ' 00:00:00');
                $this->enddate = $this->tools->ToUnixTimestamp(
                        $_SESSION['Reporting']['startdate'] . ' 23:59:59');
            } else {
                $this->enddate = $this->tools->ToUnixTimestamp(
                        $_SESSION['Reporting']['enddate'] . ' 23:59:59');
            }

            $this->startdate = $this->DB_DATE($this->startdate);
            $this->enddate = $this->DB_DATE($this->enddate);

            if ($event == 'advance') {
                if (!$this->user->hasRight(60) || !$this->user->Security->Reporting) {
                    $event = '';
                }
            }
        }

        if (defined('ASSETDESK') && ASSETDESK == 1) {
            $this->DBVersion = $this->db->getOne('SELECT DBVersion FROM DBVersion');
            $this->DBVersion = (DB::isError($this->DBVersion)) ? 2 : substr($this->DBVersion, 0, 1);
        }

        $this->EntriesPerPage = (isset($_REQUEST['EntriesPerPage']) && in_array($_REQUEST['EntriesPerPage'], array(5, 10, 20, 50, 100)) ) ? $_REQUEST['EntriesPerPage'] : $this->EntriesPerPage;
        $this->set('EntriesPerPage', $this->EntriesPerPage);
        $this->set('timing_add', $this->getTimePeriods());
    }

    // }}}
    // {{{ __default
    /**
     * Liefert die Reports 'je Benutzer'.
     * Bis Version 3.2: task: 'default', 'tuser'
     */
    public function __default() {
        $this->set('report_type', 'tuser');
        $this->tuser();
    }

    /**
     * Zeigt den Report 'je Kategorie' an.
     */
    public function tcat() {
        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'cid');

        $where = '';
        $where2 = '';

        $category_id = (int) @$_REQUEST['category_id'];
        $this->set('category_id', $category_id);
        if ((int) $category_id > 0) {
            $where .= sprintf(' AND p.root_id = %u ', $category_id);
            $where2 .= sprintf(' AND p.root_id = %u ', $category_id);
        }

        $where .= $this->showArchivedWhere;
        $where .= ' AND (' . $this->user->getRightFilter() . ')';

        // Zeitlichebegrenzung
        $where .= sprintf(' AND (hm_Ticket.EditDate >= %s AND
                hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);

        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $where .= sprintf(' AND (UPPER(p.name) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
            $where2 .= sprintf(' AND (UPPER(p.name) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        }

        $sql = sprintf('
                SELECT
                    p.id,
                    p.name,
                    p.lft,
                    p.rgt,
                    (p.levelno+1) levelno,
                    (n.cost_rate / 60) CostRate,
                    SUM(DISTINCT hm_Ticket.expExpense) ExpExpense, COUNT(DISTINCT hm_Ticket.ID) Anzahl,
                    SUM(%s) ProcessTime,
                    SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                    n.name MainName,
                    SUM(TE.Kosten) Kosten,
                    SUM (TE.Aufwand) Aufwand
                FROM
                    hm_Categories n
                    INNER JOIN hm_Categories p ON (p.root_id = n.id)
                    LEFT JOIN hm_Ticket ON
                        (hm_Ticket.CategoryID1 = p.id OR hm_Ticket.CategoryID2 = p.id)
                    LEFT JOIN (
                            SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                            FROM hm_TicketEvent
							WHERE Deleted IS NULL OR Deleted = 0
                            Group BY TicketID
                          ) TE ON TE.TicketID = hm_Ticket.ID
		    LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                    LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
                WHERE
                    (n.published = 1 OR n.published = 2) AND
                    n.root_id <> 0 AND
                    n.root_id = n.id AND
                    (p.published = 1 OR p.published = 2) AND
                    p.root_id <> 0
                    %s
                    %s
                GROUP BY
                    n.cost_rate,
                    p.lft,
                    p.rgt,
                    p.id,
                    n.name,
                    p.name,
                    p.levelno', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString(), $where, $where2);

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = '
                SELECT
                    Anzahl,
                    Aufwand,
                    name,
                    id,
                    levelno,
                    (rgt-lft)/2 childs,
                    ProcessTime,
                    AvgProcessTime,
                    Kosten,
                    MainName,
                    ExpExpense
                FROM
                    (' . $sql . ') TInfo';

        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        $sql .= ' ORDER BY ';
        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {
            case 'COSTS': $sql .= 'Kosten';
                break;
            case 'EXPENSE': $sql .= 'Aufwand';
                break;
            case 'COUNT': $sql .= 'Anzahl';
                break;
            case 'PROCESSTIME': $sql .= 'ProcessTime';
                break;
            case 'AVGPROCESSTIME': $sql .= 'AvgProcessTime';
                break;
            case 'EXPEXPENSE': $sql .= 'ExpExpense';
                break;
            case 'KOSTEN': $sql .= 'Kosten';
                break;
            default:
                $sql .= ' TInfo.MainName ASC, TInfo.lft ';
                $sortOrder = 'ASC';
                $_REQUEST['sorting'] = 'Name';
                break;
        }
        $sql .= ' ' . $sortOrder;

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        $res = (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) ? $this->db->query($sql) : $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                if (@$_REQUEST['action'] != 'xls' &&
                        !in_array(strtoupper(@$_REQUEST['sorting']), array(
                            'KOSTEN', 'EXPENSE', 'COUNT', 'PROCESSTIME',
                            'AVGPROCESSTIME', 'EXPEXPENSE'))) {

                    $row['fullname'] = $this->getCatPath($row['id']) . $row['name'];

                    for ($i = 0; $i < $row['levelno'] - 1; $i++) {
                        $row['name'] = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' .
                                $row['name'];
                    }
                }
                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }
                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }
                $tickets[] = $row;
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandKategorie', 'Kategorie');
        }

        $this->set('ReportingSubpage', 'tcat');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Kategorie'));
        $this->set('GridHeader', $this->user->gettext('Kategorie'));
        $this->set('categories', $this->getMainCategories());

        if (@$_REQUEST['action'] == 'print') {
            $tickets = $tickets;
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }
        $this->set('tickets', $tickets);
    }

    /**
     * Liefert die verwendeten Hauptkategorien.
     * @author Dirk Herbes <d.herbes@fair-computer.de>
     * @return array
     */
    private function getMainCategories() {
        $categories = array();

        $sql = 'SELECT p.id, p.name
                FROM hm_Categories n
                    INNER JOIN hm_Categories p ON  (p.root_id = n.id)
                    LEFT JOIN hm_Ticket ON (hm_Ticket.CategoryID1 = p.id OR hm_Ticket.CategoryID2 = p.id)
                WHERE (n.published = 1 OR n.published = 2)
                    AND n.root_id <> 0 AND n.root_id = n.id AND (p.published = 1 OR p.published = 2)
                    AND p.root_id <> 0 AND p.id = p.root_id AND (' . $this->user->getRightFilter() . ')
                GROUP BY p.id, p.name
                ORDER BY p.name';

        $res = $this->db->query($sql);

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $categories[$row['id']] = $row['name'];
            }
        }
        return $categories;
    }

    /**
     * Zeigt den Report 'je Kategorie (kumulativ)' an.
     *
     */
    public function tcatkumu() {
        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'cidkumu');

        $where = '';
        $where2 = '';

        $category_id = (int) @$_REQUEST['category_id'];
        $this->set('category_id', $category_id);
        if ((int) $category_id > 0) {
            //$where  .= sprintf(' AND p.root_id = %u ', $category_id);
            $where2 .= sprintf(' AND n.id = %u ', $category_id);
        }

        $where .= ' (' . $this->user->getRightFilter() . ')';
        $where .= $this->showArchivedWhere;

        // Zeitlichebegrenzung
        $where .= sprintf(' AND (hm_Ticket.EditDate >= %s AND
                hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);

        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $where .= sprintf(' AND (UPPER(p.name) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
            $where2 .= sprintf(' AND (UPPER(p.name) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        }


        // Wird "Daten neu laden" geklickt ODER die Where-Bedingung gendert => den Cache leeren
        if ((isset($_REQUEST['renewCache']) && 1 == $_REQUEST['renewCache'] ) ||
                $where != $_SESSION['Reporting']['CatKumuWhere'] || $where2 != $_SESSION['Reporting']['CatKumuWhere2']) {
            unset($_SESSION['KatData']);
            unset($_SESSION['CatKumuStarttime']);
            unset($_SESSION['CatKumuStarttimestamp']);
            unset($_SESSION['verbleibende']);
            unset($_SESSION['verarbeitete']);
            unset($_SESSION['Reporting']['CatKumuWhere']);
            unset($_SESSION['Reporting']['CatKumuWhere2']);
        } else {
            $this->set('renewCache', 0);
        }


        //Where-Bedinung Cachen zur verwendung in getCategorieData()
        if (!isset($_SESSION['Reporting']['CatKumuWhere'])) {
            $_SESSION['Reporting']['CatKumuWhere'] = $where;
        }
        //Where-Bedinung Cachen zur verwendung in getCategorieData()
        if (!isset($_SESSION['Reporting']['CatKumuWhere2'])) {
            $_SESSION['Reporting']['CatKumuWhere2'] = $where2;
        }

        if (!isset($_SESSION['verbleibende'])) {
            $sql = sprintf('SELECT
                                    p.id,
                                    p.name,
                                    p.levelno
                            FROM
                                    hm_Categories n
                                    INNER JOIN hm_Categories p ON (p.root_id = n.id)
                            WHERE
                                    (n.published = 1 OR n.published = 2) AND
                                    n.root_id <> 0 AND
                                    n.root_id = n.id AND
                                    (p.published = 1 OR p.published = 2) AND
                                    p.root_id <> 0
                                    %s
                            ORDER BY p.root_id, p.levelno ASC ', $where2);

            if ($this->Debug) {
                echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n--Abfrage 1 - Alle Kategorien: <pre>$sql</pre>";
            }

            $res = $this->db->query($sql);
            if (!DB::isError($res)) {
                while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                    //$row['ticketids'] = $this->getTicketIDsForCat($row['id']);
                    $_SESSION['verbleibende'][$row['id']] = $row;
                    //$Categories[$row['id']] = $row;
                }
            } else {
                $this->log->log('Fehler beim Reporting [Kategorien (kumulativ)]. Message: ' . $res->getMessage(), PEAR_LOG_ERR);
            }
        }


        //Fr jede Kat die Daten sammeln:
        $CatRows = array();

        //timer:
        $StartTime = time();
        if (!isset($_SESSION['CatKumuStarttimestamp'])) {
            $_SESSION['CatKumuStarttimestamp'] = $StartTime;
        }


        if (date("d.m", $_SESSION['CatKumuStarttimestamp']) == date("d.m")) {
            $_SESSION['CatKumuStarttime'] = $this->user->gettext('Heute, um ') . date("H:i", $_SESSION['CatKumuStarttimestamp']);
        } else {
            $_SESSION['CatKumuStarttime'] = $this->user->gettext('am ') . date("d.m H:i", $_SESSION['CatKumuStarttimestamp']);
        }

        $this->set('javascript', array(
            'includes/js/jquery.progressbar.min.js'));

        foreach ($_SESSION['verbleibende'] as $CatID => $Categorie) {
            if ((time() - $StartTime ) < 10) {
                $_SESSION['verarbeitete'][$CatID] = array_merge($Categorie, $this->getCategoryData($CatID));
                $_SESSION['verarbeitete'][$CatID]['notKumu'] = $this->getCategoryData($CatID, false);
                unset($_SESSION['verbleibende'][$CatID]);
            } else {
                break;
            }
        }
        if (!count($_SESSION['verbleibende'])) {
//echo "FERTIG!";

            $this->set('cacheTime', $_SESSION['CatKumuStarttime']);
            $this->set('reload', FALSE);
            $Categories = $_SESSION['verarbeitete'];
        } else {
            $this->set('reload', true);
            $this->set('Counter', count($_SESSION['verarbeitete']));
            $this->set('CountKats', count($_SESSION['verarbeitete']) + count($_SESSION['verbleibende']));
        }

        //Sortierung:
        $sortOrder = (isset($_REQUEST['sortOrder']) && $_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';
        $sort = (isset($_REQUEST['sorting'])) ? $_REQUEST['sorting'] : false;
        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', $sort);

        switch ($sort) {
            case 'Name':
                $sort = 'name';
                break;
            case 'Count':
                $sort = 'anzahl';
                break;
            case 'Costs':
                $sort = 'kosten';
                break;
            case 'ProcessTime':
                $sort = 'processtime';
                break;
            case 'AvgProcessTime':
                $sort = 'avgprocesstime';
                break;
            case 'Expense':
                $sort = 'expense';
                break;
            default:
                $sort = false;
        }
        $sort_prodopt = array();

        //Ordnung nicht durcheinanderbringen, wenn keine Sortierung gewhlt
        if ($sort) {

            $SortMode = ('name' == $sort) ? SORT_STRING : SORT_NUMERIC;
            foreach ($Categories as $key => $array) {

                $temp = strtolower($array[$sort]);
                if ('name' == $sort) {
                    $temp .= ($sortOrder != 'DESC') ? '-->aa' : '-->xx';
                } else if ('kosten' == $sort) {
                    $temp = $this->tools->toFloat($temp);
                }
                $sort_prodopt[$key] = $temp;
            }
            if ($sortOrder != 'DESC') {
                $test = array_multisort($sort_prodopt, SORT_ASC, $SortMode, $Categories);
            } else {
                $test = array_multisort($sort_prodopt, SORT_DESC, $SortMode, $Categories);
            }
        }


        //<--Sortierung ENDE
        //
        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = count($Categories);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        if ((isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print'))) {
            //kein Paging:
        } else {
            $Categories = array_slice($Categories, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }
        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        //Paging ende

        $tickets = $Categories;

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense_tcatkumu($tickets, 'AufwandKategorie', 'Kategorie');
        }

        $this->set('ReportingSubpage', 'tcatkumu');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Kategorie (kumulativ)'));
        $this->set('GridHeader', $this->user->gettext('Kategorie'));
        $this->set('categories', $this->getMainCategories());

        if (@$_REQUEST['action'] == 'print') {
            $tickets = $tickets;
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }
//if($this->Debug) echo "<pre>".print_r($tickets, true)."</pre>";

        $this->set('tickets', $tickets);
    }

    /**
     * Ermittelt die Ticketdaten einer Kategorie.
     * @param int $CatID
     * @return array
     */
    private function getCategoryData($CatID, $kumulativ = true) {


        if ($kumulativ) {
            $CatConnection = ' p.root_id = n.root_id ';
        } else {
            $CatConnection = ' p.id = n.id ';
        }

        $where = (isset($_SESSION['Reporting']['CatKumuWhere']) && '' != trim($_SESSION['Reporting']['CatKumuWhere'])) ? $_SESSION['Reporting']['CatKumuWhere'] : $this->user->getRightFilter();

        $sql = sprintf('SELECT
                                Anzahl,
                                Aufwand,
                                ProcessTime,
                                AvgProcessTime,
                                Kosten, ExpExpense
                        FROM
                                (
                        SELECT DISTINCT

                                SUM(DISTINCT hm_Ticket.expExpense) ExpExpense, COUNT(DISTINCT hm_Ticket.ID) Anzahl,
                                SUM(%s) ProcessTime,
                                SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                                SUM(TE.Kosten) Kosten,
                                SUM (TE.Aufwand) Aufwand
                        FROM
                                hm_Ticket
                                LEFT JOIN (
                                                SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                                                FROM hm_TicketEvent
                                                WHERE Deleted IS NULL OR Deleted = 0
                                                Group BY TicketID
                                          ) TE ON TE.TicketID = hm_Ticket.ID
                                LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                                LEFT JOIN hm_TicketGroup ON hm_Ticket.ID = hm_TicketGroup.TicketID
                        WHERE
                                hm_Ticket.ID IN(
            SELECT DISTINCT hm_Ticket.ID
            FROM hm_Categories n
            	INNER JOIN hm_Categories p ON (n.lft BETWEEN p.lft AND p.rgt) AND %s
            	INNER JOIN hm_Ticket ON ((hm_Ticket.CategoryID1 = n.id OR hm_Ticket.CategoryID2 = n.id))
                LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                    LEFT JOIN hm_TicketSupporter ON hm_Ticket.ID = hm_TicketSupporter.TicketID
                    LEFT JOIN hm_TicketGroup ON hm_Ticket.ID = hm_TicketGroup.TicketID
                    LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
            WHERE p.id = %u AND (%s)
)
    ) TInfo', $this->getProcessTimeSQLString()
                , $this->getProcessTimeSQLString(), $CatConnection, $CatID, $where
        );

//echo "<pre>$sql</pre>";

        if ($this->Debug) {
            echo "<hr /> --" . $Categorie['name'] . ":<pre>$sql</pre>";
        }

        $row = $this->db->getRow($sql);

        if (DB::isError($row)) {
            $this->log->log('Error while fetch Tickets for CatID[' . $CatID . ']. Message: ' . $row->getMessage(), PEAR_LOG_ERR);
            if ($this->Debug) {
                $this->log->log("SQL: $sql", PEAR_LOG_DEBUG);
            }
        } else {
            //Wenn keine Tickets gefunden wurden, alle ermittelten Werte auf 0 setzten
            if (1 == count($row)) {
                $row['anzahl'] = 0;
                $row['aufwand'] = 0;
                $row['processtime'] = 0;
                $row['avgprocesstime'] = 0;
                $row['kosten'] = 0;
            }

            $row['anzahl'] = (0 < (int) $row['anzahl']) ? $row['anzahl'] : 0;

            $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

            $row['expense'] = $row['aufwand'];

            $Tage = floor($row['aufwand'] / (60 * 24));
            $row['aufwand'] -= $Tage * 60 * 24;
            $Stunden = floor($row['aufwand'] / 60);
            $row['aufwand'] -= $Stunden * 60;
            $Minuten = $row['aufwand'];

            if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                $row['processtime'] = floor((int) $row['processtime'] / 60) .
                        ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                        ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
            }

            $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
            $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

            $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                    str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

            if ($Stunden > 0 || $Tage > 0) {
                $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
            }
            if ($Tage > 0) {
                $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
            }

            $row['fullname'] = $this->getCatPath($CatID) . $_SESSION['verbleibende'][$CatID]['name'];

            for ($i = 0; $i < $_SESSION['verbleibende'][$CatID]['levelno'] - 1; $i++) {
                $row['name'] = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $_SESSION['verbleibende'][$CatID]['name'];
            }
        }
        return $row;
    }

    /**
     * Generiert den ExcelExport fr 'Tickets je Kategorie (kumulativ).
     * @param array $data
     * @param string $title
     * @param string $subject
     */
    private function ExcelExportExpense_tcatkumu($data, $title = 'AufwandBenutzer', $subject = 'Benutzer') {

        //$this->log->log('ExcelExportExpense Request: '.print_r($_REQUEST, true), PEAR_LOG_DEBUG);
        //$this->log->log('ExcelExportExpense Data'.print_r($data, true), PEAR_LOG_DEBUG);

        include_once 'Spreadsheet/Excel/Writer.php';

        $workbook = new Spreadsheet_Excel_Writer();
        $workbook->send('ReportTicket.xls');
        $worksheet = & $workbook->addWorksheet($title);

        $length = array();

        $format_bold = & $workbook->addFormat();
        $format_bold->setBold();

        $format_right = & $workbook->addFormat();
        $format_right->setAlign('right');

        $worksheet->writeString(0, 0, $this->user->gettext('Zeitraum vom:'), $format_bold);
        $worksheet->writeString(0, 1, $_SESSION['Reporting']['startdate']);
        $worksheet->writeString(1, 0, $this->user->gettext('bis zum:'), $format_bold);
        $worksheet->writeString(1, 1, $_SESSION['Reporting']['enddate']);

        $y = 4;
        $Benutzer = $this->user->gettext($subject);
        $Firma = $this->user->gettext('Firma');
        $Anzahl = $this->user->gettext('Anzahl Tickets');
        $Aufwand = (true) ? $this->user->gettext('Zeitaufwand') : '';
        $AufwandMin = (true) ? $this->user->gettext('Zeitaufwand [m]') : '';
        $AufwandStd = (true) ? $this->user->gettext('Zeitaufwand [h]') : '';
        $Kosten = $this->user->gettext('Kosten');
        $Liegezeit = $this->user->gettext('Liegezeit [h]');
        $Liegezeitavg = $this->user->gettext('Durchschnittliche Liegezeit');

        $j = 0;
        $length[$j++] = strlen($Benutzer);

        $i = 0;

        $length[$j++ + $i] = strlen($Anzahl);

        if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
            if ($this->user->hasRight(48)) {
                $length[$j++ + $i] = strlen($Aufwand);
                $length[$j++ + $i] = strlen($AufwandMin);
                $length[$j++ + $i] = strlen($AufwandStd);
                $length[$j++ + $i] = strlen($Kosten);
            }
            $length[$j++ + $i] = strlen($Liegezeit);
            $length[$j++ + $i] = strlen($Liegezeitavg);
        } else {
            if ($this->user->hasRight(48)) {
                $length[$j++ + $i] = strlen($AufwandMin);
                $length[$j++ + $i] = strlen($Kosten);
            }
        }
        $k = 0;
        $worksheet->writeString($y - 1, $k++, $Benutzer, $format_bold);
        $worksheet->writeString($y - 1, $k++ + $i, $Anzahl, $format_bold);
        if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
            if ($this->user->hasRight(48)) {
                if (true)
                    $worksheet->writeString($y - 1, $k++ + $i, $Aufwand, $format_bold);
                if (true)
                    $worksheet->writeString($y - 1, $k++ + $i, $AufwandMin, $format_bold);
                if (true)
                    $worksheet->writeString($y - 1, $k++ + $i, $AufwandStd, $format_bold);
                $worksheet->writeString($y - 1, $k++ + $i, $Kosten, $format_bold);
            }
            $worksheet->writeString($y - 1, $k++ + $i, $Liegezeit, $format_bold);
            $worksheet->writeString($y - 1, $k++ + $i, $Liegezeitavg, $format_bold);
        } else {
            if ($this->user->hasRight(48)) {
                $worksheet->writeString($y - 1, 2 + $i, $AufwandMin, $format_bold);
                $worksheet->writeString($y - 1, 3 + $i, $Kosten, $format_bold);
            }
        }

        foreach ($data as $val) {
            ////
            if (1 == $val['levelno']) {
                $l = 0;
                $val['name'] = str_replace('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;', '-->', $val['name']);
                $val['name'] = str_replace('&nbsp;', '-->', $val['name']);
                if (strlen($val['name'] . " (gesamt)") > $length[$l]) {
                    $length[$l] = strlen($val['name'] . " (gesamt)");
                }
                $l++;
                if (strlen($val['anzahl']) > $length[$l + $i]) {
                    $length[$l + $i] = strlen($val['anzahl']);
                }
                $l++;
                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    if ($this->user->hasRight(48)) {
                        if (true) {
                            if (strlen($val['aufwand']) > $length[$l + $i]) {
                                $length[$l + $i] = strlen($val['aufwand']);
                            }
                            $l++;
                        }
                        if (true) {
                            if (strlen($val['expense']) > $length[$l + $i]) {
                                $length[$l + $i] = strlen($val['expense']);
                            }
                            $l++;
                        }
                        if (true) {
                            if (strlen($val['zeitaufwandstunden']) > $length[$l + $i]) {
                                $length[$l + $i] = strlen($val['zeitaufwandstunden']);
                            }
                            $l++;
                        }
                        if (strlen($val['kosten']) > $length[$l + $i]) {
                            $length[$l + $i] = strlen(number_format($val['kosten'], 2, ',', '.') . " " . $this->user->getCurrencyDescr());
                        }
                        $l++;
                    }
                    if (strlen($val['processtime']) > $length[$l + $i]) {
                        $length[$l + $i] = strlen($val['processtime']);
                    }
                    $l++;
                    if (strlen($val['avgprocesstime']) > $length[$l + $i]) {
                        $length[$l + $i] = strlen($val['avgprocesstime']);
                    }
                } else {
                    if ($this->user->hasRight(48)) {
                        if (strlen($val['expense']) > $length[$l + $i]) {
                            $length[$l + $i] = strlen($val['expense']);
                        }
                        $l++;
                        if (strlen($val['kosten']) > $length[$l + $i]) {
                            $length[$l + $i] = strlen($val['kosten']);
                        }
                        $l++;
                    }
                }
                $m = 0;
                $worksheet->writeString($y, $m++, $val['name'] . " (gesamt)");

                $worksheet->writeNumber($y, $m++ + $i, $val['anzahl']);
                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    if ($this->user->hasRight(48)) {
                        if (true)
                            $worksheet->writeString($y, $m++ + $i, $val['aufwand'], $format_right);
                        if (true)
                            $worksheet->writeNumber($y, $m++ + $i, $val['expense']);
                        if (true)
                            $worksheet->writeString($y, $m++ + $i, $val['zeitaufwandstunden']);
                        $val['kosten'] = str_replace('.', '', $val['kosten']);
                        $val['kosten'] = str_replace(',', '.', $val['kosten']);
                        //$this->log->log('val[\'kosten\'] '.print_r($val['kosten'], true), PEAR_LOG_DEBUG);
                        $worksheet->writeNumber($y, $m++ + $i, $val['kosten'] . " ");
                    }
                    $worksheet->writeString($y, $m++ + $i, $val['processtime']);
                    $worksheet->writeString($y, $m++ + $i, str_replace(array('.', ','), array('', '.'), $val['avgprocesstime']));
                } else {
                    if ($this->user->hasRight(48)) {
                        $worksheet->writeNumber($y, $m++ + $i, $val['expense']);
                        $worksheet->writeNumber($y, $m++ + $i, str_replace(array('.', ','), array('', '.'), $val['kosten']));
                    }
                }
                $y++;

                $l = 0;
                if (strlen($val['name']) > $length[$l]) {
                    $length[$l] = strlen($val['name']);
                }
                $l++;
                if (strlen($val['notKumu']['anzahl']) > $length[$l + $i]) {
                    $length[$l + $i] = strlen($val['notKumu']['anzahl']);
                }
                $l++;
                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    if ($this->user->hasRight(48)) {
                        if (true) {
                            if (strlen($val['notKumu']['aufwand']) > $length[$l + $i]) {
                                $length[$l + $i] = strlen($val['notKumu']['aufwand']);
                            }
                            $l++;
                        }
                        if (true) {
                            if (strlen($val['notKumu']['expense']) > $length[$l + $i]) {
                                $length[$l + $i] = strlen($val['notKumu']['expense']);
                            }
                            $l++;
                        }
                        if (true) {
                            if (strlen($val['notKumu']['zeitaufwandstunden']) > $length[$l + $i]) {
                                $length[$l + $i] = strlen($val['notKumu']['zeitaufwandstunden']);
                            }
                            $l++;
                        }
                        if (strlen($val['notKumu']['kosten']) > $length[$l + $i]) {
                            $length[$l + $i] = strlen(number_format($val['notKumu']['kosten'], 2, ',', '.') . " " . $this->user->getCurrencyDescr());
                        }
                        $l++;
                    }
                    if (strlen($val['processtime']) > $length[$l + $i]) {
                        $length[$l + $i] = strlen($val['processtime']);
                    }
                    $l++;
                    if (strlen($val['notKumu']['avgprocesstime']) > $length[$l + $i]) {
                        $length[$l + $i] = strlen($val['notKumu']['avgprocesstime']);
                    }
                } else {
                    if ($this->user->hasRight(48)) {
                        if (strlen($val['notKumu']['expense']) > $length[$l + $i]) {
                            $length[$l + $i] = strlen($val['notKumu']['expense']);
                        }
                        $l++;
                        if (strlen($val['notKumu']['kosten']) > $length[$l + $i]) {
                            $length[$l + $i] = strlen($val['notKumu']['kosten']);
                        }
                        $l++;
                    }
                }
                $m = 0;
                $worksheet->writeString($y, $m++, $val['name']);
                if ($Benutzer == 'Kontakt') {
                    $worksheet->writeString($y, $m++, $val['notKumu']['company']);
                }
                if ($title == 'AufwandGeraet') {
                    $worksheet->writeString($y, $m++, $val['notKumu']['typename']);
                }
                $worksheet->writeNumber($y, $m++ + $i, $val['notKumu']['anzahl']);
                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    if ($this->user->hasRight(48)) {
                        if (true)
                            $worksheet->writeString($y, $m++ + $i, $val['notKumu']['aufwand'], $format_right);
                        if (true)
                            $worksheet->writeNumber($y, $m++ + $i, $val['notKumu']['expense']);
                        if (true)
                            $worksheet->writeString($y, $m++ + $i, $val['notKumu']['zeitaufwandstunden']);
                        $val['notKumu']['kosten'] = str_replace('.', '', $val['notKumu']['kosten']);
                        $val['notKumu']['kosten'] = str_replace(',', '.', $val['notKumu']['kosten']);
                        //$this->log->log('val[\'kosten\'] '.print_r($val['kosten'], true), PEAR_LOG_DEBUG);
                        $worksheet->writeNumber($y, $m++ + $i, $val['notKumu']['kosten'] . " ");
                    }
                    $worksheet->writeString($y, $m++ + $i, $val['notKumu']['processtime']);
                    $worksheet->writeString($y, $m++ + $i, str_replace(array('.', ','), array('', '.'), $val['notKumu']['avgprocesstime']));
                } else {
                    if ($this->user->hasRight(48)) {
                        $worksheet->writeNumber($y, $m++ + $i, $val['notKumu']['expense']);
                        $worksheet->writeNumber($y, $m++ + $i, str_replace(array('.', ','), array('', '.'), $val['notKumu']['kosten']));
                    }
                }
                $y++;
                ////
            } else {
                $l = 0;
                $val['name'] = str_replace('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;', '-->', $val['name']);
                $val['name'] = str_replace('&nbsp;', '-->', $val['name']);
                if (strlen($val['name']) > $length[$l]) {
                    $length[$l] = strlen($val['name']);
                }
                $l++;
                if ($Benutzer == 'Kontakt') {
                    if (strlen($val['company']) > $length[$l]) {
                        $length[$l] = strlen($val['company']);
                    }
                    $l++;
                }
                if ($title == 'AufwandGeraet') {
                    if (strlen($val['typename']) > $length[$l]) {
                        $length[$l] = strlen($val['typename']);
                    }
                    $l++;
                }

                if (strlen($val['anzahl']) > $length[$l + $i]) {
                    $length[$l + $i] = strlen($val['anzahl']);
                }
                $l++;
                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    if ($this->user->hasRight(48)) {
                        if (true) {
                            if (strlen($val['aufwand']) > $length[$l + $i]) {
                                $length[$l + $i] = strlen($val['aufwand']);
                            }
                            $l++;
                        }
                        if (true) {
                            if (strlen($val['expense']) > $length[$l + $i]) {
                                $length[$l + $i] = strlen($val['expense']);
                            }
                            $l++;
                        }
                        if (true) {
                            if (strlen($val['zeitaufwandstunden']) > $length[$l + $i]) {
                                $length[$l + $i] = strlen($val['zeitaufwandstunden']);
                            }
                            $l++;
                        }
                        if (strlen($val['kosten']) > $length[$l + $i]) {
                            $length[$l + $i] = strlen(number_format($val['kosten'], 2, ',', '.') . " " . $this->user->getCurrencyDescr());
                        }
                        $l++;
                    }
                    if (strlen($val['processtime']) > $length[$l + $i]) {
                        $length[$l + $i] = strlen($val['processtime']);
                    }
                    $l++;
                    if (strlen($val['avgprocesstime']) > $length[$l + $i]) {
                        $length[$l + $i] = strlen($val['avgprocesstime']);
                    }
                } else {
                    if ($this->user->hasRight(48)) {
                        if (strlen($val['expense']) > $length[$l + $i]) {
                            $length[$l + $i] = strlen($val['expense']);
                        }
                        $l++;
                        if (strlen($val['kosten']) > $length[$l + $i]) {
                            $length[$l + $i] = strlen($val['kosten']);
                        }
                        $l++;
                    }
                }
                $m = 0;
                $worksheet->writeString($y, $m++, $val['name']);
                if ($Benutzer == 'Kontakt') {
                    $worksheet->writeString($y, $m++, $val['company']);
                }
                if ($title == 'AufwandGeraet') {
                    $worksheet->writeString($y, $m++, $val['typename']);
                }
                $worksheet->writeNumber($y, $m++ + $i, $val['anzahl']);
                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    if ($this->user->hasRight(48)) {
                        if (true)
                            $worksheet->writeString($y, $m++ + $i, $val['aufwand'], $format_right);
                        if (true)
                            $worksheet->writeNumber($y, $m++ + $i, $val['expense']);
                        if (true)
                            $worksheet->writeString($y, $m++ + $i, $val['zeitaufwandstunden']);
                        $val['kosten'] = str_replace('.', '', $val['kosten']);
                        $val['kosten'] = str_replace(',', '.', $val['kosten']);
                        //$this->log->log('val[\'kosten\'] '.print_r($val['kosten'], true), PEAR_LOG_DEBUG);
                        $worksheet->writeNumber($y, $m++ + $i, $val['kosten'] . " ");
                    }
                    $worksheet->writeString($y, $m++ + $i, $val['processtime']);
                    $worksheet->writeString($y, $m++ + $i, str_replace(array('.', ','), array('', '.'), $val['avgprocesstime']));
                } else {
                    if ($this->user->hasRight(48)) {
                        $worksheet->writeNumber($y, $m++ + $i, $val['expense']);
                        $worksheet->writeNumber($y, $m++ + $i, str_replace(array('.', ','), array('', '.'), $val['kosten']));
                    }
                }
                $y++;
            }
        }


        foreach ($length as $key => $val) {
            $worksheet->setColumn($key, $key, $val);
        }

        $workbook->close();
        exit;
    }

    public function tdev() {
        if (!defined('ASSETDESK') || ASSETDESK != 1) {
            header('Location: index.php');
        }
        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'devid');

        $this->set('devtype', @$_REQUEST['devtype']);
        $this->set('devtypes', $this->getDeviceTypes());

        if ($this->DBVersion >= 3) {

            $sql = sprintf('SELECT Device.DeviceID id, Device.DeviceName
                    name, DeviceType.TypeName, SUM(DISTINCT hm_Ticket.expExpense) ExpExpense, COUNT(DISTINCT hm_Ticket.ID) Anzahl,
                    SUM(hm_Ticket.Expense) Aufwand, SUM(%s) ProcessTime,
                    SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime FROM hm_TicketDevice
                    INNER JOIN Device ON hm_TicketDevice.DeviceID = Device.DeviceID
                    INNER JOIN DeviceType ON DeviceType.DeviceTypeID =
                    Device.DeviceTypeID INNER JOIN hm_Ticket ON hm_Ticket.ID =
                    hm_TicketDevice.TicketID ', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());
        } else {

            $sql = sprintf('SELECT Device.DevID id, Device.DeviceName
                    name, DeviceType.TypeName, SUM(DISTINCT hm_Ticket.expExpense) ExpExpense, COUNT(DISTINCT hm_Ticket.ID) Anzahl,
                    SUM(hm_Ticket.Expense) Aufwand, SUM(%s) ProcessTime,
                    SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime FROM hm_TicketDevice
                    INNER JOIN Device ON hm_TicketDevice.DeviceID = Device.DevID
                    INNER JOIN DeviceType ON DeviceType.TypeID =
                    Device.ICCMDeviceType INNER JOIN hm_Ticket ON hm_Ticket.ID =
                    hm_TicketDevice.TicketID ', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());
        }

        // Zeitlichebegrenzung
        $sql .= sprintf(' WHERE (hm_Ticket.EditDate >= %s AND
                hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);

        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $sql .= sprintf(' AND (UPPER(Device.DeviceName) LIKE UPPER(%s))', $this->db->quoteSmart('%' .
                            $_SESSION['Reporting']['filter'] . '%'));
        }

        // Nach bestimmten Geraetetypen filtern
        if ($this->DBVersion >= 3) {
            if ((int) @$_REQUEST['devtype'] > 0) {
                $sql .= sprintf(' AND (DeviceType.DeviceTypeID LIKE %u)', (int) $_REQUEST['devtype']);
            }
        } else {
            if ((int) @$_REQUEST['devtype'] > 0) {
                $sql .= sprintf(' AND (DeviceType.TypeID LIKE %u)', (int) $_REQUEST['devtype']);
            }
        }

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;
        if ($this->DBVersion >= 3) {
            $sql .= 'GROUP BY Device.DeviceID, Device.DeviceName,
                    DeviceType.TypeName';
        } else {
            $sql .= 'GROUP BY Device.DevID, Device.DeviceName,
                    DeviceType.TypeName';
        }

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = 'SELECT Anzahl, Aufwand, name, id, ProcessTime,
                AvgProcessTime, TypeName FROM (' . $sql . ') TInfo';

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        // Sortierung wird hier vorgenommen
        $sql .= ' ORDER BY ';
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'TYPE': $sql .= 'TypeName';
                break;
            case 'COSTS':
            case 'EXPENSE': $sql .= 'Aufwand';
                break;
            case 'COUNT': $sql .= 'Anzahl';
                break;
            case 'PROCESSTIME': $sql .= 'ProcessTime';
                break;
            case 'AVGPROCESSTIME': $sql .= 'AvgProcessTime';
                break;
            case 'EXPEXPENSE': $sql .= 'ExpExpense';
                break;
            default: $sql .= 'name';
                $_REQUEST['sorting'] = 'Name';
                break;
        }
        $sql .= ' ' . $sortOrder;

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);

        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if (@$_REQUEST['action'] == 'xls') {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format($row['aufwand'] * $this->MinutenSatz, 2, ',', '.') : '0,00';

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' .
                            $row['aufwand'];
                }
                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' .
                            $row['aufwand'];
                }
                $tickets[] = $row;
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandGeraet', 'Geraet');
        }

        $this->set('ReportingSubpage', 'tdev');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Ger&auml;t'));
        $this->set('GridHeader', $this->user->gettext('Ger&auml;t'));

        $this->set('tickets', $tickets);
    }

    /**
     * Zeigt die Reports 'je Gert' an.
     * Bis Version 3.2: function tdev_new
     */
    public function tdevnew() {
        if (!defined('ASSETDESK') || ASSETDESK != 1) {
            header('Location: index.php');
        }

        $this->tplFile = 'reportingtickets_dev_new.tpl'; // Template File
        $this->set('devtypes', $this->getDeviceTypes());
        $this->set('list_field', 'devid');
        $this->set('devtype', @$_REQUEST['devtype']);

        if ($this->DBVersion >= 3) {

            $sql = sprintf('SELECT 	COUNT(DISTINCT TD.TicketID) Anzahl, D.DeviceID ID,
                                	D.Hostname name, D.DomainName, DeviceType.TypeName,

                                	SUM(SumProcessingTimeForDeviceID.ProcessTime) ProcessTime,
                                	SUM(SumProcessingTimeForDeviceID.AvgProcessTime) AvgProcessTime,

                    SUM(TE.Kosten) Kosten,
                    SUM(TE.Aufwand) Aufwand,
                    SUM(Distinct hm_Ticket.ExpExpense) ExpExpense

                                FROM hm_TicketDevice TD
                                	INNER JOIN Device D ON D.DeviceID = TD.DeviceID
                                	INNER JOIN DeviceType ON DeviceType.DeviceTypeID = D.DeviceTypeID
                                	INNER JOIN hm_Ticket ON hm_Ticket.ID = TD.TicketID
                                	INNER JOIN (
                                		SELECT TD3.DeviceID,
                                				SUM( %s ) ProcessTime,
                                				SUM( %s ) / COUNT(DISTINCT T4.ID) AvgProcessTime
                                		FROM hm_Ticket T4
                                			INNER JOIN hm_TicketDevice TD3 ON T4.ID = TD3.TicketID
                                		GROUP BY TD3.DeviceID
                                	) SumProcessingTimeForDeviceID ON SumProcessingTimeForDeviceID.DeviceID = TD.DeviceID

                                	LEFT JOIN (
                                		SELECT HC2.HostName, HC2.DomainName, HC2.TicketNumber,
                                			SUM(HC2.TotalCost) TotalCostSum,
                                			SUM(HC2.Amount) Aufwand
                                		FROM Helpdeskcost HC2
                                		WHERE 1=1
                                		GROUP BY HC2.HostName, HC2.Domainname, HC2.TicketNumber
                                	) HC ON HC.HostName = D.Hostname AND HC.DomainName = D.Domainname AND HC.TicketNumber = TD.TicketID

                    LEFT JOIN (
                            SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                            FROM hm_TicketEvent
                            WHERE Deleted IS NULL OR Deleted = 0
                            Group BY TicketID
                          ) TE ON TE.TicketID = hm_Ticket.ID

                                WHERE (hm_Ticket.EditDate >= %s AND hm_Ticket.EditDate <= %s )', $this->DB_DATEDIFF('minute', 'T4.CreateDate', 'CASE WHEN T4.TicketStatusID = 3 THEN T4.UpdateDate ELSE ' . $this->DB_DATE('now()') . ' END '), $this->DB_DATEDIFF('minute', 'T4.CreateDate', 'CASE WHEN T4.TicketStatusID = 3 THEN T4.UpdateDate ELSE ' . $this->DB_DATE('now()') . ' END '), $this->startdate, $this->enddate);
        } else {

            $sql = sprintf('SELECT Device.DevID id, Device.DeviceName
                    name, DeviceType.TypeName, SUM(DISTINCT hm_Ticket.expExpense) ExpExpense, COUNT(DISTINCT hm_Ticket.ID) Anzahl,
                    SUM(hm_Ticket.Expense) Aufwand, SUM(%s) ProcessTime,
                    SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime FROM hm_TicketDevice
                    INNER JOIN Device ON hm_TicketDevice.DeviceID = Device.DevID
                    INNER JOIN DeviceType ON DeviceType.TypeID = Device.ICCMDeviceType
                    INNER JOIN hm_Ticket ON hm_Ticket.ID = hm_TicketDevice.TicketID', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());
        }


        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $sql .= sprintf(' AND (UPPER(D.Hostname) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        }

        // Nach bestimmten Geraetetypen filtern
        if ($this->DBVersion >= 3) {
            if ((int) @$_REQUEST['devtype'] > 0) {
                $sql .= sprintf(' AND (DeviceType.DeviceTypeID LIKE %u)', (int) $_REQUEST['devtype']);
            }
        } else {
            if ((int) @$_REQUEST['devtype'] > 0) {
                $sql .= sprintf(' AND (DeviceType.TypeID LIKE %u)', (int) $_REQUEST['devtype']);
            }
        }

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;

        if ($this->DBVersion >= 3) {
            $sql .= ' GROUP BY D.Hostname, D.Domainname, D.DeviceID, DeviceType.TypeName ';
        } else {
            $sql .= 'GROUP BY Device.DevID, Device.DeviceName,
                    DeviceType.TypeName';
        }

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
//             $sql      = 'SELECT Anzahl, Aufwand, name, id, ProcessTime,
//                 AvgProcessTime, TypeName FROM ('.$sql.') TInfo';
        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos) ? $pos : 1;
        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        // Sortierung wird hier vorgenommen
        $sql .= ' ORDER BY ';
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'TYPE': $sql .= 'TypeName';
                break;
            case 'COSTS': $sql .= 'Kosten';
                break;
            case 'EXPENSE': $sql .= 'Aufwand';
                break;
            case 'COUNT': $sql .= 'Anzahl';
                break;
            case 'PROCESSTIME': $sql .= 'ProcessTime';
                break;
            case 'AVGPROCESSTIME': $sql .= 'AvgProcessTime';
                break;
            case 'EXPEXPENSE': $sql .= 'ExpExpense';
                break;
            case 'KOSTEN': $sql .= 'Kosten';
                break;
            default: $sql .= 'name';
                $_REQUEST['sorting'] = 'Name';
                break;
        }
        $sql .= ' ' . $sortOrder;

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if (@$_REQUEST['action'] == 'xls') {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten'])), 2, ',', '.') : '0,00';

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' .
                            $row['aufwand'];
                }
                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' .
                            $row['aufwand'];
                }
                $tickets[] = $row;
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandGeraet', 'Geraet');
        }

        $this->set('ReportingSubpage', 'tdev');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Ger&auml;t'));
        $this->set('GridHeader', $this->user->gettext('Ger&auml;t'));

        $this->set('tickets', $tickets);
    }

    /**
     * Zeigt den Report 'je Prioritt' an.
     * Bis Version 3.2: function dating_priority()
     *
     */
    public function tprio() {
        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'prioid');


        $sql = sprintf('
                    SELECT
                        SUM(DISTINCT hm_Ticket.expExpense) ExpExpense, COUNT(DISTINCT hm_Ticket.ID) Anzahl,
                        hm_TicketPrio.Descr name,
                        hm_Ticket.TicketPrioID id,
	                    SUM(%s) ProcessTime,
                        SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                        SUM(TE.Aufwand) Aufwand,
                        SUM(TE.Kosten) Kosten
                    FROM
                        hm_Ticket
                            INNER JOIN hm_TicketPrio ON hm_Ticket.TicketPrioID = hm_TicketPrio.TicketPrioID
                            LEFT JOIN (
                                    SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                                    FROM hm_TicketEvent
        							WHERE Deleted IS NULL OR Deleted = 0
                                    Group BY TicketID
                                  ) TE ON TE.TicketID = hm_Ticket.ID
                    WHERE 1=1 ', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());

        if (defined('HMCOMPANY') && HMCOMPANY == 'HOLIDAY AUTOS' &&
                (!$this->user->hasRight(26) || @$_REQUEST['UserPrio'] == 'Y')) {

            $this->set('UserPrio', 'Y');

            $sql = sprintf('SELECT
                        COUNT(DISTINCT ID) Anzahl,
                            hm_TicketPrio.Descr name,
                            hm_Ticket.TicketUserPrioID id,
    	                   SUM(%s) ProcessTime,
                            SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                            SUM(TE.Aufwand) Aufwand,
                            SUM(TE.Kosten) Kosten
                        FROM
                            hm_Ticket
                                INNER JOIN hm_TicketPrio
                                    ON hm_Ticket.TicketUserPrioID = hm_TicketPrio.TicketPrioID
                            LEFT JOIN (
                                    SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                                    FROM hm_TicketEvent
        							WHERE Deleted IS NULL OR Deleted = 0
                                    Group BY TicketID
                                  ) TE ON TE.TicketID = hm_Ticket.ID
                        WHERE 1=1 ', $this->DB_DATEDIFF('minute', 'hm_Ticket.EditDate', 'hm_Ticket.UpdateDate'), $this->DB_DATEDIFF('minute', 'hm_Ticket.EditDate', 'hm_Ticket.UpdateDate'));
        }

        // Zeitlichebegrenzung
        $sql .= sprintf(' AND (hm_Ticket.EditDate >= %s AND hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;
        if (defined('HMCOMPANY') && HMCOMPANY == 'HOLIDAY AUTOS' &&
                (!$this->user->hasRight(26) || @$_REQUEST['UserPrio'] == 'Y')) {
            $sql .= ' GROUP BY hm_TicketPrio.Descr, hm_Ticket.TicketUserPrioID';
        } else {
            $sql .= ' GROUP BY hm_TicketPrio.Descr, hm_Ticket.TicketPrioID';
        }

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = sprintf('SELECT Anzahl, name, id, ProcessTime,
                                        AvgProcessTime,
                                        Kosten, Aufwand, ExpExpense
                                     FROM (%s) TInfo', $sql);

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos + 1 > $pages) ? (($pages > 0) ? $pages - 1 : 0) : $pos;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'COSTS':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'EXPENSE':
                $sql .= sprintf(' ORDER BY Aufwand %s', $sortOrder);
                break;

            case 'COUNT':
                $sql .= sprintf(' ORDER BY Anzahl %s', $sortOrder);
                break;

            case 'PROCESSTIME':
                $sql .= sprintf(' ORDER BY ProcessTime %s', $sortOrder);
                break;

            case 'AVGPROCESSTIME':
                $sql .= sprintf(' ORDER BY AvgProcessTime %s', $sortOrder);
                break;
            case 'EXPEXPENSE':
                $sql .= sprintf(' ORDER BY ExpExpense %s', $sortOrder);
                break;
            default:
                $_REQUEST['sorting'] = 'Name';
                $sql .= sprintf(' ORDER BY name %s', $sortOrder);
                break;
        }

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, $pos * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                if (trim($row['name']) == '') {
                    $row['name'] = $this->user->gettext('[ ohne Priorit&auml;t ]');
                }

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }

                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }
                $tickets[] = $row;
            }
        } else {
            if ($this->Debug) {
                echo "<pre>$sql</pre> - " . $res->getMessage();
            }
        }


        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandPrio', $this->user->gettext('Priorit&auml;t'));
        }

        $this->set('ReportingSubpage', 'tprio');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Priorit&auml;t'));
        $this->set('GridHeader', $this->user->gettext('Priorit&auml;t'));

        if (@$_REQUEST['action'] == 'print') {
            $tickets = $tickets;
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }

        $this->set('tickets', $tickets);
    }

    /**
     * Zeigt den Report 'je Supporter' an.
     */
    public function tsupporter() {
        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'tsupporter');

        //Alle 0 in NULL wandeln:
        $this->db->query(sprintf('UPDATE HM_Ticket SET SupporterID = NULL WHERE SupporterID = 0'));

        $sql = sprintf('
            SELECT
                SUM(Distinct hm_Ticket.expExpense) ExpExpense, COUNT(DISTINCT hm_Ticket.ID) Anzahl,
                hm_Users.username name,
                hm_TicketSupporter.UserID id,
                SUM(%s) ProcessTime,
                SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                SUM(TE.Aufwand) Aufwand,
                SUM(TE.Kosten) Kosten
            FROM
                hm_Ticket
                    LEFT JOIN hm_TicketSupporter ON hm_TicketSupporter.TicketID = hm_Ticket.ID
                    LEFT JOIN hm_Users ON hm_TicketSupporter.UserID = hm_Users.User_ID
                    LEFT JOIN hm_TicketGroup ON hm_TicketGroup.TicketID = hm_Ticket.ID
                    LEFT JOIN (
                        SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                        FROM hm_TicketEvent
                        WHERE Deleted IS NULL OR Deleted = 0
                        GROUP BY TicketID
                      ) TE ON TE.TicketID = hm_Ticket.ID
                LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
            WHERE 1=1 ', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());

        // Zeitlichebegrenzung
        $sql .= sprintf(' AND (hm_Ticket.EditDate >= %s AND hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;

        $supporter_ids = @$_REQUEST['supporter_id'];
        if (false !== array_search("0", $supporter_ids)) {
            $supporter_ids = array();
        }
        $this->set('supporter_id', $supporter_ids);

        if (count($supporter_ids) > 0) {
            //Ohne Supporter:
            $ohneSupporter = array_search("NULL", $supporter_ids);
            $tmpsql = '';
            if (false !== $ohneSupporter) {
                $supporter_ids[$ohneSupporter] = 0;
                $tmpsql = ' OR hm_TicketSupporter.UserID IS NULL ';
            }

            $sql .= sprintf(' AND ( hm_TicketSupporter.UserID IN (%s) %s)', implode(',', array_map('intval', $supporter_ids)), $tmpsql);
        }


        $sql .= ' GROUP BY hm_TicketSupporter.UserID, hm_Users.username';


        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = sprintf('SELECT Anzahl, name, id, ProcessTime,
                                    AvgProcessTime,
                                    Kosten, Aufwand, ExpExpense
                                 FROM (%s) TInfo', $sql);

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'COSTS':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'EXPENSE':
                $sql .= sprintf(' ORDER BY Aufwand %s', $sortOrder);
                break;

            case 'COUNT':
                $sql .= sprintf(' ORDER BY Anzahl %s', $sortOrder);
                break;

            case 'PROCESSTIME':
                $sql .= sprintf(' ORDER BY ProcessTime %s', $sortOrder);
                break;

            case 'AVGPROCESSTIME':
                $sql .= sprintf(' ORDER BY AvgProcessTime %s', $sortOrder);
                break;

            case 'EXPEXPENSE':
                $sql .= sprintf(' ORDER BY ExpExpense %s', $sortOrder);
                break;


            default:
                $_REQUEST['sorting'] = 'Name';
                $sql .= sprintf(' ORDER BY name %s', $sortOrder);
                break;
        }

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                if (trim($row['name']) == '') {
                    $row['name'] = $this->user->gettext('[ ohne Supporter ]');
                    $row['id'] = 0;
                }

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }

                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }
                $tickets[] = $row;
            }
        } else{
            if ($this->Debug) {
                echo "<pre>$sql</pre> - " . $res->getMessage();
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandSupporter', 'Supporter');
        }

        $this->set('ReportingSubpage', 'tsupporter');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Supporter'));
        $this->set('GridHeader', $this->user->gettext('Supporter'));
        $this->set('SupporterList', $this->getSupporters());

        if (@$_REQUEST['action'] == 'print') {
            $tickets = $tickets;
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }

        $this->set('tickets', $tickets);
    }

    /**
     * Zeigt den Report 'je Gruppe' an.
     */
    public function tgroup() {
        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'tgroup');

        //Alle 0 in NULL wandeln:
        $this->db->query(sprintf('UPDATE HM_Ticket SET GroupID = NULL WHERE GroupID = 0'));

        $filter = sprintf('UPPER(hm_Groups.name) LIKE UPPER(%s)', $this->db->quoteSmart('%' . $_REQUEST['filter'] . '%'));

        $sql = sprintf('
            SELECT
            SUM(DISTINCT hm_Ticket.expExpense) ExpExpense,
                COUNT(DISTINCT hm_Ticket.ID) Anzahl,
                hm_Groups.name,
                hm_TicketGroup.GroupID id,
                SUM(%s) ProcessTime,
                SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                SUM(TE.Aufwand) Aufwand,
                SUM(TE.Kosten) Kosten
            FROM
                hm_Ticket
                INNER JOIN hm_TicketGroup ON hm_TicketGroup.TicketID = hm_Ticket.ID
                INNER JOIN hm_Groups ON hm_TicketGroup.GroupID = hm_Groups.group_id
                    LEFT JOIN (
                        SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                        FROM hm_TicketEvent
                        WHERE Deleted IS NULL OR Deleted = 0
                        Group BY TicketID
                      ) TE ON TE.TicketID = hm_Ticket.ID
                LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                    LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
            WHERE %s ', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString(), $filter);

        // Zeitlichebegrenzung
        $sql .= sprintf(' AND (hm_Ticket.EditDate >= %s AND hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;

        $group_ids = @$_REQUEST['group_ids'];
        if (false !== array_search("0", $group_ids)) {
            $group_ids = array();
        }
        $this->set('group_ids', $group_ids);

        if (count($group_ids) > 0) {
            $ohneGruppe = array_search("NULL", $group_ids);
            $tmpsql = '';
            if (false !== $ohneGruppe) {
                $group_ids[$ohneGruppe] = 0;
                $tmpsql = ' OR hm_TicketGroups.GroupID IS NULL ';
            }

            $sql .= sprintf(' AND ( hm_TicketGroup.GroupID IN (%s) %s)', implode(',', array_map('intval', $group_ids)), $tmpsql);
        }


        $sql .= ' GROUP BY hm_TicketGroup.GroupID, hm_Groups.name ';


        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = sprintf('SELECT Anzahl, name, id, ProcessTime,
                                    AvgProcessTime,
                                    Kosten, Aufwand, ExpExpense
                                 FROM (%s) TInfo', $sql);

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'COSTS':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'EXPENSE':
                $sql .= sprintf(' ORDER BY Aufwand %s', $sortOrder);
                break;

            case 'COUNT':
                $sql .= sprintf(' ORDER BY Anzahl %s', $sortOrder);
                break;

            case 'PROCESSTIME':
                $sql .= sprintf(' ORDER BY ProcessTime %s', $sortOrder);
                break;

            case 'AVGPROCESSTIME':
                $sql .= sprintf(' ORDER BY AvgProcessTime %s', $sortOrder);
                break;
            case 'EXPEXPENSE':
                $sql .= sprintf(' ORDER BY ExpExpense %s', $sortOrder);
                break;
            default:
                $_REQUEST['sorting'] = 'Name';
                $sql .= sprintf(' ORDER BY name %s', $sortOrder);
                break;
        }

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                if (trim($row['name']) == '') {
                    $row['name'] = $this->user->gettext('[ ohne Gruppe ]');
                    $row['id'] = 0;
                }

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }

                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }
                $tickets[] = $row;
            }
        } else {
            if ($this->Debug) {
                echo "<pre>$sql</pre> - " . $res->getMessage();
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandSupporter', 'Supporter');
        }

        $this->set('ReportingSubpage', 'tgroup');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Gruppe'));
        $this->set('GridHeader', $this->user->gettext('Gruppen'));
        $this->set('Grouplist', $this->getGroups());

        if (@$_REQUEST['action'] == 'print') {
            $tickets = $tickets;
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }

        $this->set('tickets', $tickets);
    }

    /**
     * Zeigt den Report 'je Eskalationsstufe' an.
     */
    public function tesca() {
        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'tesca');

        $sql = sprintf('
                    SELECT
                        COUNT(DISTINCT ID) Anzahl,
                        hm_Ticket.EscalationLevel name,
                        hm_Ticket.EscalationLevel id,
                        CASE WHEN hm_Ticket.EscalationLevel IS NULL THEN 0 ELSE hm_Ticket.EscalationLevel END OrderByName,
                        SUM(%s) ProcessTime,
                        SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                        SUM(TE.Aufwand) Aufwand,
                        SUM(TE.Kosten) Kosten,
                        SUM(DISTINCT hm_Ticket.ExpExpense) ExpExpense
                    FROM
                        hm_Ticket
                            LEFT JOIN (
                                    SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                                    FROM hm_TicketEvent
        							WHERE Deleted IS NULL OR Deleted = 0
                                    Group BY TicketID
                                  ) TE ON TE.TicketID = hm_Ticket.ID
                        LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                        LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
                    WHERE 1=1
                    ', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());

        // Zeitlichebegrenzung
        $sql .= sprintf(' AND (hm_Ticket.EditDate >= %s AND hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;
        $sql .= ' GROUP BY hm_Ticket.Escalationlevel';

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = sprintf('SELECT Anzahl, name, id, ProcessTime,
                                        AvgProcessTime,
                                        Kosten, Aufwand, ExpExpense
                                     FROM (%s) TInfo', $sql);

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'COSTS':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'EXPENSE':
                $sql .= sprintf(' ORDER BY Aufwand %s', $sortOrder);
                break;

            case 'COUNT':
                $sql .= sprintf(' ORDER BY Anzahl %s', $sortOrder);
                break;

            case 'PROCESSTIME':
                $sql .= sprintf(' ORDER BY ProcessTime %s', $sortOrder);
                break;

            case 'AVGPROCESSTIME':
                $sql .= sprintf(' ORDER BY AvgProcessTime %s', $sortOrder);
                break;

            case 'EXPEXPENSE':
                $sql .= sprintf(' ORDER BY ExpExpense %s', $sortOrder);
                break;

            default:
                $_REQUEST['sorting'] = 'Name';
                $sql .= sprintf(' ORDER BY OrderByName %s', $sortOrder);
                break;
        }

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                if ($row['id'] == '')
                    $row['id'] = "0";
                if (@$_REQUEST['action'] != 'xls') {
                    $row['name'] = sprintf('<img src="images/escalation%u.gif" alt="" title="Eskalation: -%u-" height="13" width="57">', $row['name'], $row['name']);
                } else {
                    $row['name'] = (trim($row['name']) == '') ? '0' : $row['name'];
                    $row['name'] = $this->user->gettext('Eskalationsstufe') . " " . (string) $row['name'];
                }
                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }

                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }
                $tickets[] = $row;
            }
        } else{
            if ($this->Debug) {
                echo "<pre>$sql</pre> - " . $res->getMessage();
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandEscalation', $this->user->gettext('Eskalationsstufe'));
        }

        $this->set('ReportingSubpage', 'tesca');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Eskalationsstufe'));
        $this->set('GridHeader', $this->user->gettext('Eskalationsstufe'));

        if (@$_REQUEST['action'] == 'print') {
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }

        $this->set('tickets', $tickets);
    }

    /**
     * Zeigt den Report 'je Bearbeitungsart' an.
     * Bis Version 3.2: function tprocessingtype
     */
    public function tproctype() {

        //Bei Kaufbeuren wird die Inventarnummern-Liste in der ProcessingType-Liste gefhrt...
        if (defined('HMCOMPANY') && HMCOMPANY == 'STADT KAUFBEUREN') {
            header('location: index.php?module=reporting&event=tinvno');
        }

        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'proctype');

        $tickets = array();
        $this->db->query('UPDATE hm_TicketEvent SET processingtype = NULL WHERE processingtype = 0');
        $where = sprintf(' (hm_TicketEvent.EventDate >= %s AND
                hm_TicketEvent.EventDate <= %s ) ', $this->startdate, $this->enddate);

        $where .= " AND (hm_TicketEvent.Deleted IS NULL OR hm_TicketEvent.Deleted = 0)";

        // Filtern der Eintr&auml;ge
        if ($_SESSION['Reporting']['filter'] != '') {
            $where .= sprintf(' AND (UPPER(hm_Users.name) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] .
                            '%'));
        }
        $where .= ' AND (' . $this->user->getRightFilter() . ')';
        $where .= $this->showArchivedWhere;
        $sql = sprintf('
                SELECT
                    COUNT(DISTINCT TicketID) Anzahl,
                    SUM(Aufwand) Aufwand,
                    name,
                    ID ,
                    SUM(ProcessTime) ProcessTime,
                    SUM(ProcessTime) / COUNT(DISTINCT TicketID) AvgProcessTime,
                    SUM(Kosten) Kosten,
                    SUM(DISTINCT ExpExpense) ExpExpense
                FROM (
                    SELECT
                        hm_TicketEvent.TicketID,
                        hm_TicketEvent.processingtype ID,
			PT.description name,
                        SUM(hm_TicketEvent.Expense) Aufwand,
                        %s ProcessTime,
                        SUM(hm_TicketEvent.Expense * hm_TicketEvent.CostRatePerMinute) Kosten,
                        SUM(DISTINCT hm_ticket.ExpExpense) ExpExpense
                    FROM
                        hm_TicketEvent
                        INNER JOIN hm_Ticket ON hm_Ticket.ID = hm_TicketEvent.TicketID
                        LEFT JOIN hm_ProcessingType PT ON PT.processingtype_id = hm_TicketEvent.processingtype
			LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                        LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
                    WHERE
                        %s
                    GROUP BY
                        hm_TicketEvent.TicketID,
                        hm_TicketEvent.processingtype,
			PT.description,
                        hm_Ticket.EditDate,
                         hm_Ticket.TicketStatusID,
                        hm_Ticket.UpdateDate
                ) TInfo
                GROUP BY
                    name,
                    id', $this->getProcessTimeSQLString(), $where);

        // Zeitlichebegrenzung
        $sqlCount = sprintf('
                SELECT
                    COUNT(*)
                FROM (
                    SELECT
                        hm_TicketEvent.processingtype
                    FROM
                        hm_TicketEvent
                        INNER JOIN hm_Ticket ON hm_Ticket.ID = hm_TicketEvent.TicketID
                        LEFT JOIN hm_ProcessingType PT ON PT.processingtype_id = hm_TicketEvent.processingtype
                        LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                    LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
                    WHERE
                        %s
                    GROUP BY
                        hm_TicketEvent.processingtype
                ) TInfo', $where);

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos + 1 > $pages) ? (($pages > 0) ? $pages - 1 : 0) : $pos;
        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        $sql .= ' ORDER BY ';
        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {
            case 'COSTS': $sql .= 'Kosten';
                break;
            case 'EXPENSE': $sql .= 'Aufwand';
                break;
            case 'COUNT': $sql .= 'Anzahl';
                break;
            case 'PROCESSTIME': $sql .= 'ProcessTime';
                break;
            case 'AVGPROCESSTIME': $sql .= 'AvgProcessTime';
                break;
            case 'EXPEXPENSE': $sql .= 'ExpExpense';
                break;
            case 'KOSTEN': $sql .= 'Kosten';
                break;
            default: $sql .= 'name';
                $_REQUEST['sorting'] = 'Name';
                break;
        }
        $sql .= ' ' . $sortOrder;

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        // SQL-Abfrage absetzen
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, $pos * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                if (trim($row['name']) == '') {
                    $row['name'] = $this->user->gettext('[ ohne Bearbeitungsart ]');
                    $row['id'] = 0;
                }
                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];
                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') ||
                        HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] /
                                    60) . ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor(
                                    (int) $row['avgprocesstime'] / 60) . ':' . str_pad((
                                    (int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) .
                        ':' . str_pad(($row['expense'] - floor($row['expense'] /
                                        60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' .
                            $row['aufwand'];
                }
                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' .
                            $row['aufwand'];
                }
                $tickets[] = $row;
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandBenutzer', 'Benutzer');
        }

        $this->set('ReportingSubpage', 'tproctype');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Bearbeitungsart'));
        $this->set('GridHeader', $this->user->gettext('Bearbeitungsart'));

        if (@$_REQUEST['action'] == 'print') {
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }

        $this->set('tickets', $tickets);
    }

    /**
     * Zeigt den Report 'je Schlagwort' an.
     */
    public function tTags() {

        if (!$this->user->hasRight(219)) {
            header('Location: index.php');
        }

        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'ttags');

        $sql = sprintf('
            SELECT
                SUM(DISTINCT hm_Ticket.expExpense) ExpExpense, COUNT(DISTINCT hm_Ticket.ID) Anzahl,
                hm_Tags.Tag name,
                hm_Tags.ID id,
                SUM(%s) ProcessTime,
                SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                SUM(TE.Aufwand) Aufwand,
                SUM(TE.Kosten) Kosten
            FROM
                hm_Ticket
                    INNER JOIN hm_TicketTags TT ON hm_Ticket.ID = TT.TagID
                    LEFT JOIN hm_Tags ON hm_Tags.ID = TT.TagID
                    LEFT JOIN (
                        SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                        FROM hm_TicketEvent
                                                    WHERE Deleted IS NULL OR Deleted = 0
                        Group BY TicketID
                      ) TE ON TE.TicketID = hm_Ticket.ID
                LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                    LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
            WHERE 1=1 ', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());

        // Zeitlichebegrenzung
        $sql .= sprintf(' AND (hm_Ticket.EditDate >= %s AND hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;

        $TagIDs = @$_REQUEST['TagIDs'];
        if (false !== array_search("0", $TagIDs)) {
            $TagIDs = array();
        }
        $this->set('TagIDs', $TagIDs);

        if (count($TagIDs) > 0) {
            $sql .= sprintf(' AND TT.TagID IN (%s)', implode(',', array_map('intval', $TagIDs)));
        }

        $sql .= ' GROUP BY hm_Tags.ID, hm_Tags.Tag';


        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = sprintf('SELECT Anzahl, name, id, ProcessTime,
                                    AvgProcessTime,
                                    Kosten, Aufwand, ExpExpense
                                 FROM (%s) TInfo', $sql);

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'COSTS':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'EXPENSE':
                $sql .= sprintf(' ORDER BY Aufwand %s', $sortOrder);
                break;

            case 'COUNT':
                $sql .= sprintf(' ORDER BY Anzahl %s', $sortOrder);
                break;

            case 'PROCESSTIME':
                $sql .= sprintf(' ORDER BY ProcessTime %s', $sortOrder);
                break;

            case 'AVGPROCESSTIME':
                $sql .= sprintf(' ORDER BY AvgProcessTime %s', $sortOrder);
                break;

            case 'EXPEXPENSE':
                $sql .= sprintf(' ORDER BY ExpExpense %s', $sortOrder);
                break;

            default:
                $_REQUEST['sorting'] = 'Name';
                $sql .= sprintf(' ORDER BY name %s', $sortOrder);
                break;
        }

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }

                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }
                $tickets[] = $row;
                $Tags[$row['id']] = $row['name'];
            }
        } else {
            if ($this->Debug) {
                echo "<pre>$sql</pre> - " . $res->getMessage();
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandSchlagworte', 'Schlagworte');
        }

        $this->set('ReportingSubpage', 'ttags');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Schlagwort'));
        $this->set('GridHeader', $this->user->gettext('Schlagworte'));
        $this->set('TagList', $this->getTags());

        if (@$_REQUEST['action'] == 'print') {
            $tickets = $tickets;
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }

        $this->set('tickets', $tickets);
    }

    /**
     * Zeigt den Report 'je Struktur' an.
     */
    public function tstruct() {

        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'sid');

        $tickets = array();

        $sql = sprintf('SELECT n.ordering, p.id, p.name, p.lft, p.rgt, p.levelno,'
                . ' (hm_Categories.cost_rate / 60) CostRate, SUM(hm_Ticket.Expense) Aufwand,'
                . ' SUM(DISTINCT hm_Ticket.expExpense) ExpExpense, COUNT(DISTINCT hm_Ticket.ID) Anzahl, SUM(%s) ProcessTime, SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,'
                . ' hm_StructureTyp.name StructureName'
                . ' FROM hm_Structure n'
                . ' INNER JOIN hm_Structure p ON n.id = p.root_id'
                . ' INNER JOIN hm_StructureTyp ON p.styp_id = hm_StructureTyp.styp_id'
                . ' LEFT JOIN hm_ContactStructure ON hm_ContactStructure.structure_id = p.id'
                . ' LEFT JOIN hm_Ticket ON hm_Ticket.ContactID = hm_ContactStructure.contact_id'
                . ' LEFT JOIN hm_Categories ON hm_Categories.id = hm_Ticket.CategoryID1'
                . ' LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID '
                . ' LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID '
                . ' WHERE 1 = 1', $this->DB_DATEDIFF('minute', 'hm_Ticket.EditDate', 'hm_Ticket.UpdateDate'), $this->DB_DATEDIFF('minute', 'hm_Ticket.EditDate', 'hm_Ticket.UpdateDate'));


        $structure_id = (int) @$_REQUEST['structure_id'];
        $this->set('structure_id', $structure_id);
        if ((int) $structure_id > 0) {
            $sql .= sprintf(' AND p.root_id = %u ', $structure_id);
        }

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;
        // Zeitlichebegrenzung
        $sql .= sprintf(' AND (hm_Ticket.EditDate >= %s AND
                hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);

        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $sql .= sprintf(' AND (UPPER(p.name) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        }

        $sql .= ' GROUP BY hm_Categories.cost_rate, n.ordering, p.lft,
                p.rgt, p.id, p.name, p.levelno, hm_StructureTyp.name ';

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = 'SELECT StructureName, Anzahl, Aufwand, name, id, levelno,
                (rgt-lft)/2 childs, ProcessTime, AvgProcessTime, (Aufwand *
                CostRate) Kosten, ExpExpense FROM (' . $sql . ') TInfo';

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        $sql .= ' ORDER BY ';
        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {
            case 'COSTS': $sql .= '(Aufwand * CostRate)';
                break;
            case 'EXPENSE': $sql .= 'Aufwand';
                break;
            case 'COUNT': $sql .= 'Anzahl';
                break;
            case 'PROCESSTIME': $sql .= 'ProcessTime';
                break;
            case 'AVGPROCESSTIME': $sql .= 'AvgProcessTime';
                break;
            case 'EXPEXPENSE': $sql .= 'ExpExpense';
                break;
            default: $sql .= 'ordering, lft';
                $sortOrder = 'ASC';
                $_REQUEST['sorting'] = 'Name';
                break;
        }
        $sql .= ' ' . $sortOrder;

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);

        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);

        $res = (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) ? $this->db->query($sql) : $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                if (@$_REQUEST['action'] != 'xls' &&
                        !in_array(strtoupper(@$_REQUEST['sorting']), array(
                            'COSTS', 'EXPENSE', 'COUNT', 'PROCESSTIME',
                            'AVGPROCESSTIME', 'EXPEXPENSE'))) {

                    for ($i = 0; $i < $row['levelno'] - 1; $i++) {
                        $row['name'] = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' .
                                $row['name'];
                    }
                }
                $row['name'] .= ' (' . $row['structurename'] . ')';

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format($this->tools->toFloat($row['kosten']), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }
                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }
                $tickets[] = $row;
            }
        }


        // ExcelExport der aktuellen Seite
        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandStruktur', 'Struktur');
        }

        $this->set('ReportingSubpage', 'tstruct');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Firmenstruktur'));
        $this->set('GridHeader', $this->user->gettext('Firmenstruktur'));

        $this->set('structure', $this->getMainStructure());

        if (@$_REQUEST['action'] == 'print') {
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }
        $this->set('tickets', $tickets);
    }

    /**
     * Liefert die Struktureintrge aus der Tabelle hm_Structure.
     *
     * @author Dirk Herbes <d.herbes@fair-computer.de>
     * @return array
     */
    private function getMainStructure() {
        $structure = array();

        $sql = 'SELECT id, name
                FROM hm_Structure
                WHERE root_id = id
                ORDER BY ordering';

        $res = $this->db->query($sql);

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $structure[$row['id']] = $row['name'];
            }
        }
        return $structure;
    }

    /**
     * Zeigt den Report 'je Kontakt' an.
     *
     */
    public function tcon() {
        $this->tplFile = 'reportingtickets_contact.tpl'; // Template File
        $this->set('list_field', 'conid');


        $tickets = array();

        $this->db->query('UPDATE hm_Contacts SET company = NULL WHERE company = 0');
        $this->db->query('UPDATE hm_Contacts SET companyID = NULL WHERE companyID = 0');

        $sql = sprintf('SELECT SUM(DISTINCT hm_Ticket.expExpense) ExpExpense, COUNT(DISTINCT hm_Ticket.ID) Anzahl,
                                hm_Company.company, hm_Contacts.name,
                                hm_Contacts.contact_id id,
                                SUM(%s) ProcessTime,
                                SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                                SUM(Kosten) Kosten,
                                SUM(Aufwand) Aufwand
                            FROM hm_Contacts
                                INNER JOIN hm_Ticket ON hm_Ticket.ContactID = hm_Contacts.contact_id
                                LEFT JOIN hm_Company ON hm_Contacts.CompanyID = hm_Company.CompanyID
                                LEFT JOIN (
                                        SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                                        FROM hm_TicketEvent
										WHERE (Deleted IS NULL OR Deleted = 0)
                                        Group BY TicketID
                                      ) TE ON TE.TicketID = hm_Ticket.ID
                            WHERE 1=1 ', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());

        // Zeitlichebegrenzung
        $sql .= sprintf(' AND (hm_Ticket.EditDate >= %s AND hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);

        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $sql .= sprintf(' AND (UPPER(hm_Contacts.name) LIKE UPPER(%s) OR UPPER(hm_Company.company) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'), $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        }

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;
        $sql .= ' GROUP BY hm_Company.company, hm_Contacts.name, hm_Contacts.contact_id';
        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';
        $this->set('sortOrder', $sortOrder);

        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'COSTS':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'KOSTEN':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'EXPENSE':
                $sql .= sprintf(' ORDER BY Aufwand %s', $sortOrder);
                break;

            case 'COUNT':
                $sql .= sprintf(' ORDER BY Anzahl %s', $sortOrder);
                break;

            case 'PROCESSTIME':
                $sql .= sprintf(' ORDER BY ProcessTime %s', $sortOrder);
                break;

            case 'AVGPROCESSTIME':
                $sql .= sprintf(' ORDER BY AvgProcessTime %s', $sortOrder);
                break;

            case 'EXPEXPENSE':
                $sql .= sprintf(' ORDER BY expexpense %s', $sortOrder);
                break;

            case 'COMPANY':
                $_REQUEST['sorting'] = 'Company';
                $sql .= sprintf(' ORDER BY hm_Company.company %s,
                        hm_Contacts.name ASC', $sortOrder, $sortOrder);
                break;

            default:
                $_REQUEST['sorting'] = 'Name';
                $sql .= sprintf(' ORDER BY hm_Contacts.name %s,
                        hm_Company.company ASC', $sortOrder, $sortOrder);
                break;
        }
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<hr /> --SQLCount: <pre>$sqlCount</pre>";
        }
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {

            $pos = (int) @$_REQUEST['pos'];
            $Entries = (int) $this->db->getOne($sqlCount);
            $pages = ceil($Entries / $this->EntriesPerPage);

            if ($pos > $pages) {
                $pos = ($pages > 0) ? $pages : 1;
            }
            $pos = ($pos > 0) ? $pos : 1;

            $this->set('pos', $pos);
            $this->set('pages', $pages);
            $this->set('entries', $Entries);

            $this->set('Paging', $this->tools->Paging($pages, $pos));

            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }
                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }

                $row['hours'] = floor($row['expense'] / 60) . ':';
                $Minutes = $row['expense'] - (floor($row['expense'] / 60) * 60);
                $row['hours'] .= ($Minutes < 10) ? '0' . $Minutes : $Minutes;

                $row['company'] = ($row['company'] == '') ? '&nbsp;' : $row['company'];

                $tickets[] = $row;
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandKontakt', 'Kontakt');
        }

        $this->set('ReportingSubpage', 'tcon');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Kontakt'));
        $this->set('GridHeader', $this->user->gettext('Kontakt'));

        if (@$_REQUEST['action'] == 'print') {
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }

        $this->set('tickets', $tickets);
    }

    /**
     * Zeigt den Report 'je Kostenstelle' an.
     */
    public function tcostcenter() {
        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'costc');

        $this->db->query('UPDATE hm_Contacts SET costcenter = NULL WHERE costcenter = 0');

        $sql = sprintf('SELECT
                    COUNT(DISTINCT ID) Anzahl,
                    hm_Contacts.costcenter name,
	                SUM(%s) ProcessTime,
                    SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                    SUM(TE.Kosten) Kosten,
                    SUM(TE.Aufwand) Aufwand,
                    SUM(DISTINCT hm_Ticket.ExpExpense) ExpExpense
                FROM
                    hm_Ticket
                        INNER JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                    LEFT JOIN hm_TicketSupporter ON hm_Ticket.ID = hm_TicketSupporter.TicketID
                    LEFT JOIN hm_TicketGroup ON hm_Ticket.ID = hm_TicketGroup.TicketID
                    LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
                    LEFT JOIN (
                            SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                            FROM hm_TicketEvent
							WHERE Deleted IS NULL OR Deleted = 0
                            Group BY TicketID
                          ) TE ON TE.TicketID = hm_Ticket.ID', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());

        // Zeitlichebegrenzung

        $sql .= sprintf(' WHERE (hm_Ticket.EditDate >= %s AND hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);


        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $sql .= sprintf(' AND (UPPER(hm_Contacts.costcenter) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        }

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;
        $sql .= ' GROUP BY hm_Contacts.costcenter';

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = sprintf('SELECT Anzahl, name, ProcessTime,
                                        AvgProcessTime,
                                        Aufwand, Kosten, ExpExpense
                                    FROM (%s) TInfo', $sql);

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'COSTS':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'EXPENSE':
                $sql .= sprintf(' ORDER BY Aufwand %s', $sortOrder);
                break;

            case 'COUNT':
                $sql .= sprintf(' ORDER BY Anzahl %s', $sortOrder);
                break;

            case 'PROCESSTIME':
                $sql .= sprintf(' ORDER BY ProcessTime %s', $sortOrder);
                break;

            case 'AVGPROCESSTIME':
                $sql .= sprintf(' ORDER BY AvgProcessTime %s', $sortOrder);
                break;

            case 'EXPEXPENSE':
                $sql .= sprintf(' ORDER BY expexpense %s', $sortOrder);
                break;

            default:
                $_REQUEST['sorting'] = 'Name';
                $sql .= sprintf(' ORDER BY name %s', $sortOrder);
                break;
        }

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                if (trim($row['name']) == '') {
                    $row['name'] = $this->user->gettext('[ ohne Kostenstelle ]');
                }

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }

                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }
                $row['id'] = '\'' . $row['name'] . '\'';

                $tickets[] = $row;
            }
        } else{
            if ($this->Debug) {
                echo "<pre>$sql</pre> - " . $res->getMessage();
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandKategorie', 'Kategorie');
        }

        $this->set('ReportingSubpage', 'company');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Kostenstelle'));
        $this->set('GridHeader', $this->user->gettext('Kostenstelle'));

        if (@$_REQUEST['action'] == 'print') {
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }

        $this->set('tickets', $tickets);
    }

    /**
     * Zeigt den Report 'je Abteilung' an.
     */
    public function tdepartment() {
        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'dep');

        $this->db->query("UPDATE hm_Contacts SET department = NULL WHERE department = ''");

        $sql = sprintf('SELECT
                    COUNT(DISTINCT ID) Anzahl,
                    hm_Contacts.department name,
	                SUM(%s) ProcessTime,
                    SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                    SUM(TE.Kosten) Kosten,
                    SUM(TE.Aufwand) Aufwand,
                    SUM(DISTINCT hm_Ticket.ExpExpense) ExpExpense
                FROM
                    hm_Ticket
                        INNER JOIN hm_Contacts
                            ON hm_Contacts.contact_id = hm_Ticket.ContactID
                    LEFT JOIN (
                            SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                            FROM hm_TicketEvent
							WHERE Deleted IS NULL OR Deleted = 0
                            Group BY TicketID
                          ) TE ON TE.TicketID = hm_Ticket.ID', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());

        // Zeitlichebegrenzung

        $sql .= sprintf(' WHERE (hm_Ticket.EditDate >= %s AND hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);


        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $sql .= sprintf(' AND (UPPER(hm_Contacts.department) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        }

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;
        $sql .= ' GROUP BY hm_Contacts.department';

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = sprintf('SELECT Anzahl, name, ProcessTime,
                                        AvgProcessTime,
                                        Aufwand, Kosten, ExpExpense
                                    FROM (%s) TInfo', $sql);

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'COSTS':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'EXPENSE':
                $sql .= sprintf(' ORDER BY Aufwand %s', $sortOrder);
                break;

            case 'COUNT':
                $sql .= sprintf(' ORDER BY Anzahl %s', $sortOrder);
                break;

            case 'PROCESSTIME':
                $sql .= sprintf(' ORDER BY ProcessTime %s', $sortOrder);
                break;

            case 'AVGPROCESSTIME':
                $sql .= sprintf(' ORDER BY AvgProcessTime %s', $sortOrder);
                break;
            case 'EXPEXPENSE':
                $sql .= sprintf(' ORDER BY expexpense %s', $sortOrder);
                break;
            default:
                $_REQUEST['sorting'] = 'Name';
                $sql .= sprintf(' ORDER BY name %s', $sortOrder);
                break;
        }

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                if (trim($row['name']) == '') {
                    $row['name'] = $this->user->gettext('[ ohne Abteilung ]');
                }

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }

                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }
                $row['id'] = '\'' . $row['name'] . '\'';

                $tickets[] = $row;
            }
        } else {
            if ($this->Debug) {
                echo "<pre>$sql</pre> - " . $res->getMessage();
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandKategorie', 'Kategorie');
        }

        $this->set('ReportingSubpage', 'tdepartment');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Abteilung'));
        $this->set('GridHeader', $this->user->gettext('Abteilung'));

        if (@$_REQUEST['action'] == 'print') {
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }

        $this->set('tickets', $tickets);
    }

    /**
     * Ermittelt die Tickets fr das Reporting 'je InventoryNumber'.
     */
    public function tinvno() {

        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'invno');

        $this->db->query('UPDATE hm_Ticket SET KAUFBINVENTORYNUMBER = NULL WHERE KAUFBINVENTORYNUMBER = 0');

        $sql = sprintf('SELECT
                    COUNT(DISTINCT ID) Anzahl,
                    PT.Description name,
                    hm_Ticket.KaufbInventoryNumber id,
	                SUM(%s) ProcessTime,
                    SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                    SUM(TE.Kosten) Kosten,
                    SUM(TE.Aufwand) Aufwand,
                    SUM(DISTINCT hm_Ticket.ExpExpense) ExpExpense
                FROM
                    hm_Ticket
                        LEFT JOIN hm_Processingtype PT ON hm_Ticket.KaufbInventoryNumber = PT.processingtype_id
                    LEFT JOIN (
                            SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                            FROM hm_TicketEvent
							WHERE Deleted IS NULL OR Deleted = 0
                            Group BY TicketID
                          ) TE ON TE.TicketID = hm_Ticket.ID', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());

        // Zeitlichebegrenzung

        $sql .= sprintf(' WHERE (hm_Ticket.EditDate >= %s AND hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);


        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $sql .= sprintf(' AND (UPPER(PT.Description) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        }

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;
        $sql .= ' GROUP BY PT.Description, hm_Ticket.KaufbInventoryNumber';

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = sprintf('SELECT Anzahl,  name, ProcessTime,
                                        AvgProcessTime,
                                        Aufwand, Kosten, ExpExpense
                                    FROM (%s) TInfo', $sql);

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'COSTS':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'KOSTEN':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'EXPENSE':
                $sql .= sprintf(' ORDER BY Aufwand %s', $sortOrder);
                break;

            case 'COUNT':
                $sql .= sprintf(' ORDER BY Anzahl %s', $sortOrder);
                break;

            case 'PROCESSTIME':
                $sql .= sprintf(' ORDER BY ProcessTime %s', $sortOrder);
                break;

            case 'AVGPROCESSTIME':
                $sql .= sprintf(' ORDER BY AvgProcessTime %s', $sortOrder);
                break;
            case 'EXPEXPENSE':
                $sql .= sprintf(' ORDER BY expexpense %s', $sortOrder);
                break;
            default:
                $_REQUEST['sorting'] = 'Name';
                $sql .= sprintf(' ORDER BY name %s', $sortOrder);
                break;
        }

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                if (trim($row['name']) == '') {
                    $row['name'] = $this->user->gettext('[ ohne Inventarnummer ]');
                }

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }

                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }
                $row['id'] = '\'' . $row['name'] . '\'';

                $tickets[] = $row;
            }
        } else{
            if ($this->Debug) {
                echo "<pre>$sql</pre> - " . $res->getMessage();
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'Inventarnummer', 'Inventarnummer');
        }

        $this->set('ReportingSubpage', 'tinvno');
        $this->set('ReportingHeader', $this->user->gettext('Tickets Inventarnummer'));
        $this->set('GridHeader', $this->user->gettext('Inventarnummer'));

        if (@$_REQUEST['action'] == 'print') {
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }
        $this->set('tickets', $tickets);
    }

    /**
     * Ermittelt die Tickets fr das Reporting 'je InventoryNumber'.
     */
    public function tsla() {

        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'sla');

        $this->db->query('UPDATE hm_Ticket SET SLAID = NULL WHERE SLAID = 0');

        $sql = sprintf('SELECT
                    SUM(DISTINCT hm_Ticket.expExpense) ExpExpense, COUNT(DISTINCT hm_Ticket.ID) Anzahl,
                    SLA.ID name,
                    hm_Ticket.SLAID id,
	                SUM(%s) ProcessTime,
                    SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                    SUM(TE.Kosten) Kosten,
                    SUM(TE.Aufwand) Aufwand
                FROM
                    hm_Ticket
                        LEFT JOIN hm_ServiceLvlAgreement SLA ON hm_Ticket.SLAID = SLA.ID
                        LEFT JOIN hm_Company  ON hm_Company.CompanyID = SLA.CompanyID
                    LEFT JOIN (
                            SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                            FROM hm_TicketEvent
                            WHERE Deleted IS NULL OR Deleted = 0
                            Group BY TicketID
                          ) TE ON TE.TicketID = hm_Ticket.ID', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());

        // Zeitlichebegrenzung
        $sql .= sprintf(' WHERE (hm_Ticket.EditDate >= %s AND hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);

        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $sql .= sprintf(' AND (UPPER(hm_Company.Company) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        }

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;
        $sql .= ' GROUP BY SLA.ID, hm_Ticket.SLAID';

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = sprintf('SELECT Anzahl,  name, ProcessTime,
                                        AvgProcessTime,
                                        Aufwand, Kosten, ExpExpense
                                    FROM (%s) TInfo', $sql);

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'COSTS':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'KOSTEN':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'EXPENSE':
                $sql .= sprintf(' ORDER BY Aufwand %s', $sortOrder);
                break;

            case 'COUNT':
                $sql .= sprintf(' ORDER BY Anzahl %s', $sortOrder);
                break;

            case 'PROCESSTIME':
                $sql .= sprintf(' ORDER BY ProcessTime %s', $sortOrder);
                break;

            case 'AVGPROCESSTIME':
                $sql .= sprintf(' ORDER BY AvgProcessTime %s', $sortOrder);
                break;
            case 'EXPEXPENSE':
                $sql .= sprintf(' ORDER BY expexpense %s', $sortOrder);
                break;
            default:
                $_REQUEST['sorting'] = 'Name';
                $sql .= sprintf(' ORDER BY name %s', $sortOrder);
                break;
        }

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                if (trim($row['name']) == '') {
                    $row['name'] = $this->user->gettext('[ ohne SLA ]');
                }

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }

                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }
                $row['id'] = '\'' . $row['name'] . '\'';

                $tickets[] = $row;
            }
        } else {
            if ($this->Debug) {
                echo "<pre>$sql</pre> - " . $res->getMessage();
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'SLA', 'SLA');
        }

        $this->set('ReportingSubpage', 'tsla');
        $this->set('ReportingHeader', $this->user->gettext('Tickets SLA'));
        $this->set('GridHeader', $this->user->gettext('Service Level Agreements'));

        if (@$_REQUEST['action'] == 'print') {
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }
        $this->set('tickets', $tickets);
    }

    /**
     * Zeigt den Report 'je Firma' an.
     * Bis Version 3.2: function tcompany
     */
    public function company() {

        //$this->pageTemplateFile = 'iframe.tpl';
        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'com');

        //NULL und Leere Eintrge angleichen:
        $this->db->query("UPDATE hm_Contacts SET company = NULL WHERE company = ''");

        $sql = sprintf('SELECT
                    COUNT(DISTINCT ID) Anzahl,
                    hm_Company.company name,
	                SUM(%s) ProcessTime,
                    SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                    SUM(TE.Kosten) Kosten,
                    SUM(TE.Aufwand) Aufwand,
                    SUM(DISTINCT hm_Ticket.ExpExpense) ExpExpense
                FROM
                    hm_Ticket
                    INNER JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                    LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
                    LEFT JOIN (
                            SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                            FROM hm_TicketEvent
							WHERE Deleted IS NULL OR Deleted = 0
                            Group BY TicketID
                          ) TE ON TE.TicketID = hm_Ticket.ID', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());

        // Zeitlichebegrenzung

        $sql .= sprintf(' WHERE (hm_Ticket.EditDate >= %s AND hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);


        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $sql .= sprintf(' AND (UPPER(hm_Company.company) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        }

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;
        $sql .= ' GROUP BY hm_Company.company';

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = sprintf('SELECT Anzahl,  name, ProcessTime,
                                        AvgProcessTime,
                                        Aufwand, Kosten, ExpExpense
                                    FROM (%s) TInfo', $sql);

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'COSTS':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'KOSTEN':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'EXPENSE':
                $sql .= sprintf(' ORDER BY Aufwand %s', $sortOrder);
                break;

            case 'COUNT':
                $sql .= sprintf(' ORDER BY Anzahl %s', $sortOrder);
                break;

            case 'PROCESSTIME':
                $sql .= sprintf(' ORDER BY ProcessTime %s', $sortOrder);
                break;

            case 'AVGPROCESSTIME':
                $sql .= sprintf(' ORDER BY AvgProcessTime %s', $sortOrder);
                break;
            case 'EXPEXPENSE':
                $sql .= sprintf(' ORDER BY expexpense %s', $sortOrder);
                break;
            default:
                $_REQUEST['sorting'] = 'Name';
                $sql .= sprintf(' ORDER BY name %s', $sortOrder);
                break;
        }

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                if (trim($row['name']) == '') {
                    $row['name'] = $this->user->gettext('[ ohne Firma ]');
                }

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }

                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }
                //$row['id'] = '\''.htmlentities($row['name']).'\'';
                $row['id'] = '\'' . $row['name'] . '\'';

                $tickets[] = $row;
            }
        } else{
            if ($this->Debug) {
                echo "<pre>$sql</pre> - " . $res->getMessage();
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandKategorie', 'Kategorie');
        }

        $this->set('ReportingSubpage', 'company');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Firma'));
        $this->set('GridHeader', $this->user->gettext('Firma'));

        if (@$_REQUEST['action'] == 'print') {
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }

        $this->set('tickets', $tickets);
    }

    /**
     * Zeigt die ermitelten Tickets eines Reports in einer Liste an.
     * Bis Version 3.2: task: 'tickets'
     *
     * @author Dirk Herbes <d.herbes@fair-computer.de>
     */
    public function showTickets() {
        //$this->pageTemplateFile = 'iframe.tpl';
        $this->tplFile = 'list.tpl'; // Template File

        if (isset($_REQUEST['dating'])) {
            $this->showDatingTickets();
        }

        $device = false;

        // Erstellung der SQL-Statements
        $sql = sprintf('SELECT DISTINCT hm_Ticket.EscalationLevel,
                hm_Ticket.EscalationType, hm_Ticket.TicketDescr,
                hm_Ticket.ContactID, hm_Contacts.name Contact, hm_Contacts.department Department,
                hm_Contacts.important, hm_Ticket.SupporterID, hm_Users.name
                Supporter, hm_Company.company, hm_Ticket.TicketStatusID,
                hm_TicketStatus.Descr TStatus, hm_Ticket.TicketPrioID,
                hm_TicketPrio.Descr Priority, hm_Ticket.Published, %s
                OnHold, %s TicketDesireDate, hm_Ticket.CategoryID1, Cat1.name
                Category1, hm_Ticket.CategoryID2, Cat2.name Category2, %s
                CreateDate, %s EditDate, hm_Ticket.GroupID,
                hm_Groups.name GroupDescr, hm_Ticket.ID, %s DiffOnHold, %s
                UpdateDate, %s ProcessTime, hm_Ticket.ExpExpense ', $this->DB_CONVERT('hm_Ticket.OnHold'), $this->DB_CONVERT('hm_Ticket.TicketDesireDate'), $this->DB_CONVERT('hm_Ticket.EditDate'), $this->DB_CONVERT('hm_Ticket.EditDate'), $this->DB_DATEDIFF('minute', $this->DB_DATE('now()'), 'hm_Ticket.OnHold'), $this->DB_CONVERT('hm_Ticket.UpdateDate'), $this->getProcessTimeSQLString());


        // Auswahl der Tabellen
        $sql_from = ' FROM hm_Ticket
                            LEFT JOIN hm_Users ON hm_Users.user_id = hm_Ticket.SupporterID
                            LEFT JOIN hm_Contacts ON hm_Ticket.ContactID = hm_Contacts.contact_id
                    LEFT JOIN hm_TicketSupporter ON hm_Ticket.ID = hm_TicketSupporter.TicketID
                    LEFT JOIN hm_TicketGroup ON hm_Ticket.ID = hm_TicketGroup.TicketID
                    LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
                            LEFT JOIN hm_Categories Cat1 ON Cat1.id = hm_Ticket.CategoryID1
                            LEFT JOIN hm_Categories Cat2 ON Cat2.id = hm_Ticket.CategoryID2
                            LEFT JOIN hm_TicketStatus ON hm_Ticket.TicketStatusID = hm_TicketStatus.ID
                            LEFT JOIN hm_Groups ON hm_Ticket.GroupID = hm_Groups.group_id
                            LEFT JOIN hm_TicketPrio ON hm_Ticket.TicketPrioID = hm_TicketPrio.TicketPrioID
                            LEFT JOIN hm_Processingtype PT ON hm_Ticket.KaufbInventoryNumber = PT.processingtype_id
                            LEFT JOIN (
                                        SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                                        FROM hm_TicketEvent
                                        WHERE (Deleted <> 1 OR Deleted IS NULL)
                                        Group BY TicketID
                                      ) TE ON TE.TicketID = hm_Ticket.ID ';

        // Die Ticketliste nach diesen Kriterien filtern
        $where = array();

        //Wenn kein anderer filter gesetzt: Keine Archivierten Tickets:
        $where[] = $_SESSION['Reporting']['showArchivedWhere'];

        //Unterscheiden, ob Gert oder nicht-Gert:
        if ((int) @$_REQUEST['devid'] > 0) {
            $sql .= ', HC.DeviceCostSum Kosten, HC.DeviceCostAufwand Expense';
        } else {
            $sql .= ', TE.Kosten Kosten, TE.Aufwand Expense ';
        }
        // Benutzer -> Supporter
        if (isset($_REQUEST['uid'])) {
            if ((int) @$_REQUEST['uid'] > 0) {
                $this->set('list_name', $this->db->getOne(sprintf('SELECT
                        name FROM hm_Users WHERE user_id = %u', $_REQUEST['uid'])));
            }
            $this->set('list_field', 'uid');
            $this->set('list_value', $_REQUEST['uid']);
        } else if (trim(@$_REQUEST['tsupporter']) != '') {
            //Tickets je Firma wenn firma nicht gefllt anzeigen:
            if ((int) @$_REQUEST['tsupporter'] === 0) {
                $where[] = "(hm_TicketSupporter.UserID IS NULL)";
            } else {
                $where[] = sprintf('hm_TicketSupporter.UserID = %s', $this->db->quoteSmart($_REQUEST['tsupporter']));
            }
            $this->set('list_name', $this->db->getOne(sprintf('SELECT
                    name FROM hm_Users WHERE user_id = %u', $_REQUEST['tsupporter'])));
            $this->set('list_field', 'tsupporter');
            $this->set('list_value', $_REQUEST['tsupporter']);
        } else if (trim(@$_REQUEST['tgroup']) != '') {
            //Tickets je Firma wenn firma nicht gefllt anzeigen:
            if ((int) @$_REQUEST['tgroup'] === 0) {
                $where[] = "(hm_TicketGroup.GroupID IS NULL OR hm_TicketGroup.GroupID = 0)";
            } else {
                $where[] = sprintf('hm_TicketGroup.GroupID = %s', $this->db->quoteSmart($_REQUEST['tgroup']));
            }
            $this->set('list_name', $this->db->getOne(sprintf('SELECT
                    name FROM hm_Groups WHERE group_id = %u', $_REQUEST['tgroup'])));
            $this->set('list_field', 'tgroup');
            $this->set('list_value', $_REQUEST['tgroup']);
        } else if (isset($_REQUEST['ttags']) && 0 < $_REQUEST['ttags']) {

            $sql_from .= " INNER JOIN hm_TicketTags TT ON TT.TicketID = hm_Ticket.ID ";

            $where[] = sprintf('TT.TagID = %u', $_REQUEST['ttags']);

            $this->set('list_name', $this->db->getOne(sprintf('SELECT
                    Tag FROM hm_Tags WHERE ID = %u', $_REQUEST['ttags'])));
            $this->set('list_field', 'ttags');
            $this->set('list_value', $_REQUEST['ttags']);
        } else
        //Bearbeitungsart
        if (isset($_REQUEST['proctype'])) {
            if ((int) @$_REQUEST['proctype'] > 0) {
                $this->set('list_name', $this->db->getOne(sprintf('SELECT
                        description FROM hm_Processingtype WHERE processingtype_id = %u', $_REQUEST['protype'])));
            } else {
                $this->set('list_name', $this->user->gettext('[ ohne Bearbeitungsart ]'));
            }
            $this->set('list_field', 'proctype');
            $this->set('list_value', $_REQUEST['proctype']);
        } else

        // Category
        if (isset($_REQUEST['cid'])) {
            if ((int) @$_REQUEST['cid'] > 0) {
                $where[] = sprintf('(hm_Ticket.CategoryID1 = %u OR ' .
                        'hm_Ticket.CategoryID2 = %u)', $_REQUEST['cid'], $_REQUEST['cid']);
                $this->set('list_name', $this->db->getOne(sprintf('SELECT
                        name FROM hm_Categories WHERE id = %u', $_REQUEST['cid'])));
            }
            $this->set('list_field', 'cid');
            $this->set('list_value', $_REQUEST['cid']);
        } else

        // Category Kumulativ
        if (isset($_REQUEST['cidkumu'])) {
            if ((int) @$_REQUEST['cidkumu'] > 0) {
                $where[] = sprintf('(hm_Ticket.id in(%s))', implode(',', $this->getTicketIDsForCat((int) @$_REQUEST['cidkumu'])));
                $this->set('list_name', $this->db->getOne(sprintf('SELECT
                        name FROM hm_Categories WHERE id = %u', $_REQUEST['cidkumu'])));
            }
            $this->set('list_field', 'cidkumu');
            $this->set('list_value', $_REQUEST['cidkumu']);
        } else

        // ContactID
        if (isset($_REQUEST['conid'])) {
            if ((int) @$_REQUEST['conid'] > 0) {
                $where[] = sprintf(' hm_Ticket.ContactID = %u ', $_REQUEST['conid']);

                $this->set('list_name', $this->db->getOne(sprintf('SELECT
                        name FROM hm_Contacts WHERE contact_id = %u', $_REQUEST['conid'])));
            }
            $this->set('list_field', 'conid');
            $this->set('list_value', $_REQUEST['conid']);
        } else
        // Company
        if (trim(@$_REQUEST['com']) != '') {
            //Tickets je Firma wenn firma nicht gefllt anzeigen:
            if (trim(@$_REQUEST['com']) == '[ ohne Firma ]') {
                $where[] = "hm_Contacts.companyID IS NULL";
            } else {
                $where[] = sprintf('hm_Company.company = %s', $this->db->quoteSmart($_REQUEST['com']));
            }
            $this->set('list_name', $_REQUEST['com']);
            $this->set('list_field', 'com');
            $this->set('list_value', $_REQUEST['com']);
        } else

        // Kaufbeuren InventoryNumber (Modifizierte Prozessingtype...)
        if (trim(@$_REQUEST['invno']) != '') {
            //Tickets je Firma wenn firma nicht gefllt anzeigen:
            if (trim(@$_REQUEST['invno']) == '[ ohne Inventarnummer ]') {
                $where[] = "hm_Ticket.KaufbInventoryNumber IS NULL";
            } else {
                $where[] = sprintf('PT.Description = %s', $this->db->quoteSmart($_REQUEST['invno']));
            }
            $this->set('list_name', $_REQUEST['invno']);
            $this->set('list_field', 'invno');
            $this->set('list_value', $_REQUEST['invno']);
        } else

        // Kaufbeuren InventoryNumber (Modifizierte Prozessingtype...)
        if (trim(@$_REQUEST['sla']) != '') {
            //Tickets je Firma wenn firma nicht gefllt anzeigen:
            if (trim(@$_REQUEST['invno']) == '[ ohne SLA ]') {
                $where[] = "hm_Ticket.SLAID IS NULL";
            } else {
                $where[] = sprintf('hm_Ticket.SLAID = %s', $this->db->quoteSmart($_REQUEST['sla']));
            }
            $this->set('list_name', $_REQUEST['sla']);
            $this->set('list_field', 'sla');
            $this->set('list_value', $_REQUEST['sla']);
        } else

        if (trim(@$_REQUEST['dep']) != '') {
            //Tickets je Firma wenn firma nicht gefllt anzeigen:
            if (trim(@$_REQUEST['dep']) == '[ ohne Abteilung ]') {
                $where[] = "(hm_Contacts.department IS NULL OR hm_Contacts.department = '')";
            } else {
                $where[] = sprintf('hm_Contacts.department = %s', $this->db->quoteSmart($_REQUEST['dep']));
            }
            $this->set('list_name', $_REQUEST['dep']);
            $this->set('list_field', 'dep');
            $this->set('list_value', $_REQUEST['dep']);
        } else
        //Kostenstelle
        if (trim(@$_REQUEST['costc']) != '') {
            //Tickets je Firma wenn firma nicht gefllt anzeigen:
            if (trim(@$_REQUEST['costc']) == '[ ohne Kostenstelle ]') {
                $where[] = "(hm_Contacts.costcenter IS NULL OR hm_Contacts.costcenter = '')";
            } else {
                $where[] = sprintf('hm_Contacts.costcenter = %s', $this->db->quoteSmart($_REQUEST['costc']));
            }
            $this->set('list_name', $_REQUEST['costc']);
            $this->set('list_field', 'costc');
            $this->set('list_value', $_REQUEST['costc']);
        } else
        // Device
        if ((int) @$_REQUEST['devid'] > 0) {
            $sql .= ', HC.DeviceCostSum, HC.DeviceCostAufwand ';
            $sql_from .= ' LEFT JOIN hm_TicketDevice ON hm_Ticket.ID = hm_TicketDevice.TicketID
							    LEFT JOIN Device D  ON D.DeviceID = hm_TicketDevice.DeviceID
                                	LEFT JOIN (
                                		SELECT HC2.TicketNumber, HC2.HostName, HC2.DomainName,
                                			SUM(HC2.TotalCost) DeviceCostSum,
                                			SUM(HC2.Amount) DeviceCostAufwand
                                		FROM Helpdeskcost HC2
                                		WHERE 1=1
                                		GROUP BY HC2.TicketNumber, HC2.HostName, HC2.DomainName
                                	) HC ON HC.TicketNumber = hm_Ticket.ID AND HC.HostName = D.DeviceName AND HC.DomainName = D.DomainName';
            $where[] = sprintf(' hm_TicketDevice.DeviceID = %u ', $_REQUEST['devid']);

            $device = true;

            if ($this->DBVersion >= 3) {
                $this->set('list_name', $this->db->getOne(sprintf('SELECT
                        DeviceName FROM Device WHERE DeviceID = %u', $_REQUEST['devid'])));
            } else {
                $this->set('list_name', $this->db->getOne(sprintf('SELECT
                        DeviceName FROM Device WHERE DevID = %u', $_REQUEST['devid'])));
            }

            $this->set('list_field', 'devid');
            $this->set('list_value', $_REQUEST['devid']);
        } else
        // Structure
        if ((int) @$_REQUEST['sid'] > 0) {
            $sql_from .= ' LEFT JOIN hm_ContactStructure ON
                    hm_Ticket.ContactID = hm_ContactStructure.contact_id ';
            $where[] = sprintf(' hm_ContactStructure.structure_id = %u ', $_REQUEST['sid']);

            $this->set('list_name', $this->db->getOne(sprintf('SELECT name
                    FROM hm_Structure WHERE id = %u', $_REQUEST['sid'])));
            $this->set('list_field', 'sid');
            $this->set('list_value', $_REQUEST['sid']);
        } else

        if (isset($_REQUEST['tesca'])) {

            if ($_REQUEST['tesca'] > 0) {
                $where[] = sprintf(' hm_Ticket.EscalationLevel = %u ', $_REQUEST['tesca']);
            } else {
                $where[] = ' (hm_Ticket.EscalationLevel IS NULL OR hm_Ticket.EscalationLevel = 0)';
            }

            $this->set('list_name', $_REQUEST['tesca']);
            $this->set('list_field', 'tesca');
            $this->set('list_value', $_REQUEST['tesca']);
        } else

        // Assigned
        if ((int) @$_REQUEST['assign'] > 0) {

            $sql_from .= ' INNER JOIN hm_TicketEvent ON
                    hm_TicketEvent.TicketID = hm_Ticket.ID ';
            $where[] = sprintf(' (hm_TicketEvent.TicketStatusID = 4 AND
                    hm_TicketEvent.UserID = %u)   ', $_REQUEST['assign']);

            $where[] = " hm_TicketEvent.Deleted IS NULL ";

            $this->set('list_name', $this->db->getOne(sprintf('SELECT
                    name FROM hm_Users WHERE user_id = %u', $_REQUEST['assign'])));
            $this->set('list_field', 'assign');
            $this->set('list_value', $_REQUEST['assign']);
        } else
        if ((int) @$_REQUEST['tldapdev'] > 0) {

            $sql_from .= ' INNER JOIN hm_TicketLDAPDevice ON hm_TicketLDAPDevice.TicketID = hm_Ticket.ID ';
            //$sql_from .= ' INNER JOIN hm_LDAPDevices ON hm_LDAPDevices.DeviceID = hm_TicketLDAPDevice.DeviceID ';

            $where[] = sprintf(' hm_TicketLDAPDevice.DeviceID = %u ', $_REQUEST['tldapdev']);

            $this->set('list_name', $this->db->getOne(sprintf('SELECT
                        name FROM hm_LDAPDevices WHERE DeviceID = %u', $_REQUEST['tldapdev'])));

            $this->set('list_field', 'tldapdev');
            $this->set('list_value', $_REQUEST['tldapdev']);
        } else {
            $this->set('list_name', $this->db->getOne(sprintf('SELECT Descr
                    FROM hm_TicketPrio WHERE TicketPrioID = %u', @$_REQUEST['prioid'])));
        }

        $where[] = '(' . $this->user->getRightFilter() . ')';
        //if($sql_from . $sql_where != '') $where[] = $sql_from . $sql_where;

        if ((int) @$_REQUEST['uid'] > 0 || (int) @$_REQUEST['proctype'] > 0) {
            $user_where = '';
            if ((int) @$_REQUEST['uid'] > 0) {
                $user_where .= sprintf(' hm_TicketEvent.UserID = %u AND (hm_TicketEvent.EventDate >= %s AND
                    hm_TicketEvent.EventDate <= %s) AND hm_TicketEvent.TicketStatusID <> 5  ', $_REQUEST['uid'], $this->startdate, $this->enddate);
            } else if (isset($_REQUEST['proctype'])) {

                if ((int) @$_REQUEST['proctype'] > 0) {
                    $user_where .= sprintf(' hm_TicketEvent.processingtype = %u AND (hm_TicketEvent.EventDate >= %s AND
                        hm_TicketEvent.EventDate <= %s)   ', (int) $_REQUEST['proctype'], $this->startdate, $this->enddate);
                } else {
                    $user_where .= sprintf(' (hm_TicketEvent.processingtype = 0 OR hm_TicketEvent.processingtype IS NULL)
                                                    AND (hm_TicketEvent.EventDate >= %s AND hm_TicketEvent.EventDate <= %s) ', $this->startdate, $this->enddate);
                }
            }

            $user_where .= " AND hm_TicketEvent.Deleted IS NULL ";

            // Filtern der Eintr&auml;ge
            if ($_SESSION['Reporting']['filter'] != '') {
                $user_where .= sprintf(' AND (UPPER(hm_Users.name) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] .
                                '%'));
            }

            // Erstellung der SQL-Statements
            $sql = sprintf('SELECT hm_Ticket.EscalationLevel,
                    hm_Ticket.EscalationType, hm_Ticket.TicketDescr,
                    hm_Ticket.ContactID, hm_Contacts.name Contact,
                    hm_Contacts.important, hm_Company.company, hm_Ticket.TicketStatusID,
                    hm_TicketStatus.Descr TStatus, hm_Ticket.TicketPrioID,
                    hm_TicketPrio.Descr Priority, hm_Ticket.Published, %s
                    OnHold, %s TicketDesireDate, hm_Ticket.CategoryID1, Cat1.name
                    Category1, hm_Ticket.CategoryID2, Cat2.name Category2, %s
                    CreateDate, %s EditDate, TInfo.Aufwand Expense, hm_Ticket.ID, %s DiffOnHold, %s
                    UpdateDate, %s ProcessTime, TInfo.Kosten Kosten, TInfo.Aufwand Aufwand, hm_Ticket.ExpExpense ', $this->DB_CONVERT('hm_Ticket.OnHold'), $this->DB_CONVERT('hm_Ticket.TicketDesireDate'), $this->DB_CONVERT('hm_Ticket.EditDate'), $this->DB_CONVERT('hm_Ticket.EditDate'), $this->DB_DATEDIFF('minute', $this->DB_DATE('now()'), 'hm_Ticket.OnHold'), $this->DB_CONVERT('hm_Ticket.UpdateDate'), $this->getProcessTimeSQLString());

            // Auswahl der Tabellen
            $sql_from = sprintf('
                    FROM (
                            SELECT hm_TicketEvent.TicketID,
                                SUM(hm_TicketEvent.Expense) Aufwand,
                                SUM(hm_TicketEvent.Expense * hm_TicketEvent.CostRatePerMinute) Kosten
                            FROM hm_TicketEvent
                                INNER JOIN hm_Ticket ON hm_Ticket.ID = hm_TicketEvent.TicketID
                                INNER JOIN hm_Users ON hm_Users.user_id = hm_TicketEvent.UserID
                            WHERE %s GROUP BY hm_TicketEvent.TicketID
                        ) TInfo
                            INNER JOIN hm_Ticket ON hm_Ticket.id = TInfo.TicketID
                            LEFT JOIN hm_Contacts ON hm_Ticket.ContactID = hm_Contacts.contact_id
                            LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
                            LEFT JOIN hm_Categories Cat1 ON Cat1.id = hm_Ticket.CategoryID1
                            LEFT JOIN hm_Categories Cat2 ON Cat2.id = hm_Ticket.CategoryID2
                            LEFT JOIN hm_TicketStatus ON hm_Ticket.TicketStatusID = hm_TicketStatus.ID
                            LEFT JOIN hm_TicketPrio ON hm_Ticket.TicketPrioID = hm_TicketPrio.TicketPrioID ', $user_where);
        } else {

            if ((int) @$_REQUEST['assign'] > 0) {
                // Zeitlichebegrenzung
                $where[] = sprintf('(hm_TicketEvent.EventDate >= %s
                    AND hm_TicketEvent.EventDate <= %s)', $this->startdate, $this->enddate);
            } else {
                // Zeitlichebegrenzung
                $where[] = sprintf('(hm_Ticket.EditDate >= %s
                    AND hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);
            }
        }

        // Nur eigene Tickets anzeigen
        $myTickets = (int) @$_REQUEST['myTickets'];
        $this->set('myTickets', $myTickets);
        if ($myTickets == 1) {
            $where[] = sprintf('hm_Ticket.SupporterID = %u', $this->user->UserID);
        }

        // Nach Prioritaet filtern
        $prioid = (int) @$_REQUEST['prioid'];
        $this->set('prioid', $prioid);
        if ($prioid > 0) {
            $where[] = sprintf('hm_Ticket.TicketPrioID = %u', $prioid);
        }

        $status_where = (count($where) > 0) ? ' WHERE ' . join(' AND ', $where) . ' ' : '';

        // Nach Status filtern
        $statusid = (int) @$_REQUEST['statusid'];
        $this->set('statusid', $statusid);
        if ($statusid != 0 && $statusid != 8 && $statusid != 99 && $statusid != 98) {
            $where[] = sprintf('hm_Ticket.TicketStatusID = %u AND (%s <= 0
                    OR hm_Ticket.OnHold IS NULL)', $statusid, $this->DB_DATEDIFF('minute', $this->DB_DATE('now()'), 'hm_Ticket.OnHold'));
        } else if ($statusid == 8) { // Status ist OnHold
            $where[] = sprintf('%s > 0', $this->DB_DATEDIFF('minute', $this->DB_DATE('now()'), 'hm_Ticket.OnHold'));
        } else if ($statusid == 99) { // Alle Aktiven Tickets
            $where[] = 'hm_Ticket.TicketStatusID <> 3 AND
                    hm_Ticket.TicketStatusID <> 7';
            // jk 22.05.09: Benutzerreporting nur fr Tickets die nicht ASSIGNED
        } else if ($statusid == 98) {
            $where[] = sprintf('hm_Ticket.TicketStatusID != 4 AND (%s <= 0
                OR hm_Ticket.OnHold IS NULL)', $this->DB_DATEDIFF('minute', $this->DB_DATE('now()'), 'hm_Ticket.OnHold'));
        } else { // Alle Tickets
            $where[] = '1 = 1';
        }

        $sql_where = (count($where) > 0) ? ' WHERE ' . join(' AND ', $where) . ' ' : '';

        // Die Ticketliste entsprechend der Kriterien sortieren
        $sortorder = (@$_REQUEST['SortOrder'] == 'DESC') ? 'DESC' : 'ASC';
        $sort = @$_REQUEST['Sorting'];
        $sql_order = ' ORDER BY ';
        switch ($sort) {
            case "Status": $sqlo = 'TStatus';
                break;
            case "Priority": $sqlo = 'hm_Ticket.TicketPrioID';
                break;
            case "TicketDescr": $sqlo = 'hm_Ticket.TicketDescr';
                break;
            case "ID": $sqlo = 'hm_Ticket.ID';
                break;
//            case "Gruppe": $sqlo = 'hm_Groups.name';
//                break;
//            case "Name":
//                $sqlo = 'hm_Users.name';
//                $sort = 'Supporter';
//                break;
//            case "Supporter": $sqlo = 'hm_Users.name';
//                break;
            case "Contact": $sqlo = 'hm_Contacts.name';
                break;
            case "Company": $sqlo = 'hm_Company.company';
                break;
            case "Expense": $sqlo = 'Aufwand';
                break;
            case "ExpenseDate": $sqlo = 'Aufwand';
                break;
            case "ExpExpense": $sqlo = 'hm_Ticket.ExpExpense';
                break;
            case "Costs": $sqlo = 'Kosten';
                break;
            case "ProcessTime":
            case "ProcessDate": $sqlo = 'ProcessTime';
                break;
            case "Department": $sqlo = 'hm_Contacts.Department';
                break;
            case "CreateDate": $sqlo = 'hm_Ticket.EditDate';
                break;


            default:
                $_REQUEST['sorting'] = 'ID';
                $sqlo = 'hm_Ticket.ID';
                break;
        }
        $sql_order .= $sqlo . ' ' . $sortorder;
        $this->set('sort', $sort);
        $this->set('sortorder', $sortorder);

        // Seitennavigation ermitteln und vorbereiten
        if ((int) @$_REQUEST['assign'] > 0) {
            $entries = (int) $this->db->getOne('SELECT COUNT(*) FROM ( SELECT
                    DISTINCT hm_Ticket.ID ' . $sql_from . $sql_where . ') Tcount');
        } else {
            if ($this->Debug) {
                echo "--" . __LINE__ . ": " . __FUNCTION__ . "Entries: <br/>\n<pre> " . 'SELECT COUNT(DISTINCT hm_Ticket.ID) ' . $sql_from . $sql_where . "</pre>";
            }
            $entries = (int) $this->db->getOne('SELECT COUNT(DISTINCT hm_Ticket.ID) ' . $sql_from .
                            $sql_where);
        }
        $pos = (int) @$_REQUEST['pos'];
        $EntriesPerPage = (int) @$_REQUEST['EntriesPerPage'];
        if ($EntriesPerPage <= 0)
            $EntriesPerPage = 10;
        if ($EntriesPerPage >= 50)
            $EntriesPerPage = 50;
        $pages = ceil($entries / $EntriesPerPage);
        if (($pos) > $pages)
            $pos = $pages;
        if ($pos < 1)
            $pos = 1;
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>" . $sql . $sql_from . $sql_where . $sql_order . "</pre>";
        }

        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            // Die Tickets fuer die Darstellung holen
            $res = $this->db->query($sql . $sql_from . $sql_where . $sql_order);
        } else {
            // Die Tickets fuer die Darstellung holen
            $res = $this->db->limitQuery($sql . $sql_from . $sql_where . $sql_order, ($pos - 1) * $EntriesPerPage, $EntriesPerPage);
        }


        $tickets = array();

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                // Zeitberechnungaus Ticketevent.CostRatePerMinute
                $row['kosten'] = ($this->user->hasRight(48)) ? number_format($this->tools->toFloat($row['kosten']), 2, ',', '.') : '0,00';

                $Expense = $row['expense'];
                $row['expensedate']['days'] = floor($Expense / (60 * 24));
                $Expense -= $row['expensedate']['days'] * 60 * 24;
                $row['expensedate']['hours'] = floor($Expense / 60);
                $Expense -= $row['expensedate']['hours'] * 60;
                $row['expensedate']['minutes'] = $Expense;

                $ProcessTime = $row['processtime'];
                $row['processdate']['days'] = floor($ProcessTime / (60 * 24));
                $ProcessTime -= $row['processdate']['days'] * 60 * 24;
                $row['processdate']['hours'] = floor($ProcessTime / 60);
                $ProcessTime -= $row['processdate']['hours'] * 60;
                $row['processdate']['minutes'] = $ProcessTime;
                //MultiSupporter:
                $row['groups'] = $this->tools->getTicketGroups($row['id']);
                $row['supporters'] = $this->tools->getTicketSupporters($row['id']);
                $tickets[] = $row;
            }
        } else {
            $this->log->log('Reporting: Fehler beim laden der Tickets. Message: ' . $res->getMessage(), PEAR_LOG_ERR);
        }

        $this->set('tickets', $tickets);
        $this->set('EntriesPerPage', $EntriesPerPage);
        $this->set('entries', $entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('pos', $pos);
        $this->set('pages', $pages);
        $this->set('prios', $this->getPrios());
        $this->set('status', $this->getStatus($status_where, $device));

        if (isset($_REQUEST['action']) && $_REQUEST['action'] == 'print') {
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'iframe.tpl';
            $this->tplFile = 'print_tickets.tpl'; // Template File
            return TRUE;
        }

        if (isset($_REQUEST['action']) && $_REQUEST['action'] == 'xls') {
            $this->ExcelExportTicketList($tickets, $_REQUEST['listfield']);
            exit;
        }
    }

    /**
     * Generiert die Excel-Datei fr die Ticketlisten der Reports.
     * @param array $Tickets
     * @param type $Liste
     */
    private function ExcelExportTicketList($Tickets, $Liste) {

        if ($this->Debug)
            $this->log->log('ExcelExportTicketList Tickets: ' . print_r($Tickets, true), PEAR_LOG_DEBUG);
//JK, 27.09.2011: Ausfhrungszeit bei grerer Ticketanzahl erhhen:
        if (count($Tickets) > 1000) {
            @set_time_limit(count($Tickets) * 0.1);
        }

        include_once 'Spreadsheet/Excel/Writer.php';

        $workbook = new Spreadsheet_Excel_Writer();
        $workbook->send('ReportTicketList.xls');
        $worksheet = & $workbook->addWorksheet($Liste);

        $length = array();

        $format_bold = & $workbook->addFormat();
        $format_bold->setBold();

        $format_right = & $workbook->addFormat();
        $format_right->setAlign('right');

        $worksheet->writeString(0, 0, $this->user->gettext('Zeitraum vom:'), $format_bold);
        $worksheet->writeString(0, 1, $_SESSION['Reporting']['startdate']);
        $worksheet->writeString(1, 0, $this->user->gettext('bis zum:'), $format_bold);
        $worksheet->writeString(1, 1, $_SESSION['Reporting']['enddate']);

        $Zeile = 4;

        //berschriften:
        $Status = $this->user->gettext('Status');
        $Kurzbeschr = $this->user->gettext('Kurzbeschreibung');
        $TicketNr = $this->user->gettext('TicketNr');
        $Firma = $this->user->gettext('Firma');
        $Abteilung = $this->user->gettext('Abteilung');
        $Kontakt = $this->user->gettext('Kontakt');
        $Gruppe = $this->user->gettext('Gruppe');
        $Supporter = $this->user->gettext('Supporter');
        $CreateDate = $this->user->gettext('Erstellt am');
        $Kosten = $this->user->gettext('Kosten');
        $ErwAufwand = $this->user->gettext('Erw. Aufwand');
        $Aufwand = $this->user->gettext('Aufwand [m]');
        $Liegezeit = $this->user->gettext('Liegezeit [m]');

        //Breite fr berschrift:
        $Spalte = 0;
        $length[$Spalte++] = strlen($Status);
        $length[$Spalte++] = strlen($Kurzbeschr);
        $length[$Spalte++] = strlen($TicketNr);
        $length[$Spalte++] = strlen($Firma);
        $length[$Spalte++] = strlen($Abteilung);
        $length[$Spalte++] = strlen($Kontakt);
        $length[$Spalte++] = strlen($Gruppe);
        $length[$Spalte++] = strlen($Supporter);
        $length[$Spalte++] = strlen($Kosten);
        $length[$Spalte++] = strlen($Aufwand);
        $length[$Spalte++] = strlen($ErwAufwand);
        $length[$Spalte++] = strlen($Liegezeit);
        $length[$Spalte++] = strlen($CreateDate);


        //berschriften eintragen:
        $k = 0;
        $worksheet->writeString($Zeile - 1, $k++, $Status, $format_bold);
        $worksheet->writeString($Zeile - 1, $k++, $Kurzbeschr, $format_bold);
        $worksheet->writeString($Zeile - 1, $k++, $TicketNr, $format_bold);
        $worksheet->writeString($Zeile - 1, $k++, $Firma, $format_bold);
        $worksheet->writeString($Zeile - 1, $k++, $Abteilung, $format_bold);
        $worksheet->writeString($Zeile - 1, $k++, $Kontakt, $format_bold);
        $worksheet->writeString($Zeile - 1, $k++, $Gruppe, $format_bold);
        $worksheet->writeString($Zeile - 1, $k++, $Supporter, $format_bold);
        $worksheet->writeString($Zeile - 1, $k++, $CreateDate, $format_bold);
        if ($this->user->hasRight(48)) {
            $worksheet->writeString($Zeile - 1, $k++, $Kosten, $format_bold);
            $worksheet->writeString($Zeile - 1, $k++, $Aufwand, $format_bold);
            $worksheet->writeString($Zeile - 1, $k++, $ErwAufwand, $format_bold);
        }
        $worksheet->writeString($Zeile - 1, $k++, $Liegezeit, $format_bold);

        foreach ($Tickets as $Ticket) {
            $Status = $Ticket['tstatus'];
            $Kurzbeschr = $Ticket['ticketdescr'];
            $TicketNr = $Ticket['id'];
            $Firma = $Ticket['company'];
            $Abteilung = isset($Ticket['department']) ? $Ticket['department'] : '';
            $Kontakt = $Ticket['contact'];
            $Gruppe = $Ticket['groupdescr'];
            $Supporter = $Ticket['supporter'];
            $CreateDate = strftime("%d.%m.%Y %H:%M", strtotime($Ticket['editdate']));
            $Kosten = $Ticket['kosten'];
            $Aufwand = $Ticket['expense'];
            $ErwAufwand = $Ticket['expexpense'];
            $Liegezeit = $Ticket['processtime'];
            //Spaltenbreite nach Inhalt, wenn dieser lnger als die berschrift ist:
            $Spalte = 0;
            if (strlen($Status) > $length[$Spalte])
                $length[$Spalte] = strlen($Status) + 2;
            $Spalte++;
            if (strlen($Kurzbeschr) > $length[$Spalte])
                $length[$Spalte] = strlen($Kurzbeschr) + 2;
            $Spalte++;
            if (strlen($TicketNr) > $length[$Spalte])
                $length[$Spalte] = strlen($TicketNr) + 2;
            $Spalte++;
            if (strlen($Firma) > $length[$Spalte])
                $length[$Spalte] = strlen($Firma) + 2;
            $Spalte++;
            if (strlen($Abteilung) > $length[$Spalte])
                $length[$Spalte] = strlen($Abteilung) + 2;
            $Spalte++;
            if (strlen($Kontakt) > $length[$Spalte])
                $length[$Spalte] = strlen($Kontakt) + 2;
            $Spalte++;
            if (strlen($Gruppe) > $length[$Spalte])
                $length[$Spalte] = strlen($Gruppe) + 2;
            $Spalte++;
            if (strlen($Supporter) > $length[$Spalte])
                $length[$Spalte] = strlen($Supporter) + 2;
            $Spalte++;
            if (strlen($CreateDate) > $length[$Spalte])
                $length[$Spalte] = strlen($CreateDate) + 2;
            $Spalte++;
            if ($this->user->hasRight(48)) {
                if (strlen($Kosten) > $length[$Spalte])
                    $length[$Spalte] = strlen($Kosten) + 2;
                $Spalte++;
                if (strlen($Aufwand) > $length[$Spalte])
                    $length[$Spalte] = strlen($Aufwand) + 2;
                $Spalte++;
                if (strlen($ErwAufwand) > $length[$Spalte])
                    $length[$Spalte] = strlen($ErwAufwand) + 2;
                $Spalte++;
            }
            if (strlen($Liegezeit) > $length[$Spalte])
                $length[$Spalte] = strlen($Liegezeit) + 2;
            $Spalte++;
            //Inhalte Eintragen:
            $Spalte = 0;
            $worksheet->writeString($Zeile, $Spalte++, $Status);
            $worksheet->writeString($Zeile, $Spalte++, $Kurzbeschr);
            $worksheet->writeString($Zeile, $Spalte++, $TicketNr);
            $worksheet->writeString($Zeile, $Spalte++, $Firma);
            $worksheet->writeString($Zeile, $Spalte++, $Abteilung);
            $worksheet->writeString($Zeile, $Spalte++, $Kontakt);
            $worksheet->writeString($Zeile, $Spalte++, $Gruppe);
            $worksheet->writeString($Zeile, $Spalte++, $Supporter);
            $worksheet->writeString($Zeile, $Spalte++, $CreateDate);
            if ($this->user->hasRight(48)) {
                $worksheet->writeString($Zeile, $Spalte++, $Kosten);
                $worksheet->writeString($Zeile, $Spalte++, $Aufwand);
                $worksheet->writeString($Zeile, $Spalte++, $ErwAufwand);
            }
            $worksheet->writeString($Zeile, $Spalte++, $Liegezeit);

            $Zeile++;
        }


        foreach ($length as $key => $val) {
            $worksheet->setColumn($key, $key, $val);
        }

        $workbook->close();
        exit;
    }

    /**
     * Zeigt den Report 'Tickets weitergegeben' an.
     * Bis Version 3.2: function assign()
     */
    public function move() {
        $this->tplFile = 'assign.tpl'; // Template File

        $tickets = array();

        $sql = sprintf('SELECT COUNT(*) Anzahl, UserID, name
                FROM (
                    SELECT DISTINCT hm_Ticket.ID, hm_TicketEvent.UserID, hm_Users.name
                    FROM hm_TicketEvent
                        INNER JOIN hm_Users ON hm_Users.user_id = hm_TicketEvent.UserID
                        INNER JOIN hm_Ticket ON hm_Ticket.ID = hm_TicketEvent.TicketID
                        LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                        LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
                    WHERE hm_TicketEvent.TicketStatusID = 4
                        AND hm_TicketEvent.Deleted IS NULL
                        AND (hm_TicketEvent.EventDate >= %s AND hm_TicketEvent.EventDate <= %s)
                        AND ( %s ) ', $this->startdate, $this->enddate, $this->user->getRightFilter());

        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $sql .= sprintf(' AND (UPPER(hm_Users.name) LIKE UPPER(%s) )', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        }

        $sql .= ') Tinfo GROUP BY UserID, name';

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos + 1 > $pages) ? (($pages > 0) ? $pages - 1 : 0) : $pos;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';
        // Sortierung wird hier vorgenommen
        $sql .= ' ORDER BY ';
        switch (strtoupper(@$_REQUEST['sorting'])) {
            case 'COUNT': $sql .= 'Anzahl';
                break;
            default:
                $_REQUEST['sorting'] = 'Name';
                $sql .= 'name';
                break;
        }
        $sql .= ' ' . $sortOrder;

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        //$this->set('Paging' , $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);

        // Senden der Abfrage
        $res = (@$_REQUEST['action'] == 'xls') ? $this->db->query($sql) : $this->db->limitquery($sql, $pos * $this->EntriesPerPage, $this->EntriesPerPage);

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $tickets[] = $row;
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExport($tickets, 'WeitergegebeneTickets', 'Benutzer');
        }

        $this->set('tickets', $tickets);
    }

    /**
     * Generiert die Excel-Datei fr 'Weitergegebene Tickets'.
     * @param array $data
     * @param string $title
     * @param string $subject
     */
    private function ExcelExport($data, $title = 'Tickets', $subject = 'Benutzer') {

        include_once 'Spreadsheet/Excel/Writer.php';

        $workbook = new Spreadsheet_Excel_Writer();
        $workbook->send('ReportTicket.xls');
        $worksheet = & $workbook->addWorksheet($title);

        $length = array();

        $format_bold = & $workbook->addFormat();
        $format_bold->setBold();

        $worksheet->writeString(0, 0, $this->user->gettext('Zeitraum vom:'), $format_bold);
        $worksheet->writeString(0, 1, $_SESSION['Reporting']['startdate']);
        $worksheet->writeString(1, 0, $this->user->gettext('bis zum:'), $format_bold);
        $worksheet->writeString(1, 1, $_SESSION['Reporting']['enddate']);

        $y = 4;
        $Benutzer = $this->user->gettext($subject);
        $worksheet->writeString($y - 1, 0, $Benutzer, $format_bold);
        $length[0] = strlen($Benutzer);

        foreach ($data as $val) {

            $x = 0;
            if (strlen($val['name']) > $length[$x])
                $length[$x] = strlen($val['name']);
            $worksheet->writeString($y, $x, $val['name']);

            foreach ($val['status'] as $key => $status) {
                if ($y == 4) {
                    $Header = $this->tools->html2text($this->user->gettext($key));
                    if (strlen($Header) > $length[$x + 1])
                        $length[$x + 1] = strlen($Header);
                    $worksheet->writeString(3, $x + 1, $Header, $format_bold);
                }

                $x++;

                if (strlen($status) > $length[$x])
                    $length[$x] = strlen($status);
                $worksheet->writeNumber($y, $x, $status);
            }

            $worksheet->writeNumber($y, $x + 1, $val['anzahl']);
            $y++;
        }

        $worksheet->writeString($y, 0, $this->user->gettext('Summe:'), $format_bold);
        $worksheet->writeFormula($y, 1, '=SUM(B5:B' . $y . ')', $format_bold);

        foreach ($length as $key => $val) {
            $worksheet->setColumn($key, $key, $val);
        }

        $workbook->close();
        exit;
    }

    /**
     * Anzeige des Reports 'Termintreue'.
     */
    public function dating() {
        $this->tplFile = 'dating.tpl'; // Template File
        // Filtern der Eintr&auml;ge
        if ($_SESSION['Reporting']['filter'] != '') {
            $filter = sprintf(' AND (UPPER(hm_Categories.name) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        } else {
            $filter = '';
        }

        // RG, 30.10.2007: Feature 14 aus 'EOS-Feature-Liste'
        // - Auswertung greift nicht mehr auf SLA, sondern auf Faelligkeit:
        $sql = sprintf('
                SELECT
                    CategoryID1 id,
                    name,
                    SUM(status_green) status_green,
                    SUM(status_red) status_red
                FROM (
                    SELECT
                        hm_Ticket.ID,
                        CategoryID1, name,
                        CASE
                            WHEN (hm_Ticket.TicketStatusID NOT IN (3,7,11) AND
                                 DATEDIFF(dd, TicketDesireDate, %s) > 0) OR
				                 (hm_Ticket.TicketStatusID IN (3,7,11) AND
                                 DATEDIFF(dd, TicketDesireDate, hm_Ticket.UpdateDate) > 0)
                                 THEN 1
                            ELSE 0
                        END status_red,
                        CASE
                            WHEN (hm_Ticket.TicketStatusID NOT IN (3,7,11) AND
                                 DATEDIFF(dd, TicketDesireDate, %s) <= 0) OR
				                 (hm_Ticket.TicketStatusID IN (3,7,11) AND
                                 DATEDIFF(dd, TicketDesireDate, hm_Ticket.UpdateDate) <= 0)
                                 THEN 1
                            ELSE 0
                        END status_green
                    FROM
                        hm_Categories,
                    WHERE
                        hm_Ticket.CategoryID1 = hm_Categories.id AND
                        hm_Categories.id = hm_Categories.root_id AND
                        hm_Ticket.TicketDesireDate >= %s AND
                        hm_Ticket.TicketDesireDate <= %s AND (%s) %s
                    ) dating
                GROUP BY
                    dating.CategoryID1,
                    dating.name
                ORDER BY ', $this->DB_DATE('now()'), $this->DB_DATE('now()'), $this->startdate, $this->enddate, $this->user->getRightFilter(), $filter);

        $sort = (($str = trim(@$_REQUEST['sort'])) != '') ? $str : 'Name';
        $sortorder = (trim(@$_REQUEST['sortorder']) == 'DESC') ? 'DESC' : 'ASC';
        $this->set('sort', $sort);
        $this->set('sortorder', $sortorder);

        switch ($sort) {

            case 'Summe':
                $sql .= '(SUM(status_green)+SUM(status_red))';
                break;

            case 'StatusGreen':
                $sql .= 'SUM(status_green)';
                break;

            case 'SumGreen':
                $sql .= '((100 * SUM(status_green)) / (SUM(status_green)+SUM(status_red)))';
                break;

            case 'StatusRed':
                $sql .= 'SUM(status_red)';
                break;

            case 'SumRed':
                $sql .= '((100 * SUM(status_red)) / (SUM(status_green)+SUM(status_red)))';
                break;

            case 'Name':
            default:
                $sort = 'Name';
                $sql .= 'dating.name';
                break;
        }
        $sql .= ' ' . $sortorder;
        $res = $this->db->query($sql);
        $Categories = array();
        $Categories[] = array(
            'name'                 => $this->user->gettext('Gesamt&uuml;bersicht'),
            'total'                => 0,
            'status_green'         => 0,
            'status_red'           => 0,
            'status_green_percent' => 0,
            'status_red_percent'   => 0,
            'id'                   => 0
        );

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $row['total'] = $row['status_green'] + $row['status_red'];
                $row['status_green_percent'] = str_pad(round(100 * ($row['status_green'] / $row['total']), 0), 2, '0', STR_PAD_LEFT);
                $row['status_red_percent'] = str_pad(round(100 * ($row['status_red'] / $row['total']), 0), 2, '0', STR_PAD_LEFT);

                $Categories[0]['total'] += $row['total'];
                $Categories[0]['status_green'] += $row['status_green'];
                $Categories[0]['status_red'] += $row['status_red'];

                $Categories[] = $row;
            }
        }

        if ($Categories[0]['total'] > 0) {
            $Categories[0]['status_green_percent'] = str_pad(
                    round(100 * ($Categories[0]['status_green'] / $Categories[0]['total']), 0), 2, '0', STR_PAD_LEFT);

            $Categories[0]['status_red_percent'] = str_pad(
                    round(100 * ($Categories[0]['status_red'] / $Categories[0]['total']), 0), 2, '0', STR_PAD_LEFT);
        }
        $this->set('categories', $Categories);
    }

    /**
     * Report 'Termintreue Benutzer'.
     * Bis Version 3,2: function dating_user
     */
    public function duser() {
        $this->tplFile = 'dating_user.tpl'; // Template File
        // Filtern der Eintr&auml;ge
        if ($_SESSION['Reporting']['filter'] != '') {
            $filter = sprintf(' AND (UPPER(hm_Users.name) LIKE UPPER(%s) OR UPPER(hm_Users.username) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'), $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        } else
            $filter = '';

        // RG, 30.10.2007: Feature 14 aus 'EOS-Feature-Liste'
        // - Die Auswertung greift nicht mehr auf SLA, sondern auf F&auml;lligkeit:
        $sql = sprintf('
                SELECT
                    SupporterID id,
                    name,
                    username,
                    SUM(status_green) status_green,
                    SUM(status_red) status_red
                FROM (
                    SELECT
                        hm_Ticket.ID,
                        SupporterID,
                        hm_Users.name,
                        hm_Users.username,
                        CASE
                            WHEN (hm_Ticket.TicketStatusID NOT IN (3,7,11) AND
                                 DATEDIFF(dd, TicketDesireDate, %s) > 0) OR
				                 (hm_Ticket.TicketStatusID IN (3,7,11) AND
                                 DATEDIFF(dd, TicketDesireDate, hm_Ticket.UpdateDate) > 0)
                                 THEN 1
                            ELSE 0
                        END status_red,
                        CASE
                            WHEN (hm_Ticket.TicketStatusID NOT IN (3,7,11) AND
                                 DATEDIFF(dd, TicketDesireDate, %s) <= 0) OR
				                 (hm_Ticket.TicketStatusID IN (3,7,11) AND
                                 DATEDIFF(dd, TicketDesireDate, hm_Ticket.UpdateDate) <= 0)
                                 THEN 1
                            ELSE 0
                        END status_green
                    FROM
                        hm_Ticket
                        LEFT JOIN hm_Users ON hm_Users.user_id = hm_Ticket.SupporterID
                    WHERE
                        hm_Ticket.TicketDesireDate >= %s AND
                        hm_Ticket.TicketDesireDate <= %s AND (%s) %s
                    ) dating
                GROUP BY
                    dating.SupporterID,
                    dating.name,
                    dating.username
                ORDER BY ', $this->DB_DATE('now()'), $this->DB_DATE('now()'), $this->startdate, $this->enddate, $this->user->getRightFilter(), $filter);

        $sort = (($str = trim(@$_REQUEST['sort'])) != '') ? $str : 'Name';
        $sortorder = (trim(@$_REQUEST['sortorder']) == 'DESC') ? 'DESC' : 'ASC';
        $this->set('sort', $sort);
        $this->set('sortorder', $sortorder);

        switch ($sort) {

            case 'Summe':
                $sql .= '(SUM(status_green)+SUM(status_red))';
                break;

            case 'StatusGreen':
                $sql .= 'SUM(status_green)';
                break;

            case 'SumGreen':
                $sql .= '((100 * SUM(status_green)) / (SUM(status_green)+SUM(status_red)))';
                break;

            case 'StatusRed':
                $sql .= 'SUM(status_red)';
                break;

            case 'SumRed':
                $sql .= '((100 * SUM(status_red)) / (SUM(status_green)+SUM(status_red)))';
                break;

            case 'UserName':
                $sql .= 'username';
                break;

            case 'Name':
            default:
                $this->set('sort', 'Name');
                $sql .= 'dating.name';
                break;
        }
        $sql .= ' ' . $sortorder;
        $res = $this->db->query($sql);

        $Categories = array();
        $Categories[] = array(
            'name'                 => $this->user->gettext('Gesamt&uuml;bersicht'),
            'total'                => 0,
            'status_green'         => 0,
            'status_red'           => 0,
            'status_green_percent' => 0,
            'status_red_percent'   => 0,
            'id'                   => 0
        );

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $row['total'] = $row['status_green'] + $row['status_red'];
                $row['status_green_percent'] = str_pad(round(100 * ($row['status_green'] / $row['total']), 0), 2, '0', STR_PAD_LEFT);
                $row['status_red_percent'] = str_pad(round(100 * ($row['status_red'] / $row['total']), 0), 2, '0', STR_PAD_LEFT);

                $Categories[0]['total'] += $row['total'];
                $Categories[0]['status_green'] += $row['status_green'];
                $Categories[0]['status_red'] += $row['status_red'];

                $Categories[] = $row;
            }
        }

        if ($Categories[0]['total'] > 0) {
            $Categories[0]['status_green_percent'] = str_pad(
                    round(100 * ($Categories[0]['status_green'] / $Categories[0]['total']), 0), 2, '0', STR_PAD_LEFT);

            $Categories[0]['status_red_percent'] = str_pad(
                    round(100 * ($Categories[0]['status_red'] / $Categories[0]['total']), 0), 2, '0', STR_PAD_LEFT);
        }

        $this->set('categories', $Categories);
    }

    /**
     * Report 'Termintrue Kontakt'.
     * Bis Version 3.2: function dating_contact()
     */
    public function dcontact() {
        $this->tplFile = 'dating_contact.tpl'; // Template File
        // Filtern der Eintr&auml;ge
        if ($_SESSION['Reporting']['filter'] != '') {
            $filter = sprintf(' AND (UPPER(hm_Contacts.name) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        } else
            $filter = '';

        // RG, 30.10.2007: Feature 14 aus 'EOS-Feature-Liste'
        // - Auswertung greift nicht mehr auf SLA, sondern auf F&auml;lligkeit:
        $sql = sprintf('
                SELECT
                    ContactID id,
                    name,
                    SUM(status_green) status_green,
                    SUM(status_red) status_red
                FROM (
                    SELECT
                        hm_Ticket.ID,
                        ContactID,
                        hm_Contacts.name,
                        CASE
                            WHEN (hm_Ticket.TicketStatusID NOT IN (3,7,11) AND
                                 DATEDIFF(dd, TicketDesireDate, %s) > 0) OR
				                 (hm_Ticket.TicketStatusID IN (3,7,11) AND
                                 DATEDIFF(dd, TicketDesireDate, hm_Ticket.UpdateDate) > 0)
                                 THEN 1
                            ELSE 0
                        END status_red,
                        CASE
                            WHEN (hm_Ticket.TicketStatusID NOT IN (3,7,11) AND
                                 DATEDIFF(dd, TicketDesireDate, %s) <= 0) OR
				                 (hm_Ticket.TicketStatusID IN (3,7,11) AND
                                 DATEDIFF(dd, TicketDesireDate, hm_Ticket.UpdateDate) <= 0)
                                 THEN 1
                            ELSE 0
                        END status_green
                    FROM
                        hm_Ticket
                        LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                        LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
                    WHERE
                        hm_Ticket.TicketDesireDate >= %s AND
                        hm_Ticket.TicketDesireDate <= %s AND (%s) %s
                    ) dating
                GROUP BY
                    dating.ContactID,
                    dating.name
                ORDER BY ', $this->DB_DATE('now()'), $this->DB_DATE('now()'), $this->startdate, $this->enddate, $this->user->getRightFilter(), $filter);

        $sort = (($str = trim(@$_REQUEST['sort'])) != '') ? $str : 'Name';
        $sortorder = (trim(@$_REQUEST['sortorder']) == 'DESC') ? 'DESC' : 'ASC';
        $this->set('sort', $sort);
        $this->set('sortorder', $sortorder);

        switch ($sort) {

            case 'Summe':
                $sql .= '(SUM(status_green)+SUM(status_red))';
                break;

            case 'StatusGreen':
                $sql .= 'SUM(status_green)';
                break;

            case 'SumGreen':
                $sql .= '((100 * SUM(status_green)) / (SUM(status_green)+SUM(status_red)))';
                break;

            case 'StatusRed':
                $sql .= 'SUM(status_red)';
                break;

            case 'SumRed':
                $sql .= '((100 * SUM(status_red)) / (SUM(status_green)+SUM(status_red)))';
                break;

            case 'UserName':
                $sql .= 'dating.name';
                break;

            case 'Name':
            default:
                $this->set('sort', 'Name');
                $sql .= 'dating.name';
                break;
        }
        $sql .= ' ' . $sortorder;
        $res = $this->db->query($sql);

        $Categories = array();
        $Categories[] = array(
            'name'                 => $this->user->gettext('Gesamt&uuml;bersicht'),
            'total'                => 0,
            'status_green'         => 0,
            'status_red'           => 0,
            'status_green_percent' => 0,
            'status_red_percent'   => 0
        );

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $row['total'] = $row['status_green'] + $row['status_red'];
                $row['status_green_percent'] = str_pad(round(100 * ($row['status_green'] / $row['total']), 0), 2, '0', STR_PAD_LEFT);
                $row['status_red_percent'] = str_pad(round(100 * ($row['status_red'] / $row['total']), 0), 2, '0', STR_PAD_LEFT);

                $Categories[0]['total'] += $row['total'];
                $Categories[0]['status_green'] += $row['status_green'];
                $Categories[0]['status_red'] += $row['status_red'];

                $Categories[] = $row;
            }
        }

        if ($Categories[0]['total'] > 0) {
            $Categories[0]['status_green_percent'] = str_pad(
                    round(100 * ($Categories[0]['status_green'] / $Categories[0]['total']), 0), 2, '0', STR_PAD_LEFT);

            $Categories[0]['status_red_percent'] = str_pad(
                    round(100 * ($Categories[0]['status_red'] / $Categories[0]['total']), 0), 2, '0', STR_PAD_LEFT);
        }
        $this->set('categories', $Categories);
    }

    /**
     * Zeigt den Report 'Weitergabe' an.
     *
     * @author Dirk Herbes <d.herbes@fair-computer.de>
     */
    public function handover() {
        $this->tplFile = 'handover.tpl'; // Template File

        $tickets = array();

        $sql = sprintf('SELECT hm_Ticket.TicketDescr, hm_Ticket.ID,
                hm_Ticket.handover, hm_Categories.name category, hm_Users.name supporter FROM
                hm_Ticket LEFT JOIN hm_Categories ON
                hm_Ticket.CategoryID1 = hm_Categories.id LEFT JOIN hm_Users
                ON hm_Ticket.SupporterID = hm_Users.user_id
                WHERE (hm_Ticket.EditDate
                >= %s AND hm_Ticket.EditDate <= %s) AND (%s) AND Handover IS NOT
                NULL AND Handover <> \'\'', $this->startdate, $this->enddate, $this->user->getRightFilter());

        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $sql .= sprintf(' AND (UPPER(hm_Ticket.TicketDescr) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        }

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = $this->db->getOne($sqlCount);

        $pages = ceil((int) $Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        $sql .= ' ORDER BY ';

        switch (@$_REQUEST['sorting']) {
            case 'supporter':
                $sql .= 'hm_Users.name';
                break;
            case 'category':
                $sql .= 'hm_Categories.name';
                break;
            case 'handover':
                $sql .= 'hm_Ticket.Handover';
                break;
            case 'ID':
                $sql .= 'hm_Ticket.ID';
                break;
            default:
                $_REQUEST['sorting'] = 'TicketDescr';
                $sql .= 'hm_Ticket.TicketDescr';
                break;
        }
        $sql .= ' ' . $sortOrder;

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        $this->set('ReportingHeader', $this->user->gettext('Ticketweitergabe'));

        $this->set('ReportingSubpage', 'handover');

        $res = (@$_REQUEST['action'] == 'xls') ? $this->db->query($sql) : $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);

        $tickets = array();

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $tickets[] = $row;
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->HandoverExcelExport($tickets);
            exit;
        }

        $this->set('tickets', $tickets);
    }

    /**
     * Generiert die Excel-Datei fr 'Ticketweitergabe'.
     *
     * @param array $tickets
     */
    private function HandoverExcelExport($tickets) {
        include_once 'Spreadsheet/Excel/Writer.php';

        $workbook = new Spreadsheet_Excel_Writer();
        $workbook->send('ReportTicket.xls');
        $worksheet = & $workbook->addWorksheet('Handover');

        $format_bold = & $workbook->addFormat();
        $format_bold->setBold();

        $worksheet->writeString(0, 0, $this->user->gettext('Zeitraum vom:'), $format_bold);
        $worksheet->writeString(0, 1, $_SESSION['Reporting']['startdate']);
        $worksheet->writeString(1, 0, $this->user->gettext('bis zum:'), $format_bold);
        $worksheet->writeString(1, 1, $_SESSION['Reporting']['enddate']);

        $y = 4;
        $worksheet->writeString($y - 1, 0, $this->tools->html2text('Ticket'), $format_bold);
        $worksheet->writeString($y - 1, 1, $this->tools->html2text('ID'), $format_bold);
        $worksheet->writeString($y - 1, 2, $this->tools->html2text('Weitergabe'), $format_bold);

        if (count($tickets)) {
            foreach ($tickets as $ticket) {
                $worksheet->writeString($y, 0, $this->tools->html2text($ticket['ticketdescr']));
                $worksheet->writeNumber($y, 1, $this->tools->html2text($ticket['id']));
                $worksheet->writeString($y, 2, $this->tools->html2text($ticket['handover']));
                $y++;
            }
        }
        $workbook->close();
        exit;
    }

    /**
     * Zeigt den Report 'Priorittsnderung' an.
     * Bis Version 3.2: function history_prio()
     */
    public function priohistory() {
        $this->tplFile = 'history_prio.tpl'; // Template File

        $sql = sprintf('SELECT hm_Ticket.TicketDescr, p1.Descr, p2.Descr
                HPrioDescr, hm_Ticket.ID, hm_Ticket.TicketPrioID, %s
                TicketDesireDate, HistoryID, hm_TicketHistory.TicketPrioID
                HPrioID, %s HDesireDate FROM hm_Ticket LEFT JOIN (SELECT
                MIN(TicketHistoryID) HistoryID, ID FROM hm_TicketHistory
                GROUP BY ID) History ON History.ID = hm_Ticket.ID LEFT JOIN
                hm_TicketHistory ON (hm_TicketHistory.TicketHistoryID =
                HistoryID) LEFT JOIN hm_TicketPrio p1 ON (p1.TicketPrioID =
                hm_Ticket.TicketPrioID) LEFT JOIN hm_TicketPrio p2 ON
                (p2.TicketPrioID = hm_TicketHistory.TicketPrioID) WHERE
                HistoryID IS NOT NULL AND (%s) AND (hm_Ticket.EditDate >= %s
                AND hm_Ticket.EditDate <= %s) AND (hm_Ticket.TicketPrioID <>
                hm_TicketHistory.TicketPrioID OR hm_Ticket.TicketDesireDate <>
                hm_TicketHistory.TicketDesireDate)', $this->DB_CONVERT('hm_Ticket.TicketDesireDate'), $this->DB_CONVERT('hm_TicketHistory.TicketDesireDate'), $this->user->getRightFilter(), $this->startdate, $this->enddate);

        // Filtern der Eintraege
        if ($_SESSION['Reporting']['filter'] != '') {
            $sql .= sprintf(' AND (UPPER(hm_Ticket.TicketDescr) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        }

        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos + 1 > $pages) ? (($pages > 0) ? $pages - 1 : 0) : $pos;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        $sql .= ' ORDER BY ';

        switch (@$_REQUEST['sorting']) {
            case 'Prio':
                $sql .= 'p1.Descr';
                break;
            case 'HPrio':
                $sql .= 'p2.Descr';
                break;
            case 'TicketDesireDate':
                $sql .= 'hm_Ticket.TicketDesireDate';
                break;
            case 'HDesireDate':
                $sql .= 'hm_TicketHistory.TicketDesireDate';
                break;
            case 'ID':
                $sql .= 'hm_Ticket.ID';
                break;
            default:
                $_REQUEST['sorting'] = 'TicketDescr';
                $sql .= 'hm_Ticket.TicketDescr';
                break;
        }
        $sql .= ' ' . $sortOrder;

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);

        $res = (@$_REQUEST['action'] == 'xls') ? $this->db->query($sql) : $this->db->limitquery($sql, $pos * $this->EntriesPerPage, $this->EntriesPerPage);

        $tickets = array();

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $row['ticketdesiredate'] = date('d.m.Y H:i', strtotime(
                                $row['ticketdesiredate']));
                $row['hdesiredate'] = date('d.m.Y H:i', strtotime(
                                $row['hdesiredate']));
                $tickets[] = $row;
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->PrioExcelExport($tickets);
            exit;
        }
        $this->set('tickets', $tickets);
    }

    /**
     * Generiert die Excel-Datei fr 'Tickets je Prioritt'.
     * @param array $tickets
     */
    private function PrioExcelExport($tickets) {
        include_once 'Spreadsheet/Excel/Writer.php';

        $workbook = new Spreadsheet_Excel_Writer();
        $workbook->send('ReportTicket.xls');
        $worksheet = & $workbook->addWorksheet('PrioHistory');

        $format_bold = & $workbook->addFormat();
        $format_bold->setBold();

        $length = array();

        $worksheet->writeString(0, 0, $this->user->gettext('Zeitraum vom:'), $format_bold);
        $worksheet->writeString(0, 1, $_SESSION['Reporting']['startdate']);
        $worksheet->writeString(1, 0, $this->user->gettext('bis zum:'), $format_bold);
        $worksheet->writeString(1, 1, $_SESSION['Reporting']['enddate']);

        $y = 4;
        $worksheet->writeString($y - 1, 0, $this->tools->html2text('Ticket'), $format_bold);
        $worksheet->writeString($y - 1, 1, $this->tools->html2text('ID'), $format_bold);
        $worksheet->writeString($y - 1, 2, $this->tools->html2text('Priorit&auml;t [akt]'), $format_bold);
        $worksheet->writeString($y - 1, 3, $this->tools->html2text('Priorit&auml;t [alt]'), $format_bold);
        $worksheet->writeString($y - 1, 4, $this->tools->html2text('F&auml;lligkeit [akt]'), $format_bold);
        $worksheet->writeString($y - 1, 5, $this->tools->html2text('F&auml;lligkeit [alt]'), $format_bold);

        if (count($tickets)) {
            foreach ($tickets as $ticket) {
                $worksheet->writeString($y, 0, $this->tools->html2text($ticket['ticketdescr']));
                $worksheet->writeNumber($y, 1, $this->tools->html2text($ticket['id']));
                $worksheet->writeString($y, 2, $this->tools->html2text($ticket['descr']));
                $worksheet->writeString($y, 3, $this->tools->html2text($ticket['hpriodescr']));
                $worksheet->writeString($y, 4, $this->tools->html2text($ticket['ticketdesiredate']));
                $worksheet->writeString($y, 5, $this->tools->html2text($ticket['hdesiredate']));
                $y++;
            }
        }

        $workbook->close();
        exit;
    }

    /**
     * Bis Version 3.2: task: 'tickets' REQUEST['dating']
     */
    private function showDatingTickets() {

        //$this->pageTemplateFile = 'iframe.tpl';
        $this->tplFile = 'dating_list.tpl'; // Template File


        $mode = (@$_REQUEST['mode'] == 'green') ? 'green' : 'red';
        $dating = (string) @$_REQUEST['dating'];
        $uid = (int) @$_REQUEST['uid'];
        $cid = (int) @$_REQUEST['cid'];
        $conid = (int) @$_REQUEST['conid'];

        $this->set('mode', $mode);
        $this->set('dating', $dating);

        $tickets = array();

        // Erstellung der SQL-Statements
        $sql = sprintf('SELECT DISTINCT hm_Ticket.EscalationLevel,
                hm_Ticket.EscalationType, hm_Ticket.TicketDescr,
                hm_Ticket.ContactID, hm_Contacts.name Contact,
                hm_Contacts.important, hm_Ticket.SupporterID, hm_Users.name
                Supporter, hm_Company.company, hm_Ticket.TicketStatusID,
                hm_TicketStatus.Descr TStatus, hm_Ticket.TicketPrioID,
                hm_TicketPrio.Descr Priority, hm_Ticket.Published, %s
                OnHold, %s TicketDesireDate, hm_Ticket.CategoryID1, Cat1.name
                Category1, hm_Ticket.CategoryID2, Cat2.name Category2, %s
                CreateDate, %s EditDate, hm_Ticket.Expense, hm_Ticket.GroupID,
                hm_Groups.name GroupDescr, hm_Ticket.ID, %s DiffOnHold, %s
                UpdateDate, %s ProcessTime ', $this->DB_CONVERT('hm_Ticket.OnHold'), $this->DB_CONVERT('hm_Ticket.TicketDesireDate'), $this->DB_CONVERT('hm_Ticket.EditDate'), $this->DB_CONVERT('hm_Ticket.EditDate'), $this->DB_DATEDIFF('minute', $this->DB_DATE('now()'), 'hm_Ticket.OnHold'), $this->DB_CONVERT('hm_Ticket.UpdateDate'), $this->DB_DATEDIFF('minute', 'hm_Ticket.EditDate', 'hm_Ticket.UpdateDate'));

        // Auswahl der Tabellen
        $sql_from = ' FROM hm_Ticket
                        LEFT JOIN hm_Users ON hm_Users.user_id = hm_Ticket.SupporterID
                        LEFT JOIN hm_Contacts ON hm_Ticket.ContactID = hm_Contacts.contact_id
                        LEFT JOIN hm_TicketSupporter ON hm_Ticket.ID = hm_TicketSupporter.TicketID
                        LEFT JOIN hm_TicketGroup ON hm_Ticket.ID = hm_TicketGroup.TicketID
                        LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
                        LEFT JOIN hm_Categories Cat1 ON Cat1.id = hm_Ticket.CategoryID1
                        LEFT JOIN hm_Categories Cat2 ON Cat2.id = hm_Ticket.CategoryID2
                        LEFT JOIN hm_TicketStatus ON hm_Ticket.TicketStatusID = hm_TicketStatus.ID
                        LEFT JOIN hm_Groups ON hm_Ticket.GroupID = hm_Groups.group_id
                        LEFT JOIN hm_TicketPrio ON hm_Ticket.TicketPrioID = hm_TicketPrio.TicketPrioID ';

        // Die Ticketliste nach diesen Kriterien filtern
        $where = array();

        switch ($dating) {

            case 'user':
                if ($uid > 0) {
                    $where[] = sprintf(' hm_Ticket.ID IN (SELECT TicketID FROM hm_TicketSupporter WHERE UserID = %u) ', $uid);
                    $this->set('list_name', $this->db->getOne(sprintf('SELECT name FROM hm_Users WHERE user_id = %u', $uid)));
                }
                $this->set('list_field', 'uid');
                $this->set('list_value', $uid);
                break;

            case 'contact':
                if ($conid > 0) {
                    $where[] = sprintf(' hm_Ticket.ContactID = %u ', $conid);
                    $this->set('list_name', $this->db->getOne(sprintf('SELECT
                            name FROM hm_Contacts WHERE contact_id = %u', $conid)));
                }
                $this->set('list_field', 'conid');
                $this->set('list_value', $conid);
                break;

            default:
            case 'category':
                if ($cid > 0) {
                    $where[] = sprintf('(hm_Ticket.CategoryID1 = %u OR ' .
                            'hm_Ticket.CategoryID2 = %u)', $cid, $cid);
                    $this->set('list_name', $this->db->getOne(sprintf('SELECT
                            name FROM hm_Categories WHERE id = %u', $cid)));
                }
                $this->set('list_field', 'cid');
                $this->set('list_value', $cid);
                break;
        }

        $where[] = '(' . $this->user->getRightFilter() . ')';

        // Zeitlichebegrenzung
        $where[] = sprintf('(hm_Ticket.TicketDesireDate >= %s
                AND hm_Ticket.TicketDesireDate <= %s)', $this->startdate, $this->enddate);

        // Nur eigene Tickets anzeigen
        $myTickets = (int) @$_REQUEST['myTickets'];
        $this->set('myTickets', $myTickets);
        if ($myTickets == 1) {
            $where[] = sprintf(' hm_Ticket.ID IN (SELECT TicketID FROM hm_TicketSupporter WHERE UserID = %u) ', $this->user->UserID);
        }

        // Nach Prioritaet filtern
        $prioid = (int) @$_REQUEST['prioid'];
        $this->set('prioid', $prioid);
        if ($prioid > 0) {
            $where[] = sprintf('hm_Ticket.TicketPrioID = %u', $prioid);
        }

        $status_where = (count($where) > 0) ? ' WHERE ' . join(' AND ', $where) . ' ' : '';

        // Nach Status filtern
        $statusid = (int) @$_REQUEST['statusid'];
        $this->set('statusid', $statusid);
        if ($statusid != 0 && $statusid != 8 && $statusid != 99) {
            $where[] = sprintf('hm_Ticket.TicketStatusID = %u AND (%s <= 0
                    OR hm_Ticket.OnHold IS NULL)', $statusid, $this->DB_DATEDIFF('minute', $this->DB_DATE('now()'), 'hm_Ticket.OnHold'));
        } else if ($statusid == 8) { // Status ist OnHold
            $where[] = sprintf('%s > 0', $this->DB_DATEDIFF('minute', $this->DB_DATE('now()'), 'hm_Ticket.OnHold'));
        } else if ($statusid == 99) { // Alle Aktiven Tickets
            $where[] = 'hm_Ticket.TicketStatusID <> 3 AND
                    hm_Ticket.TicketStatusID <> 7';
        }

        if ($mode == 'green') {
            $where[] = sprintf('((hm_Ticket.TicketStatusID NOT IN (3,7,11) AND
                     DATEDIFF(dd, hm_Ticket.TicketDesireDate, %s) <= 0) OR
                    (hm_Ticket.TicketStatusID IN (3,7,11) AND DATEDIFF(dd,
                    hm_Ticket.TicketDesireDate, hm_Ticket.UpdateDate) <= 0))', $this->DB_DATE('now()'));
        } else {
            $where[] = sprintf('((hm_Ticket.TicketStatusID NOT IN (3,7,11) AND
                     DATEDIFF(dd, hm_Ticket.TicketDesireDate, %s) > 0) OR
                    (hm_Ticket.TicketStatusID IN (3,7,11) AND DATEDIFF(dd,
                    hm_Ticket.TicketDesireDate, hm_Ticket.UpdateDate) > 0))', $this->DB_DATE('now()'));
        }

        $sql_where = (count($where) > 0) ? ' WHERE ' . join(' AND ', $where) . ' ' : '';

        $entries = (int) $this->db->getOne('SELECT COUNT(*) ' . $sql_from . $sql_where);
        $pos = (int) @$_REQUEST['pos'];
        $EntriesPerPage = (int) @$_REQUEST['EntriesPerPage'];
        if ($EntriesPerPage <= 0)
            $EntriesPerPage = 10;
        if ($EntriesPerPage >= 50)
            $EntriesPerPage = 50;
        $pages = ceil($entries / $EntriesPerPage);
        if (($pos + 1) > $pages)
            $pos = $pages - 1;
        if ($pos < 0)
            $pos = 0;

        // Die Ticketliste entsprechend der Kriterien sortieren
        $sortorder = (@$_REQUEST['SortOrder'] == 'DESC') ? 'DESC' : 'ASC';
        $sort = @$_REQUEST['Sorting'];
        $sql_order = ' ORDER BY ';
        switch ($sort) {
            case "Status": $sqlo = 'TStatus';
                break;
            case "Priority": $sqlo = 'hm_Ticket.TicketPrioID';
                break;
            case "TicketDescr": $sqlo = 'hm_Ticket.TicketDescr';
                break;
            case "ID": $sqlo = 'hm_Ticket.ID';
                break;
//            case "Gruppe": $sqlo = 'hm_Groups.name';
//                break;
//            case "Name":
//                $sqlo = 'hm_Users.name';
//                $sort = 'Supporter';
//                break;
//            case "Supporter": $sqlo = 'hm_Users.name';
//                break;
            case "Contact": $sqlo = 'hm_Contacts.name';
                break;
            case "Company": $sqlo = 'hm_Company.company';
                break;
            case "Expense": $sqlo = 'hm_Ticket.Expense';
                break;
            case "ExpenseDate": $sqlo = 'hm_Ticket.Expense';
                break;
            case "ProcessTime":
            case "ProcessDate":
                $sqlo = '(' . $this->DB_DATEDIFF('minute', 'hm_Ticket.EditDate', 'hm_Ticket.UpdateDate') . ')';
                break;
            default:
                $_REQUEST['sorting'] = 'ID';
                $sqlo = 'hm_Ticket.ID';
                break;
        }
        $sql_order .= $sqlo . ' ' . $sortorder;
        $this->set('sort', $sort);
        $this->set('sortorder', $sortorder);

        // Die Tickets fuer die Darstellung holen
        $res = $this->db->limitQuery($sql . $sql_from . $sql_where . $sql_order, $pos * $EntriesPerPage, $EntriesPerPage);

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                // Zeitberechnung / Aufwand
                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten'])), 2, ',', '.') : '0,00';

                $Expense = $row['expense'];
                $row['expensedate']['days'] = floor($Expense / (60 * 24));
                $Expense -= $row['expensedate']['days'] * 60 * 24;
                $row['expensedate']['hours'] = floor($Expense / 60);
                $Expense -= $row['expensedate']['hours'] * 60;
                $row['expensedate']['minutes'] = $Expense;

                $ProcessTime = $row['processtime'];
                $row['processdate']['days'] = floor($ProcessTime / (60 * 24));
                $ProcessTime -= $row['processdate']['days'] * 60 * 24;
                $row['processdate']['hours'] = floor($ProcessTime / 60);
                $ProcessTime -= $row['processdate']['hours'] * 60;
                $row['processdate']['minutes'] = $ProcessTime;
                $tickets[] = $row;
            }
        }

        $this->set('tickets', $tickets);
        $this->set('EntriesPerPage', $EntriesPerPage);
        $this->set('entries', $entries);
        $this->set('pos', $pos);
        $this->set('pages', $pages);
        $this->set('prios', $this->getPrios());
        $this->set('status', $this->getStatus($status_where, $device));
    }

    /**
     * Liefert die Tickets fr den Report 'je Benutzer'.
     * Bis Version 3.2: function getUserTickets() - task: 'default', 'tuser'
     */
    public function tuser() {
        if (defined('HMCOMPANY') && (HMCOMPANY == 'MESSE DSSELDORF' || HMCOMPANY == 'BHS BAD HOMBURGER SERVICEGESELLSCHAFT')) {
            header('Location: index.php');
        }
        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'uid');

        $tickets = array();

        $where = sprintf(' (hm_TicketEvent.EventDate >= %s AND hm_TicketEvent.EventDate <= %s ) ', $this->startdate, $this->enddate);

        $where .= " AND hm_TicketEvent.Deleted IS NULL AND hm_TicketEvent.TicketStatusID <> 5";

        // Filtern der Eintr&auml;ge
        if (isset($_SESSION['Reporting']['filter']) && $_SESSION['Reporting']['filter'] != '') {
            $where .= sprintf(' AND (UPPER(hm_Users.name) LIKE UPPER(%s))', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] .
                            '%'));
        }
        $where .= ' AND (' . $this->user->getRightFilter() . ')';
        $where .= $this->showArchivedWhere;

        $sql = sprintf('
                SELECT
                    COUNT(DISTINCT TicketID) Anzahl,
                    SUM(Aufwand) Aufwand,
                    name,
                    UserID id,
                    SUM(ProcessTime) ProcessTime,
                    SUM(ProcessTime) / COUNT(DISTINCT TicketID) AvgProcessTime,
                    SUM(Kosten) Kosten,
                    SUM(DISTINCT TInfo.ExpExpense) ExpExpense
                FROM (
                    SELECT
                        hm_TicketEvent.TicketID,
                        hm_TicketEvent.UserID,
                        hm_Users.name,
                        SUM(hm_TicketEvent.Expense) Aufwand,
                        %s ProcessTime,
                        SUM(hm_TicketEvent.Expense * hm_TicketEvent.CostRatePerMinute) Kosten,
                        hm_Ticket.ExpExpense
                    FROM
                        hm_TicketEvent
                        INNER JOIN hm_Ticket ON hm_Ticket.ID = hm_TicketEvent.TicketID
                        INNER JOIN hm_Users ON hm_Users.user_id = hm_TicketEvent.UserID
                        LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                        LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
                    WHERE
                        %s
                    GROUP BY
                        hm_TicketEvent.TicketID,
                        hm_TicketEvent.UserID,
                        hm_Users.name,
                        hm_Ticket.EditDate,
                         hm_Ticket.TicketStatusID,
                        hm_Ticket.UpdateDate,
                        hm_Ticket.ExpExpense
                ) TInfo
                GROUP BY
                    name,
                    UserID', $this->getProcessTimeSQLString(), $where);

        // Zeitlichebegrenzung
        $sqlCount = sprintf('
                SELECT
                    COUNT(*)
                FROM (
                    SELECT
                        hm_TicketEvent.UserID
                    FROM
                        hm_TicketEvent
                        INNER JOIN hm_Users ON hm_Users.user_id = hm_TicketEvent.UserID
                        INNER JOIN hm_Ticket ON hm_TicketEvent.TicketID = hm_Ticket.ID
			LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                    LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
                    WHERE
                        %s
                    GROUP BY
                        hm_TicketEvent.UserID
                ) TInfo', $where);

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 0) : $pos;
        $pos = ($pos > 0) ? $pos : 1;
        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $sql .= ' ORDER BY ';
        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {
            case 'COSTS': $sql .= 'Kosten';
                break;
            case 'EXPENSE': $sql .= 'Aufwand';
                break;
            case 'COUNT': $sql .= 'Anzahl';
                break;
            case 'PROCESSTIME': $sql .= 'ProcessTime';
                break;
            case 'AVGPROCESSTIME': $sql .= 'AvgProcessTime';
                break;
            case 'EXPEXPENSE': $sql .= 'ExpExpense';
                break;

            case 'KOSTEN': $sql .= 'Kosten';
                break;
            default: $sql .= 'name';
                $_REQUEST['sorting'] = 'Name';
                break;
        }
        $sql .= ' ' . $sortOrder;

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);

        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }

        // SQL-Abfrage absetzen
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];
                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') ||
                        HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] /
                                    60) . ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor(
                                    (int) $row['avgprocesstime'] / 60) . ':' . str_pad((
                                    (int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) .
                        ':' . str_pad(($row['expense'] - floor($row['expense'] /
                                        60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' .
                            $row['aufwand'];
                }
                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' .
                            $row['aufwand'];
                }
                $tickets[] = $row;
            }
        } else {
            $this->log->log('Reporting: Cant fetch reports for user. Message: ' . $res->getMessage(), PEAR_LOG_ERR);
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandBenutzer', 'Benutzer');
        }

        $this->set('ReportingSubpage', 'tuser');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Benutzer'));
        $this->set('GridHeader', $this->user->gettext('Benutzer'));

        if (@$_REQUEST['action'] == 'print') {
            $tickets = $tickets;
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }

        $this->set('tickets', $tickets);
    }

    /**
     * Report je LDAP-Device
     */
    public function tldapdev() {

        if (!$this->user->Security->LDAP) {
            header('Location: index.php');
        }

        $this->tplFile = 'reportingtickets.tpl'; // Template File
        $this->set('list_field', 'tldapdev');

        $sql = sprintf('
            SELECT
                SUM(DISTINCT hm_Ticket.expExpense) ExpExpense, COUNT(DISTINCT hm_Ticket.ID) Anzahl,
                hm_LDAPDevices.Name ,
                hm_LDAPDevices.DeviceID id,
                SUM(%s) ProcessTime,
                SUM(%s) / COUNT(DISTINCT hm_Ticket.ID) AvgProcessTime,
                SUM(TE.Aufwand) Aufwand,
                SUM(TE.Kosten) Kosten,
                hm_LDAPDevices.Type TypeName
            FROM
                hm_Ticket
                    INNER JOIN hm_TicketLDAPDevice TicketDevices ON hm_Ticket.ID = TicketDevices.TicketID
                    LEFT JOIN hm_LDAPDevices ON hm_LDAPDevices.DeviceID = TicketDevices.DeviceID
                    LEFT JOIN (
                        SELECT TicketID, SUM(Expense * CostRatePerMinute) Kosten, SUM(Expense) Aufwand
                        FROM hm_TicketEvent
                        WHERE Deleted IS NULL OR Deleted = 0
                        Group BY TicketID
                      ) TE ON TE.TicketID = hm_Ticket.ID
                LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID
                    LEFT JOIN hm_TicketSupporter ON hm_Ticket.ID = hm_TicketSupporter.TicketID
                    LEFT JOIN hm_TicketGroup ON hm_Ticket.ID = hm_TicketGroup.TicketID
                    LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID
            WHERE 1=1 ', $this->getProcessTimeSQLString(), $this->getProcessTimeSQLString());

        // Zeitlichebegrenzung
        $sql .= sprintf(' AND (hm_Ticket.EditDate >= %s AND hm_Ticket.EditDate <= %s)', $this->startdate, $this->enddate);

        $sql .= ' AND (' . $this->user->getRightFilter() . ')';
        $sql .= $this->showArchivedWhere;

        $DeviceIDs = @$_REQUEST['DeviceIDs'];
        if (false !== array_search("0", $DeviceIDs)) {
            $DeviceIDs = array();
        }
        $this->set('DeviceIDs', $DeviceIDs);

        if (count($DeviceIDs) > 0) {
            $sql .= sprintf(' AND TicketDevices.DeviceID IN (%s)', implode(',', array_map('intval', $DeviceIDs)));
        }

        // Filtern der Eintr&auml;ge
        if ($_SESSION['Reporting']['filter'] != '') {
            $filter = sprintf(' AND ( UPPER(hm_LDAPDevices.Name) LIKE UPPER(%s) OR UPPER(hm_LDAPDevices.Type) LIKE UPPER(%s) )', $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'), $this->db->quoteSmart('%' . $_SESSION['Reporting']['filter'] . '%'));
        } else {
            $filter = '';
        }
        $sql .= $filter;


        $sql .= ' GROUP BY hm_LDAPDevices.DeviceID, hm_LDAPDevices.Name, hm_LDAPDevices.Type';


        $sqlCount = 'SELECT COUNT(*) FROM (' . $sql . ') TCount';
        $sql = sprintf('SELECT Anzahl, name, id, ProcessTime,
                                    AvgProcessTime,
                                    Kosten, Aufwand, TypeName, ExpExpense
                                 FROM (%s) TInfo', $sql);

        // Paging Informationen ermitteln
        $pos = (int) @$_REQUEST['pos'];
        $Entries = (int) $this->db->getOne($sqlCount);
        $pages = ceil($Entries / $this->EntriesPerPage);
        $pos = ($pos > $pages) ? (($pages > 0) ? $pages : 1) : $pos;
        $pos = ($pos > 0) ? $pos : 1;

        $sortOrder = (@$_REQUEST['sortOrder'] == 'DESC') ? 'DESC' : 'ASC';

        // Sortierung wird hier vorgenommen
        switch (strtoupper(@$_REQUEST['sorting'])) {

            case 'COSTS':
                $sql .= sprintf(' ORDER BY Kosten %s', $sortOrder);
                break;

            case 'TYPE':
                $sql .= sprintf(' ORDER BY TypeName %s', $sortOrder);
                break;

            case 'EXPENSE':
                $sql .= sprintf(' ORDER BY Aufwand %s', $sortOrder);
                break;

            case 'COUNT':
                $sql .= sprintf(' ORDER BY Anzahl %s', $sortOrder);
                break;

            case 'PROCESSTIME':
                $sql .= sprintf(' ORDER BY ProcessTime %s', $sortOrder);
                break;

            case 'AVGPROCESSTIME':
                $sql .= sprintf(' ORDER BY AvgProcessTime %s', $sortOrder);
                break;
            case 'EXPEXPENSE':
                $sql .= sprintf(' ORDER BY expexpense %s', $sortOrder);
                break;
            default:
                $_REQUEST['sorting'] = 'Name';
                $sql .= sprintf(' ORDER BY name %s', $sortOrder);
                break;
        }

        $this->set('pages', $pages);
        $this->set('pos', $pos);
        $this->set('entries', $Entries);
        $this->set('Paging', $this->tools->Paging($pages, $pos));

        $this->set('sortOrder', $sortOrder);
        $this->set('sorting', @$_REQUEST['sorting']);
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<pre>$sql</pre>";
        }
        if (isset($_REQUEST['action']) && ($_REQUEST['action'] == 'xls' || $_REQUEST['action'] == 'print')) {
            $res = $this->db->query($sql);
        } else {
            $res = $this->db->limitquery($sql, ($pos - 1) * $this->EntriesPerPage, $this->EntriesPerPage);
        }

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                $row['kosten'] = ($this->user->hasRight(48)) ? number_format(round($this->tools->toFloat($row['kosten']), 2), 2, ',', '.') : '0,00';

                $row['expense'] = $row['aufwand'];

                $Tage = floor($row['aufwand'] / (60 * 24));
                $row['aufwand'] -= $Tage * 60 * 24;
                $Stunden = floor($row['aufwand'] / 60);
                $row['aufwand'] -= $Stunden * 60;
                $Minuten = $row['aufwand'];

                if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                    $row['processtime'] = floor((int) $row['processtime'] / 60) .
                            ':' . str_pad(((int) $row['processtime'] % 60), 2, '0', STR_PAD_LEFT);
                    $row['avgprocesstime'] = floor((int) $row['avgprocesstime'] / 60) .
                            ':' . str_pad(((int) $row['avgprocesstime'] % 60), 2, '0', STR_PAD_LEFT);
                }

                $MinutenStr = ($Minuten != 1) ? $this->user->gettext('Minuten') : $this->user->gettext('Minute');
                $row['aufwand'] = $Minuten . ' ' . $MinutenStr;

                $row['zeitaufwandstunden'] = (floor($row['expense'] / 60)) . ':' .
                        str_pad(($row['expense'] - floor($row['expense'] / 60) * 60), 2, '0', STR_PAD_LEFT);

                if ($Stunden > 0 || $Tage > 0) {
                    $StundenStr = ($Stunden != 1) ? $this->user->gettext('Stunden') : $this->user->gettext('Stunde');
                    $row['aufwand'] = $Stunden . ' ' . $StundenStr . ' ' . $row['aufwand'];
                }

                if ($Tage > 0) {
                    $TageStr = ($Tage != 1) ? $this->user->gettext('Tage') : $this->user->gettext('Tag');
                    $row['aufwand'] = $Tage . ' ' . $TageStr . ' ' . $row['aufwand'];
                }
                $tickets[] = $row;
                $LDAPDevices[$row['id']] = $row['name'];
            }
        } else {
            if ($this->Debug) {
                echo "<pre>$sql</pre> - " . $res->getMessage();
            }
        }

        if (@$_REQUEST['action'] == 'xls') {
            $this->ExcelExportExpense($tickets, 'AufwandLDAPDevice', 'LDAP-Devices');
        }

        $this->set('ReportingSubpage', 'tldapdev');
        $this->set('ReportingHeader', $this->user->gettext('Tickets je Gert'));
        $this->set('GridHeader', $this->user->gettext('Gerte'));
        $this->set('LDAPDevList', $this->getLDAPDevices());

        if (@$_REQUEST['action'] == 'print') {
            $tickets = $tickets;
            $this->set('tickets', $tickets);
            $this->pageTemplateFile = 'dynamic.tpl';
            $this->tplFile = 'print.tpl'; // Template File
            return TRUE;
        }

        $this->set('tickets', $tickets);
    }

    private function getLDAPDevices() {
        $Devices = array();
        $sql = sprintf('SELECT D.DeviceID, D.DeviceID, D.Name, D.Type '
                . 'FROM hm_LDAPDevices D '
                . 'INNER JOIN hm_TicketLDAPDevice TD ON D.DeviceID = TD.DeviceID '
                . 'WHERE TD.TicketID > 0');
        $res = $this->db->query($sql);
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $Devices[$row['deviceid']] = $row['name'];
            }
        }
        return $Devices;
    }

    function encode_items(&$item, $key) {
        $item = utf8_encode($item);
    }

// }}}

    /**
     * Liefert die benutzerdefinierten ZeitPerioden.
     * Daten fr die eintrge aus der Tabelle hm_TimePeriod
     * @param type $id
     * @param type $start_else_end
     * @return boolean
     */
    private function getTimePeriods($id = false, $start_else_end = true) {

        $s = array(0 => 'Tag', 1 => 'Wochenanfang', 2 => 'Monatsanfang');
        $timing_add = array();

        if ($id)
            $res = $this->db->query('SELECT ID, Name, start_date "start", start_months, start_weeks, start_days, end_months, end_weeks, end_days, published FROM hm_TimePeriod WHERE id = ' . (int) $id);
        else
            $res = $this->db->query('SELECT ID, Name, start_date "start", start_months, start_weeks, start_days, end_months, end_weeks, end_days, published FROM hm_TimePeriod WHERE published = 1');

        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {

                //Beispiel:
                if ($row['start'] == 1) {
                    //Begin am Wochenanfang
                    $start = date('d.m.Y', strtotime("last Monday " . -$row['start_months'] . ' Month ' . -$row['start_weeks'] . ' weeks ' . -$row['start_days'] . ' Days '));
                } else if ($row['start'] == 2) {
                    //Begin am Monatsanfang
                    $start = date('01.m.Y', strtotime(-$row['start_months'] . ' Month ' . -$row['start_weeks'] . ' weeks ' . -$row['start_days'] . ' Days '));
                } else {
                    $start = date('d.m.Y', strtotime(-$row['start_months'] . ' Month ' . -$row['start_weeks'] . ' weeks ' . -$row['start_days'] . ' Days '));
                }

                $start_a = explode('.', $start);
                $ts_end = mktime(00, 00, 00, $start_a[1] + $row['end_months'], $start_a[0] + ($row['end_days'] + ($row['end_weeks'] * 7) - 1 ), $start_a[2]);
                $end = date('d.m.Y', $ts_end);

                $timing_add[$row['name']] = array(
                    'id'    => $row['id'],
                    'start' => $start,
                    'end'   => $end
                );
            }
        }
        if (!count($timing_add))
            return false;

        if ($id) {
            return ($start_else_end) ? $start . ' 00:00:00' : $end . ' 23:59:59';
        } else {
            return (count($timing_add) > 0) ? $timing_add : false;
        }
    }

    /**
     * Gibt eine Excel-Datei mit Ticketdaten aus.
     *
     * @param array $data Tickets
     * @param string $title
     * @param string $subject
     */
    private function ExcelExportExpense($data, $title = 'AufwandBenutzer', $subject = 'Benutzer') {

        if ($this->Debug)
            $this->log->log('ExcelExportExpense Request: ' . print_r($_REQUEST, true), PEAR_LOG_DEBUG);
//if($this->Debug) $this->log->log('ExcelExportExpense Data'.print_r($data, true), PEAR_LOG_DEBUG);

        include_once 'Spreadsheet/Excel/Writer.php';

        $workbook = new Spreadsheet_Excel_Writer();
        $workbook->send('ReportTicket.xls');
        $worksheet = & $workbook->addWorksheet($title);

        $length = array();

        $format_bold = & $workbook->addFormat();
        $format_bold->setBold();

        $format_right = & $workbook->addFormat();
        $format_right->setAlign('right');

        $worksheet->writeString(0, 0, $this->user->gettext('Zeitraum vom:'), $format_bold);
        $worksheet->writeString(0, 1, $_SESSION['Reporting']['startdate']);
        $worksheet->writeString(1, 0, $this->user->gettext('bis zum:'), $format_bold);
        $worksheet->writeString(1, 1, $_SESSION['Reporting']['enddate']);

        $y = 4;
        $Benutzer = $this->user->gettext($subject);
        $Firma = $this->user->gettext('Firma');
        $Anzahl = $this->user->gettext('Anzahl Tickets');
        $Aufwand = (true) ? $this->user->gettext('Zeitaufwand') : '';
        $AufwandMin = (true) ? $this->user->gettext('Zeitaufwand [m]') : '';
        $AufwandStd = (true) ? $this->user->gettext('Zeitaufwand [h]') : '';
        $ErwAufwand = (true) ? $this->user->gettext('Erw. Aufwand') : '';
        $Kosten = $this->user->gettext('Kosten');
        $Liegezeit = $this->user->gettext('Liegezeit [h]');
        $Liegezeitavg = $this->user->gettext('Durchschnittliche Liegezeit');

        $j = 0;
        $length[$j++] = strlen($Benutzer);
        if ($Benutzer == 'Kontakt') {
            $length[$j++] = strlen($Firma);
        }

        $i = 0;
        if ($title == 'AufwandGeraet') {
            $Geraetetyp = $this->user->gettext('Ger&auml;tetyp');
            $length[$j++] = strlen($Geraetetyp);
            $i += 1;
        }
        $length[$j++ + $i] = strlen($Anzahl);

        if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
            if ($this->user->hasRight(48)) {
                $length[$j++ + $i] = strlen($Aufwand);
                $length[$j++ + $i] = strlen($AufwandMin);
                $length[$j++ + $i] = strlen($AufwandStd);
                $length[$j++ + $i] = strlen($Kosten);
                $length[$j++ + $i] = strlen($ErwAufwand);
            }
            $length[$j++ + $i] = strlen($Liegezeit);
            $length[$j++ + $i] = strlen($Liegezeitavg);
        } else {
            if ($this->user->hasRight(48)) {
                $length[$j++ + $i] = strlen($AufwandMin);
                $length[$j++ + $i] = strlen($Kosten);
            }
        }

        $k = 0;
        $worksheet->writeString($y - 1, $k++, $Benutzer, $format_bold);

        if ($title == 'AufwandGeraet') {
            $worksheet->writeString($y - 1, $k++, $Geraetetyp, $format_bold);
        }

        if ($Benutzer == 'Kontakt') {
            $worksheet->writeString($y - 1, $k++ + $i, $Firma, $format_bold);
        }

        $worksheet->writeString($y - 1, $k++ + $i, $Anzahl, $format_bold);
        if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
            if ($this->user->hasRight(48)) {
                if (true) {
                    $worksheet->writeString($y - 1, $k++ + $i, $Aufwand, $format_bold);
                }
                if (true) {
                    $worksheet->writeString($y - 1, $k++ + $i, $AufwandMin, $format_bold);
                }
                if (true) {
                    $worksheet->writeString($y - 1, $k++ + $i, $AufwandStd, $format_bold);
                }
                $worksheet->writeString($y - 1, $k++ + $i, $Kosten, $format_bold);
                $worksheet->writeString($y - 1, $k++ + $i, $ErwAufwand, $format_bold);
            }
            $worksheet->writeString($y - 1, $k++ + $i, $Liegezeit, $format_bold);
            $worksheet->writeString($y - 1, $k++ + $i, $Liegezeitavg, $format_bold);
        } else {
            if ($this->user->hasRight(48)) {
                $worksheet->writeString($y - 1, 2 + $i, $AufwandMin, $format_bold);
                $worksheet->writeString($y - 1, 3 + $i, $Kosten, $format_bold);
            }
        }

        foreach ($data as $val) {
            $l = 0;
            if (strlen($val['name']) > $length[$l])
                $length[$l] = strlen($val['name']);
            $l++;
            if ($Benutzer == 'Kontakt') {
                if (strlen($val['company']) > $length[$l])
                    $length[$l] = strlen($val['company']);
                $l++;
            }
            if ($title == 'AufwandGeraet') {
                if (strlen($val['typename']) > $length[$l])
                    $length[$l] = strlen($val['typename']);
                $l++;
            }

            if (strlen($val['anzahl']) > $length[$l + $i])
                $length[$l + $i] = strlen($val['anzahl']);
            $l++;
            if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                if ($this->user->hasRight(48)) {
                    if (true) {
                        if (strlen($val['aufwand']) > $length[$l + $i])
                            $length[$l + $i] = strlen($val['aufwand']);
                        $l++;
                    }
                    if (true) {
                        if (strlen($val['expense']) > $length[$l + $i])
                            $length[$l + $i] = strlen($val['expense']);
                        $l++;
                    }
                    if (true) {
                        if (strlen($val['zeitaufwandstunden']) > $length[$l + $i])
                            $length[$l + $i] = strlen($val['zeitaufwandstunden']);
                        $l++;
                    }
                    if (strlen($val['kosten']) > $length[$l + $i])
                        $length[$l + $i] = strlen(number_format($val['kosten'], 2, ',', '.') . " " . $this->user->getCurrencyDescr());
                    $l++;
                    if (strlen($val['expexpense']) > $length[$l + $i])
                        $length[$l + $i] = strlen($val['expexpense']);
                    $l++;
                }
                if (strlen($val['processtime']) > $length[$l + $i])
                    $length[$l + $i] = strlen($val['processtime']);
                $l++;
                if (strlen($val['avgprocesstime']) > $length[$l + $i])
                    $length[$l + $i] = strlen($val['avgprocesstime']);
            } else {
                if ($this->user->hasRight(48)) {
                    if (strlen($val['expense']) > $length[$l + $i])
                        $length[$l + $i] = strlen($val['expense']);
                    $l++;
                    if (strlen($val['kosten']) > $length[$l + $i])
                        $length[$l + $i] = strlen($val['kosten']);
                    $l++;
                }
            }
            $m = 0;

            $worksheet->writeString($y, $m++, $val['name']);
            if ($Benutzer == 'Kontakt') {
                $worksheet->writeString($y, $m++, $val['company']);
            }
            if ($title == 'AufwandGeraet') {
                $worksheet->writeString($y, $m++, $val['typename']);
            }

            $worksheet->writeNumber($y, $m++ + $i, $val['anzahl']);
            if (!defined('HMCOMPANY') || HMCOMPANY != 'LANDKREIS SCHAUMBURG') {
                if ($this->user->hasRight(48)) {
                    if (true) {
                        $worksheet->writeString($y, $m++ + $i, $val['aufwand'], $format_right);
                    }
                    if (true) {
                        $worksheet->writeNumber($y, $m++ + $i, $val['expense']);
                    }
                    if (true)
                        $worksheet->writeString($y, $m++ + $i, $val['zeitaufwandstunden']);
                    $val['kosten'] = str_replace('.', '', $val['kosten']);
                    $val['kosten'] = str_replace(',', '.', $val['kosten']);
                    //$this->log->log('val[\'kosten\'] '.print_r($val['kosten'], true), PEAR_LOG_DEBUG);
                    $worksheet->writeNumber($y, $m++ + $i, $val['kosten'] . " ");
                    $worksheet->writeNumber($y, $m++ + $i, $val['expexpense']);
                }
                $worksheet->writeString($y, $m++ + $i, $val['processtime']);
                $worksheet->writeString($y, $m++ + $i, str_replace(array('.', ','), array('', '.'), $val['avgprocesstime']));
            } else {
                if ($this->user->hasRight(48)) {
                    $worksheet->writeNumber($y, $m++ + $i, $val['expense']);
                    $worksheet->writeNumber($y, $m++ + $i, str_replace(array('.', ','), array('', '.'), $val['kosten']));
                }
            }

            $y++;
        }


        foreach ($length as $key => $val) {
            $worksheet->setColumn($key, $key, $val);
        }

        $workbook->close();
        exit;
    }

    /**
     * Ermittelt die Tickets einer bestimmten Kategorie.
     *
     * @param type $CatID
     * @return array $TicketIDs
     */
    private function getTicketIDsForCat($CatID) {
        //Alle Tickets aller Kategorien ermitteln:
        //Fr jede CatID:
        $TicketIDs = array();
        $sql = sprintf('SELECT DISTINCT T.ID
            FROM hm_Categories n
            	INNER JOIN hm_Categories p ON (n.lft BETWEEN p.lft AND p.rgt) AND p.root_id = n.root_id
            	INNER JOIN hm_Ticket T ON ((T.CategoryID1 = n.id OR T.CategoryID2 = n.id))
            WHERE p.id = %u', $CatID);

        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n<hr />" . __FUNCTION__ . ": $sql<hr />";
        }

        $res2 = $this->db->query($sql);
        if (!DB::isError($res2)) {
            while ($row2 = $res2->fetchrow(DB_FETCHMODE_ASSOC)) {
                if (!in_array($row2['id'], $TicketIDs))
                    $TicketIDs[] = $row2['id'];
            }
        }
        if (count($TicketIDs) === 0) {
            $TicketIDs[] = 0;
        }
        return $TicketIDs;
    }

    /**
     * Liefert die Device-Typen aus AssetDesk.
     * @return array
     */
    private function getDeviceTypes() {
        if ($this->DBVersion >= 3) {
            $sql = 'SELECT TypeName, DeviceType.DeviceTypeID
                    FROM DeviceType
                        INNER JOIN Device ON Device.DeviceTypeID = DeviceType.DeviceTypeID
                        INNER JOIN hm_TicketDevice ON Device.DeviceID = hm_TicketDevice.DeviceID
                    GROUP BY DeviceType.TypeName, DeviceType.DeviceTypeID
                    ORDER BY DeviceType.TypeName ASC';
        } else {
            $sql = 'SELECT TypeName, TypeID
                    FROM DeviceType
                        INNER JOIN Device ON Device.ICCMDeviceType = DeviceType.TypeID
                        INNER JOIN hm_TicketDevice ON Device.DevID = hm_TicketDevice.DeviceID
                    GROUP BY DeviceType.TypeName, DeviceType.TypeiD
                    ORDER BY DeviceType.TypeName ASC';
        }

        $res = $this->db->query($sql);
        $DeviceTypes = array();
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $DeviceTypes[] = $row;
            }
        }
        return $DeviceTypes;
    }

    /**
     * Liefert die Prioritts-Daten aus der HM-Tabelle hm_TicketPrio.
     * @author Dirk Herbes <d.herbes@fair-computer.de>
     * @return array $prios
     */
    private function getPrios() {
        $prios = array();
        $res = $this->db->query('SELECT * FROM hm_TicketPrio ORDER BY Ordering');
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $prios[] = $row;
            }
        }
        return $prios;
    }

    /**
     * Liefert die Heinzelmann-Kategorien.
     * @return array
     */
    private function getCategories() {
        $Cats = array();
        $sql = sprintf('SELECT id, name FROM hm_Categories ORDER BY Name');
        $res = $this->db->query($sql);
        while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
            $Cats[$row['id']] = $row['name'];
        }
        return $Cats;
    }

    /**
     * Liefert die verwendeten TicketStatus.
     *
     * @author Dirk Herbes <d.herbes@fair-computer.de>
     * @param string $where
     * @param boolean $device
     * @return array
     */
    private function getStatus($where, $device = false) {

        $status = array();

        if ($device) {
            $where = ' INNER JOIN hm_TicketDevice ON hm_Ticket.ID = hm_TicketDevice.TicketID ' . $where;
        }

        $sql = 'SELECT TicketStatusID, Descr, COUNT(*) Anzahl
                FROM hm_Ticket
                    INNER JOIN hm_TicketStatus ON hm_TicketStatus.ID =  hm_Ticket.TicketStatusID '
                . $where .
                ' GROUP BY TicketStatusID, Descr
                ORDER BY Descr';

        $res = $this->db->query($sql);
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $status[] = $row;
            }
        }
        return $status;
    }

    /**
     * Liefert die als Supporter verwendeten Benutzer.
     * @return array
     */
    private function getSupporters() {
        $Users = array('NULL' => "Ohne Supporter");
        $sql = sprintf('SELECT DISTINCT username name, user_id ID
                        FROM hm_TicketSupporter
                            INNER JOIN hm_Users ON hm_Users.user_id = hm_TicketSupporter.UserID');
        $res = $this->db->query($sql);
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $Users[$row['id']] = $row['name'];
            }
        }
        return $Users;
    }

    /**
     * Liefert die Gruppen.
     * @return array
     */
    private function getGroups() {
        $Groups = array('NULL' => "Ohne Gruppe");
        $sql = sprintf('SELECT DISTINCT name, group_id ID
                        FROM hm_TicketGroup
                            INNER JOIN hm_Groups ON hm_TicketGroup.GroupID = hm_Groups.group_id');

        $res = $this->db->query($sql);
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $Groups[$row['id']] = $row['name'];
            }
        }
        return $Groups;
    }

    /**
     * Liefert die verwendeten Tags.
     * @return array
     */
    private function getTags() {
        $Tags = array();
        $sql = sprintf('SELECT DISTINCT '
                . 'hm_Tags.Tag , hm_Tags.ID '
                . 'FROM hm_Ticket '
                . 'INNER JOIN hm_TicketTags TT ON hm_Ticket.ID = TT.TagID '
                . 'LEFT JOIN hm_Tags ON hm_Tags.ID = TT.TagID '
                . 'LEFT JOIN hm_Contacts ON hm_Contacts.contact_id = hm_Ticket.ContactID '
                . 'LEFT JOIN hm_TicketSupporter ON hm_Ticket.ID = hm_TicketSupporter.TicketID '
                . 'LEFT JOIN hm_TicketGroup ON hm_Ticket.ID = hm_TicketGroup.TicketID '
                . 'LEFT JOIN hm_Company ON hm_Company.CompanyID = hm_Contacts.CompanyID '
                . 'WHERE %s '
                . 'ORDER BY Tag', $this->user->getRightfilter());
        if ($this->Debug) {
            echo "--" . __LINE__ . ": " . __FUNCTION__ . "<br/>\n getTags sql: $sql";
        }
        $res = $this->db->query($sql);
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $Tags[$row['id']] = $row['tag'];
            }
        }
        return $Tags;
    }

    /**
     * Liefert die 'Eltern' einer Kategorie als String mit Pfeilen.
     * Beispiel: root-->SubCat-->SubSubCat->
     * @param int $CatID
     * @return string
     */
    private function getCatPath($CatID) {
        $Path = "";

        require_once _HM_INCLUDES . 'nestedsets.php';

        $nestedset = new NestedSet('hm_Categories', $this->db, array('fields' => array('name')));
        $Parents = $nestedset->getParents($CatID);
        $ParentNames = array();
        if (0 < count($Parents)) {
            foreach ($Parents As $key => $value) {
                $ParentNames[] = $value['name'];
            }
            $Path = implode('-->', $ParentNames);
            $Path .= '-->';
        }
        return $Path;
    }

    public function TicketReports() {

        if (!$this->user->inGroup(1)) {
            header('Location: index.php');
        }
        $this->tplFile = 'FHDReport.tpl'; // Template File
        //$this->startdate = $this->tools->ToUnixTimestamp( $_SESSION['Reporting']['startdate'] . ' 00:00:00');
        //$this->enddate = $this->tools->ToUnixTimestamp($_SESSION['Reporting']['enddate'] . ' 00:00:00');
        $StartDate = $_SESSION['Reporting']['startdate'] . ' 00:00:00';
        $EndDate = $_SESSION['Reporting']['enddate'] . ' 23:59:59';
        $this->startdate = $this->tools->ToUnixTimestamp($StartDate);
        $this->enddate = $this->tools->ToUnixTimestamp($EndDate);
        $tmpDate = $this->startdate;

        $BetweenClause = sprintf(" BETWEEN %s AND %s ", $this->DB_DATE($StartDate), $this->DB_DATE($EndDate));

        $res = $this->db->query("SELECT USER_ID, username, name FROM hm_Users");
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $SupporterArray[$row['user_id']] = $row['name'];
            }
            $SupporterArray[0] = "-- Ohne Supporter --";
        }
        $res = $this->db->query("SELECT group_id, name FROM hm_Groups");
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $GroupArray[$row['group_id']] = $row['name'];
            }
            $GroupArray[0] = "-- Ohne Gruppe --";
        }

        $SupporterReportComplete = array();

        $SupporterReport = array();
        /*
          cntTuochedTickets:
          Anzahl der Tickes in denen der Supporter min. eine Bearbeitung gettigt hat
          => EditDate, CreateUserID der TicketEvents
         */
        $sql = sprintf("SELECT CONVERT(varchar(10), EventDate, 104) Datum, CreateUserID SupporterID, COUNT(DISTINCT TicketID) 'AnzahlTickets'"
                . "FROM hm_TicketEvent TE "
                . "WHERE  EventDate %s "
                . "GROUP BY CreateUserID, CONVERT(varchar(10), EventDate, 104) "
                . "ORDER BY Datum", $BetweenClause);
        $SQLS .= "<br />--Anzahl der Tickes in denen der Supporter min. eine Bearbeitung gettigt hat:<br /> --$sql<br />";
        $res = $this->db->query($sql);
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $SupporterReport[$row['datum']][$row['supporterid']]['cntTuochedTickets'] += $row['anzahltickets'];
                $SupporterReportComplete[$row['supporterid']]['cntTuochedTickets'] += $row['anzahltickets'];
            }
        }
        /*
          cntCreatedFor
          Anzahl der Tickets die fr einen Supporter erstellt wurden
          => CreateDate, Supporterid Tickets
         */
        $sql = sprintf("SELECT CONVERT(varchar(10), T.EditDate, 104) Datum, ISNULL(TS.UserID, 0) SupporterID, COUNT(DISTINCT ID) 'AnzahlTickets' "
                . "FROM hm_Ticket T "
                . "LEFT JOIN hm_TicketSupporter TS ON T.ID = TS.TicketID "
                . "WHERE T.EditDate %s "
                . "GROUP BY ISNULL(TS.UserID, 0), CONVERT(varchar(10), T.EditDate, 104) "
                . "ORDER BY Datum", $BetweenClause);
        $SQLS .= "<br />--Anzahl der Tickets die fr einen Supporter erstellt wurden:<br /> --$sql<br />";
        $res = $this->db->query($sql);
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $SupporterReport[$row['datum']][$row['supporterid']]['cntCreatedFor'] += $row['anzahltickets'];
                $SupporterReportComplete[$row['supporterid']]['cntCreatedFor'] += $row['anzahltickets'];
            }
        }

        /*
          cntCreatedFrom
          Anzahl der Tickets, die ein Supporter erstellt hat
          => CreateDate, CreateUserID Tickets
         */
        $sql = sprintf("SELECT CONVERT(varchar(10), T.EditDate, 104) Datum, CreateUserID SupporterID, COUNT(DISTINCT ID) 'AnzahlTickets' "
                . "FROM hm_Ticket T "
                . "WHERE T.EditDate %s "
                . "GROUP BY CreateUserID, CONVERT(varchar(10), T.EditDate, 104) "
                . "ORDER BY Datum", $BetweenClause);
        $SQLS .= "<br />--Anzahl der Tickets, die ein Supporter erstellt hat:<br /> --$sql<br />";
        $res = $this->db->query($sql);
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $SupporterReport[$row['datum']][$row['supporterid']]['cntCreatedFrom'] = $row['anzahltickets'];
                $SupporterReportComplete[$row['supporterid']]['cntCreatedFrom'] += $row['anzahltickets'];
            }
        }

        /*
          cntClosedBy
          Anzahl der Tickets die ein Supporter geschlossen hat
          => CreateuserID, EditDate der Ticketevents mit Ticketstatusid 3 , Editdate im Auswertungszeitraum
         */

        $sql = sprintf("SELECT CONVERT(varchar(10), EventDate, 104) Datum, CreateUserID SupporterID, COUNT(distinct TicketID) 'AnzahlTickets' "
                . "FROM hm_TicketEvent TE "
                . "WHERE  TicketStatusID = 3 AND EventDate %s "
                . "GROUP BY CreateUserID, CONVERT(varchar(10), EventDate, 104) "
                . "ORDER BY Datum", $BetweenClause);
        $SQLS .= "<br />--Anzahl der Tickets die ein Supporter geschlossen hat:<br /> --$sql<br />";
        $res = $this->db->query($sql);
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $SupporterReport[$row['datum']][$row['supporterid']]['cntClosedBy'] = $row['anzahltickets'];
                $SupporterReportComplete[$row['supporterid']]['cntClosedBy'] += $row['anzahltickets'];
            }
        }

        /*
          cntClosedBy Schnellschuss
          Anzahl der Tickets die ein Supporter per Schnellschuss geschlossen hat
         */

        $sql = sprintf("SELECT TmpTbl.Datum, TmpTbl.CreateUserID SupporterID, COUNT(DISTINCT ID) 'AnzahlTickets'
FROM (
	SELECT
		T.ID , T.CreateUserID, CONVERT(varchar(10), EditDate, 104) Datum
	FROM
		hm_Ticket T
			LEFT JOIN hm_TicketEvent TE ON T.ID = TE.TicketID
	WHERE
		T.TicketStatusID = 3 AND EditDate %s
	GROUP BY T.ID, T.CreateUserID, CONVERT(varchar(10), EditDate, 104)
	HAVING  COUNT(TE.ID) = 1
	) As TmpTbl
GROUP BY TmpTbl.CreateUserID, TmpTbl.Datum ", $BetweenClause);
        $SQLS .= "<br />--Anzahl der Tickets die ein Supporter per Schnellschuss geschlossen hat:<br /> --$sql<br />";
        $res = $this->db->query($sql);
        $row = array();
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                if (isset($SupporterReport[$row['datum']][$row['supporterid']]['cntClosedBy'])) {
                    $SupporterReport[$row['datum']][$row['supporterid']]['cntClosedBy'] += $row['anzahltickets'];
                } else {
                    $SupporterReport[$row['datum']][$row['supporterid']]['cntClosedBy'] = $row['anzahltickets'];
                }
                $SupporterReportComplete[$row['supporterid']]['cntClosedBy'] += $row['anzahltickets'];
            }
        }

        /*
          cntClosedfor
          Anzahl der Tickets die fr einen Supporter geschlossen wurden
          => UpdateDate, SupporterID von Ticketstausid3 , UpdateDate im Auswertungszeitraum
         */


        $sql = sprintf("SELECT CONVERT(varchar(10), T.UpdateDate, 104) Datum, ISNULL(TS.UserID, 0) SupporterID, COUNT(DISTINCT ID) 'AnzahlTickets' "
                . "FROM hm_Ticket T "
                . "LEFT JOIN hm_TicketSupporter TS ON T.ID = TS.TicketID "
                . "WHERE T.TicketStatusID = 3 AND T.UpdateDate %s "
                . "GROUP BY ISNULL(TS.UserID, 0), CONVERT(varchar(10), T.UpdateDate, 104) "
                . "ORDER BY Datum", $BetweenClause);
        $SQLS .= "<br />--Anzahl der Tickets die fr einen Supporter geschlossen wurden:<br /> --$sql<br />";
        $res = $this->db->query($sql);
        $row = array();
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $SupporterReport[$row['datum']][$row['supporterid']]['cntClosedfor'] = $row['anzahltickets'];
                $SupporterReportComplete[$row['supporterid']]['cntClosedfor'] += $row['anzahltickets'];
            }
        }


        /*
          Durchschnitte
          Liegezeit und Durchschnittliches Liegezeit Tickets pro Supporter
          => Liegezeit aller Tickets welche im Auswertungszeitraum erstellt wurden und welche dem Supporter zugewiesen sind / die Anzahl dieser Tickets

          Aufwnde in Tickets des Supporters	und Durschnitliche Aufwnde in den Tickets
         */
        $sql = sprintf("SELECT
	Datum,
	SupporterID,
	AnzahlTicketsImZeitraum,
	ProcessTime,
	AvgProcessTime,
	Expense,
	AvgExpense,
        ExpExpense
FROM (
	SELECT
		COUNT(DISTINCT ID) AnzahlTicketsImZeitraum,
		ISNULL(TS.UserID, 0) SupporterID ,
		SUM( DATEDIFF(mi, hm_Ticket.EditDate, CASE WHEN hm_Ticket.TicketStatusID = 3 THEN hm_Ticket.UpdateDate ELSE  GETDATE()  END ) ) ProcessTime,
		SUM( DATEDIFF(mi, hm_Ticket.EditDate, CASE WHEN hm_Ticket.TicketStatusID = 3 THEN hm_Ticket.UpdateDate ELSE  GETDATE()  END ) ) / COUNT(DISTINCT ID) AvgProcessTime,
		SUM(TE.Aufwand) Expense,
		SUM(TE.Aufwand) / COUNT(DISTINCT ID)  AvgExpense,
		CONVERT(varchar(10), hm_Ticket.EditDate, 104) Datum,
                SUM(DISTINCT hm_Ticket.ExpExpense) ExpExpense
	FROM
		hm_Ticket
		LEFT JOIN (
			SELECT TicketID, SUM(Expense) Aufwand
			FROM hm_TicketEvent
			WHERE Deleted IS NULL OR Deleted = 0
			Group BY TicketID
		) TE ON TE.TicketID = hm_Ticket.ID
                LEFT JOIN hm_TicketSupporter TS ON T.ID = TS.TicketID
	WHERE
		hm_Ticket.EditDate %s
	GROUP BY
		ISNULL(TS.UserID, 0), CONVERT(varchar(10), hm_Ticket.EditDate, 104)
) TInfo
ORDER BY Datum", $BetweenClause);
        $SQLS .= "<br />--Liegezeiten und Durchschnittliches Liegezeiten und Aufwnde Tickets pro Supporter:<br /> --$sql<br />";
        $res = $this->db->query($sql);
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $tmp = $row;
                unset($tmp['datum']);
                unset($tmp['supporterid']);

                $tmp['processtime_ra'] = $this->readableTimes($tmp['processtime']);
                $tmp['avgprocesstime_ra'] = $this->readableTimes($tmp['avgprocesstime']);
                $tmp['expense_ra'] = $this->readableTimes($tmp['expense'], false);
                $tmp['avgexpense_ra'] = $this->readableTimes($tmp['avgexpense'], false);

//                $SupporterReport[$row['datum']][$row['supporterid']] += $tmp;
                $SupporterReport[$row['datum']][$row['supporterid']] = array_merge($SupporterReport[$row['datum']][$row['supporterid']], $tmp);

                foreach ($tmp as $key => $value) {
                    $SupporterReportComplete[$row['supporterid']][$key] += $value;
                }
            }
        }

        /*
          SupporterExpense
          Summe der generierten Aufwnde eines Supporters im Zeitrum in Minuten
         */
        $sql = sprintf("SELECT CONVERT(varchar(10), EventDate, 104) Datum, CreateUserID SupporterID, SUM(Expense) Aufwand "
                . "FROM hm_TicketEvent "
                . "WHERE EventDate %s "
                . "GROUP BY CreateUserID, CONVERT(varchar(10), EventDate, 104) "
                . "ORDER BY Datum", $BetweenClause);
        $SQLS .= "<br />--Summe der generierten Aufwnde eines Supporters im Zeitrum in Minuten:<br /> --$sql<br />";
        $res = $this->db->query($sql);
        $row = array();
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $SupporterReport[$row['datum']][$row['supporterid']]['SupporterExpense'] = $row['aufwand'];
                $SupporterReport[$row['datum']][$row['supporterid']]['SupporterExpense_ra'] = $this->readableTimes($row['aufwand'], false);
                $SupporterReportComplete[$row['supporterid']]['SupporterExpense'] += $row['aufwand'];
            }
        }
        /*
          cntOpenTickets
          Anzahl der aktuell offenen Tickets pro Supporter
         */
        $sql = sprintf("SELECT CONVERT(varchar(10), GETDATE(), 104) Datum, ISNULL(TS.UserID, 0) SupporterID, COUNT(DISTINCT ID) 'AnzahlTickets' "
                . "FROM hm_Ticket "
                . "LEFT JOIN hm_TicketSupporter TS ON hm_Ticket.ID = TS.TicketID "
                . "WHERE TicketStatusID <> 3 "
                . "GROUP BY ISNULL(TS.UserID, 0) ");
        $SQLS .= "<br />--Anzahl der aktuell offenen Tickets pro Supporter:<br /> $sql<br />";
        $res = $this->db->query($sql);
        $row = array();
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $AktuellOffeneTicketsJeSupporter[$row['datum']][$row['supporterid']]['cntOpenTickets'] = $row['anzahltickets'];
            }
        }
        /*
          Anzahl der aktuell offenen Tickets pro Gruppe
         */

        $sql = sprintf("SELECT COUNT(DISTINCT ID) 'AnzahlTickets', ISNULL(TG.GroupID, 0) GroupID, CONVERT(varchar(10), GETDATE(), 104) Datum FROM hm_Ticket LEFT JOIN hm_TicketGroup TG ON hm_Ticket.ID = TG.TicketID WHERE TicketStatusID <> 3 GROUP BY ISNULL(TG.GroupID, 0)");
        $SQLS .= "<br />--Anzahl der aktuell offenen Tickets pro Gruppe:<br /> $sql<br />";
//"<br />--Anzahl der aktuell offenen Tickets pro Gruppe:<br /> --$sql<br />";
        $res = $this->db->query($sql);
        $row = array();
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $AktuellOffeneTicketsJeGruppe[$row['datum']][$row['groupid']]['cntOpenTickets'] = $row['anzahltickets'];
            }
        }

        /*
          cntCreatedFor
          Tgliche Tickets pro Gruppe
          => Anzahl erstellter Tickets je Tag je Gruppe
         */
        $sql = sprintf("SELECT COUNT(DISTINCT ID) 'AnzahlTickets' , ISNULL(TG.GroupID, 0) GroupID, CONVERT(varchar(10), T.EditDate, 104) Datum "
                . "FROM hm_Ticket T "
                . "LEFT JOIN hm_TicketGroup TG ON T.ID = TG.TicketID "
                . "WHERE T.EditDate %s "
                . "GROUP BY ISNULL(TG.GroupID, 0), CONVERT(varchar(10), T.EditDate, 104) "
                . "ORDER BY Datum", $BetweenClause);
        $SQLS .= "<br />--Tgliche Tickets pro Gruppe:<br /> $sql<br />";
//echo "<br />--Tgliche Tickets pro Gruppe:<br /> --$sql<br />";
        $res = $this->db->query($sql);
        $row = array();
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $GroupReport[$row['datum']][$row['groupid']]['cntCreatedFor'] = $row['anzahltickets'];
                $GroupReportComplete[$row['groupid']]['cntCreatedFor'] += $row['anzahltickets'];
            }
        }

        /*
          cntClosed
          Anzahl der Tickets einer Gruppe die geschlossen wurden je Tag
          => Alle Tickets die der Gruppe zugeweisen sind und die im Auswertungszeitraum geschlossen wurden
         */
        $sql = sprintf("SELECT CONVERT(varchar(10), T.UpdateDate, 104) Datum, ISNULL(TG.GroupID, 0) GroupID, COUNT(DISTINCT ID) 'AnzahlTickets' "
                . "FROM hm_Ticket T "
                . "LEFT JOIN hm_TicketGroup TG ON T.ID = TG.TicketID "
                . "WHERE TicketStatusID = 3 AND T.UpdateDate %s "
                . "GROUP BY ISNULL(TG.GroupID, 0), CONVERT(varchar(10), T.UpdateDate, 104) "
                . "ORDER BY Datum", $BetweenClause);
        $SQLS .= "<br />--Tgliche Tickets pro Gruppe:<br /> --$sql<br />";
//echo "<br />--Tgliche Tickets pro Gruppe:<br /> --$sql<br />";
        $res = $this->db->query($sql);
        $row = array();
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $GroupReport[$row['datum']][$row['groupid']]['cntClosed'] = $row['anzahltickets'];
                $GroupReportComplete[$row['groupid']]['cntClosed'] += $row['anzahltickets'];
            }
        }

        /*
          GroupData
          Durchschnittliches Liegezeit Tickets pro Gruppe
          => Liegezeit aller Tickets welche im Auswertungszeitraum erstellt wurden, die einer Gruppe zugewiesen sind / die Anzahl dieser Tickets
         */

        $sql = sprintf("SELECT
	Datum,
	GroupID,
	Anzahl,
	ProcessTime,
	AvgProcessTime,
	Expense,
	AvgExpense,
        ExpExpense
FROM (
	SELECT
		COUNT(DISTINCT ID) Anzahl,
		ISNULL(TG.GroupID, 0)GroupID ,
		SUM( DATEDIFF(mi, hm_Ticket.EditDate, CASE WHEN hm_Ticket.TicketStatusID = 3 THEN hm_Ticket.UpdateDate ELSE  GETDATE()  END ) ) ProcessTime,
		SUM( DATEDIFF(mi, hm_Ticket.EditDate, CASE WHEN hm_Ticket.TicketStatusID = 3 THEN hm_Ticket.UpdateDate ELSE  GETDATE()  END ) ) / COUNT(DISTINCT ID) AvgProcessTime,
		SUM(TE.Aufwand) Expense,
		SUM(TE.Aufwand) / COUNT(DISTINCT ID)  AvgExpense,
		CONVERT(varchar(10), hm_Ticket.EditDate, 104) Datum,
                SUM(DISTINCT hm_ticket.ExpExpense) ExpExpense
	FROM
		hm_Ticket
		LEFT JOIN (
			SELECT TicketID, SUM(Expense) Aufwand
			FROM hm_TicketEvent
			WHERE Deleted IS NULL OR Deleted = 0
			Group BY TicketID
		) TE ON TE.TicketID = hm_Ticket.ID
                LEFT JOIN hm_TicketGroup TG ON hm_Ticket.ID = TG.TicketID
	WHERE
		hm_Ticket.EditDate %s
	GROUP BY
		ISNULL(TG.GroupID, 0), CONVERT(varchar(10), hm_Ticket.EditDate, 104)
) TInfo
ORDER BY Datum, GroupID", $BetweenClause);
        $SQLS .= "<br />--Durchschnittliches Liegezeit Tickets pro Gruppe:<br /> $sql<br />";
//echo "<br />--Durchschnittliches Liegezeit Tickets pro Gruppe:<br /> --$sql<br />";
        $res = $this->db->query($sql);
        $row = array();
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $tmp = $row;
                unset($tmp['datum']);
                unset($tmp['groupid']);

                $tmp['processtime_ra'] = $this->readableTimes($tmp['processtime']);
                $tmp['avgprocesstime_ra'] = $this->readableTimes($tmp['avgprocesstime']);
                $tmp['expense_ra'] = $this->readableTimes($tmp['expense'], false);
                $tmp['avgexpense_ra'] = $this->readableTimes($tmp['avgexpense'], false);

                foreach ($tmp as $key => $value) {
                    $GroupReport[$row['datum']][$row['groupid']][$key] = $value;
                    $GroupReportComplete[$row['groupid']][$key] += $value;
                }
            }
        }

        foreach ($SupporterReportComplete as $key => $value) {
            $SupporterReportComplete[$key]['avgprocesstime'] = ($SupporterReportComplete[$key]['processtime'] / $SupporterReportComplete[$key]['anzahlticketsimzeitraum']);
            $SupporterReportComplete[$key]['processtime_ra'] = $this->readableTimes($SupporterReportComplete[$key]['processtime'], true);
            $SupporterReportComplete[$key]['avgprocesstime_ra'] = $this->readableTimes($SupporterReportComplete[$key]['avgprocesstime'], true);
            $SupporterReportComplete[$key]['expense_ra'] = $this->readableTimes($SupporterReportComplete[$key]['expense'], false);
            $SupporterReportComplete[$key]['avgexpense_ra'] = $this->readableTimes($SupporterReportComplete[$key]['avgexpense'], false);
            $SupporterReportComplete[$key]['SupporterExpense_ra'] = $this->readableTimes($SupporterReportComplete[$key]['SupporterExpense'], false);
        }

        foreach ($GroupReportComplete as $key => $value) {
            $GroupReportComplete[$key]['avgprocesstime'] = ($GroupReportComplete[$key]['processtime'] / $GroupReportComplete[$key]['anzahl']);
            $GroupReportComplete[$key]['processtime_ra'] = $this->readableTimes($GroupReportComplete[$key]['processtime'], true);
            $GroupReportComplete[$key]['avgprocesstime_ra'] = $this->readableTimes($GroupReportComplete[$key]['avgprocesstime'], true);
            $GroupReportComplete[$key]['expense_ra'] = $this->readableTimes($GroupReportComplete[$key]['expense'], false);
            $GroupReportComplete[$key]['avgexpense_ra'] = $this->readableTimes($GroupReportComplete[$key]['avgexpense'], false);
            $GroupReportComplete[$key]['SupporterExpense_ra'] = $this->readableTimes($GroupReportComplete[$key]['SupporterExpense'], false);
        }


        $this->set('SupporterReport', $SupporterReport);
        $this->set('AktuellOffeneTicketsJeSupporter', $AktuellOffeneTicketsJeSupporter);
        $this->set('SupporterArray', $SupporterArray);
        $this->set('SupporterReportComplete', $SupporterReportComplete);

        $this->set('GroupReport', $GroupReport);
        $this->set('AktuellOffeneTicketsJeGruppe', $AktuellOffeneTicketsJeGruppe);
        $this->set('GroupArray', $GroupArray);
        $this->set('GroupReportComplete', $GroupReportComplete);
//echo $SQLS;
        if (isset($_REQUEST['SupporterReport'])) {
            header("Content-type: text/csv");
            header("Content-Disposition: attachment; filename=SupporterReport.csv");
            header("Pragma: no-cache");
            header("Expires: 0");

            echo "Datum;Supporter;Bearbeitete Tickets;Erstellt fr;Erstellt von;Geschlossen fr;Geschlossen von;Liegezeit der an diesem Tag erstellten Tickets;durchschnittliche Liegezeit;Aufwand;durchschnittlicher Aufwand;Aufwand eingetragen" . "\n";
            foreach ($SupporterReport as $Datum => $SupporterDays) {
                foreach ($SupporterDays as $Supporter => $SupporterData) {
                    echo $Datum . ";";
                    echo $SupporterArray[$Supporter] . ";";
                    echo $SupporterData['cntTuochedTickets'] . ";";
                    echo $SupporterData['cntCreatedFor'] . ";";
                    echo $SupporterData['cntCreatedFrom'] . ";";
                    echo $SupporterData['cntClosedBy'] . ";";
                    echo $SupporterData['cntClosedfor'] . ";";
                    echo $SupporterData['processtime_ra'] . ";";
                    echo $SupporterData['avgprocesstime_ra'] . ";";
                    echo $SupporterData['expense_ra'] . ";";
                    echo $SupporterData['avgexpense_ra'] . ";";
                    echo $SupporterData['SupporterExpense_ra'] . ";";
                    echo "\n";
                }
            }
            exit;
        }

        if (isset($_REQUEST['GroupReport'])) {
            header("Content-type: text/csv");
            header("Content-Disposition: attachment; filename=GruppenReport.csv");
            header("Pragma: no-cache");
            header("Expires: 0");

            echo "Datum;Gruppe;Erstellte Tickets;Geschlossene Tickets;Liegezeit der an diesem Tag erstellten Tickets;durchschnittliche Liegezeit;Aufwand;durchschnittlicher Aufwand" . "\n";
            foreach ($GroupReport as $Datum => $SupporterDays) {
                foreach ($SupporterDays as $Supporter => $SupporterData) {
                    echo $Datum . ";";
                    echo $GroupArray[$Supporter] . ";";
                    echo $SupporterData['cntCreatedFor'] . ";";
                    echo $SupporterData['cntClosed'] . ";";
                    echo $SupporterData['processtime_ra'] . ";";
                    echo $SupporterData['avgprocesstime_ra'] . ";";
                    echo $SupporterData['expense_ra'] . ";";
                    echo $SupporterData['avgexpense_ra'] . ";";
                    echo "\n";
                }
            }
            exit;
        }

        if (isset($_REQUEST['AktuellOffeneTicketsJeSupporter'])) {
            header("Content-type: text/csv");
            header("Content-Disposition: attachment; filename=OffeneTicketsJeSupporter.csv");
            header("Pragma: no-cache");
            header("Expires: 0");

            echo "Datum;Supporter;Derzeit offene Tickets" . "\n";
            foreach ($AktuellOffeneTicketsJeSupporter as $Datum => $SupporterDays) {
                foreach ($SupporterDays as $Supporter => $SupporterData) {
                    echo $Datum . ";";
                    echo $SupporterArray[$Supporter] . ";";
                    echo $SupporterData['cntOpenTickets'] . ";";
                    echo "\n";
                }
            }
            exit;
        }


        if (isset($_REQUEST['AktuellOffeneTicketsJeGruppe'])) {
            header("Content-type: text/csv");
            header("Content-Disposition: attachment; filename=OffeneTicketsJeGruppe.csv");
            header("Pragma: no-cache");
            header("Expires: 0");

            echo "Datum;Gruppe;Derzeit offene Tickets" . "\n";
            foreach ($AktuellOffeneTicketsJeGruppe as $Datum => $SupporterDays) {
                foreach ($SupporterDays as $Supporter => $SupporterData) {
                    echo $Datum . ";";
                    echo $GroupArray[$Supporter] . ";";
                    echo $SupporterData['cntOpenTickets'] . ";";
                    echo "\n";
                }
            }
            exit;
        }



        if (isset($_REQUEST['GroupReportComplete'])) {
            header("Content-type: text/csv");
            header("Content-Disposition: attachment; filename=GruppenReportKomplett.csv");
            header("Pragma: no-cache");
            header("Expires: 0");

            echo "Gruppe;AnzahlTicket;Geschlossen;Liegezeit;durchschnittLiegeZeit;Aufwand;durchschnittAufwand" . "\n";
            foreach ($GroupReportComplete as $key => $value) {
                echo $GroupArray[$key] . ";";
                echo $value['cntCreatedFor'] . ";";
                echo $value['cntClosedfor'] . ";";
                echo $value['processtime_ra'] . ";";
                echo $value['avgprocesstime_ra'] . ";";
                echo $value['expense_ra'] . ";";
                echo $value['avgexpense_ra'] . ";";
                echo "\n";
            }
            exit;
        }

        if (isset($_REQUEST['SupporterReportComplete'])) {
            header("Content-type: text/csv");
            header("Content-Disposition: attachment; filename=SupporterReportKomplett.csv");
            header("Pragma: no-cache");
            header("Expires: 0");
            echo "Supporter;Bearbeitete Tickets;Erstellt fr;Erstellt von;Geschlossen fr;Geschlossen von;Liegezeit der an diesem Tag erstellten Tickets;Liegezeit;durchschnittliche Liegezeit;Aufwand;durchschnittlicher Aufwand;Aufwand eingetragen" . "\n";
            foreach ($SupporterReportComplete as $key => $value) {
                echo $SupporterArray[$key] . ";";
                echo $value['cntTuochedTickets'] . ";";
                echo $value['cntCreatedFor'] . ";";
                echo $value['cntCreatedFrom'] . ";";
                echo $value['cntClosedBy'] . ";";
                echo $value['cntClosedfor'] . ";";
                echo $value['anzahlticketsimzeitraum'] . ";";
                echo $value['processtime_ra'] . ";";
                echo $value['avgprocesstime_ra'] . ";";
                echo $value['expense_ra'] . ";";
                echo $value['avgexpense_ra'] . ";";
                echo $value['SupporterExpense_ra'] . ";";
                echo "\n";
            }
            exit;
        }
    }

    private function readableTimes($Minutes, $withDays = true) {
        $String = "";
        if (0 < $Minutes) {
            if ($withDays) {
                $Tage = (int) ($Minutes / (24 * 60) );
            } else {
                $Tage = 0;
            }
            $Stunden = (int) (($Minutes - ($Tage * (24 * 60) ) ) / 60);
            $Minuten = (int) (($Minutes - ($Tage * (24 * 60)) - ($Stunden * 60) ));

            $String .= ($Tage) ? $Tage . " Tage " : "";
            $String .= ($Stunden) ? $Stunden . " Std " : "";
            $String .= ($Minuten) ? $Minuten . " Min " : "";
        }
        return $String;
    }

    /**
     * Erweitert den DateDiff-String um ein Typecasting zu Bigint.
     * Bei MSSQL-DBs zu CONVERT(bigint, ...)
     * @return string
     */
    private function getProcessTimeSQLString() {
        $sql = $this->DB_DATEDIFF('minute', 'hm_Ticket.EditDate', 'CASE WHEN hm_Ticket.TicketStatusID = 3 THEN hm_Ticket.UpdateDate ELSE ' . $this->DB_DATE('now()') . ' END ');
        if ($this->db->phptype == 'oci8') {#
        } else {
            $sql = "CONVERT(bigint, $sql)";
        }
        return $sql;
    }


    public function CatReport() {
        $this->tplFile = 'catReport.tpl';

        $Report = array();


        if (isset($_REQUEST['startdate']) && $_REQUEST['startdate'] != '') {
            $startdate = $_REQUEST['startdate'];
            $enddate = $_REQUEST['enddate'];
        } else if (isset($_SESSION['CatReport']['startdate'])) {
            $startdate = $_SESSION['CatReport']['startdate'];
            $enddate = $_SESSION['CatReport']['enddate'];
        } else {
            $startdate = date('01.m.Y', strtotime("-1 month"));
            $enddate = date('t.m.Y', strtotime("-1 month"));
        }
        $_SESSION['CatReport']['startdate'] = $startdate;
        $_SESSION['CatReport']['enddate'] = $enddate;

        $this->set('startdate', $startdate);
        $this->set('enddate', $enddate);

        $startdate .= " 00:00";
        $enddate .= " 23:59";

        $sql = sprintf("
select
ticket.kategorie1 'kategorie1'
, ticket.kategorie2 'kategorie2'
, sum(ticket.anzahlopen) 'cntopen'
, sum(ticket.anzahlclose) 'cntclosed'
, sum(ticket.level0) 'cntesc0'
, sum(ticket.level1) 'cntesc1'
, sum(ticket.level2) 'cntesc2'
, sum(ticket.level3) 'cntesc3'
, sum(ticket.level4) 'cntesc4'
, sum(ticket.level5) 'cntesc5'
from
	(select
	T.ID 'Ticket',
	TC1.name 'Kategorie1'
	, TC2.name 'Kategorie2'
	, TicketStart.TicketOpen
	, count(TicketStart.StatusOpen) 'Anzahlopen'
	, TicketStart.DateOpen
	, TicketEnde.TicketClose
	, count(TicketEnde.StatusClose) 'AnzahlClose'
	, TicketEnde.DateClose
	, TicketEnde.ESTicket
	, TicketEnde.ESDatum
	, isNULL(TicketEnde.Level0,0) 'Level0'
	, isNULL(TicketEnde.Level1,0) 'Level1'
	, isNULL(TicketEnde.Level2,0) 'Level2'
	, isNULL(TicketEnde.Level3,0) 'Level3'
	, isNULL(TicketEnde.Level4,0) 'Level4'
	, isNULL(TicketEnde.Level5,0) 'Level5'
	,  isNULL(count(TicketStart.StatusOpen),0) +  isNULL(count(TicketEnde.StatusClose),0) + isNULL(TicketEnde.Level0, 0) +
	   isNULL(TicketEnde.Level1, 0) +  isNULL(TicketEnde.Level2, 0) +  isNULL(TicketEnde.Level3, 0) + isNULL(TicketEnde.Level4, 0) + isNULL(TicketEnde.Level5, 0) 'Pruefung'
	from dbo.hm_Ticket T
	--Ticket erffnet im Zeitraum
		LEFT JOIN (
			select
			T.ID as TicketOpen
			, T.CreateDate as DateOpen
			, T.TicketStatusID as StatusOpen
			from
			dbo.hm_Ticket T
			where
			--T.TicketStatusID = 1 and
			T.CreateDate between %s and %s
		) TicketStart ON  T.ID = TicketStart.TicketOpen
	--Ticket geschlossen im Zeitraum
		LEFT JOIN (
			select
			TE1.TicketID as TicketClose
			, TE1.TicketStatusID as StatusClose
			, min(TE1.EventDate) as DateClose
			, LVL.ESTICKET
			, LVL.ESDATUM
			, LVL.ESLEVEL
			, CASE isNULL(MAX(LVL.ESLEVEL),0) WHEN '0' THEN 1 ELSE 0 END 'Level0'
			, CASE MAX(LVL.ESLEVEL) WHEN '1' THEN 1	ELSE 0 END 'Level1'
			, CASE MAX(LVL.ESLEVEL) WHEN '2' THEN 1	ELSE 0 END 'Level2'
			, CASE MAX(LVL.ESLEVEL) WHEN '3' THEN 1	ELSE 0 END 'Level3'
			, CASE MAX(LVL.ESLEVEL) WHEN '4' THEN 1	ELSE 0 END 'Level4'
			, CASE MAX(LVL.ESLEVEL) WHEN '5' THEN 1	ELSE 0 END 'Level5'
			from
			dbo.hm_TicketEvent TE1
		Left join (
			Select  T2.ESTicket 'ESTICKET',
			MAX(ESLEVEL) 'ESLEVEL',
			MAX(ESDATUM) 'ESDATUM'
			from (select
				TE1.TicketID as TicketClose
				, TE1.TicketStatusID as StatusClose
				, min(TE1.EventDate) as DateClose
				from
				dbo.hm_TicketEvent TE1
				where
				TE1.TicketStatusID = 3 and
				TE1.UpdateDate between %s and %s
				group by
				TE1.TicketID, TE1.TicketStatusID)T1
			,(select EH.TicketID 'ESTicket', EH.EscalationLevel 'ESLevel', EH.EscalationDate 'ESDatum'
				from dbo.hm_EscalationHistory EH)T2
				where T1.TicketClose=T2.esticket
				and t1.dateclose>=t2.esdatum
			group by T2.ESTicket)LVL on TE1.TicketID = LVL.ESTicket
		where
		TE1.TicketStatusID = 3 and
		TE1.UpdateDate between %s and %s
		group by
		TE1.TicketID
		, TE1.TicketStatusID
		, LVL.ESTICKET
		, LVL.ESDATUM
		, LVL.ESLEVEL
		) TicketEnde on T.ID = TicketEnde.TicketClose
--Kategorien
LEFT JOIN dbo.hm_Categories TC1 ON T.CategoryID1 = TC1.id
LEFT JOIN dbo.hm_Categories TC2 ON T.CategoryID2 = TC2.id
Where (T.UpdateDate between %s and %s or T.CreateDate between %s and %s)
group by
T.ID,
TC1.name
, TC2.name
, TicketStart.TicketOpen
, TicketStart.DateOpen
, TicketEnde.TicketClose
, TicketEnde.DateClose
, TicketEnde.ESTicket
, TicketEnde.ESDatum
, TicketEnde.Level0
, TicketEnde.Level1
, TicketEnde.Level2
, TicketEnde.Level3
, TicketEnde.Level4
, TicketEnde.Level5) Ticket
where Pruefung <> 0
group by
Ticket.Kategorie1
, Ticket.Kategorie2
order by
Ticket.Kategorie1
, Ticket.Kategorie2
", $this->DB_DATE($startdate), $this->DB_DATE($enddate), $this->DB_DATE($startdate), $this->DB_DATE($enddate), $this->DB_DATE($startdate), $this->DB_DATE($enddate), $this->DB_DATE($startdate), $this->DB_DATE($enddate), $this->DB_DATE($startdate), $this->DB_DATE($enddate));

        $res = $this->db->query($sql);
        if (!DB::isError($res)) {
            while ($row = $res->fetchrow(DB_FETCHMODE_ASSOC)) {
                $Report[] = $row;
            }
        }

        if (isset($_REQUEST['Export'])) {
            $this->CatReportExcel($Report);
        } else {
            $this->set('Report', $Report);
        }
    }

    /**
     * Generiert die Excel-Datei fr 'Kategorie-Report'.
     *
     * @param array $Rport
     */
    private function CatReportExcel($Report) {
        include_once 'Spreadsheet/Excel/Writer.php';

        $workbook = new Spreadsheet_Excel_Writer();
        $workbook->send('KategorienReport.xls');
        $worksheet = & $workbook->addWorksheet('KategorienReport');

        $format_bold = & $workbook->addFormat();
        $format_bold->setBold();

        $worksheet->writeString(0, 0, $this->user->gettext('Zeitraum vom:'), $format_bold);
        $worksheet->writeString(0, 1, $_SESSION['CatReport']['startdate']);
        $worksheet->writeString(1, 0, $this->user->gettext('bis zum:'), $format_bold);
        $worksheet->writeString(1, 1, $_SESSION['CatReport']['enddate']);

        $y = 4;
        $worksheet->writeString($y - 1, 0, trim('Kategorie 1'), $format_bold);
        $worksheet->writeString($y - 1, 1, trim('Kategorie 2'), $format_bold);
        $worksheet->writeString($y - 1, 2, trim('Anzahl offen'), $format_bold);
        $worksheet->writeString($y - 1, 3, trim('Anzahl geschlossen'), $format_bold);
        $worksheet->writeString($y - 1, 4, trim('Anzahl Eskalationsstufe 0'), $format_bold);
        $worksheet->writeString($y - 1, 5, trim('Anzahl Eskalationsstufe 1'), $format_bold);
        $worksheet->writeString($y - 1, 6, trim('Anzahl Eskalationsstufe 2'), $format_bold);
        $worksheet->writeString($y - 1, 7, trim('Anzahl Eskalationsstufe 3'), $format_bold);
        $worksheet->writeString($y - 1, 8, trim('Anzahl Eskalationsstufe 4'), $format_bold);
        $worksheet->writeString($y - 1, 9, trim('Anzahl Eskalationsstufe 5'), $format_bold);

        if (count($Report)) {
            foreach ($Report as $Column) {
                $worksheet->writeString($y, 0, $Column['kategorie1']);
                $worksheet->writeString($y, 1, $Column['kategorie2']);
                $worksheet->writeNumber($y, 2, $Column['cntopen']);
                $worksheet->writeNumber($y, 3, $Column['cntclose']);
                $worksheet->writeNumber($y, 4, $Column['cntesc0']);
                $worksheet->writeNumber($y, 5, $Column['cntesc1']);
                $worksheet->writeNumber($y, 6, $Column['cntesc2']);
                $worksheet->writeNumber($y, 7, $Column['cntesc3']);
                $worksheet->writeNumber($y, 8, $Column['cntesc4']);
                $worksheet->writeNumber($y, 9, $Column['cntesc5']);
                $y++;
            }
        }
        $workbook->close();
        exit;
    }

// {{{ __destruct
    public function __destruct() {
        parent::__destruct();
    }

// }}}
}

?>
